#!/bin/csh -f
#
# Sample script to show basic function of LoadLeveler
# - since no "executable" is specified, this file "job1.cmd" will be used as
#   the executable
#
# @ error   = ./out/job3.$(jobid).err
# @ output  = ./out/job3.$(jobid).out
#### @ wall_clock_limit = 05:00 
# @ job_type = parallel
### @ job_type = serial
# @ node = 4 
# @ tasks_per_node=8
# @ network.MPI = sn_single,shared,us
# @ class = smalljob
### @ class = normald
# @ job_name = bccam2_T63
# @ comment  = BCC_CSM
# @ notification = complete
# @ environment = MP_LABELIO=yes ;  MP_INFOLEVEL=2; MP_STDOUTMODE=ordered 
### @ notify_user = yourID@cn.ibm.com
# @ queue

#
# simulate a compute bound job by killing some time
#
# must be set equal to (CPUs-per-node / tasks_per_node)
setenv OMP_NUM_THREADS 1

## suggestion from Jim Edwards to reintroduce XLSMPOPTS on 11/13/03
setenv XLSMPOPTS "stack=256000000"
setenv AIXTHREAD_SCOPE S
setenv MALLOCMULTIHEAP true
setenv OMP_DYNAMIC false
## Do our best to get sufficient stack memory
limit stacksize unlimited

poe ./bld/bccam < namelist 
