#include <misc.h>
#include <params.h>

      module compre
!----------------------------------------------------------------------- 
! 
! Purpose: Variables associated with temp dataset
! 
! Author: CCM Core Group
! 
!-----------------------------------------------------------------------

      use shr_kind_mod, only: r8 => shr_kind_r8
      use pmgrid

      implicit none

      real(r8) cdaytmpm  ! dataset calendar day previous month
      real(r8) cdaytmpp  ! dataset calendar day next month
      real(r8) cplos    ! constant for temp path length integral
      real(r8) cplol    ! constant for temp path length integral

      integer nm        ! Array indices for previous step temp data
      integer np        ! Array indices for next month temp data
      integer preid     ! netcdf id for temp variable
      integer preid2     ! netcdf id for temp variable
      integer lonsiz    ! size of longitude dimension on temp dataset
      integer latsiz    ! size of latitude dimension on temp dataset
      integer timesiz   ! size of time dimension on temp dataset
      integer timesiz2   ! size of time dimension on temp dataset
      integer timesiz_max   ! size of time dimension on temp dataset
      integer np1
      integer yc        ! record org year
      real(r8) pre_factor     ! factors
      real(r8) pre_offset     ! factors   

      type pre_pters
        real(r8), dimension(:,:), pointer :: val  ! (pcols,levsiz,begchunk:endchunk)
      end type pre_pters
      type (pre_pters) :: temprain(2)          ! mixing rat         
                                                
      real(r8), allocatable :: tplon(:)         ! Longitudes of bdy dataset (lonsiz)
      real(r8), allocatable :: tplat(:)         ! Latitudes of bdy dataset (latsiz)
      integer, allocatable ::  date_pre(:)           ! Date on temp dataset (YYYYMMDD)
      integer, allocatable ::  date_pre2(:)          ! Date on temp dataset (YYYYMMDD)

      real(r8) :: fillvalue                     ! default value                                                    
      logical  :: reverp = .false.
      logical  :: reverlat = .false.

      end module compre
