#include <misc.h>
#include <params.h>

      module comtp
!----------------------------------------------------------------------- 
! 
! Purpose: Variables associated with temp dataset
! 
! Author: CCM Core Group
! 
!-----------------------------------------------------------------------

      use shr_kind_mod, only: r8 => shr_kind_r8
      use pmgrid

      implicit none

      real(r8) cdaytmpm  ! dataset calendar day previous month
      real(r8) cdaytmpp  ! dataset calendar day next month
      real(r8) cplos    ! constant for temp path length integral
      real(r8) cplol    ! constant for temp path length integral

      integer nm        ! Array indices for previous step temp data
      integer np        ! Array indices for next month temp data
      integer tpid     ! netcdf id for temp variable
      integer tpid2    ! netcdf id for temp variable
      integer qnid     ! netcdf id for temp variable
      integer qnid2     ! netcdf id for temp variable
      integer ncpsid     ! netcdf id for temp variable
      integer ncpsid2     ! netcdf id for temp variable
      integer unid     ! netcdf id for temp variable
      integer unid2     ! netcdf id for temp variable
      integer vnid     ! netcdf id for temp variable
      integer vnid2     ! netcdf id for temp variable
      integer lonsiz    ! size of longitude dimension on temp dataset
      integer levsiz    ! size of level dimension on temp dataset
      integer levsiz8   ! size of level dimension on temp dataset
      integer levsiz26    ! size of level dimension on temp dataset
      integer latsiz    ! size of latitude dimension on temp dataset
      integer timesiz   ! size of time dimension on temp dataset
      integer timesiz2   ! size of time dimension on temp dataset
      integer timesiz_max   ! size of time dimension on temp dataset
      integer np1
      integer yc        ! record org year

      real(r8) ps_factor, tp_factor, qn_factor, un_factor, vn_factor      ! factors
      real(r8) ps_offset, tp_offset, qn_offset, un_offset, vn_offset      ! factors   
      real(r8) p0_ecmwf   
      integer :: obs_year(2)         ! components of a year

      type ozmixm_pters
        real(r8), dimension(:,:,:), pointer :: val  ! (pcols,levsiz,begchunk:endchunk)
      end type ozmixm_pters
      type (ozmixm_pters) :: tempt(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tempq(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tempu(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tempv(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tempvt(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tempdv(2)          ! mixing ratios for lower and upper bounds
      type (ozmixm_pters) :: tmp       
      type (ozmixm_pters) :: tmp8         

      real(r8), allocatable :: tplon(:)         ! Longitudes of bdy dataset (lonsiz)
      real(r8), allocatable :: tplat(:)         ! Latitudes of bdy dataset (latsiz)
      real(r8), allocatable :: pin(:)           ! level of bdy dataset (lonsiz)
      real(r8), allocatable :: hyam_ecmwf(:)           ! level of bdy dataset (lonsiz)
      real(r8), allocatable :: hybm_ecmwf(:)           ! level of bdy dataset (lonsiz)
      integer, allocatable ::  dat(:) 
      integer, allocatable ::  date_tp(:)           ! Date on temp dataset (YYYYMMDD)
      integer, allocatable ::  date_tp2(:)          ! Date on temp dataset (YYYYMMDD)

      real(r8), allocatable ::  lev(:)
      real(r8), allocatable ::  lev8(:)

      real(r8) :: fillvalue                     ! default value                                                    
      logical  :: reverp = .false.
      logical  :: reverlat = .false.

      end module comtp
