#include <misc.h>
#include <params.h>

module bcc_adjrxt
      private
      public :: adjrxt

contains

      subroutine adjrxt( rate, inv, m, ncol )
      use ppgrid,        only : pcols, pver
      use shr_kind_mod,  only : r8 => shr_kind_r8
      use bcc_chem_mods, only : nfs, rxntot
      implicit none
!--------------------------------------------------------------------
! ... dummy arguments
!--------------------------------------------------------------------
      integer,  intent(in) :: ncol
      real(r8), intent(in) :: inv(pcols,pver,nfs)
      real(r8), intent(in) :: m(pcols,pver)
      real(r8), intent(inout) :: rate(pcols,pver,rxntot)
!--------------------------------------------------------------------
! ... local variables
!--------------------------------------------------------------------
      integer :: k, i
      real(r8) :: im(pcols)

!------------------------------
      do k = 1,pver
	    do i=1, ncol
         rate(i,k, 74) = rate(i,k, 74) * inv(i,k, 1)
         rate(i,k, 76) = rate(i,k, 76) * inv(i,k, 1)
         rate(i,k, 79) = rate(i,k, 79) * inv(i,k, 2)
         rate(i,k, 85) = rate(i,k, 85) * inv(i,k, 2)
         rate(i,k, 87) = rate(i,k, 87) * inv(i,k, 2)
         rate(i,k,113) = rate(i,k,113) * inv(i,k, 1)
         rate(i,k,117) = rate(i,k,117) * inv(i,k, 1)
         rate(i,k,119) = rate(i,k,119) * inv(i,k, 1)
         rate(i,k,120) = rate(i,k,120) * inv(i,k, 1)
         rate(i,k,121) = rate(i,k,121) * inv(i,k, 1)
         rate(i,k,127) = rate(i,k,127) * inv(i,k, 1)
         rate(i,k,129) = rate(i,k,129) * inv(i,k, 1)
         rate(i,k,137) = rate(i,k,137) * inv(i,k, 1)
         rate(i,k,139) = rate(i,k,139) * inv(i,k, 1)
         rate(i,k,148) = rate(i,k,148) * inv(i,k, 1)
         rate(i,k,167) = rate(i,k,167) * inv(i,k, 1)
         rate(i,k,171) = rate(i,k,171) * inv(i,k, 1)
         rate(i,k,172) = rate(i,k,172) * inv(i,k, 1)
         rate(i,k,188) = rate(i,k,188) * inv(i,k, 1)
         rate(i,k,220) = rate(i,k,220) * inv(i,k, 2)
         rate(i,k,228) = rate(i,k,228) * inv(i,k, 2)
         rate(i,k, 74) = rate(i,k, 74) * m(i,k)
         rate(i,k, 75) = rate(i,k, 75) * m(i,k)
         rate(i,k, 76) = rate(i,k, 76) * m(i,k)
         rate(i,k, 77) = rate(i,k, 77) * m(i,k)
         rate(i,k, 78) = rate(i,k, 78) * m(i,k)
         rate(i,k, 80) = rate(i,k, 80) * m(i,k)
         rate(i,k, 81) = rate(i,k, 81) * m(i,k)
         rate(i,k, 83) = rate(i,k, 83) * m(i,k)
         rate(i,k, 84) = rate(i,k, 84) * m(i,k)
         rate(i,k, 88) = rate(i,k, 88) * m(i,k)
         rate(i,k, 89) = rate(i,k, 89) * m(i,k)
         rate(i,k, 90) = rate(i,k, 90) * m(i,k)
         rate(i,k, 91) = rate(i,k, 91) * m(i,k)
         rate(i,k, 92) = rate(i,k, 92) * m(i,k)
         rate(i,k, 93) = rate(i,k, 93) * m(i,k)
         rate(i,k, 94) = rate(i,k, 94) * m(i,k)
         rate(i,k, 95) = rate(i,k, 95) * m(i,k)
         rate(i,k, 96) = rate(i,k, 96) * m(i,k)
         rate(i,k, 97) = rate(i,k, 97) * m(i,k)
         rate(i,k, 98) = rate(i,k, 98) * m(i,k)
         rate(i,k, 99) = rate(i,k, 99) * m(i,k)
         rate(i,k,100) = rate(i,k,100) * m(i,k)
         rate(i,k,101) = rate(i,k,101) * m(i,k)
         rate(i,k,102) = rate(i,k,102) * m(i,k)
         rate(i,k,103) = rate(i,k,103) * m(i,k)
         rate(i,k,104) = rate(i,k,104) * m(i,k)
         rate(i,k,105) = rate(i,k,105) * m(i,k)
         rate(i,k,106) = rate(i,k,106) * m(i,k)
         rate(i,k,107) = rate(i,k,107) * m(i,k)
         rate(i,k,108) = rate(i,k,108) * m(i,k)
         rate(i,k,109) = rate(i,k,109) * m(i,k)
         rate(i,k,110) = rate(i,k,110) * m(i,k)
         rate(i,k,111) = rate(i,k,111) * m(i,k)
         rate(i,k,112) = rate(i,k,112) * m(i,k)
         rate(i,k,113) = rate(i,k,113) * m(i,k)
         rate(i,k,114) = rate(i,k,114) * m(i,k)
         rate(i,k,115) = rate(i,k,115) * m(i,k)
         rate(i,k,116) = rate(i,k,116) * m(i,k)
         rate(i,k,117) = rate(i,k,117) * m(i,k)
         rate(i,k,118) = rate(i,k,118) * m(i,k)
         rate(i,k,119) = rate(i,k,119) * m(i,k)
         rate(i,k,121) = rate(i,k,121) * m(i,k)
         rate(i,k,122) = rate(i,k,122) * m(i,k)
         rate(i,k,123) = rate(i,k,123) * m(i,k)
         rate(i,k,124) = rate(i,k,124) * m(i,k)
         rate(i,k,125) = rate(i,k,125) * m(i,k)
         rate(i,k,126) = rate(i,k,126) * m(i,k)
         rate(i,k,127) = rate(i,k,127) * m(i,k)
         rate(i,k,128) = rate(i,k,128) * m(i,k)
         rate(i,k,130) = rate(i,k,130) * m(i,k)
         rate(i,k,131) = rate(i,k,131) * m(i,k)
         rate(i,k,132) = rate(i,k,132) * m(i,k)
         rate(i,k,133) = rate(i,k,133) * m(i,k)
         rate(i,k,134) = rate(i,k,134) * m(i,k)
         rate(i,k,135) = rate(i,k,135) * m(i,k)
         rate(i,k,136) = rate(i,k,136) * m(i,k)
         rate(i,k,137) = rate(i,k,137) * m(i,k)
         rate(i,k,138) = rate(i,k,138) * m(i,k)
         rate(i,k,139) = rate(i,k,139) * m(i,k)
         rate(i,k,140) = rate(i,k,140) * m(i,k)
         rate(i,k,141) = rate(i,k,141) * m(i,k)
         rate(i,k,142) = rate(i,k,142) * m(i,k)
         rate(i,k,143) = rate(i,k,143) * m(i,k)
         rate(i,k,144) = rate(i,k,144) * m(i,k)
         rate(i,k,145) = rate(i,k,145) * m(i,k)
         rate(i,k,146) = rate(i,k,146) * m(i,k)
         rate(i,k,147) = rate(i,k,147) * m(i,k)
         rate(i,k,148) = rate(i,k,148) * m(i,k)
         rate(i,k,149) = rate(i,k,149) * m(i,k)
         rate(i,k,150) = rate(i,k,150) * m(i,k)
         rate(i,k,151) = rate(i,k,151) * m(i,k)
         rate(i,k,152) = rate(i,k,152) * m(i,k)
         rate(i,k,153) = rate(i,k,153) * m(i,k)
         rate(i,k,154) = rate(i,k,154) * m(i,k)
         rate(i,k,155) = rate(i,k,155) * m(i,k)
         rate(i,k,156) = rate(i,k,156) * m(i,k)
         rate(i,k,157) = rate(i,k,157) * m(i,k)
         rate(i,k,158) = rate(i,k,158) * m(i,k)
         rate(i,k,159) = rate(i,k,159) * m(i,k)
         rate(i,k,160) = rate(i,k,160) * m(i,k)
         rate(i,k,161) = rate(i,k,161) * m(i,k)
         rate(i,k,162) = rate(i,k,162) * m(i,k)
         rate(i,k,163) = rate(i,k,163) * m(i,k)
         rate(i,k,164) = rate(i,k,164) * m(i,k)
         rate(i,k,165) = rate(i,k,165) * m(i,k)
         rate(i,k,166) = rate(i,k,166) * m(i,k)
         rate(i,k,167) = rate(i,k,167) * m(i,k)
         rate(i,k,168) = rate(i,k,168) * m(i,k)
         rate(i,k,169) = rate(i,k,169) * m(i,k)
         rate(i,k,170) = rate(i,k,170) * m(i,k)
         rate(i,k,171) = rate(i,k,171) * m(i,k)
         rate(i,k,173) = rate(i,k,173) * m(i,k)
         rate(i,k,174) = rate(i,k,174) * m(i,k)
         rate(i,k,175) = rate(i,k,175) * m(i,k)
         rate(i,k,176) = rate(i,k,176) * m(i,k)
         rate(i,k,177) = rate(i,k,177) * m(i,k)
         rate(i,k,178) = rate(i,k,178) * m(i,k)
         rate(i,k,179) = rate(i,k,179) * m(i,k)
         rate(i,k,180) = rate(i,k,180) * m(i,k)
         rate(i,k,181) = rate(i,k,181) * m(i,k)
         rate(i,k,182) = rate(i,k,182) * m(i,k)
         rate(i,k,183) = rate(i,k,183) * m(i,k)
         rate(i,k,184) = rate(i,k,184) * m(i,k)
         rate(i,k,185) = rate(i,k,185) * m(i,k)
         rate(i,k,186) = rate(i,k,186) * m(i,k)
         rate(i,k,187) = rate(i,k,187) * m(i,k)
         rate(i,k,188) = rate(i,k,188) * m(i,k)
         rate(i,k,189) = rate(i,k,189) * m(i,k)
         rate(i,k,190) = rate(i,k,190) * m(i,k)
         rate(i,k,191) = rate(i,k,191) * m(i,k)
         rate(i,k,192) = rate(i,k,192) * m(i,k)
         rate(i,k,193) = rate(i,k,193) * m(i,k)
         rate(i,k,194) = rate(i,k,194) * m(i,k)
         rate(i,k,195) = rate(i,k,195) * m(i,k)
         rate(i,k,196) = rate(i,k,196) * m(i,k)
         rate(i,k,197) = rate(i,k,197) * m(i,k)
         rate(i,k,198) = rate(i,k,198) * m(i,k)
         rate(i,k,199) = rate(i,k,199) * m(i,k)
         rate(i,k,200) = rate(i,k,200) * m(i,k)
         rate(i,k,201) = rate(i,k,201) * m(i,k)
         rate(i,k,205) = rate(i,k,205) * m(i,k)
         rate(i,k,206) = rate(i,k,206) * m(i,k)
         rate(i,k,207) = rate(i,k,207) * m(i,k)
         rate(i,k,210) = rate(i,k,210) * m(i,k)
         rate(i,k,211) = rate(i,k,211) * m(i,k)
         rate(i,k,216) = rate(i,k,216) * m(i,k)
         rate(i,k,217) = rate(i,k,217) * m(i,k)
         rate(i,k,218) = rate(i,k,218) * m(i,k)
         rate(i,k,219) = rate(i,k,219) * m(i,k)
         rate(i,k,221) = rate(i,k,221) * m(i,k)
         rate(i,k,222) = rate(i,k,222) * m(i,k)
         rate(i,k,223) = rate(i,k,223) * m(i,k)
         rate(i,k,224) = rate(i,k,224) * m(i,k)
         rate(i,k,225) = rate(i,k,225) * m(i,k)
         rate(i,k,226) = rate(i,k,226) * m(i,k)
         rate(i,k,227) = rate(i,k,227) * m(i,k)
         rate(i,k,229) = rate(i,k,229) * m(i,k)
         rate(i,k,230) = rate(i,k,230) * m(i,k)
         rate(i,k,231) = rate(i,k,231) * m(i,k)
         rate(i,k,232) = rate(i,k,232) * m(i,k)
!----
!wtw
!
!wtw         rate(i,k,233) = rate(i,k,233) * m(i,k)         ! similar to r202, r208, r213   
!wtw         rate(i,k,234) = rate(i,k,234) * m(i,k)      
!
         rate(i,k,235) = rate(i,k,235) * m(i,k)      
         rate(i,k,236) = rate(i,k,236) * m(i,k)      
         rate(i,k,237) = rate(i,k,237) * m(i,k)      
         rate(i,k,238) = rate(i,k,238) * m(i,k)      
         rate(i,k,239) = rate(i,k,239) * m(i,k)   
!wtw		    
!---------------
        enddo
      end do

      end subroutine adjrxt

end module bcc_adjrxt
