#include <misc.h>
#include <params.h>

 module bcc_const_mozart

      use shr_kind_mod,    only: r8 => shr_kind_r8
      use pmgrid,         only:  plon, plat   !add by zf 2008.03.11
      use physconst,      only : avogad, boltz
      implicit none

      save

      real(r8), parameter ::  gravit = 9.80616    ! m/s
      real(r8), parameter ::  rgrav  = 1./gravit
      real(r8), parameter ::  dayspy = 365.       ! days per year
      real(r8), parameter ::  rearth = 6.37122e6  ! radius earth (m)
!#ifdef BCCCHEM
      real(r8), parameter ::  avogadro  = avogad*1.e-3  ! Avogadro numb - molecules/mole
      real(r8), parameter ::  boltzmann = boltz*1.e7_r8 ! erg/k
!#endif
      real(r8), parameter ::  pi    = 3.1415926                  ! radians
      real(r8), parameter ::  twopi = 2.*pi             ! 2*pi (radians)
      real(r8), parameter ::  pid2  = .5*pi             ! pi/2 (radians)
      real(r8), parameter ::  r2d   = 180./pi           ! radians to degrees
      real(r8), parameter ::  d2r   = pi/180.           ! degrees to radians 
      real(r8), parameter ::  lat25 = d2r * 25.         ! 25 latitude (radians)
      real(r8), parameter ::  lat45 = d2r * 45.         ! 45 latitude (radians)
      real(r8), parameter ::  lat59 = d2r * 59.         ! 59 latitude (radians)
      real(r8), parameter ::  lat60 = d2r * 60.         ! 60 latitude (radians)
      real(r8), parameter ::  lat70 = d2r * 70.         ! 70 latitude (radians)
      real(r8) ::  phi(plat)          ! latitudes (radians)
      real(r8) ::  lam(plon)          ! longitudes( radians )
      real(r8) ::  sinlam(plon)       ! sine of longitudes
      real(r8) ::  coslam(plon)       ! cose of longitudes

!     integer ::  ktop                !add by zf 2008.07.11

 end module bcc_const_mozart
