#include <misc.h>
#include <params.h>

module bcc_jpl
      use shr_kind_mod, only : r8 => shr_kind_r8 
      use ppgrid,        only: pcols

      private
      public :: jpl

      contains

      subroutine jpl( rate, m, factor, ko, kinf, ncol )
!-----------------------------------------------------------------
!        ... Calculate JPL troe rate
!-----------------------------------------------------------------
      
      use shr_kind_mod, only : r8 => shr_kind_r8

      implicit none

!-----------------------------------------------------------------
!        ... Dummy args
!-----------------------------------------------------------------
      integer, intent(in)   ::   ncol
      real(r8), intent(in)  ::   factor
      real(r8), intent(in)  ::   ko(pcols)
      real(r8), intent(in)  ::   kinf(pcols)
      real(r8), intent(in)  ::   m(pcols)
      real(r8), intent(out) ::   rate(pcols)

!-----------------------------------------------------------------
!        ... Local variables
!-----------------------------------------------------------------
      real(r8)  ::  xpo(pcols)

      xpo(:)  = ko(:) * m(:) / kinf(:)
      rate(:) = ko(:) / (1._r8 + xpo(:))
      xpo(:)  = log10( xpo(:) )
      xpo(:)  = 1._r8 / (1._r8 + xpo(:)*xpo(:))
      rate(:) = rate(:) * factor**xpo(:)

      end subroutine jpl

end module bcc_jpl
