#include <misc.h>
#include <params.h>

module bcc_surf_nature_emis

  implicit none

  public :: surf_nature_emis

contains

   subroutine surf_nature_emis (lchnk, ncol, sflx, q, pdel, qtend, lq) 

    use shr_kind_mod,         only : r8 => shr_kind_r8
    use ppgrid,               only : pcols, pver
    use constituents,         only : ppcnst
    use physconst,            only : gravit
    use bcc_chem_mods,        only : map2chm
    !-----------------------------------------------------------------------
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Arguments:
    !
    integer,  intent(in) :: ncol, lchnk
    real(r8), intent(in) :: sflx(pcols, ppcnst) 
    real(r8), intent(in) :: q(pcols,pver, ppcnst)        ! temperature (K)
    real(r8), intent(in) :: pdel(pcols,pver)             ! pressure difference across layers
    real(r8), intent(inout) :: qtend(pcols,pver,ppcnst)  ! fraction of transported species that are insoluble
    logical,  intent(inout) :: lq(ppcnst) 
    !
    ! Local variables
    !
    integer :: m,n
!------------------------------------------------------------------------------
    do m = 1,ppcnst
       lq(m) = .TRUE.
       qtend(:ncol,pver,m) = qtend(:ncol,pver,m) + sflx(:ncol,m)/pdel(:ncol,pver)*gravit
    end do  
    return
    end subroutine surf_nature_emis

end module bcc_surf_nature_emis
