#ifdef DOC

!     *****************************************************************

!           CONSIDERATION OF MIXED PHASES

!     *****************************************************************

!     FOEALFA is calculated to distinguish the three cases:

!                       FOEALFA=1            water phase
!                       FOEALFA=0            ice phase
!                       0 < FOEALFA < 1      mixed phase

!               INPUT : PTARE = TEMPERATURE
#endif
      REAL  ::  PTARE
      REAL  :: FOEALFA 
      FOEALFA (PTARE) = MIN(1.,((MAX(RTICE,MIN(RTWAT,PTARE))-RTICE)     &
       /(RTWAT-RTICE))**2) 

#ifdef DOC

!     Pressure of water vapour at saturation
!        INPUT : PTARE = TEMPERATURE
#endif
      REAL :: FOEEWM,FOEDEM,FOELDCPM,FOELHM

      FOEEWM ( PTARE ) = R2ES *                                         &
            (FOEALFA(PTARE)*EXP(R3LES*(PTARE-RTT)/(PTARE-R4LES))+       &
         (1.-FOEALFA(PTARE))*EXP(R3IES*(PTARE-RTT)/(PTARE-R4IES)))  

      FOEDEM ( PTARE ) = FOEALFA(PTARE)*R5ALVCP*(1./(PTARE-R4LES)**2)+  &
                   (1.-FOEALFA(PTARE))*R5ALSCP*(1./(PTARE-R4IES)**2)

      FOELDCPM ( PTARE ) = FOEALFA(PTARE)*RALVDCP+                      &
                  (1.-FOEALFA(PTARE))*RALSDCP

      FOELHM ( PTARE ) =                                                &
               FOEALFA(PTARE)*RLVTT+(1.-FOEALFA(PTARE))*RLSTT
!     ------------------------------------------------------------------
