      SUBROUTINE GETAGO(GGPAK,NPACK,NAME,NF,NLON,NLAT,NL,IDAY,GG)
C
C     * MAY 21/97 - S. GONG   - VARIABLE LEVEL
C     * SEP 27/92 - M.LAZARE. - MAXX NOW INCLUDES "MACHINE" FACTOR.
C     * SEP 21/88 - M.LAZARE. - MAX DEFINED EXPLICITLY IN SUBROUTINE. 
C     * JAN 04/84 - R.LAPRISE, J.D.HENDERSON. 
C
C     * GETS GAUSSIAN GRID GG(NLON,NLAT) CALLED NAME FROM FILE NF.
C     * AND PACKS IT INTO ARRAY GGPAK WITH PACKING DENSITY NPACK. 
C     * THE LAST POINT IN EACH ROW IS OMITTED SINCE IT IS 
C     *  JUST A COPY OF THE FIRST POINT IN THE ROW. 
C     * IDAY IS THE DAY OF THE YEAR.
C 
      REAL GGPAK(1),GG(NLON,NLAT)
      LOGICAL OK
C 
C     * ICOM IS A SHARED SCM I/O AREA. IT MUST BE LARGE ENOUGH
C     * FOR AN 8 WORD LABEL FOLLOWED BY A PACKED GAUSSIAN GRID. 
C 
      COMMON /ICOM/ IBUF(8),IDAT(1) 
      COMMON /MACHTYP/ MACHINE, INTSIZE
      COMMON /MPILAT/ ILAT
C-----------------------------------------------------------------------
C     * REWIND THE FILE AND READ THE FIELD. 
C     * STOP IF NOT FOUND OR WRONG SIZE IS READ.
C 
      MAXX=( NLON*NLAT + 8 )*MACHINE
      CALL GETFLD2(NF,GG,NC4TO8("GRID"),IDAY,NAME,NL,IBUF,MAXX,OK)
      IF(.NOT.OK) GO TO 900 
      WRITE(6,6025) IBUF
      IF(IBUF(5).NE.NLON) GO TO 900 
      IF(IBUF(6).NE.NLAT) GO TO 900 
C
C     * CONVERT TO ORDERED S-N PAIRS.
C
      CALL RGTOCG2(GGPAK,GG,NLON-1,NLAT,ILAT)

      RETURN
C 
C     * ERROR EXIT - STOP IF GRID MISSING OR WRONG SIZE.
C 
  900 WRITE(6,6020) IDAY,NAME,NLON,NLAT 
      WRITE(6,6025) IBUF
      CALL XIT('GETAGO ',-1) 
C-----------------------------------------------------------------------
 6020 FORMAT('0 GRID',I10,1X,A4,5X,'SIZE',2I6,5X,'NOT FOUND') 
 6025 FORMAT(' ',A4,I10,1X,A4,5I6)
 6030 FORMAT('+',55X,A4,' BIAS =',1PE12.4)
      END  
