!
! Tranfer the grapes binary initial data to NetCdf format
! The description of the variables should be completed
! wzz, 2007.07.13
! compute the monthly mean, and vertical interpolation to
! BCCAM model
! wzz, 2008.9.22
!
  implicit none
!
#include <netcdf.inc>
!
  integer, parameter :: ids=1, ide=128
  integer, parameter :: jds=1, jde=64
  integer, parameter :: kms=1, kme=32
  integer, parameter :: pver  = 26
! integer, parameter :: month = 1
  integer, parameter :: num_soil_layers=5   ! aerosol types
!
  real, allocatable, dimension(:,:,:) :: ain, aout, ainm
  real, allocatable, dimension(:,:)   :: ain2d
  real, allocatable, dimension(:)     :: ain1d
  real, allocatable, dimension(:)     :: alon, alat, alev, hyam, hybm
  real, allocatable, dimension(:,:)   :: pmid 
  real, allocatable, dimension(:,:,:) :: pscam
!
  integer month
  integer, dimension(5)               :: mdate
  integer date(12), datek, monday(12)
  integer                             :: fid
  integer :: i, j, k, l, jdf
  character :: filname*256, unit*256, name*256
  logical :: global_opt = .true.
!
  integer :: nlon, nlat, nlev, luc, nsoil, nsand, nclay
  integer :: status, ncid
  integer :: LONID, LATID, LEVID, TIMEID, NSOILID, NLUCID, &
             NSLID, NSDID, NCYID, LEVAID
  integer :: dim4_id(4)
  integer :: start2w(4), count2w(4)
  integer :: varid_LON, varid_LAT, varid_LEV, varid_TIME, varid_NS
  integer :: varid
  real    :: sig(32)
  real    :: p0
!
  data monday/31,28,31,30,31,30,31,31,30,31,30,31/
  data date/18700115,18700214,18700315,18700415,18700515,18700615,  &
            18700715,18700815,18700915,18701015,18701115,18701215/
  data sig/0.1E-3, 0.294E-3, 0.6E-3, 0.12, 0.23, 0.41, 0.68, 0.104, &
           0.148, 0.197, 0.261, 0.329, 0.398, 0.466, 0.531, 0.592, &
           0.648, 0.698, 0.742, 0.780, 0.813, 0.841, 0.865, 0.885, &
           0.902, 0.916, 0.930, 0.944, 0.958, 0.972, 0.986, 0.995/ 


   jdf = jde
!   IF (global_opt) jdf = jde-1

   nlon = ide-ids+1
   nlat = jdf-jds+1
   nlev = kme-kms+1
   luc  = 15; nsoil=12; nsand=6; nclay=2
   allocate (alon(nlon) )
   allocate (alat(nlat) )
!
   allocate (alev(pver) )
   allocate (hyam(pver) )
   allocate (hybm(pver) )
   allocate (pscam(nlon,nlat,12) )
   allocate (aout(nlon,nlat,pver) )
   allocate (pmid(nlon,pver) )
!
   p0 = 1.e5
!
   mdate(1) = 1985
   mdate(2) = 1
!  mdate(2) = month
   mdate(3) = 1
   mdate(4) = 0
   mdate(5) = 0
!   READ(fid) mdate
   write(*,*)'mdate = ', mdate
!
   filname = 'oxid_3d_64x128_L26_c030722.nc'
   status = NF_OPEN(filname, NF_NOWRITE,ncid)
   status = nf_inq_varid (ncid, 'lon', varid)
   status = nf_get_var_real (ncid, varid, alon)
   status = nf_inq_varid (ncid, 'lat', varid)
   status = nf_get_var_real (ncid, varid, alat)
   status = nf_inq_varid (ncid, 'hyam', varid)
   status = nf_get_var_real (ncid, varid, hyam)
   status = nf_inq_varid (ncid, 'hybm', varid)
   status = nf_get_var_real (ncid, varid, hybm)
   status = nf_inq_varid (ncid, 'lev', varid)
   status = nf_get_var_real (ncid, varid, alev)
   status = nf_inq_varid (ncid, 'PS', varid)
   status = nf_get_var_real (ncid, varid, pscam)
   status = nf_close(ncid)
!
   filname = 'mozartdat'
   status=nf_create(trim(filname)//'.nc', nf_clobber, ncid)
   if (status .NE. nf_noerr) call handerr(status)
   write(*,*) 'A NetCDF file is created, and its ID is => ', ncid
!... begin to define your dimentions
   status=nf_def_dim(ncid, 'lon', nlon, LONID)
   if (status .NE. nf_noerr) call handerr(status)

   status=nf_def_dim(ncid, 'lat', nlat, LATID)
   if (status .NE. nf_noerr) call handerr(status)

   status=nf_def_dim(ncid, 'lev',pver, LEVID)
   if (status .NE. nf_noerr) call handerr(status)

   status=nf_def_dim(ncid, 'time',nf_unlimited, TIMEID)
   if (status .NE. nf_noerr) call handerr(status)

   write(*,*) 'define the dimentions lon,lat,lev,   &
   &      and time, the ID is => ',LONID,LATID,LEVID,TIMEID

!... Put the attribute of your variables
      name = 'longitude'
      unit = 'degrees_east'
      call wrap_def_var (ncid, 'lon',nf_real, 1,LONID, varid, &
     &                   name, unit)
!
      name = 'latitude'
      unit = 'degrees_north'
      call wrap_def_var (ncid, 'lat',nf_real, 1,LATID, varid, &
     &                   name, unit)
!
      name = 'sigma level at midpoints (1000*(Sig))'
      unit = 'hPa'
      call wrap_def_var (ncid, 'lev',nf_real, 1,LEVID, varid, &
     &                   name, unit)
      status = nf_put_att_text (ncid,varid,'positive',4,'down')
!
      name = 'time'
      unit = 'days since 0001-01-01 00:00:00'
      write(unit(12:15),'(i4.4)') mdate(1)
      write(unit(17:18),'(i2.2)') mdate(2)
      write(unit(20:21),'(i2.2)') mdate(3)
      write(unit(23:24),'(i2.2)') mdate(4)
      call wrap_def_var (ncid, 'time',nf_double, 1,TIMEID, varid, &
     &                   name, unit)
!
      status=nf_put_att_text(ncid, nf_global, 'long_name', &
      27, 'BCC_AGCM aerosol input data')
      status=nf_put_att_text(ncid, nf_global, 'host', &
      7, 'wangzzh')
      status=nf_put_att_text(ncid, nf_global, 'source', &
      53, 'transfered from the unformatted data: mozart128x64.01')
      status=nf_put_att_text(ncid, nf_global, 'title', &
      9, 'BCC_AGCM2')
      if (status .NE. nf_noerr) call handerr(status)
!
      name = 'date as 8 digit integer (YYYYMMDD)'
      unit = '-'
      call wrap_def_var (ncid, 'date',nf_int, 1,TIMEID, varid, &
     &                   name, unit)
!
! define atm 3-d data
      dim4_id(1) = lonid
      dim4_id(2) = latid
      dim4_id(3) = LEVID
      dim4_id(4) = timeid
!
      name = 'OH monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'OH',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
      name = 'H2O2 monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'H2O2',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
      name = 'O3 monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'O3',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
      name = 'NO3 monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'NO3',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
      name = 'HNO3 monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'HNO3',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
      name = 'NH3 monthly input' 
      unit = '-'
      call wrap_def_var (ncid, 'NH3',nf_real, 4,dim4_id, varid, &
     &                   name, unit)
!
!
!... end of define mode (this function is must be used)
      status=nf_enddef(ncid)
      if (status .NE. nf_noerr) call handerr(status)
      print *, 'end_define'
!
!  do k = 1, monday(month)
   k = monday(1)/2
   do month = 1, 12
      status = nf_inq_varid (ncid, 'time',varid)
      status = nf_put_vara_double (ncid, varid, month, 1 , dble(k-1) )
!
      status = nf_inq_varid (ncid, 'date',varid)
      datek = 19850000+month*100
      datek = datek+15
      status = nf_put_vara_int (ncid, varid, month, 1 , datek )
!     status = nf_put_vara_int (ncid, varid, k, 1 , date(k) )
      k = k+monday(month)
   enddo
   status = nf_inq_varid (ncid, 'lon', varid)
   status = nf_put_var_real (ncid, varid, alon)
   status = nf_inq_varid (ncid, 'lat', varid)
   status = nf_put_var_real (ncid, varid, alat)
!  alev = 1000.*sig
   status = nf_inq_varid (ncid, 'lev', varid)
   status = nf_put_var_real (ncid, varid, alev)

! now write the data
!
   fid = 10
!
   allocate (ain(nlon+1,nlat,nlev) )
   allocate (ainm(nlon,nlat,nlev) )
!
   start2w = 1
   count2w(1)=nlon; count2w(2)=nlat; count2w(3) = pver; count2w(4) = 1
!
   filname = 'chem01.dat'
   do month = 1, 12
   write(filname(5:6), '(i2.2)') month
   open(fid, file=trim(filname), status='old', form='unformatted', &
         action='read')
   start2w(4) = month
!
   ainm = 0.0
   do k = 1, monday(month)
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
      ainm = ainm + ain(1:nlon,:,:)
   enddo
   ainm = ainm/monday(month)
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ainm(:,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'OH',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
!
   ainm = 0.0
   do k = 1, monday(month)
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
      ainm = ainm + ain(1:nlon,:,:)
   enddo
   ainm = ainm/monday(month)
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ainm(:,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'H2O2',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
!
   ainm = 0.0
   do k = 1, monday(month)
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
      ainm = ainm + ain(1:nlon,:,:)
   enddo
   ainm = ainm/monday(month)
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ainm(:,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'O3',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
!
   ainm = 0.0
   do k = 1, monday(month)
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
      ainm = ainm + ain(1:nlon,:,:)
   enddo
   ainm = ainm/monday(month)
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ainm(:,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'NO3',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
!
   ainm = 0.0
   do k = 1, monday(month)
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
      ainm = ainm + ain(1:nlon,:,:)
   enddo
   ainm = ainm/monday(month)
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ainm(:,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'HNO3',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
!
   close(fid)
   enddo
!
   filname = 'chem.dat'    ! 
   open(fid, file=trim(filname), status='old', form='unformatted', &
         action='read')
! pass the emission data first
   do month = 1, 12
      read(fid)ain(:,:,1)  ! ODFLX
   enddo
   do month = 1, 12
      do j = 1, 5
      read(fid)ain(:,:,1)  ! BCFLX
      enddo
   enddo
   do j = 1, 5
      read(fid)ain(:,:,1)  ! BCHIT
   enddo
   do month = 1, 12
      do j = 1, 5
      read(fid)ain(:,:,1)  ! OCFLX
      enddo
   enddo
   do j = 1, 5
      read(fid)ain(:,:,1)  ! OCHIT
   enddo
   do month = 1, 4
      read(fid)ain(:,:,1)  ! H2SFLX
      read(fid)ain(:,:,1)  ! LDMFLX
      read(fid)ain(:,:,1)  ! PSO2FLX
      read(fid)ain(:,:,1)  ! ASO2FLX
      read(fid)ain(:,:,1)  ! PSO4FLX
      read(fid)ain(:,:,1)  ! ASO4FLX
      read(fid)ain(:,:,1)  ! PNO2FLX
      read(fid)ain(:,:,1)  ! ANO2FLX
      read(fid)ain(:,:,1)  ! PNOFLX
      read(fid)ain(:,:,1)  ! ANOFLX
   enddo
!
! read NH3 now
   do month = 1, 12
   start2w(4) = month
      do j = 1, nlev
      read(fid)ain(:,:,j)
      enddo
! vertical interpolate
   do j = 1, nlat
   do k =1, pver
   pmid(:,k) = pscam(:,j,month)*hybm(k)+p0*hyam(k)
   enddo
   call  vert_interpolate (pscam(:,j,month), sig, pmid, aout(:,j,:), ain(1:nlon,j,:), &
                           nlon, nlon, 1, nlev, pver)
   enddo
! output the data
   status = nf_inq_varid (ncid, 'NH3',varid)
   call wrap_put_vara_gcm (ncid, varid, start2w, count2w, aout(1:nlon, :,:))
   enddo
   close(fid)
!
   deallocate (ain, ainm)
   deallocate (aout)
!
!... close the nc file..
   status=nf_close(ncid)
   if (status .NE. nf_noerr) call handerr(status)
   stop
999 continue
!
   end
!
      subroutine wrap_def_var (nfid, var, dtype, ndims, dimid, &
     &                         varid, name, unit)
     implicit none
#include <netcdf.inc>

      integer nfid, dtype, ndims
      integer dimid(*)
      character*(*) var, name, unit
      integer varid
      integer ret, lenth
!      integer lenstring
!
      ret = nf_def_var (nfid, var, dtype, ndims, dimid, varid)
      if (ret.ne.NF_NOERR) call handerr (ret)
!
      lenth = len_trim(name)
      if ( lenth.gt.0 ) then
         ret = nf_put_att_text (nfid,varid,'long_name', lenth, name)
         if (ret.ne.NF_NOERR) call handerr (ret)
      endif
      lenth = len_trim(unit)
      if ( lenth.gt.0 ) then
         ret = nf_put_att_text (nfid,varid,'units' ,lenth, unit)
         if (ret.ne.NF_NOERR) call handerr (ret)
      endif
!
      end
!
      subroutine wrap_put_vara_gcm (nfid, varid, start,count,arr)
      implicit none
#include <netcdf.inc>

      integer nfid, varid
      integer start(*), count(*)
      real arr(*)

      integer ret
!#if (REALTYP == 0 )
      ret = nf_put_vara_real (nfid, varid,start,count, arr)
!#endif
!#if (REALTYP == 1 )
!      ret = nf_put_vara_double (nfid, varid, start,count,arr)
!#endif
      if (ret.ne.NF_NOERR) call handerr (ret)
      end
!

!... Make the error control program!
        subroutine handerr(status)

        implicit none
!... include the usefully NetCDF include file
#include <netcdf.inc>

        integer status

        if (status .NE. nf_noerr) then
        write(*,*) NF_STRERROR(status), status
        stop 'program stoped, and you must find   &
     & the error in your source code.'
        endif
        end

subroutine vert_interpolate (Match_ps, sigp, pmid, AEROSOL, AEROSOLc, &
                             pcols, ncol, naer, nlev, pver)
!--------------------------------------------------------------------
! Input: match surface pressure, cam interface pressure, 
!        month index, number of columns, chunk index
! 
! Output: Aerosol mass mixing ratio (AEROSOL)
!
! Method:
!         interpolate column mass (cumulative) from match onto
!           bccam's vertical grid (pressure coordinate)
!         convert back to mass mixing ratio
!
!--------------------------------------------------------------------

!  use physconst,     only: gravit

   integer, intent(in) :: ncol                            ! chunk index and number of columns
   integer, intent(in) :: pcols, nlev, pver
   integer, intent(in) :: naer                            ! number of species.

   real, intent(in) :: Match_ps(pcols), sigp(nlev)    ! surface pressure at a particular month
   real, intent(in) :: pmid(pcols,pver)               ! mid-point pressure from CAM

   real, intent(in) :: AEROSOLc(pcols,nlev,naer)      ! aerosol mmr from CAM
   real, intent(out) :: AEROSOL(pcols,pver,naer)      ! aerosol mmr from MATCH
!  AEROSOLc is:
!  Cumulative Mass at midpoint of each month
!    on BCCAM's horizontal grid (col)
!    on MATCH's levels (nlev)
!
! Local workspace
!
   integer m                           ! index to aerosol species
   integer kupper(pcols)               ! last upper bound for interpolation
   integer i, k, kk, kkstart, kount    ! loop vars for interpolation
   integer isv, ksv, msv               ! loop indices to save

   logical bad                         ! indicates a bad point found
   logical lev_interp_comp             ! interpolation completed for a level 
   logical error_found

   real dpl, dpu                   ! lower and upper intepolation factors
   real v_coord                    ! vertical coordinate
!  real(r8) m_to_mmr                   ! mass to mass mixing ratio conversion factor
!  real(r8) AER_diff                   ! temp var for difference between aerosol masses

!
! Initialize index array 
!
   do i=1,ncol
      kupper(i) = 1
   end do
!
! At every pressure level, interpolate onto that pressure level
!
   do k=1,pver
!
! Top level we need to start looking is the top level for the previous k
! for all longitude points
!
      kkstart = nlev
      do i=1,ncol
         kkstart = min0(kkstart,kupper(i))
      end do
      kount = 0
!
! Store level indices for interpolation
!
! for the pressure interpolation should be comparing
! pmid(column,lev) with sigp(lev)*M_ps_cam_col(month,column,chunk)
!
      lev_interp_comp = .false.
      do kk=kkstart,nlev-1
         if(.not.lev_interp_comp) then
         do i=1,ncol
            v_coord = pmid(i,k)
            if (sigp(kk)*Match_ps(i) .lt. v_coord .and. v_coord .le. sigp(kk+1)*Match_ps(i)) then
               kupper(i) = kk
               kount = kount + 1
            end if
         end do
!
! If all indices for this level have been found, do the interpolation and
! go to the next level
!
! Interpolate in pressure.
!
         if (kount.eq.ncol) then
            do m=1,naer
               do i=1,ncol
                  dpu = pmid(i,k) - sigp(kupper(i))*Match_ps(i)
                  dpl = sigp(kupper(i)+1)*Match_ps(i) - pmid(i,k)
                  AEROSOL(i,k,m) = &
                     (AEROSOLc(i,kupper(i)  ,m)*dpl + &
                     AEROSOLc(i,kupper(i)+1,m)*dpu)/(dpl + dpu)
               enddo !i
            end do
            lev_interp_comp = .true.
         end if
         end if
      end do
!
! If we've fallen through the kk=1,levsiz-1 loop, we cannot interpolate and
! must extrapolate from the bottom or top pressure level for at least some
! of the longitude points.
!

      if(.not.lev_interp_comp) then
         do m=1,naer
            do i=1,ncol
               if (pmid(i,k) .lt. sigp(1)*Match_ps(i)) then
                  AEROSOL(i,k,m) =  AEROSOLc(i,1,m)
               else if (pmid(i,k) .gt. sigp(nlev)*Match_ps(i)) then
                  AEROSOL(i,k,m) = AEROSOLc(i,nlev,m)
               else
                  dpu = pmid(i,k) - sigp(kupper(i))*Match_ps(i)
                  dpl = sigp(kupper(i)+1)*Match_ps(i) - pmid(i,k)
                  AEROSOL(i,k,m) = &
                     (AEROSOLc(i,kupper(i)  ,m)*dpl + &
                     AEROSOLc(i,kupper(i)+1,m)*dpu)/(dpl + dpu)
               end if
            end do
         end do

         if (kount.gt.ncol) then
            write(*,*)'VERT_INTERPOLATE: Bad data: non-monotonicity suspected in dependent variable'
            stop
!           call endrun ('VERT_INTERPOLATE: Bad data: non-monotonicity suspected in dependent variable')
         end if
      end if
   end do

!
! Set mass in layer to zero whenever it is less than 
!   1.e-40 kg/m^2 in the layer
!
   do m = 1, naer
      do k = 1, pver
         do i = 1, ncol
            if (AEROSOL(i,k,m) < 1.e-40) AEROSOL(i,k,m) = 0.
         end do
      end do
   end do
!

end subroutine vert_interpolate

