#include "phy_macros_f.h"
      subroutine aero_chem_cam(dt,trnch,kount,ni,nk, IL1, IL2,  &
     &                         aero_tr,fn_aerochem, npg,        &
     &                         tt,hu,psfc,sig,hght,surfwd,      &
     &              fws,fmodv,flwc,ftsoil,                      &
     &             ice,snow,par,chem_land,fn_luc,frdz,ftv,deglat,deglon, &
     &              tcsza, csza,grcld_ck,grcld_cs,  &
     &              mu,eu,du,md,mc,ed,              &
     &              dp,mb,eps0,zfg,dsubcld,ideep,jt,maxg,jd,lengath,  &
     &              fkt,fhs,uu,vv,PRETROW,         &
     &              cld_fn,GC1,IDAY,ROAROW,RHROW,  &
     &              ZFPREC, WPEVPA, WRSCAV, cflx, fracis,modx)


!     subroutine aero_chem_cam(dt,trnch,kount,ni,nk,
!    $                         aero_tr,fn_aerochem,
!    $                         aero_diags,fn_aerodiags,
!    $                         tt,hu,psfc,sig,hght,surfwd,
!    $              fws,fmodv,flwc,ftsoil,
!    $             ice,snow,par,chem_land,fn_luc,frdz,ftv,deglat,deglon,
!    $              csza,grcld_ck,grcld_cs,
!    $              fkt,fhs,uu,vv,PBLTROW,PRETROW,
!    $              cld_fn,GC1,IDAY,ROAROW,RHROW)

      implicit none

      real, intent(in) :: dt
      integer, intent(in) :: npg    ! the prognostic variable numbers
      integer, intent(in) :: fn_aerochem,trnch,kount,ni,nk,fn_luc 
      INTEGER, intent(in) :: IL1,IL2
      real,    intent(in) :: ZFPREC(ni,nk-1), WPEVPA(ni,nk-1), WRSCAV(ni,nk-1)
      integer, intent(in) :: modx
      real aero_tr(ni,nk,fn_aerochem)
      real tt(ni,nk), hu(ni,nk),psfc(ni),sig(ni,nk)
      real hght(ni,nk),surfwd(ni)
      real fws(ni,nk),fmodv(ni,nk),flwc(ni,nk) ,ftsoil(ni)
      real ice(ni),snow(ni),par(ni),chem_land(ni,fn_luc),frdz(ni,nk)
      real ftv(ni,nk),deglat(ni),deglon(ni)
      real, intent(in) :: tcsza(ni), csza(ni),grcld_ck(ni,nk),grcld_cs(ni,nk)
      integer status,i,l,fsiz
      real fkt(ni,nk),fhs(ni),uu(ni,nk),vv(ni,nk),GC1(ni)

!      REAL PBLTROW(ni)
      INTEGER K,MSG,IDAY
      REAL PRETROW(ni,nk-1,2)
      REAL cld_fn(ni,nk),RHROW(NI,NK),ROAROW(ni,nk-1)
! for emissions, wzz, 2008.2.13
      REAL cflx(ni, fn_aerochem)
      REAL ASO2ROW(ni), ASO4ROW(ni), PSO2ROW(ni), PSO4ROW(ni)
      REAL DMSOROW(ni), DMSLROW(ni), H2SROW(ni)
      REAL BLCROW(ni,5,2), OMCROW(ni,5,2)
      REAL SAND2ROW(ni,12),  CLAY2ROW(ni,2), SAND6ROW(ni,6)

      real fracis(ni,nk-1,npg)    ! fraction of transported species that are insoluble

! local variables
      real mu(ni, nk-1), eu(ni,nk-1), du(ni,nk-1)
      real md(ni, nk-1), mc(ni,nk-1), ed(ni,nk-1)
      real dp(ni, nk-1)
      real zfg(ni,nk)
      real mb(ni), eps0(ni), dsubcld(ni)
      integer ideep(ni), jt(ni), maxg(ni), jd(ni)
      integer lengath

      AUTOMATIC (SHJ, real, (NI,NK-1))
      AUTOMATIC (SHTJ, real, (NI,NK))
      AUTOMATIC (DSHJ, real, (NI,NK-1))
      AUTOMATIC (TFROW, real, (NI,NK))
      AUTOMATIC (DZ, real, (NI,NK-1))
      AUTOMATIC (UTENDGW, real, (NI,NK-1))
      AUTOMATIC (VTENDGW, real, (NI,NK-1))

!#include "chem_conv_point.cdk"
#include "aero_chem_order_cam9.cdk"
!#include "chem_conv.cdk"
       call chem_setreal(SHJ,0.,NI*(NK-1))
       call chem_setreal(SHTJ,0.,NI*NK)
       call chem_setreal(DSHJ,0.,NI*(NK-1))
       call chem_setreal(UTENDGW,0.,NI*(NK-1))
       call chem_setreal(VTENDGW,0.,NI*(NK-1))
       call chem_setreal(DZ,0.,NI*(NK-1))
       call chem_setreal(TFROW,0.,NI*NK)
!
      DO I=1, NI
        DO  K=1,NK
          SHTJ(I,K)=sig(i,k)
          TFROW(I,K)=tt(i,k)
        END DO
        SHTJ(I,1)=AMAX1(SHTJ(I,1),0.0003)
        DO K=1,NK-1
          SHJ(I,K)=(SHTJ(I,K)+SHTJ(I,K+1))*0.5
          DSHJ(I,K)=SHTJ(I,K+1)-SHTJ(I,K)
        END DO
      END DO
!
!     if ( trnch .eq. 193) then
!      write(0,*)'wzz: aero 20 =', aero_tr(2,nk,49)
!     endif

      CALL CONV_POINT (nk-1,nk,ni,gn_aerochem)
!      CALL CONV_POINT (nk-1,nk,ni,fn_aerochem)

      MSG=0
      MSG=4      ! from ZM scheme. wzz, 2008.9.9

!       call aero_chem_conv (psfc,tt,hu,
!    $                       dt,ni,nk,trnch,kount,
!    &                  fn_aerochem,aerochem_np,aero_tr,UU,VV,PBLTROW,
!    &                  UTENDGW,VTENDGW,IL1,IL2,MSG,
!    &             SHJ,SHTJ,DSHJ,aero_chem_loc,cncaSO2,cncaSO4,cncaH2O2,
!    $              mu,eu,du,md,mc,ed,
!    $              dp,mb,eps0,zfg,dsubcld,ideep,jt,maxg,jd,lengath,
!    &                  DZ,PRETROW,TFROW)
!     if ( trnch .eq. 193) then
!      write(0,*)'wzz: aero 21 =', aero_tr(2,nk,49), MSG, nk, lengath,zfg(2,nk+1)
!     endif
      if(modx .eq. 1 ) then
      DO K=MSG+1,NK-1                                    !cam_conv
      DO I=1,lengath
        DZ(I,K)=ZFG(I,K)-ZFG(I,K+1)
      ENDDO
      ENDDO
      endif


!     if ( trnch .eq. 193) then
!      write(0,*)'wzz: aero 22 =', aero_tr(2,nk,49),aero_tr(2,nk,13)
!     endif

      call aeroexe1(dt,trnch,kount,ni,nk,  &
     &                         aero_tr,fn_aerochem, npg,  &
     &                         tt,hu,psfc,sig,hght,surfwd,  &
     &              fws,fmodv,flwc,ftsoil,  &
     &             ice,snow,par,chem_land,fn_luc,frdz,ftv,deglat,deglon,  &
     &              tcsza, csza,grcld_cs,grcld_ck,  &
     &              mu,eu,du,md,mc,ed,  &
     &              dp,mb,eps0,zfg,dsubcld,ideep,jt,maxg,jd,lengath,  &
     &              fkt,fhs,uu,vv,SHJ,SHTJ,DSHJ,IL1,IL2,  &
     &               MSG,DZ,PRETROW,TFROW,cld_fn,GC1,IDAY,RHROW,  &
     &              ROAROW, ZFPREC, WPEVPA, WRSCAV, &
     &              cflx, fracis, modx)
                    
!     if ( trnch .eq. 193) then
!      write(0,*)'wzz: aero 22 =', aero_tr(2,nk,12),aero_tr(2,nk,13)
!     endif
      return
      end
