#include "phy_macros_f.h"

      subroutine aero_chem_conv(psfc,tt,hu,  &
     &                          frdt,ni,nk,trnch,kount,  &
     &                  NTRAC,ITRAC,XROW,UROW,VROW,PBLTROW,  &
     &                  UTENDGW,VTENDGW,IL1,IL2,MSG,  &
     &                  SHJ,SHTJ,DSHJ,aero_chem_loc,ISO2,ISO4,IHPO,  &
     &              mu,eu,du,md,mc,ed,  &
     &              dp,mb,eps0,zfg,dsubcld,ideep,jt,maxg,jd,lengath,  &
     &                  DZ,PRETROW,TFROW)

#include "impnone.cdk"

      integer ni,nk,trnch,kount
      real tt(ni,nk), hu(ni,nk),psfc(ni)
      real frdt

#include "chem_nml_vars9.cdk"

!#include "chem_conv.cdk"

!   -------------------------------------------------------P
      INTEGER IL1,IL2,ILG,ILEV,NTRAC,MSG,ISO2,ISO4,IHPO
      INTEGER aero_chem_loc(NTRAC)

      REAL XROW(ni,nk,NTRAC),UROW(ni,nk-1),VROW(ni,nk-1),PBLTROW(ni)
      REAL TFROW(ni,nk),DSHJ(ni,nk-1),SHJ(ni,nk-1),SHTJ(ni,nk)
      REAL UTENDGW(ni,nk-1),VTENDGW(ni,nk-1)
      REAL DZ(ni,nk-1), PRETROW(ni,nk-1,2)
      real mu(ni, nk-1), eu(ni,nk-1), du(ni,nk-1)
      real md(ni, nk-1), mc(ni,nk-1), ed(ni,nk-1)
      real dp(ni, nk-1)
      real zfg(ni,nk)
      real mb(ni), eps0(ni), dsubcld(ni)
      integer ideep(ni), jt(ni), maxg(ni), jd(ni)
      integer lengath
#include "chem_conv_point9.cdk"

!   -------------------------------------------------------L
! local variables
      integer i,k,n
      real zm(ni,nk-1)
      real zi(ni,nk)
      real pap(ni,nk-1)
      real paph(ni,nk)
      real dpp(ni,nk-1)
      real tpert(ni)
      real qpert(ni)
      real jctop(ni)
      real jcbot(ni)
      real geos(ni)
      real zcqe(ni,nk-1)
      real zcte(ni,nk-1)
      real mcon(ni,nk-1)
      real cme(ni,nk-1)
      real dlf(ni,nk-1)
      real pflx(ni,nk-1)

      INTEGER JLATPR,NUPS,ITRAC,IRAD,ik1
      AUTOMATIC (THROW, real, (NI,NK))
      AUTOMATIC (GTROW, real, (NI))
      AUTOMATIC (SHXKJ, real, (NI,NK-1))

      AUTOMATIC (TCVROW, real, (NI))
      AUTOMATIC (WRK, real, (IDSZ))
      AUTOMATIC (VA, real, (IVA))

      AUTOMATIC (ZCLFROW, real, (NI,(nk-1),2))
      AUTOMATIC (ZLWCROW, real, (NI,(nk-1),2))
      AUTOMATIC (DQLDT, real, (NI,(nk-1)))
      AUTOMATIC (DQLDTG, real, (NI,(nk-1)))

      AUTOMATIC (ITRPHS,INTEGER, (NTRAC))

#include "cam_cons9.cdk"

      REAL PTOIT
      REAL GRAV
      REAL MAXC,CO2,SIG1,CDAY,X10E,RGRAV
      COMMON /LWCONS/ MAXC,CO2,SIG1,CDAY,X10E,RGRAV

      GRAV = G
      ILG = ni
      ILEV = nk-1

!   --------------------------------------------
      call chem_setreal(THROW,0.,NI*NK)
      call chem_setreal(GTROW,0.,ni)
      call chem_setreal(SHXKJ,0.,ni*(nk-1))
      call chem_setreal(TCVROW,0.,ni)
      call chem_setreal(VA,0.,(IVA))
      call chem_setreal(WRK,0.,(IDSZ))

      call chem_setreal(ZCLFROW,0.,NI*(NK-1)*2) 
      call chem_setreal(ZLWCROW,0.,NI*(NK-1)*2) 
      call chem_setreal(DQLDT,0.,NI*(NK-1)) 
      call chem_setreal(DQLDTG,0.,NI*(NK-1)) 
!-----------------------------------------------
! conv
      if (GAS_conv_S.eq.'ZMF') then 
! deallocate after aerosols in chemexe1
        call chem_setreal(ZM,0.,ni*(nk-1))
        call chem_setreal(DZ,0.,ni*(nk-1))

        call chem_setreal(mu,0.,ni*(nk-1))
        call chem_setreal(eu,0.,ni*(nk-1))
        call chem_setreal(du,0.,ni*(nk-1))
        call chem_setreal(md,0.,ni*(nk-1))
        call chem_setreal(mc,0.,ni*(nk-1))
        call chem_setreal(ed,0.,ni*(nk-1))
        call chem_setreal(dp,0.,ni*(nk-1))
        call chem_setreal(mb,0.,ni)
        call chem_setreal(eps0,0.,ni)
        call chem_setreal(zfg,0.,ni*nk)
        call chem_setreal(dsubcld,0.,ni)
        do i=1,ni 
           ideep(i) = 0
           jt(i) = 0
           maxg(i) = 0
           jd(i) = 0
         enddo
!
!      -----------------------------------
!
!     * DEFINE SLICE OF DRY-ADIABATIC LAYER DEFINITION FOR PHYSICS.

      DO 500  K=1,NK-1
         DO 100 I=IL1,IL2
            SHXKJ (I,K)=SHJ (I,K)**RGOCP
  100    CONTINUE
  500 CONTINUE

       DO I=IL1,IL2
         GTROW(I)=TT(I,nk)  
       END DO
       IRAD = 1
       PTOIT = 50.            !from GCM
       SIG1 = PTOIT/101325.   !from GCM

      CALL THCAL3B (THROW,TFROW, TT(1,2),GTROW,  &
     &              SHJ,SHTJ,SHXKJ,ILEV,ILEV+1,ILG,IL1,IL2,IRAD)

      DO N=1,NTRAC
         IF (aero_chem_loc(N).EQ.0) THEN
           ITRPHS(N) = 1
         ELSEIF (aero_chem_loc(N).NE.0) THEN
           ITRPHS(N) = 0
         ENDIF
      END DO
      ITRPHS(ISO2) = 0
      ITRPHS(ISO4) = 0
      ITRPHS(IHPO) = 0

      JLATPR = 0    
      NUPS = 0       

!
         CALL CONV6X(tt(1,2),hu(1,2),UROW,VROW,PRETROW(1,1,2),psfc,  &
     &              TCVROW,PBLTROW,DSHJ,SHJ,SHTJ(1,2),TFROW(1,2),  &
     &              UTENDGW,VTENDGW,SHTJ,XROW,ITRPHS,NTRAC,ITRAC,  &
     &              ZCLFROW(1,1,2),ZLWCROW(1,1,2),EPS0,DZ,LENGATH,DQLDT,DQLDTG,&
     &              VA,IVA,ICD,nk-1,nk-1-1,nk,ni,IL1,IL2,MSG,NUPS,    &
     &              RGAS,GRAV,CPRES,frdt,trnch,JLATPR,KOUNT,  &
     &              WRK(ID1 ),WRK(ID2 ),       ZM,WRK(ID4 ),WRK(ID5 ),  &
     &              WRK(ID6 ),WRK(ID7 ),WRK(ID8 ),WRK(ID9 ),WRK(ID10),  &
     &              WRK(ID11),WRK(ID12),WRK(ID13),WRK(ID14),WRK(ID15),  &
     &                    ZFG,WRK(ID17),WRK(ID18),WRK(ID19),       MU,  &
     &                     EU,WRK(ID22),WRK(ID23),       DU,       MD,  &
     &                     ED,WRK(ID27),WRK(ID28),WRK(ID29),       MC,  &
     &              WRK(ID31),WRK(ID32),WRK(ID33),WRK(ID34),WRK(ID35),  &
     &                     DP,WRK(ID37),WRK(ID38),WRK(ID39),WRK(ID40),  &
     &              WRK(ID41),WRK(ID42),WRK(ID43),WRK(ID44),WRK(ID45),  &
     &              WRK(ID46),WRK(ID47),WRK(ID48),WRK(ID49),WRK(ID50),  &
     &              WRK(ID51),WRK(ID52),WRK(ID53),    IDEEP,WRK(ID55),  &
     &              WRK(ID56),WRK(ID57),WRK(ID58),WRK(ID59),     MAXG,  &
     &              WRK(ID61),WRK(ID62),WRK(ID63),WRK(ID64),  DSUBCLD,  &
     &                     MB,       JT,WRK(ID68),       JD,WRK(ID70),   &
     &              WRK(ID71),WRK(ID72),WRK(ID73),WRK(ID74),WRK(ID75),  &
     &              WRK(ID76),WRK(ID77)                              ) 
      endif
!-----------------------------------------------
      return
      end
