      SUBROUTINE CLOSUR5(Q,T,P,Z,S,TP,QS,QU,SU,MC,DU,MU,MD,QD,SD,ALPHA,&
     &                   QHAT,SHAT,DP,QSTP,ZF,QL,DSUBCLD,MB,QDB,SDB,   & 
     &                   BETAU,BETAD,CAPE,TL,LCL,LEL,JT,MX,ILEV,ILG,   &
     &                  IL1G,IL2G,RD,GRAV,CP,MSG,CAPELMT,              &
     &                   DTPDT,DQSDTP,DTMDT,DQMDT,DBOYDT,              &
     &                   THETAVP,THETAVM,                              &
     &                   DTBDT,DQBDT,DTLDT,RL,PMAX,         &
     &                   TMAX,QMAX,QHATMAX,SHATMAX,SUMAX,   &
     &                   SDMAX,MUMAX,MDMAX,QUMAX,QDMAX,     &
     &                   DADT                                          )

!     * JUN 10/98 - M.LAZARE. BUGFIX WHERE EXTRA CONTINUATION LINE
!     *                       IN CALCULATION OF "THETAVM" IN LOOP
!     *                       250 HAS BEEN REMOVED (THIS BUG HAS
!     *                       BEEN THERE SINCE INCEPTION OF DEEP
!     *                       SCHEME.
!     * JUN 26/96 - M.LAZARE. PREVIOUS VERSION CLOSUR4.
                                                                        
      IMPLICIT REAL (A-H,O-Z),  &
     &INTEGER (I-N)

      REAL        Q(ILG,ILEV),      T(ILG,ILEV),      P(ILG,ILEV),  &    
     &            Z(ILG,ILEV),      S(ILG,ILEV),     TP(ILG,ILEV),  &   
     &           QS(ILG,ILEV),     QU(ILG,ILEV),     SU(ILG,ILEV),  &  
     &           MC(ILG,ILEV),     DU(ILG,ILEV),     MU(ILG,ILEV),  & 
     &           MD(ILG,ILEV),     QD(ILG,ILEV),     SD(ILG,ILEV),  &
     &        ALPHA(ILG,ILEV),   QHAT(ILG,ILEV),   SHAT(ILG,ILEV),  &
     &           DP(ILG,ILEV),   QSTP(ILG,ILEV),     ZF(ILG,ILEV),  &
     &           QL(ILG,ILEV)                                           
                                                                        
      REAL       MB(ILG),         QDB(ILG),         SDB(ILG), &          
     &        BETAU(ILG),       BETAD(ILG),        CAPE(ILG), &         
     &           TL(ILG),     DSUBCLD(ILG)                              
                                                                        
      INTEGER   LCL(ILG),   LEL(ILG),   JT(ILG),   MX(ILG)              
                                                                        
!     * WORK FIELDS:                                                              
                                                                        
      REAL    DTPDT(ILG,ILEV), DQSDTP(ILG,ILEV),  DTMDT(ILG,ILEV), &     
     &        DQMDT(ILG,ILEV), DBOYDT(ILG,ILEV),                   &    
     &      THETAVP(ILG,ILEV),THETAVM(ILG,ILEV)                         
                                                                        
      REAL    DTBDT  (ILG),       DQBDT  (ILG),       DTLDT  (ILG),&     
     &        RL     (ILG),       PMAX   (ILG),       TMAX   (ILG),&
     &        QMAX   (ILG),       QHATMAX(ILG),       SHATMAX(ILG),&
     &        SUMAX  (ILG),       SDMAX  (ILG),       MUMAX  (ILG),&
     &        MDMAX  (ILG),       QUMAX  (ILG),       QDMAX  (ILG),&
     &        DADT   (ILG)   
!
      COMMON/EPS   / A,B,EPS1,EPS2                                      
      COMMON/HTCP  / TFREEZ,T2S,AI,BI,AW,BW,SLP                         
                                                                        
      DATA TAU /2400./                                                  
!---------------------------------------------------------------------------      
!CC   *************************************************************               
!CC   CHANGE OF SUBCLOUD LAYER PROPERTIES DUE TO CONVECTION IS                    
!CC   RELATED TO CUMULUS UPDRAFTS AND DOWNDRAFTS.                                 
!CC   MC(Z)=F(Z)*MB, MUB=BETAU*MB, MDB=BETAD*MB ARE USED                          
!CC   TO DEFINE BETAU, BETAD AND F(Z).                                            
!CC   NOTE THAT THIS IMPLIES ALL TIME DERIVATIVES ARE IN EFFECT                   
!CC   TIME DERIVATIVES PER UNIT CLOUD-BASE MASS FLUX, I.E. THEY                   
!CC   HAVE UNITS OF 1/MB INSTEAD OF 1/SEC.                                        
!CC   *************************************************************
!
!     * OBTAIN GATHERED FIELDS AT "MX" FOR ENSUING USE.
!     * INITIALIZE "DADT" ARRAY.
!
      DO 50 K=MSG+1,ILEV 
      DO 50 IL=IL1G,IL2G
        IF(K.EQ.MX(IL))                                          THEN
          PMAX   (IL)=P   (IL,K)
          TMAX   (IL)=T   (IL,K)
          QMAX   (IL)=Q   (IL,K)
          QHATMAX(IL)=QHAT(IL,K)
          QUMAX  (IL)=QU  (IL,K)
          QDMAX  (IL)=QD  (IL,K)
          SHATMAX(IL)=SHAT(IL,K)
          SUMAX  (IL)=SU  (IL,K)
          SDMAX  (IL)=SD  (IL,K)
          MUMAX  (IL)=MU  (IL,K)
          MDMAX  (IL)=MD  (IL,K) 
          DADT   (IL)=0.
        ENDIF 
   50 CONTINUE      
!
      DO 100 IL=IL1G,IL2G                                               
        MB(IL)=0.                                                       
        EB=PMAX(IL)*QMAX(IL)/(EPS1+QMAX(IL))                       
         DTBDT(IL)=(1./DSUBCLD(IL))    &                                 
     &    *( MUMAX(IL)*( SHATMAX(IL)-SUMAX(IL) ) &                  
     &      +MDMAX(IL)*( SHATMAX(IL)-SDMAX(IL) ) )                 
         DQBDT(IL)=(1./DSUBCLD(IL))             &                        
     &    *( MUMAX(IL)*( QHATMAX(IL)-QUMAX(IL) ) &                   
     &      +MDMAX(IL)*( QHATMAX(IL)-QDMAX(IL) ) )                 
        DEBDT=EPS1*PMAX(IL)/(EPS1+QMAX(IL))**2*DQBDT(IL)                
        DTLDT(IL)=-2840.*(3.5/TMAX(IL)*DTBDT(IL)-DEBDT/EB)/ &            
     &        (3.5*LOG(TMAX(IL))-LOG(EB)-4.805)**2                      
  100 CONTINUE
!                                                                                 
!CC   ******************************************************************          
!CC     DTMDT AND DQMDT ARE CUMULUS HEATING AND DRYING.                           
!CC   ******************************************************************          
!
      DO 150 K=MSG+1,ILEV                                               
      DO 150 IL=IL1G,IL2G                                               
        DTMDT(IL,K)=0.                                                  
        DQMDT(IL,K)=0.                                                  
  150 CONTINUE
!
      DO 175 K=MSG+1,ILEV-1                                             
      DO 175 IL=IL1G,IL2G                                               
        IF(K.EQ.JT(IL))                                             THEN
!         RL(IL)=(2.501-.00237*(T(IL,K+1)-TFREEZ))*1.E6                           
          RL(IL)=2.501E6                                                
          DTMDT(IL,K)=(1./DP(IL,K))                  &                   
     &               *(MU(IL,K+1)*(SU(IL,K+1)-SHAT(IL,K+1)  &              
     &                             -RL(IL)/CP*QL(IL,K+1) ) + &           
     &                 MD(IL,K+1)*(SD(IL,K+1)-SHAT(IL,K+1)) )           
          DQMDT(IL,K)=(1./DP(IL,K))                         &            
     &               *(MU(IL,K+1)*(QU(IL,K+1)-QHAT(IL,K+1)+QL(IL,K+1)) + &
     &                 MD(IL,K+1)*(QD(IL,K+1)-QHAT(IL,K+1)) )           
        ENDIF                                                           
  175 CONTINUE                                                          
!                   
      BETA=1.                                                           
      DO 180 K=MSG+1,ILEV-1                                             
      DO 180 IL=IL1G,IL2G                                               
        IF(K.GT.JT(IL) .AND. K.LT.MX(IL))                           THEN
!         RL(IL)=(2.501-.00237*(T(IL,K)-TFREEZ))*1.E6                             
          RL(IL)=2.501E6                                                
          DTMDT(IL,K)=(MC(IL,K)*(SHAT(IL,K)-S(IL,K))          &          
     &                +MC(IL,K+1)*(S(IL,K)-SHAT(IL,K+1)))/DP(IL,K) &      
     &      -RL(IL)/CP*DU(IL,K)*(BETA*QL(IL,K)+(1-BETA)*QL(IL,K+1))     
          DQMDT(IL,K)=(MC(IL,K)*(QHAT(IL,K)-Q(IL,K))    &                
     &                +MC(IL,K+1)*(Q(IL,K)-QHAT(IL,K+1)))/DP(IL,K) &     
     &                +DU(IL,K)*(QS(IL,K)-Q(IL,K))                &      
     &                +DU(IL,K)*(BETA*QL(IL,K)+(1-BETA)*QL(IL,K+1))     
        ENDIF                                                           
  180 CONTINUE                                                          
!                   
      DO 200 K=MSG+1,ILEV                                               
      DO 200 IL=IL1G,IL2G                                               
        IF(K.GE.LEL(IL) .AND. K.LE.LCL(IL))                         THEN
!         RL(IL)=(2.501-.00237*(TP(IL,K)-TFREEZ))*1.E6                            
          RL(IL)=2.501E6                                                
          THETAVP(IL,K)=TP(IL,K)*(1000./P(IL,K))**(RD/CP) &              
     &                  *(1.+1.608*QSTP(IL,K)-QMAX(IL))                 
          THETAVM(IL,K)=T(IL,K)*(1000./P(IL,K))      &                   
     &                  **(RD/CP)*(1.+0.608*Q(IL,K))                    
          DQSDTP(IL,K)=QSTP(IL,K)*(1.+QSTP(IL,K)/EPS1) &                  
     &                 *EPS1*RL(IL)/(RD*TP(IL,K)**2)                    
!CC     ******************************************************************        
!CC       DTPDT IS THE PARCEL TEMPERATURE CHANGE DUE TO CHANGE OF                 
!CC       SUBCLOUD LAYER PROPERTIES DURING CONVECTION.                            
!CC     ******************************************************************        
          DTPDT(IL,K)=TP(IL,K)                                           & 
     &               /(1.+RL(IL)/CP*(DQSDTP(IL,K)-QSTP(IL,K)/TP(IL,K)))* &
     &               (   DTBDT(IL)/TMAX(IL)+RL(IL)/CP*                   &
     &               (DQBDT(IL)/TL(IL)-QMAX(IL)/TL(IL)**2*DTLDT(IL)    & 
     &                                                                ))
!CC     ******************************************************************        
!CC       DBOYDT IS THE INTEGRAND OF CAPE CHANGE.                                 
!CC     ******************************************************************        
          DBOYDT(IL,K)=((DTPDT(IL,K)/TP(IL,K)                 &          
     &                 +1./(1.+1.608*QSTP(IL,K)-QMAX(IL))      &         
     &                 *(1.608*DQSDTP(IL,K)*DTPDT(IL,K)-DQBDT(IL))) &     
     &                 -(DTMDT(IL,K)/T(IL,K)+0.608/(1.+0.608*Q(IL,K)) &   
     &                 *DQMDT(IL,K)))*GRAV*THETAVP(IL,K)/THETAVM(IL,K)  
!CC     ******************************************************************        
        ENDIF                                                           
 200  CONTINUE
!                                                                                 
      DO 250 K=MSG+1,ILEV                                               
      DO 250 IL=IL1G,IL2G                                               
        IF(K.GT.LCL(IL) .AND. K.LT.MX(IL))                          THEN
!         RL(IL)=(2.501-.00237*(TP(IL,K)-TFREEZ))*1.E6                            
          RL(IL)=2.501E6                                                
          THETAVP(IL,K)=TP(IL,K)*(1000./P(IL,K))**(RD/CP)      &         
     &                  *(1.+0.608*QMAX(IL))                            
          THETAVM(IL,K)=T(IL,K)*(1000./P(IL,K))                &         
     &                  **(RD/CP)*(1.+0.608*Q(IL,K))                    
!CC     ******************************************************************        
!CC       DBOYDT IS THE INTEGRAND OF CAPE CHANGE.                                 
!CC     ******************************************************************        
          DBOYDT(IL,K)=(DTBDT(IL)/TMAX(IL)                      &        
     &                 +0.608/(1.+0.608*QMAX(IL))*DQBDT(IL)     &        
     &                 -DTMDT(IL,K)/T(IL,K)                     &        
     &                 -0.608/(1.+0.608*Q(IL,K))*DQMDT(IL,K))   &        
     &                 *GRAV*THETAVP(IL,K)/THETAVM(IL,K)                
!CC     ******************************************************************        
        ENDIF                                                           
 250  CONTINUE
!                                                                                 
!CCC  *************************************************************               
!CCC  BUOYANT ENERGY CHANGE IS SET TO 2/3*EXCESS CAPE PER 3 HOURS                 
!CCC  *************************************************************
!
      DO 300 K=MSG+1,ILEV
      DO 300 IL=IL1G,IL2G
        IF(K.GE.LEL(IL) .AND. K.LT.MX(IL))                        THEN  
          DADT(IL)=DADT(IL)+DBOYDT(IL,K)*(ZF(IL,K)-ZF(IL,K+1))   
        ENDIF                         
 300  CONTINUE                                                          
!         
      DO 400 IL=IL1G,IL2G                                               
        DLTAA=-1.*(CAPE(IL)-CAPELMT)*2./3.                              
        IF(DADT(IL).NE.0.)            MB(IL)=MAX(DLTAA/TAU/DADT(IL),0.) 
 400  CONTINUE      
!                                                                                 
      RETURN                                                            
      END        
