      SUBROUTINE IPNTROW (IFLD,NAME,LOC,NLEV,LOFF,ILG,IL1,IL2,JLAT) 
! 
!     * M.LAZARE. - DEC 03/90. LIKE "PRNTROW", EXCEPT FOR INTEGERS. 
! 
!     * PRINTS OUT ROW VALUES (BETWEEN IL1 AND IL2) OF INTEGER ARRAY
!     * IFLD, FOR EACH OF NLEV LEVELS AT "JLAT" LATITUDE ROW INSIDE 
!     * ROUTINE.
!     * 
!     *      IFLD = INTEGER ARRAY TO BE PRINTED OUT.
!     *      NAME = NAME OF ARRAY TO BE INCLUDED IN PRINTOUT, 
!     *             I.E. "TH" FOR THROW.
!     *      LOC  = LOCATION WHERE PRINTOUT IS OCCURRING, I.E.
!     *             "AFTER VRTDFS". 
!     *             BEING DISPLAYED.
!     *      NLEV = NUMBER OF LEVELS FOR VARIABLE.
!     *      LOFF = NUMBER OF LEVELS (INCLUDING MOON LAYER) BEFORE
!     *             VARIABLE HAS VALUES, I.E. LOFF=MSG+1 FOR ESTG,
!     *             LOFF=0 FOR THROW, LOFF=1 FOR UROW. FOR SINGLE-
!     *             LEVEL FIELDS, SOME LEVEL INDICATOR (I.E. COULD BE 
!     *             DONE IN A VERTICAL LEVEL LOOP). 
!     *             MOON LAYER REFERENCED TO AS LEVEL "0" IN PRINTOUT.
!     *      ILG  = NUMBER OF EQUALLY-SPACED LONGITUDES TO BE PRINTED OUT.
!     *      IL1  = STARTING LONGITUDE NUMBER FOR PRINTOUT. 
!     *      IL2  = FINISHING LONGITUDE NUMBER FOR PRINTOUT.
!     *      JLAT = CURRENT LATITUDE ROW FOR PRINTOUT.
! 
      IMPLICIT REAL (A-H,O-Z), &
     &INTEGER (I-N)

      INTEGER IFLD(ILG,NLEV)
      CHARACTER*14 LOC
      CHARACTER*7 NAME
!-----------------------------------------------------------------------
! 
!     * DISTINGUISH BETWEEN SINGLE-LEVEL AND MULTI-LEVEL FIELDS.
! 
      IF(NLEV.EQ.1) THEN
             WRITE(6,6100) LOC,LOFF,NAME,JLAT,(IFLD(IL,1),IL=IL1,IL2) 
 6100        FORMAT ('0',A14,', LEVEL',I3,' FOR VARIABLE ',& 
     &               A7,' AT LATITUDE ROW',I3,' :',/,(10(1X,I12)))
      ELSE
         LIND=LOFF-1
         WRITE(6,6200)
 6200    FORMAT ('1') 
         DO 200 L=1,NLEV
             WRITE(6,6300) LOC,L+LIND,NAME,JLAT,(IFLD(IL,L),IL=IL1,IL2) 
 6300        FORMAT ('0',A14,', LEVEL',I3,' FOR VARIABLE ',& 
     &               A7,' AT LATITUDE ROW',I3,' :',/,(10(1X,I12)))
  200    CONTINUE 
      ENDIF 
! 
      RETURN
      END 
