#include "phy_macros_f.h"
  subroutine aeroexe1(dt,trnch,kount,ni,nk,         &
     &                    aero_tr,NTR,npg,          &
     &                    T,q,psfc,sig,hght,surfwd, &
     &              fws,fmodv,flwc,ftsoil,          &
     &              ice,snow,ffdss,frluc,fn_luc,fdz,ftv, &
     &              lat_deg,long_deg,                    &
     &              tcszrow, cszrow,frclds,frcldc,       &
     &              mu,eu,du,md,mc,ed,                   &
     &              dp,mb,eps0,zfg,dsubcld,ideep,jt,maxg,jd,lengath, &
     &              fktm,fhs,uu,vv,SHJ,SHTJ,DSHJ,IL1,IL2,            &
     &              MSG,DZ,PRETROW,TFROW,cld_fn,GC1,IDAYi,RHROW,     &
     &              ROAROW, ZFPREC, WPEVPA, WRSCAV,                  &
     &              RSFROW, fracis, modx)

   use constituents, only: sflxnam
   use seasalt_intr, only: ssyc_idx1
   use history,      only: outfld
   use ccrnbnd,      only: ccrnbndget, ccrninpget
#ifdef GHG_2D
   use ghg_surfvals_2d, only: ghg_surfvals_get_co2vmr_2d 
#else
   use ghg_surfvals, only: chem_surfvals_get         
#endif
 
!
   implicit none
!
#include "aero_chem_order_cam9.cdk"

      integer, intent(in) :: trnch,kount,ni,nk,fn_luc
      integer, intent(in) :: NTR
      integer, intent(in) :: npg    ! the prognostic variable numbers
      integer, intent(in) :: modx
! modx == 0  :  emmision
! modx == 1  :  wet deposition
! modx == 2  :  dry deposition
!
      real,    intent(in) :: dt
      real,    intent(in) :: uu(ni,nk),vv(ni,nk)
      real,    intent(in) :: ZFPREC(ni,nk-1), WPEVPA(ni,nk-1), WRSCAV(ni,nk-1)
      real, intent(inout) :: aero_tr(ni,nk,NTR)
      real, intent(inout) :: fracis(ni,nk-1,npg)

!
! Object
!      this is the main interface subroutine for the aerosol physics/chemistry
!
! MODULES
#include <chem_land_bats15.cdk>
!#include "consphy.cdk"
!#include "aero_emis_order_geia.cdk"   ! wzz, 2008.02.13
!
      integer i,k,n,indx,l
      integer ik
      character names*8
!     fonction-formule pour faciliter le calcul des indices
      ik(i,k) = (k-1)*ni + i -1

       real T (NI,NK    )
       real q (NI,NK    )
       real psfc (NI     )
       real sig (NI,NK    )
       real hght (NI,NK     )
       real lat_deg (NI      ) 
       real long_deg (NI      ) 
       real, intent(in) :: tcszrow(ni)
       real cszrow(ni)
       real ice (NI       )
       real snow (NI      )
       real flwc (NI,NK    )
       real fmodv(NI,NK)
       real fws(ni,nk)
       real frclds (NI,NK  )
       real frcldc (NI,NK  )
       real fdz (NI,NK    )
       real frluc(NI,fn_luc)
       real ftv (NI,NK    )      
       real fktm (NI,NK    )
       real surfwd(ni)
       real ftsoil(ni)
       real ffdss(ni)
       real fhs (NI       )
       real, intent(in) :: mu(ni,nk-1)
       real, intent(in) :: eu(ni,nk-1)
       real, intent(in) :: du(ni,nk-1)
       real, intent(in) :: md(ni,nk-1)
       real, intent(in) :: mc(ni,nk-1)
       real, intent(in) :: ed(ni,nk-1)
       real, intent(in) :: dp(ni,nk-1)
       real, intent(in) :: mb(ni)
       real, intent(in) :: eps0(ni)
       real, intent(in) :: zfg(ni,nk)
       real, intent(in) :: dsubcld(ni)
       integer, intent(in) :: ideep (ni)
       integer, intent(in) :: jt(ni)
       integer, intent(in) :: maxg(ni)
       integer, intent(in) :: jd(ni)
       integer, intent(in) :: lengath
!
!  Automatic Arrays
!
!----------------------------------------------------------------------------------------

!   ---  FOR SSFLUX  --------------------------------------------------------------------
       INTEGER ICAM, IREST, MODE, NSOIL, NATS, ik1, IL1, IL2
       PARAMETER (NSOIL=152, NATS=12, MODE=2)

       REAL RSFROW(NI,NTR)
       REAL DSHJ(NI,NK-1), GC1(NI), ROAROW(NI,NK-1)
       REAL ASO2ROW(ni), ASO4ROW(ni), PSO2ROW(ni), PSO4ROW(ni)
       REAL DMSOROW(ni), DMSLROW(ni), H2SROW(ni)
       REAL BLCROW(ni,5,2), OMCROW(ni,5,2)
       REAL SAND2ROW(ni,nats),  CLAY2ROW(ni,2), SAND6ROW(ni,6)

       AUTOMATIC (FINTROW, real, (NI,aero_nsize,3))
       AUTOMATIC (VOLCROW, real, (NI,2))

       AUTOMATIC (SREL, real, (NI,NSOIL,NATS))

       AUTOMATIC (SS, real, (NI,NSOIL))
       AUTOMATIC (SOILW, real, (NI))
       AUTOMATIC (TBAR, real, (NI))

       AUTOMATIC (PXNEW, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (aero_local_loc, integer, (gn_aerochem))
       AUTOMATIC (ZHLEV, real, (NI,NK-1))

!   ---FOR CAM_V05 ONLY------------------------------------------------------------------

#include <cam_set_gem9.cdk>
#include <cam_cons9.cdk>

       INTEGER LON, NSUB, isub, MSG, NTRACA
       PARAMETER (NSUB=32, NTRACA=5)
       REAL GMT, CONDNU(15), POP, POP1, TMIN
       REAL SHJ(NI,NK-1),SHTJ(NI,NK)
       REAL DZ(ni,nk-1), PRETROW(ni,nk-1,2), TFROW(ni,nk)
       REAL cld_fn(ni,nk)
       REAL RHROW(NI,NK)
       INTEGER IDAYi         !  lqx, 2007.5.25

       AUTOMATIC (TSROW, real, (NI))
       AUTOMATIC (MODV, real, (NI,NK-1))
       AUTOMATIC (EPSI, real, (NI,NK-1))
       AUTOMATIC (F1, real, (NI,NK-1,NSUB))
       AUTOMATIC (F2, real, (NI,NK-1,NSUB))
       AUTOMATIC (FFG, complex, (NI,NK-1,2*NSUB))
       AUTOMATIC (WROW, real, (NI,NK-1))
       AUTOMATIC (RHSIZE, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RHOP, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (OHROW, real, (NI,NK-1))
       AUTOMATIC (H2O2ROW, real, (NI,NK-1))
       AUTOMATIC (O3ROW, real, (NI,NK-1))
       AUTOMATIC (NO3ROW, real, (NI,NK-1))
       AUTOMATIC (CO2ROW, real, (NI,NK-1))
       AUTOMATIC (NH3ROW, real, (NI,NK-1))
       AUTOMATIC (HNO3ROW, real, (NI,NK-1))
       AUTOMATIC (TOTMAS, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (PDIFF, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (CLDCV, real, (NI,NK-1,2))
       AUTOMATIC (ZMLWC, real, (NI,NK-1,2))
       AUTOMATIC (WSUB, real, (NI,NK-1,NSUB))
       AUTOMATIC (RADCLD, real, (NI,NK-1))
       AUTOMATIC (RGRID, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (TRWTROW, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (AERONUM, real, (NI,NK-1,aero_nsize))
!      AUTOMATIC (ZFPREC, real, (NI,NK-1))
       AUTOMATIC (PDEPV, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RTCOA, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (RTDRY, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (RTICLD, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (RTBCLD, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (THLEV, real, (NI,NK-1))
       AUTOMATIC (GDREM, real, (NI,gn_aerochem,3))
       AUTOMATIC (COLEF, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (WETDEP, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RTCOND, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RTSO2, real, (NI,NK-1,2))
       AUTOMATIC (RTSO4, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RTDMS, real, (NI,NK-1))
       AUTOMATIC (RTH2S, real, (NI,NK-1))
       AUTOMATIC (RTNUCL, real, (NI,NK-1))
       AUTOMATIC (RTH, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (VDG, real, (NI,NG))
       AUTOMATIC (RCRITS, real, (NI,NK-1,2))
       AUTOMATIC (RCOEXS, real, (NI,NK-1,2))
       AUTOMATIC (WRZ, real, (NI,NK-1,aero_nsize,2,2))
       AUTOMATIC (WRY, real, (NI,NK-1,NTRACA,2))
       AUTOMATIC (WRX, real, (NI))
       AUTOMATIC (WRW, real, (NI,NK-1,gn_aerochem,9))
       AUTOMATIC (WRU, LOGICAL, (NI,NK-1))
       AUTOMATIC (WRA, real, (NI*(NK-1)*36))
       AUTOMATIC (ZZ, real, (NI,NK-1))
       AUTOMATIC (RTHPO, real, (NI,NK-1))
       AUTOMATIC (BETA, real, (NI,NK-1,aero_nsize*aero_nsize))
       AUTOMATIC (DELIQS, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (RECRYS, real, (NI,NK-1,aero_nsize))
!      AUTOMATIC (WPEVPA, real, (NI,NK-1))
!      AUTOMATIC (WRSCAV, real, (NI,NK-1))
       AUTOMATIC (CLSIZE, real, (NI,NK-1,aero_nsize))
       AUTOMATIC (SOA, real, (NI,NK-1))
       AUTOMATIC (tcld3, real, (NI,NK-1))

       INTEGER LAMDA
       PARAMETER (LAMDA=5)
       AUTOMATIC (ABCOEF, real, (aero_nsize,13,aerochem_np,14))
       AUTOMATIC (SCCOEF, real, (aero_nsize,13,aerochem_np,14))
       AUTOMATIC (AODROW1, real, (NI,aerochem_np,LAMDA))
       AUTOMATIC (AODROW2, real, (NI,aerochem_np,LAMDA))
       AUTOMATIC (RHRROW, real, (NI))

!   ---ARRAYS NOT BE USED IN CAM---------------------------------------------------------
       INTEGER NSO4, ITRVAR
       REAL SAVERAD
!      AUTOMATIC (TCSZROW, real, (NI))
       AUTOMATIC (SURFDG, real, (NI))
       AUTOMATIC (RTVER, real, (NI,NK-1,gn_aerochem))
       AUTOMATIC (TRACG, real, (NI,NK-1,gn_aerochem))
       DATA TMIN /0.0/
!   -------------------------------------------------------------------------------------

       CALL chem_setreal(FINTROW,0.,NI*aero_nsize*3)
       CALL chem_setreal(SREL,0.,NI*NSOIL*NATS)
       CALL chem_setreal(SS,0.,NI*NSOIL)
       CALL chem_setreal(SOILW,0.,NI)
       CALL chem_setreal(TBAR,0.,NI)
       
       CALL chem_setreal(PXNEW,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(RSFROW,0.,NI*NTR) 
       CALL chem_setreal(ZHLEV,0.,NI*(NK-1))
       CALL chem_setreal(TSROW,0.,NI)
       CALL chem_setreal(MODV,0.,NI*(NK-1))
       CALL chem_setreal(EPSI,0.,NI*(NK-1)) 
       CALL chem_setreal(F1,0.,NI*(NK-1)*NSUB)
       CALL chem_setreal(F2,0.,NI*(NK-1)*NSUB)
       CALL chem_setreal(WROW,0.,NI*(NK-1))
       CALL chem_setreal(RHSIZE,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RHOP,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(OHROW,0.,NI*(NK-1))   
       CALL chem_setreal(H2O2ROW,0.,NI*(NK-1))
       CALL chem_setreal(O3ROW,0.,NI*(NK-1))
       CALL chem_setreal(NO3ROW,0.,NI*(NK-1))
       CALL chem_setreal(CO2ROW,0.,NI*(NK-1))
       CALL chem_setreal(NH3ROW,0.,NI*(NK-1))
       CALL chem_setreal(HNO3ROW,0.,NI*(NK-1))
       CALL chem_setreal(TOTMAS,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(PDIFF,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(CLDCV,0.,NI*(NK-1)*2)
       CALL chem_setreal(WSUB,0.,NI*(NK-1)*NSUB)
       CALL chem_setreal(RADCLD,0.,NI*(NK-1))
       CALL chem_setreal(RGRID,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(TRWTROW,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(AERONUM,0.,NI*(NK-1)*aero_nsize)
!      CALL chem_setreal(ZFPREC,0.,NI*(NK-1))
       CALL chem_setreal(PDEPV,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RTCOA,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(RTDRY,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(RTICLD,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(RTBCLD,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(THLEV,0.,NI*(NK-1))
!      CALL chem_setreal(GDREM,0.,NI*gn_aerochem*3)
       CALL chem_setreal(COLEF,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(WETDEP,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RTCOND,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RTSO2,0.,NI*(NK-1)*2)
       CALL chem_setreal(RTSO4,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RTDMS,0.,NI*(NK-1))  
       CALL chem_setreal(RTH2S,0.,NI*(NK-1))  
       CALL chem_setreal(RTNUCL,0.,NI*(NK-1))
       CALL chem_setreal(RTH,0.,NI*(NK-1)*aero_nsize)   
       CALL chem_setreal(VDG,0.,NI*NG)
       CALL chem_setreal(RCRITS,0.,NI*(NK-1)*2)
       CALL chem_setreal(RCOEXS,0.,NI*(NK-1)*2)
       CALL chem_setreal(WRZ,0.,NI*(NK-1)*aero_nsize*2*2)
       CALL chem_setreal(WRY,0.,NI*(NK-1)*NTRACA*2)
       CALL chem_setreal(WRX,0.,NI)
       CALL chem_setreal(WRW,0.,NI*(NK-1)*gn_aerochem*9)
       CALL chem_setreal(WRA,0.,NI*(NK-1)*36) 
       CALL chem_setreal(ZZ,0.,NI*(NK-1))
       CALL chem_setreal(RTHPO,0.,NI*(NK-1))  
       CALL chem_setreal(BETA,0.,NI*(NK-1)*aero_nsize*aero_nsize)
       CALL chem_setreal(DELIQS,0.,NI*(NK-1)*aero_nsize)
       CALL chem_setreal(RECRYS,0.,NI*(NK-1)*aero_nsize)
!      CALL chem_setreal(WPEVPA,0.,NI*(NK-1))
!      CALL chem_setreal(WRSCAV,0.,NI*(NK-1))
       CALL chem_setreal(CLSIZE,0.,NI*(NK-1)*aero_nsize) 
       CALL chem_setreal(SOA,0.,NI*(NK-1))   
       CALL chem_setreal(TRACG,0.,NI*(NK-1)*gn_aerochem)
       CALL chem_setreal(tcld3,0.,NI*(NK-1))

       CALL chem_setreal(VOLCROW,0.,NI*2)

       do l=1,gn_aerochem
         aero_local_loc(l)=0
       end do
!

!        if (kount.eq.2.and.trnch.eq.1) then
!       if (kount.eq.2.and.trnch.eq.65) then
!         if (IDEBUG.EQ.1) then
!           WRITE (*,*)   &
!    &     'CAM -> IDD,JDD,ITI,ISCAM,INT(CAMR),IDEBUG,ISLEV,ICOB,IAT,MAE'
!           WRITE (*,*)  &
!    &            '      ',IDD,JDD,ITI,ISCAM,INT(CAMR),IDEBUG,ISLEV,ICOB, &
!    &            aerochem_np,MAE

!           WRITE (*,1111)  (AERONAME(N),N=1,aerochem_np)

!           WRITE (*,2222)  (RHOP0(N),N=1,aerochem_np)

!           WRITE (*,*) '       CAM SIZE BIN CONFIGURATIONS '

!           DO N=1,aero_nsize
!             WRITE (*,*) AEROSIZE(1,N), '   ', AEROSIZE(2,N)
!           END DO
!         endif
!       endif
!
 1111 FORMAT (' AEROSOL TYPE(S) -> ', 7('| ',A8,' |',1X))
 2222 FORMAT ('     DENSITY(KG/M3) ', 7('  ',F8.2,'  ',1X))

        MAE=(nk-1)-ISLEV

!----------------------------------------------------------------------
!             AEROSOL SURFACE FLUXES MODULE
!
!                  A - SEA-SALT
!                  B - BLACK CARBON
!                  C - OC
!                  D - SOIL DUST
!                  E - SULFUR
!----------------------------------------------------------------------
!
      DELT = dt                                                 
!      G = GRAV                                                  
!      RGAS = RGASD                                              
!      RGASVP = RGASV                                            
!
      do ik1=1,nk-1
        k = ik1 + 1
        do i=1,ni
!          if (ik1.EQ.nk-1) then
!            ZHLEV(I,ik1) = fdz(i,k)
!          else
            ZHLEV(I,ik1) = hght(i,k)
!          endif
        enddo
      enddo

      ICAM=NCAM
      I_SS = 1
      IREST = 1
      do i=1, ni
        TBAR(i) = ftsoil(i)
      end do

!     do l = IAE1, ICAM
!     do i=IL1, IL2
!        RSFROW(i,l)=0.0
!     enddo
!     enddo
!     do i=IL1, IL2
!        RSFROW(i,cncaDMS)=0.0
!        RSFROW(i,cncaH2S)=0.0
!        RSFROW(i,cncaSO2)=0.0
!        RSFROW(i,cncaSO4)=0.0
!        RSFROW(i,cncaH2O2)=0.0
!     enddo
!          do n=1,gn_aerochem
      do n=1,NTR
        do ik1=1,nk-1
          do i=IL1, IL2
            TRACG(i,ik1,n) = aero_tr(i,ik1+1,n)
          enddo
        enddo
      enddo
!
      if ( modx .eq.0 ) then
      call t_startf ('cauce_sfflux')
      call ccrnbndget( ni, trnch, BLCROW, OMCROW, SAND2ROW, CLAY2ROW, SAND6ROW, &
                      DMSOROW, DMSLROW, ASO2ROW, PSO2ROW, ASO4ROW, PSO4ROW, H2SROW)
      do l = 1, npg
         fracis(:,:,l) = aero_tr(:, 2:nk,l)
      enddo
!   if ( trnch .eq. 185) then
!    write(0,*)'wzz: aero 31 =', aero_tr(14,nk,63),aero_tr(14,nk,cncaDMS)
!   endif

      CALL SFFLUX(aero_tr, frluc,   DSHJ,    IL1,   IL2,   ni,    nk,  &
     &    nk-1,NTR,aerochem_np,AERONAME, T,FINTROW,VOLCROW,            &
     &        ASO4ROW,PSO4ROW, BLCROW, DMSOROW,DMSLROW,H2SROW,TFROW(1,nk), &
     &        ASO2ROW,PSO2ROW,aero_nsize,RHOP0, ZHLEV, PXNEW,    TRACG,    &
     &        AEROSIZE, SURFWD, RSFROW,    psfc,  ICAM, ROAROW,   GC1,     &
     &            IAE1,cncaH2S,cncaDMS, cncaSO2, cncaSO4, IREST,gn_luc,    &
     &            I_SS, OMCROW,SAND2ROW,CLAY2ROW, snow,  SREL,   NATS,     &
     &           NSOIL,   MODE,    MAE,  NS, Z0CAM,  fhs,  SS, SURFDG,     &
     &        SAND6ROW,   TBAR, trnch)
!   if ( trnch .eq. 185) then
!    write(0,*)'wzz: aero 32 =', aero_tr(14,nk,63), aero_tr(14,nk,cncaDMS),cncaDMS
!   endif
      do l = 1, npg
         fracis(:,:,l) = aero_tr(:, 2:nk,l) - fracis(:,:,l)
         where (fracis(:,:,l)<0.) fracis(:,:,l) = 0.
      enddo
! output the emission results, wzz. 2008.8.1
      N = ssyc_idx1()-1
      do l = 1, npg
         call outfld(sflxnam(l+N) ,RSFROW(:,l), ni   ,trnch)
      enddo
!
      call t_stopf ('cauce_sfflux')
!
      return
      endif
!    ----------------------------------------------------------------------
!
!     apply vertical diffusion 
!
      do l=IAE1,gn_aerochem
        aero_local_loc(l)=aero_chem_loc(l)
      end do

      aero_local_loc(cncaSO2)=0
! the following call is not needed since it is done in ATM, wzz, 2008.2.19
!      call chem_trvdiff2(aero_tr,aero_local_loc,fktm,sig,ftv,dt*2.,ni,nk,
!     &                   NTR,trnch)
!     &                   gn_aerochem,trnch)

!    ----------------------------------------------------------------------
!
!         * PREPARATION FOR CALL AEROSOL PHYSICS
!
! get the input date here, wzz, 2008.9.17
      call ccrninpget( ni, trnch, OHROW, H2O2ROW, &
                     O3ROW, NO3ROW, HNO3ROW, &
                     aero_tr(:,2:,cncaNH3) )
!     call ccrninpget( ni, trnch, aero_tr(:,2:,cncaOH), aero_tr(:,2:,cncaH2O2), &
!                    aero_tr(:,2:,cncaO3), aero_tr(:,2:,cncaNO3), aero_tr(:,2:,cncaHNO3), &
!                    aero_tr(:,2:,cncaNH3) )
!     aero_tr(:,:,cncaH2O2) = 1.e-6
!
      do ik1=1,nk-1
        k = ik1 + 1
        do i=1,ni
!          do l=1,gn_aerochem
          do l=1, NTR      !  wzz, 2008.2.14
            rgrid(i,ik1,l) = aero_tr(i,k,l)
          enddo
        enddo
      enddo
!     call ccrninpget( ni, trnch, rgrid(:,:,cncaOH), rgrid(:,:,cncaH2O2), &
!                    rgrid(:,:,cncaO3), rgrid(:,:,cncaNO3), rgrid(:,:,cncaHNO3), &
!                    rgrid(:,:,cncaNH3) )
!
!     call ccrninpget( ni, trnch, OHROW, H2O2ROW, O3ROW, NO3ROW, &
!                         HNO3ROW, NH3ROW )
      do ik1=1,nk-1
        k = ik1 + 1
        do i=1,ni
          THLEV(i,ik1) = fdz(i,k)
!          RHROW(i,k) = FOHRA(q(i,k),t(i,k),psfc(i)*sig(i,k))

!         OHROW(i,ik1) = rgrid(i,ik1,cncaOH)
!         h2o2row(i,ik1) = rgrid(i,ik1,cncaH2O2)
!         o3row(i,ik1) = rgrid(i,ik1,cncaO3)
!         no3row(i,ik1) = rgrid(i,ik1,cncaNO3)
!         hno3row(i,ik1) = rgrid(i,ik1,cncaHNO3)
          nh3row(i,ik1) = rgrid(i,ik1,cncaNH3)
!         co2row(i,ik1) = rgrid(i,ik1,cncaCO2)
#ifdef GHG_2D
         call ghg_surfvals_get_co2vmr_2d(trnch,co2vmr_2d)
         co2row(i,ik1) =   co2vmr_2d(i,k1)
#else
          co2row(i,ik1) = chem_surfvals_get('CO2VMR')    
#endif
          cldcv(i,ik1,1) = frclds(i,k)
          cldcv(i,ik1,2) = frcldc(i,k)

          IF ((frclds(i,k)+frcldc(i,k)).NE.0.) THEN
            ZMLWC(i,ik1,1) = flwc(i,k)*frclds(i,k)/(frclds(i,k)+frcldc(i,k)) !strat.
            ZMLWC(i,ik1,2) = flwc(i,k)*frcldc(i,k)/(frclds(i,k)+frcldc(i,k)) !conv.
          ELSE
            ZMLWC(i,ik1,1) = 0.0
            ZMLWC(i,ik1,2) = 0.0
          ENDIF
          MODV(i,ik1) = fmodv(i,k)
!
          do isub=1, NSUB
            WSUB(i,ik1,isub) = fws(i,k)
          enddo
          tcld3(i,ik1) = cld_fn(i,k)
        enddo
      enddo
!     -----------------------------------------------------------
      do i=1,ni
        TSROW(i) = t(i,nk)        !come form aero_chem_v1
      enddo

      SAVERAD = 1.
      NSO4=2
      DO L=1,nk-1
         DO I=IL1,IL2              !apply these values for test only
           ZZ(I,L)= 0.39012E+02   !it is not used any more
!          ZFPREC(I,L)=1.E-9
!          WPEVPA(I,L)=0.5
!          WRSCAV(I,L)=0.5
         END DO
      END DO
!
!    COMPUTE THE CONDENSATION/NUCLEATION TIME INTERVALS
!
      DO I=1,15
         POP1=2.*dt/EXP(FLOAT(15-I)/1.7)
         IF (I .GE. 2) THEN
             CONDNU(I)=POP1-POP
             POP=POP1
         ELSE
             CONDNU(I)=POP1
             POP=POP1
         END IF
      END DO

!
      call t_startf ('cauce_camv5')
!
!         * CALL AEROSOL PHYSICS
!
      CALL CAM_V5   (nk-1,       nk,       ni,      IL1,      IL2,  &
     &              trnch,   ITRVAR,        t,    RHROW,      LON,  &
     &            aero_tr,     psfc,      SHJ,     SHTJ,     CAMR,  &
     &            lat_deg, long_deg,        q,      ITI,      ITR,  &
     &              TSROW,     MODV,   RSFROW,     EPSI,     DLEV,  &
     &                 F1,       F2,      FFG,     WROW,    IREST,  &
     &            TCSZROW,   CSZROW,      GMT,      MAE,      IGF,  &
!    &       TRACG,gn_aerochem,aerochem_np,    KOUNT,    fn_luc,    &
     &             gn_aerochem,aerochem_np,    KOUNT,    fn_luc,    &
     &             SURFDG,   SURFWD, AEROSIZE,   RHSIZE,     RHOP,  &
     &           AERONAME,aero_nsize,  ASO2ROW,  PSO2ROW,  ASO4ROW, &
     &            PSO4ROW,  DMSOROW,  DMSLROW,   H2SROW,     NSO4,  &
     &              OHROW,  H2O2ROW,    O3ROW,   NO3ROW,   CO2ROW,  &
     &             NH3ROW,  HNO3ROW,   TOTMAS,     NSUB,      IDD,  &
     &              PDIFF,    CLDCV,    ZMLWC,     WSUB,  SAVERAD,  &
     &            PRETROW,   RADCLD,    RGRID,  TRWTROW,   ROAROW,  &
     &              RHOP0,  AERONUM,      ice,     snow,   ZFPREC,  &
     &              PXNEW,    PDEPV,    RTCOA,   RTICLD,   RTBCLD,  &
     &              RTDRY,    RTVER,    THLEV,     DSHJ,    GDREM,  &
     &                JDD,    COLEF,   WETDEP,  cncaH2S, cncaH2O2,  &
     &            cncaDMS,  cncaSO2,  cncaSO4,     IAE1,     ICAM,  &
     &            cncaLWC,  cncaIWC,  cncaCCN,  cncaCLF,   CONDNU,  &
     &             RTCOND,    RTSO2,    RTSO4,    RTDMS,    RTH2S,  &
     &                VDG,    ffdss,     IDAYi,TFROW(1,nk),t(1,nk), &
     &              frluc,   RTNUCL,      RTH,      MSG,    IGFIJ,  &
     &             RCRITS,   RCOEXS,      WRZ,      WRY,      WRX,  &
     &                WRW,      WRU,      WRA,       MU,       EU,  &
     &                 DU,       MD,       MC,       ED,       DP,  &
     &                 DZ,       MB,     EPS0,      ZFG,  DSUBCLD,  &
     &                 ZZ,    IDEEP,       JT,     MAXG,       jd,  &
     &            LENGATH,   NTRACA,    RTHPO,     BETA,   DELIQS,  &
     &             RECRYS,   WPEVPA,   WRSCAV,   CLSIZE,   COAGFR,  &
     &               PVOL,     TMIN,       NG,       NS,       NL,  &
     &               PLLP,    Z0CAM,      scc,    RCW,   AC, CSPEC, &
     &             LAICAM,      RM0,      ZPD,     FCAP,   WP, RGW, &
     &               AEST,    GAMMA,      SOA,   ABCOEF,    SCCOEF, &
     &            AODROW1,  AODROW2,   RHRROW,    LAMDA,    tcld3,  &
     &             cld_fn,  modx)
!   if ( trnch .eq. 185) then
!    write(0,*)'wzz: aero 34 =', aero_tr(14,nk,63),aero_tr(14,nk,cncaDMS)
!   endif

!
      if ( modx == 1 ) then    ! wzz, 2008.9.1
!     do l = 1, aerochem_np*aero_nsize
      do l = 1, npg
         where( aero_tr(:, 2:nk,l)>1.e-30)   &
                fracis(:,:,l) = fracis(:,:,l)/aero_tr(:, 2:nk,l)
         where (fracis(:,:,l)<0.) fracis(:,:,l) = 0.
         where (fracis(:,:,l)>1.) fracis(:,:,l) = 1.
      enddo
      endif
!     LOAD ACCUMULATION OF CONCENTRATION
! output the deposion results, wzz. 2008.8.8
!
      do N = 1, aerochem_np
         names = ''
         if ( AERONAME(N).eq.'SEA-SALT') THEN
            names = 'SS01'
         endif
         if ( AERONAME(N).eq.'BLCARBON') THEN
            names = 'BC01'
         endif
         if ( AERONAME(N).eq.'OMCARBON') THEN
            names = 'OC01'
         endif
         if ( AERONAME(N).eq.'SOILDUST') THEN
            names = 'SD01'
         endif
         if ( len_trim(names) > 0 ) then   ! wzz, 2008.9.4
         if ( modx == 2 ) then
         do l = 1, aero_nsize
            write(names(3:4),'(I2.2)') l
            call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                        ni   ,trnch)
         enddo
         endif
         if ( modx == 1 ) then
         do l = 1, aero_nsize
            write(names(3:4),'(I2.2)') l
            call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                        ni   ,trnch)
            call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                        ni   ,trnch)
         enddo
         endif
         endif
      enddo
! for SULPHATE here
      do N = 1, aerochem_np
         names = ''
         if ( AERONAME(N).eq.'SULPHATE') THEN
!
         if ( modx == 2 ) then
         names = 'SF01'
         do l = 1, aero_nsize
            write(names(3:4),'(I2.2)') l
            call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                        ni   ,trnch)
         enddo
         l = aero_nsize+1
         names = 'DMS'
         call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                     ni   ,trnch)
         l = aero_nsize+2
         names = 'H2S'
         call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                     ni   ,trnch)
         l = aero_nsize+3
         names = 'SO2'
         call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                     ni   ,trnch)
         l = aero_nsize+4
         names = 'SO4'
         call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                     ni   ,trnch)
         l = aero_nsize+5
         names = 'H2O2'
         call outfld(trim(names)//'DRY' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,1), &
                     ni   ,trnch)
         endif
         if ( modx == 1 ) then
         names = 'SF01'
         do l = 1, aero_nsize
            write(names(3:4),'(I2.2)') l
            call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                        ni   ,trnch)
            call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                        ni   ,trnch)
         enddo
         l = aero_nsize+1
         names = 'DMS'
         call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                     ni   ,trnch)
         call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                     ni   ,trnch)
         l = aero_nsize+2
         names = 'H2S'
         call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                     ni   ,trnch)
         call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                     ni   ,trnch)
         l = aero_nsize+3
         names = 'SO2'
         call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                     ni   ,trnch)
         call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                     ni   ,trnch)
         l = aero_nsize+4
         names = 'SO4'
         call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                     ni   ,trnch)
         call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                     ni   ,trnch)
         l = aero_nsize+5
         names = 'H2O2'
         call outfld(trim(names)//'WETB' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,2), &
                     ni   ,trnch)
         call outfld(trim(names)//'WETI' ,GDREM(:,l+IAE1-1+(N-1)*aero_nsize,3), &
                     ni   ,trnch)
         endif
!
         endif
      enddo

      call t_stopf ('cauce_camv5')
          
 end subroutine aeroexe1
