      SUBROUTINE CAM_V5  (ILEV,      LEV,      ILG,      IL1,      IL2,  &
     &                     JLAT,   ITRVAR,    THROW,    RHROW,      LON,  &
     &                     XROW,   PRESSG,      SHJ,     SHTJ,     CAMR,  &
     &                   DEGLAT,   DEGLON,     QROW,       IT,      ITR,  &
     &                    TSROW,     MODV,   RSFROW,     EPSI,     DLEV,  &
     &                       F1,       F2,        F,     WROW,    IREST,  &
     &                  TCSZROW,   CSZROW,      GMT,      MAE,      IGF,  &
     &                                NTR,      NTP,    KOUNT,      LUC,  &
!    &                    TRACG,      NTR,      NTP,    KOUNT,      LUC,  &
     &                   SURFDG,   SURFWD, AEROSIZE,   RHSIZE,     RHOP,  &
     &                 AERONAME,    ISIZE,  ASO2ROW,  PSO2ROW,  ASO4ROW,  &
     &                  PSO4ROW,  DMSOROW,  DMSLROW,   H2SROW,     NSO4,  &
     &                    OHROW,  H2O2ROW,    O3ROW,   NO3ROW,   CO2ROW,  &
     &                   NH3ROW,  HNO3ROW,   TOTMAS,     NSUB,       ID,  &
     &                    PDIFF,    CLDCV,    ZMLWC,     WSUB,  SAVERAD,  &
     &                       QR,   RADCLD,    RGRID,  TRWTROW,   ROAROW,  &
     &                    RHOP0,  AERONUM,  SICNROW,  FSNOROW,   ZFPREC,  &
     &                    PXNEW,    PDEPV,    RTCOA,   RTICLD,   RTBCLD,  &
     &                    RTDRY,    RTVER,    THLEV,     DSHJ,    GDREM,  &
     &                       JD,    COLEF,   WETDEP,     IH2S,     IHPO,  &
     &                     IDMS,     ISO2,     ISO4,     IAE1,     ICAM,  &
     &                     ILWC,     IIWC,     ICDN,     ICLF,   CONDNU,  &
     &                   RTCOND,    RTSO2,    RTSO4,    RTDMS,    RTH2S,  &
     &                      VDG,   FSGROL,     IDAY,    GTROW,  SFCTROW,  &
     &                    FLAND,   RTNUCL,      RTH,      MSG,    IGFIJ,  &
     &                   RCRITS,   RCOEXS,      WRZ,      WRY,      WRX,  &! knut
     &                      WRW,      WRU,      WRA,       MU,       EU,  &! knut
     &                       DU,       MD,       MC,       ED,       DP,  &! knut
     &                       DZ,       MB,     EPS0,      ZFG,  DSUBCLD,  &! knut
     &                        Z,    IDEEP,       JT,     MAXG,      JDC,  &! knut
     &                  LENGATH,   NTRACA,    RTHPO,     BETA,   DELIQS,  &
     &                   RECRYS,   WPEVPA,   WRSCAV,   CLSIZE,   COAGFR,  &
     &                     PVOL,     TMIN,       NG,       NS,       ML,  &
     &                     PLLP,       Z0,      SCC,   RCW,   AC, CSPEC,  &
     &                      LAI,      RM0,      ZPD,    FCAP,   WP, RGW,  &
     &                     AEST,     GAMMA,     SOA,   ABCOEF,   SCCOEF,  &
     &                  AODROW1,   AODROW2,  RHRROW,    LAMDA,    tcld3,  &
     &                   cld_fn,   modx)
!------------------------------------------------------------------------
!     CAM - CANADIAN AEROSOL MODULE
!           VERSION 5.0b
!
!
!     HISTORY:
!     --------
!     * DEC 22/2000 - S.L. GONG   SOIL DUST IS IMPLEMENTED WITH THE FRENCH
!     *                           SCHEME.
!     *                           GLOBAL 1x 1 SOIL TEXTURE DATA WAS
!     *                           USED FROM GCM12.
!     * JUN 20/1999 - S.L. GONG   ADPATED FOR USE IN AURAMS.
!     *
!     * JAN 01/1998 - S.L. GONG   CAM VERSION 1.0 WITH AEROSOL ACTIVATION
!     *                           AND CLOUD CHEMISTRY
!     *
!     * OCT 01/1997 - S.L. GONG   INTERFACED WITH ADOM GAS DRYDEPOSITION
!     *
!     * JUL 09/1997 - S.L. GONG   ADD SULPHATE AEROSOL
!     *
!     * JAN 19/1996 - S.L. GONG   VECTORIZED THE WHOLE PROGRAM
!     *                           INTERFACED WITH GCM11.
!     *
!     * SEP 05/1994 - S.L. GONG   FIRST VERSION WITH FIZ-C
!     *
!------------------------------------------------------------------------
!-----------------------------------------------------------------------
!        |                                      | T |            |     |
! NAME   |                                      | Y | DIMENSIONS | IN/ |
!        |                                      | P |            | OUT |
!________|______________________________________|_E_|____________|_____|
! AERONUM| NUMBER-CONCENTRATION OF AEROSOL      | R | ILGVSIZ *1 |  I  |
!        | PARTICLES       [#/kg_air]           |   |            |     |
! ASO2ROW| CONCENTRATION IN M**3/M**3 (area src)| R | ILG        |  I  |
! ASO4ROW| CONCENTRATION IN M**3/M**3 (area src)| R | ILG        |  I  |
! BETA   | working array                        | R | ILG*ILEV*  |  L  |
!        |                                      |   | ISIZE**2   |     |
! BLCROW | CONCENTRATION IN M**3/M**3           | R | ILG*5*2    |  I  |
! CAM    | version no. of cam,                  | R |            |  I  |
!        |  (CAM>10. for AURAMS)                |   |            |     |
! CLDCV  | Cloud cover,1-Strat,2-Convec. [0-1.] | R | ILG*ILEV*2 |  I  |
! CLSIZE | activated ambient aerosol wet        | R | ILGVSIZ #  |  O  |
!        |   radius  [m] (cf. RHSIZE)           |   |            |     |
! COAGFR | coagulation transformation ratio     | R | ISIZE^3    |     |
! CO2ROW | CARBON DIOXIDE CONCENTR. [M^3/M^3]   | R | ILG*ILEV   |  I  |
! COLEF  | working array                        | R | ILGVSIZ #  |  L  |
! CSZROW | cosine of solar zenith angle         | R | ILG        |  I  |
! DELIQS | working array                        | R | CILGVSIZ # |  L  |
! DEGLAT | Grid latitude value                  | I | ILG        |  I  |
! DEGLON | Grid longitude value                 | I | ILG        |  I  |
! DMSOROW| CONCENTRATION IN [M^3/M^3]           | R | ILG        |  I  |
! DMSLROW| CONCENTRATION IN [M^3/M^3]           | R | ILG        |  I  |
! DSHJ   | Sigma value difference between layers| R | ILG*ILEV   |  O  |
! DSUBCLD| layer thickness in mbs               | R | ILG        |  L  |
!        | (between LCL and MAXI)               |   |            |     |
! DU     | detrainment in updraft               | R | ILG*ILEV   |  L  |
! DP     | working array                        | R | ILG*ILEV   |  L  |
! DZ     | working array                        | R | ILG*ILEV   |  L  |
! ED     | entrainment in downdraft             | R | ILG*ILEV   |  L  |
! EPSI   | energy dissipation rate              | R | ILG*ILEV   |  L  |
! EPS0   | working array                        | R | ILG        |  L  |
! EU     | entrainment in updraft               | R | ILG*ILEV   |  L  |
! F      | working array (see S/R SUBVVEL)      | R |ILGVSUB*2 ##|  L  |
! F1     | working array (see S/R SUBVVEL)      | R | ILGVSUB ## |  L  |
! F2     | working array (see S/R SUBVVEL)      | R | ILGVSUB ## |  L  |
! FINT3D |   (not be used in aurams)            | I |            |  I  |
! FINTROW| working array                        | R | ILG*ISIZE*2|  L  |
! FLAND  | working array                        | R | ILG*LUC    |  L  |
! FSGROL | Ground solar irradiance (W/M**2)     | R | ILG        |  I  |
! FSNROW | snow fraction                        | R | ILG        |  I  |
! GC     | ground cover                         | R | ILG        |  I  |
! GCROW  | CONCENTRATION IN [M**3/M**3]         | R | ILG        |  I  |
! GDREM  | working array for total ground level | R | ILG*NTR*3  |  L  |
!        |      tendency                        |   |            |     |
! GMT    | Greenwich meridian time of the day[s]| R |            |  I  |
! GTROW  | Ground temperature     (k)           | R | ILG        |  I  |
! H2O2ROW| CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! H2SROW | CONCENTRATION IN M**3/M**3           | R | ILG        |  I  |
! HNO3ROW| CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! ICDN   | index of ccn                         | I |            |     |
! ICAM   | index of last tracer of CAM          |   |            |     |
! IDEEP  | holds position of gathered           | I | ILG        |  L  |
!        | points vs longitude index            |   |            |     |
! IDAY   | Julian day                           | I |            |  I  |
! IDEEP  | working array                        | R | ILG        |  L  |
! IL1    | starting point of x direction -- 1   | I |            |  I  |
! IL2    | ending point of x direction  -- nis  | I |            |  I  |
! ILEV   | Number of model level                | I |            |  I  |
! ILG    | Number of grid points in x-direction | I |            |  I  |
! ISIZE  | Number of aerosol size bins          | I |            |  I  |
! IREST  | restart switch for CAM               | I |            |     |
! JD     | GCM array (not be used in aurams)    | I |            |  I  |
! JDC    | GCM array (not be used in aurams)    | I |            |  I  |
! JT     | top level index of deep cumulus      | I | ILG        |  I  |
!        | convection                           |   |            |     |
! JLAT   | Number of grid points in y-direction | I |            |  I  |
! KOUNT  | Model counts    (time step)          | I |            |  I  |
! LEV    | ILEV+1                               | I |            |  I  |
! LON    | Number of grid points in x-direction | I |            |  I  |
! LENGATH| GCM array (not be used in aurams)    | I |            |  I  |
! MAXG   | gathered values of MAXI              | I | ILG        |  L  |
! MB     | cloud base mass flux                 | R | ILG        |  I  |
! MC     | net upward cloud mass flux           | R | ILG*ILEV   |  I  |
! MD     | downward cloud mass flux(positive up)| R | ILG*ILEV   |  I  |
! MODV   | wind speed     [m/s]                 | R | ILG*ILEV   |  I  |
! MSG    | number of missing moisture levels    | I |            |  L  |
!        | at the top of model                  |   |            |     |
! MU     | upward cloud mass flux (positive up) | R | ILG*ILEV   |  I  |
! NH3ROW | CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! NO3ROW | CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! NSUB   | No. of subgrid for caculating        | I |            |  I  |
! NTRACA | not define in AURAMS                 | I |            |  I  |
! NG     | No. of gases for dry deposition      | I |            |  I  |
! O3ROW  | CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! OHROW  | CONCENTRATION IN M**3/M**3           | R | ILG*ILEV   |  I  |
! OMCROW | CONCENTRATION IN M**3/M**3           | R | ILG*5*2    |  I  |
! PDEPV  | dry deposition at first level  [m/s] | R | ILGVSIZ #  |  L  |
!        | gravitional velocity at other levels |   |            |     |
! PVOL   | dry aerosol bin volume [m^3]         |   |            |     |
! PRESSG | Grid row of surface pressure [Pa]    | R | ILG        |  I  |
! PXNEW  | general working array                | R |ILG*ILEV*NTR|  L  |
! PSO2ROW| CONCENTRATION IN M^3/M^3 (point src) | R | ILG        |  I  |
! PSO4ROW| CONCENTRATION IN M^3/M^3 (point src) | R | ILG        |  I  |
! QR     | Precip rate, 1 stratifor 2 Convective| R | ILG*ILEV   |  I  |
!        |      (kg /m2 s)                      |   |            |     |
! QROW   | specific humidity                    | R | ILG*LEV    |  I  |
! RECRYS | working array                        | R | ILGVSIZ #  |  L  |
! RHOP   | bin-specific wet aerosol density     | R | ILGVSIZ #  |  I  |
!        |      [kg/m^3]                        |   |            |     |
! RHOP0  | mass density of aerosol chemical     |   |            |     |
!        |      components [kg/m^3]             |   |            |     |
! RADCLD | mean radius of cloud droplets  [um]  | R | ILG*ILEV   |  I  |
! RTDRY  | dry deposition tendency              | R |ILG*ILEV*NTR|  O  |
! RHROW  | Slice of relative humidity [%]       | R | ILG*LEV    |  I  |
! RHSIZE | unactivated ambient aerosol wet      | R | ILGVSIZ #  |  O  |
!        |      radius  [m] (cf. CLSIZE)        |   |            |     |
! RGRID  | working arrey for aerosol species-bin|   |            |     |
!        |      mass mixing ratio [kg/kg]       |   |            |     |
! ROAROW | AIR DENSITY    [KG M-3]              | R | ILG*ILEV   |  I  |
! RSFROW |  surface flux    [kg/m^2*s]          | R | ILG*NTR    |  L  |
! RCRITS | BIN NUMBER (+ FRACTION UN-ACTIVATED) | R | ILG*ILEV*2 |  I  |
!        | OF SMALLEST ACTIVATED BIN [1-isize]  |   |            |     |
!        |    1 -> STRATIFORM CLOUDS            |   |            |     |
!        |    2 -> CONVECTIVE CLOUDS            |   |            |     |
! RCOEXS | RADIUS OF UNACTIVATED AEROSOL  [m]   | R | ILG*ILEV*2 |  L  |
!        | PARTICLES FOR PARTIALLY ACTIVATED BIN|   |            |     |
! RTVER  | vertical tendency                    | R |ILG*ILEV*NTR|  L  |
! RTCOA  | COAGULATION TENDENCY                 | R |ILG*ILEV*NTR|  O  |
! RTBCLD | BELOW-CLOUD SCAVENGING TENDENCY      | R |ILG*ILEV*NTR|  O  |
! RTHPO  | working array                        | R | ILG*ILEV   |  L  |
! RTICLD | In-cloud scavenging TENDENCY         | R |ILG*ILEV*NTR|  O  |
! RTSO2  | SULPHUR DIOXIDE TENDENCY             | R | ILG*ILEV*2 |  L  |
! RTSO4  | TENDENCY                             | R | ILGVSIZ #  |  L  |
! RTDMS  | TENDENCY                             | R | ILG*ILEV   |  L  |
! RTH2S  | TENDENCY                             | R | ILG*ILEV   |  L  |
! RTNUCL | NUCLEATION TENDENCY                  | R | ILG*ILEV   |  L  |
! RTCOND | CONDENSATION TENDENCY                | R | ILGVSIZ #  |  L  |
! RTH    | working array                        | R | ILGVSIZ #  |  L  |
! RTPAR  | working array for particle diffusion | R | ILGVSIZ #  |  L  |
!        |      coefficient (cf. PDIFF)         |   |            |     |
! SFCTROW| Surface level temperature [K]        | R | ILG        |  I  |
! SIGMAT | sigma thermal height                 | R | ILG*ILEV   |  O  |
! SIGMAM | sigma momentum height                | R | ILG*ILEV   |  O  |
! SIGMATH| sigma height of first level          | R | ILG        |  O  |
! SHJ    | Local mid-layer sigma value          | R | ILG*ILEV   |  O  |
! SHTJ   | Local interface (top) sigma value    | R | ILG*LEV    |  O  |
! SICNROW| ice fraction                         | R | ILG        |  I  |
! SNOROW | Row of snow amount                   | R |            |  I  |
! SOA    | secondary organic aerosol            | R | ILG*ILEV   |  I  |
! SURFDG | surface drag coefficient CDM=(U*/U)^2| R | ILG        |  I  |
! SURFWD | surface wind                         | R | ILG        |  I  |
! TCSZROW| Daily total cosine solar zenith angle| R | ILG        |  I  |
! THLEV  | layer thickness [m]                  | R | ILG*ILEV   |  I  |
! THROW  | Grid slice of mid-layer tempt. [K]   | R | ILG*LEV    |  I  |
! TOTMAS | bin-specific total dry  mass         | R | ILGVSIZ #  |  I  |
!        |     mixing ratio [kg/kg]             |   |            |     |
! TRACG  | Grid slice of tracer amount  [kg/kg] | R |ILG,ILEV,NTR|  I  |
! TRWTROW| water content of each bin [kg/kg]    | R | ILGVSIZ #  |  I  |
! TSROW  | First level temperature [K]          | R | ILG*ILEV   | I/O |
! VDG    | gas dry deposition velocity  [m/s]   | R | ILG*NG     |  O  |
! WETDEP | working array for wet-deposition     | R | ILGVSIZ #  |  L  |
! WROW   | Model vertical wind speed            | R | ILG*ILEV   |  I  |
! XROW   | Tracer array              [kg/kg]    | R | ILG*LEV*NTR|  I  |
! WPEVPA | evaporation fraction of precip.[0-1] | R | ILG*ILEV   |  L  |
! WRSCAV | scavenge fraction of precip.   [0-1] | R | ILG*ILEV   |  L  |
! WSUB   | sub-grid vertical velocity           | R | ILGVSUB ## |  I  |
! WRA    | working array                        | R | ILG*ILEV*36|  L  |
! WRU    | working array                        | R | ILG*ILEV   |  L  |
! WRW    | working array                        | R | ILG*ILEV*  |  l  |
!        |                                      |   | NTR*9      |     |
! WRX    | working array                        | R | ILG        |  L  |
! WRY    | working array                        | R | ILG*ILEV*  |  L  |
!        |                                      |   | NTRACA*2   |     |
! WRZ    | working array                        | R | ILG*ILEV*  |  L  |
!        |                                      |   | ISIZE*2*2  |     |
! Z      | grid slice of ambient mid-layer      | R | ILG*ILEV   |  I  |
!        | height in meters                     |   |            |     |
! ZFG    | working array                        | R | ILG*ILEV   |  L  |
! ZMLWC  | Cloud liquid water [kg/kg]           | R | ILG*ILEV*2 |  I  |
!        | 1-stratiform 2-convective            |   |            |     |
! ZM     | momentum layer height                | R | ILG*ILEV   |  I  |
! ZT     | thermal layer height                 | R | ILG*ILEV   |  I  |

      implicit none

      real DELT
      COMMON /TIMESc/DELT

       INTEGER IDEBUG, IMM, IMA, INU, ICOB,IDRYDEP,  &
     &        ITUBMIX, ICOAG, I_SS,IINCLD,IBLCLD,  ICCRN
      COMMON /AEROSWTH/ IDEBUG,   IMM,    IMA,   INU,  ICOB,IDRYDEP,  &
     &                 ITUBMIX, ICOAG,I_SS,IINCLD,IBLCLD,ICCRN     

      integer  ILEV,  LEV, ILG, IL1, IL2, JLAT, ITRVAR, LON,  &
     &         NSUB, NTR, ISIZE, MSG, IT, ITR, NTP, NTRACA
      integer IDAY, KOUNT, IREST
      integer IDMS, ISO2, ISO4, IAE1, ICAM,  &
     &        ILWC, IIWC, ICDN, ICLF, MAE, NSO4, IH2S, IHPO
      integer NG, NS, ML, ID, JD, LUC
      INTEGER  DLEV, LAMDA
!
      integer modx     ! wzz, 2009.9.1
!  modx=1 : wet deposition; modx=2 : dry deposition
!
      real CAMR, TMIN, GMT, SAVERAD
      REAL GTROW(ILG), SFCTROW(ILG)
      REAL DEGLAT(ILG), DEGLON(ILG), WETDEP(ILG,ILEV,ISIZE)
      REAL THLEV(ILG, ILEV), GDREM(ILG, NTR, 3)
      REAL THROW(ILG,LEV),RHROW(ILG,LEV),SHJ(ILG,ILEV),SHTJ(ILG,LEV)
      REAL FSNOROW(ILG), SICNROW(ILG)
      REAL QR(ILG,ILEV,2), RTVER(ILG,ILEV,NTR)
      REAL SURFDG(ILG),SURFWD(ILG),TOTMAS(ILG, ILEV,ISIZE)
      REAL RHSIZE(ILG,ILEV,ISIZE),CLSIZE(ILG,ILEV,ISIZE)
      REAL PDEPV(ILG,ILEV,ISIZE) ,ZFPREC(ILG,ILEV)
      REAL RHOP(ILG,ILEV,ISIZE), AEROSIZE(2,ISIZE), RHOP0(NTP)
      REAL RADCLD(ILG,ILEV),RGRID(ILG,ILEV,NTR),TRWTROW(ILG,ILEV,ISIZE)
      REAL RTDRY(ILG,ILEV,NTR), VDG(ILG, NG), FSGROL(ILG)
      REAL RTCOA(ILG,ILEV,NTR),RTBCLD(ILG,ILEV,NTR),RTICLD(ILG,ILEV,NTR)
      REAL RTSO2(ILG, ILEV,2),RTSO4(ILG,ILEV,ISIZE),RTDMS(ILG, ILEV)
      REAL RTH2S(ILG, ILEV), RTNUCL(ILG, ILEV),RTCOND(ILG, ILEV,ISIZE)
      REAL RTH(ILG,ILEV,ISIZE), PDIFF(ILG,ILEV,ISIZE)
      REAL PRESSG(ILG), DSHJ(ILG,ILEV), XROW(ILG,LEV,NTR)
!     REAL TRACG  (ILG,ILEV,NTR)
      REAL PXNEW(ILG,ILEV,NTR), AERONUM(ILG,ILEV,ISIZE)
      REAL ROAROW(ILG,ILEV), COLEF(ILG,ILEV,ISIZE)
      REAL DELIQS(ILG, ILEV,ISIZE),   RECRYS(ILG, ILEV,ISIZE)
      REAL ASO2ROW(ILG), PSO2ROW(ILG)
      REAL ASO4ROW(ILG),PSO4ROW(ILG)
      REAL DMSOROW(ILG),DMSLROW(ILG),H2SROW(ILG)
      REAL OHROW(ILG,ILEV), H2O2ROW(ILG,ILEV)
      REAL O3ROW(ILG,ILEV),  NO3ROW(ILG,ILEV)
      REAL CO2ROW(ILG,ILEV), NH3ROW(ILG,ILEV)
      REAL HNO3ROW(ILG,ILEV)
      REAL CLDCV(ILG,ILEV,2),ZMLWC(ILG,ILEV,2)
      REAL TSROW(ILG), QROW(ILG,LEV), MODV(ILG,ILEV), WROW(ILG,ILEV)
      REAL EPSI(ILG,ILEV), SOA(ILG,ILEV)
      REAL F1(ILG,ILEV,NSUB), F2(ILG,ILEV,NSUB)
      REAL WSUB(ILG,ILEV,NSUB)
      REAL BETA(ILG,ILEV,ISIZE*ISIZE)
      REAL WPEVPA(ILG,ILEV), WRSCAV(ILG,ILEV)
      REAL PVOL(ISIZE), COAGFR(ISIZE*ISIZE*ISIZE)
      INTEGER IGF(ISIZE),IGFIJ(ISIZE,ISIZE*ISIZE,2)

      REAL ABCOEF(ISIZE,13,NTP,14), RHRROW(ILG)
      REAL SCCOEF(ISIZE,13,NTP,14)
      REAL AODROW1(ILG,NTP,LAMDA),AODROW2(ILG,NTP,LAMDA)
           
      REAL TCSZROW(ILG),CSZROW(ILG)
      REAL FLAND(ILG,LUC), RSFROW(ILG,NTR)
      REAL RCRITS(ILG,ILEV,2),RCOEXS(ILG,ILEV,2)                        ! knut
      REAL WRA(ILG*ILEV*36)                                             ! knut
      REAL WRW(ILG,ILEV,NTR,9),WRX(ILG)                                 ! knut
      REAL WRY(ILG,ILEV,NTRACA,2),WRZ(ILG,ILEV,ISIZE,2,2)               ! knut
      REAL EPS0(ILG),MU(ILG,ILEV),EU(ILG,ILEV),DU(ILG,ILEV),MD(ILG,ILEV)! knut
      REAL MC(ILG,ILEV),ED(ILG,ILEV),DP(ILG,ILEV),DZ(ILG,ILEV),MB(ILG)  ! knut
      REAL ZFG(ILG,ILEV),DSUBCLD(ILG),RTHPO(ILG,ILEV)                   ! knut
      REAL Z(ILG,ILEV)                                                  ! knut
      REAL cld_fn(ILG,ILEV+1),tcld3(ILG,ILEV)                           ! FOR GEM-CAM

      REAL PLLP(LUC,NS),Z0(LUC,NS),SCC(NG), RCW(NG), AC(NG)
      REAL LAI(LUC,NS),RM0(NG), ZPD(LUC,NS)
      REAL FCAP(ML),WP(ML),RGW(NG)
      REAL AEST(LUC), GAMMA(LUC), CONDNU(15)
      CHARACTER*4 CSPEC(NG)

      LOGICAL WRU(ILG,ILEV), LSOA                                       ! knut
      INTEGER IDEEP(ILG),JT(ILG),MAXG(ILG),JDC(ILG),LENGATH             ! knut

      COMPLEX F(ILG,ILEV,2*NSUB)
      CHARACTER*8 AERONAME(NTP)
! local variables
      real DBSUM(ILG,ILEV), SGSUM(ILG,ILEV)   ! wzz, 2008.9.26
      integer IZON, I, L, N, NT
      real ADT2

      if ( modx.ne.1 .and. modx.ne.2 ) return
!
!     IF (IDEBUG .GE. 4 ) WRITE (*,*) ' CAM --> START'
!-----------------------------------------------------------------------
!      SECTION 0: INITIALIZATION
!
!-----------------------------------------------------------------------
      CALL PUTZERO (RTCOA,  ILG*ILEV*NTR)
      CALL PUTZERO (RTICLD, ILG*ILEV*NTR)
      CALL PUTZERO (RTBCLD, ILG*ILEV*NTR)
      CALL PUTZERO (PXNEW,  ILG*ILEV*NTR)
      CALL PUTZERO (GDREM,  ILG     *NTR*3)
      CALL PUTZERO (RTSO4,  ILG*ILEV*ISIZE)
      CALL PUTZERO (RTSO2,  ILG*ILEV*2)
      CALL PUTZERO (RTCOND, ILG*ILEV*ISIZE)
      CALL PUTZERO (RTNUCL, ILG*ILEV)
      CALL PUTZERO (PDEPV,  ILG*ILEV*ISIZE)
      CALL PUTZERO (PDIFF,  ILG*ILEV*ISIZE)
      CALL PUTZERO (RTDRY,  ILG*ILEV*NTR)
      CALL PUTZERO (COLEF,  ILG*ILEV*ISIZE)
!
      ADT2=2.*DELT
      IZON=2
      LSOA=.FALSE.
      DO N=IAE1,ICAM
         DO L=1+MAE,ILEV
            DO I=IL1,IL2
                RGRID(I,L,N)=XROW(I,L+1,N)
                IF (RGRID(I,L,N) .GT. 0.1 .OR.    &
     &              RGRID(I,L,N) .LT. 0.      )  THEN
                   IDEBUG=10
                   DLEV=L
                   ID=I
                   JD=JLAT
                   ITR=N
                   GOTO 150
                END IF
            END DO
          END DO
      END DO

!----------------------------------------------------------------------
!      SECTION 1:  AEROSOL PROPERTIES OF CLEAR SKY
!
!                  A - AMBIENT RADIUS AND DENSITY
!                  B - NUMBER DENSITY
!----------------------------------------------------------------------
     
      CALL AEROPROP (NTR,      NTP,      ILG,     ILEV,     IL1,   &
     &               IL2,    ISIZE,   RHSIZE, AEROSIZE,    RHOP,   &
     &             RHOP0,    RHROW,    THROW,    RGRID, AERONUM,   &
     &            TOTMAS,    PXNEW,     IAE1, AERONAME, TRWTROW,   &
     &             RTCOA,   RTICLD,   RTBCLD,   RTCOND, SAVERAD,   &
     &             RTDRY,    RTSO4,    COLEF,       F1,      F2,   &
     &               RTH,     WSUB,   DELIQS,   RECRYS,  ROAROW,   &
     &               SHJ,   PRESSG,    PDIFF,    PDEPV,     MAE)

!
      CALL PUTZERO (RTCOA,    ILG*ILEV*NTR)
      CALL PUTZERO (RTICLD,   ILG*ILEV*NTR)
      CALL PUTZERO (RTBCLD,   ILG*ILEV*NTR)
      CALL PUTZERO (RTCOND,   ILG*ILEV*ISIZE)
      CALL PUTZERO (COLEF,    ILG*ILEV*ISIZE)
      CALL PUTZERO (F1,       ILG*ILEV*NSUB)
      CALL PUTZERO (F2,       ILG*ILEV*NSUB)
      CALL PUTZERO (WSUB,     ILG*ILEV*NSUB)
      CALL PUTZERO (RTSO4,    ILG*ILEV*ISIZE)

!     IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)                    THEN
!        WRITE (*,*) ' AEROPROP -> AERONUM  ', AERONUM(ID,DLEV,ISIZE)
!        WRITE (*,*) ' AEROPROP -> TOTMAS   ', TOTMAS(ID,DLEV,ISIZE)
!        WRITE (*,*) ' AEROPROP -> RSFROW   ', RSFROW(ID,ITR), NTP,ITR
!        WRITE (*,*) ' AEROPROP -> XROW   ', XROW(ID,DLEV+1,ITR)
!     END IF

      if ( modx .eq. 1 ) then
!       if(JLAT.eq.185) then
!          write(0,*)'wzz: NTR= ', NTR, NTP
!          write(0,*)'wzz: jlat 0=', xrow(14,LEV,63), MU(2,ILEV), DZ(2,ILEV)
!       endif
!-----------------------------------------------------------------------
!       SECTION 2: AEROSOL-CLOUD INTERACTION
!
!                  A - AEROSOL ACTIVATION
!                  B - IN-CLOUD OXIDATION OF SO2
!                  C - IN-CLOUD SACVENGING OF AEROSOLS
!-----------------------------------------------------------------------
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF befor AEROCLD', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3)
!      endif
      CALL AEROCLD(THROW,     XROW, AERONAME, AEROSIZE,   &
     &               LEV,     ILEV,      ILG,      IL1,      IL2,   &
     &               SHJ,   PRESSG,       QR,      MAE,   &
     &            RADCLD,    RGRID,   RTICLD,   ZFPREC,   &
     &             PXNEW,   RHSIZE,     RHOP,     IHPO,     DSHJ,   &
     &              SHTJ,     IAE1,  AERONUM,    O3ROW,  H2O2ROW,   &
     &               NTR,      NTP,    ISIZE,    THLEV,     ADT2,   &
     &             GDREM,   ROAROW,       ID,       JD,   &
     &              ILWC,     IIWC,     ICDN,     ICLF,    CLDCV,   &
     &             ZMLWC,   CO2ROW,  HNO3ROW,   NH3ROW,    KOUNT,   &
     &              NSUB,     WSUB,     MODV,     WROW,     EPSI,   &
     &                 F,       F1,       F2,     QROW,    TSROW,   &
     &             RTSO2,    RTSO4,     JLAT,      LON,     NSO4,   &
     &              CAMR,       IT,      MSG,   WPEVPA,   WRSCAV,   &
     &            RCRITS,   RCOEXS,      WRZ,      WRY,      WRX,  &! knut
     &               WRW,      WRU,      WRA,       MU,       EU,  &! knut
     &               DU,        MD,       MC,       ED,       DP,  &! knut
     &               DZ,        MB,     EPS0,      ZFG,  DSUBCLD,  &! knut
     &                Z,     IDEEP,       JT,     MAXG,      JDC,  &! knut
     &          LENGATH,    NTRACA,    RTHPO,     ISO2,    RTCOA,  &
     &              RTH,COLEF(1,1,1), WETDEP,   IINCLD,COLEF(1,1,2),  &
     &           CLSIZE,    RTBCLD)
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF after AEROCLD', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3) &
!    &   , RTBCLD(14,ilev,53)
!      endif
!       if(JLAT.eq.185) then
!          write(0,*)'wzz: jlat 1=', xrow(14,LEV,63), OHROW(14,ILEV)
!       endif
!
      CALL PUTZERO (RTH,      ILG*ILEV*ISIZE)
      CALL PUTZERO (RTCOA,    ILG*ILEV*NTR)
      CALL PUTZERO (F1,       ILG*ILEV*NSUB)
      CALL PUTZERO (F2,       ILG*ILEV*NSUB)
      CALL PUTZERO (WETDEP,   ILG*ILEV*ISIZE)

      IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)                  THEN
!        write(*,*)'wzz: DLEV=', ID, DLEV, ITR, JD
         WRITE (*,*) ' AEROCLD -> RTICLD  ', RTICLD(ID,DLEV,ITR)
         WRITE (*,*) ' AEROCLD -> CLD FR  ', CLDCV(ID,DLEV,1), &
     &                                                  CLDCV(ID,DLEV,2)
         WRITE (*,*) ' AEROCLD -> CLD WT  ', ZMLWC(ID,DLEV,1), &
     &                                                  ZMLWC(ID,DLEV,2)
         WRITE (*,*) ' AEROCLD -> PRECIP  ', QR(ID,DLEV,1),QR(ID,DLEV,2)
         WRITE (*,*) ' AEROCLD -> EP & SV ', WPEVPA(ID,DLEV), &
     &                                                 WRSCAV(ID,DLEV)
         WRITE (*,*) ' AEROCLD -> RTSO4   ', RTSO4(ID,DLEV,ISIZE)
         WRITE (*,*) ' AEROCLD -> RTSO2   ', RTSO2(ID,DLEV,2)
         WRITE (*,*) ' AEROCLD -> XROW   ', XROW(ID,DLEV+1,ITR)
      END IF
  100 CONTINUE

!----------------------------------------------------------------------
!       SECTION 3:  SULPHUR PHYSICS AND CHEMISTRY [CLEAR SKY]
!                   SOA CONSENDATION
!
!                  A - SULPHUR CHEMISTRY
!                  B - NUCLEATION AND CONDENSATION
!----------------------------------------------------------------------
      DO NT=1,NTP
!           print *, AERONAME(NT)
         IF (AERONAME(NT) .EQ. 'SULPHATE' )                   THEN
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF befor SULFATE', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3)
!      endif
             CALL SULFATE ( LEV,     ILEV,      ILG,      IL1,    IL2,  &
     &                     IH2S,     IDMS,     ISO2,     ISO4,  RGRID,  &
     &                  AERONUM,     XROW,      NTR,      NTP, ROAROW,  &
     &                PRESSG,    THROW,    RHROW,      SHJ,PXNEW(1,1,1),  &
     &                 OHROW,   NO3ROW,       NT,    KOUNT,PXNEW(1,1,2),  &
     &                   RHSIZE, AEROSIZE,  TCSZROW,   CSZROW,  JLAT,  &
     &                    ISIZE,     DELT,   RTNUCL,    RHOP0,   LON,  &
     &              RTCOND,    RTSO2,    RTDMS,    RTH2S, PXNEW(1,1,3),  &
     &               CLDCV,PXNEW(1,1,4), TOTMAS,     RTH, IAE1,  &
     &                PVOL,   TMIN,  COLEF, CAMR, MAE,  &
     &                CONDNU)
           IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)               THEN
               WRITE (*,*) ' SULFATE -> RTNUCL  ', RTNUCL(ID,DLEV)
               WRITE (*,*) ' SULFATE -> RTCON   ', RTCOND(ID,DLEV,ISIZE)
               WRITE (*,*) ' SULFATE -> RTSO2   ', RTSO2(ID,DLEV,1)
               WRITE (*,*) ' SULFATE -> XROW    ', XROW(ID,DLEV+1,ITR)
           END IF
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF after SULFATE', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3)
!      endif
         END IF
!          print *, 'end of sulfate'
         IF (AERONAME(NT) .EQ. 'OMCARBON' .AND. LSOA)         THEN
             CALL CONDSOA ( LEV,     ILEV,      ILG,      IL1,    IL2,  &
     &                    RGRID,  AERONUM,     XROW,      NTR,    NTP,  &
     &                   ROAROW,       NT, AEROSIZE,     JLAT,  ISIZE,  &
     &                     DELT,   RTCOND,      RTH,     IAE1,   PVOL,  &
     &                     TMIN,    COLEF,    RHOP0,      SOA,   CAMR,  &
     &                      MAE)
         END IF
!          print *, 'end of SOA'
      END DO
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: jlat 2=', xrow(14,LEV,63)
!      endif

!---------------------------------------------------------------------
!       SECTION 4: COAGULATION
!
!---------------------------------------------------------------------
!
      IF (ICOAG .NE. 0) THEN
      CALL COAGD   (   ILG,    IL1,    IL2,     ILEV, THROW,  &
     &               ISIZE, ROAROW,  RTCOA,   RHSIZE,TOTMAS,  &
     &             AERONUM,    NTR,    NTP,   COAGFR,  IAE1,  &
     &               DBSUM,  SGSUM,    F1,    PXNEW, KOUNT,  &
     &                BETA,   ADT2,  ICOAG,    IREST,  XROW,  &
     &                PVOL, WETDEP,   JLAT,     ICOB,  TMIN,  &
     &               PDEPV,  PDIFF,  COLEF,      RTH,   MAE,  &
     &                 IGF,  IGFIJ,   RHOP, AEROSIZE, RECRYS,  &
     &              PRESSG,   DSHJ,  GDREM)

      IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)               THEN
         WRITE (*,*) ' COAGD -> RTCOA  ', RTCOA(ID,DLEV,ITR),ICOB
         WRITE (*,*) ' COAGD -> XROW   ', XROW(ID,DLEV+1,ITR)
      END IF

      END IF
!
!     if(JLAT.eq.185) then
!        write(0,*)'wzz: jlat 3=', xrow(14,LEV,63), MU(2,ILEV)
!     endif
!----------------------------------------------------------------------
!
!     SECTION 5: BELOW-CLOUD SCAVENGING OF AEROSOLS
!
!                  A - RAIN OR SNOW SCAVENGING
!---------------------------------------------------------------------
!
      IF (IBLCLD .NE. 0) THEN
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF befor SCAVENG', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3)  &
!    &   , RTBCLD(14,ilev,53)
!      endif
      CALL SCAVENG (THROW,    CLDCV,   XROW,      MAE,  &
     &                LEV,     ILEV,    ILG,      IL1,      IL2,  &
     &                SHJ,PRESSG,PDEPV,RCOEXS(1,1,1),RCRITS(1,1,1),  &
     &             RADCLD,       QR, RTBCLD,   RTICLD,  &
     &              PXNEW,   RHSIZE,   RHOP,     QROW,  &
     &               DSHJ,     IAE1,  PDIFF,     TMIN,     ISO2,  &
     &                NTR,      NTP, ISIZE,     THLEV,     ADT2,  &
     &              GDREM,   ROAROW,  COLEF,   WETDEP,    tcld3)
      IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)                THEN
         WRITE (*,*) ' SCAVENG -> RTBCLD  ', RTBCLD(ID,DLEV,ITR)
         WRITE (*,*) ' SCAVENG -> XROW    ', XROW(ID,DLEV+1,ITR)
      END IF

!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF after SCAVENG', xrow(14,lev,53), GDREM(14,53,2),GDREM(14,53,3)  &
!    &   , RTBCLD(14,ilev,53)
!      endif
      END IF
      end if    !  modx == 1
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: jlat 4=', xrow(14,LEV,63), modx
!      endif
!---------------------------------------------------------------------
!
!       SECTION 6: SEDIMENTATION AND DRY DEPOSITION
!
!                  A - PARTICLE DRY DEPOSITION AND GRAVITATIONAL
!                          SETTLING
!                  B - GAS DRY DEPOSITION
!---------------------------------------------------------------------
      if ( modx .eq. 2 ) then

      IF (IDRYDEP .NE. 0) THEN
  
!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF befor DRYDEPO', xrow(14,lev,53), GDREM(14,53,1)
!      endif
      CALL DRYDEPO(ILEV,      LEV,      ILG,      IL1,      IL2,  &
     &              VDG,   SURFWD,    GTROW,  SFCTROW,      MAE,  &
     &           FSGROL,   DEGLAT,F1(1,1,1),F1(1,1,2),F1(1,1,3),     &
     &          SICNROW,  FSNOROW,    THROW,    ISIZE,      NTP,  &
     &              NTR,     ADT2,   PRESSG,      SHJ,     TMIN,  &
     &            THLEV,   ROAROW,     RHOP,   RHSIZE,     ISO2,  &
     &             IDMS,    FLAND,     XROW,   SURFDG,    PDEPV,  &
     &            RTDRY,    PXNEW,     DSHJ,    GDREM,     IAE1,  &
     &            CLDCV,    RHROW,     IDAY,     JLAT,    PDIFF,  &
     &              LUC,     CAMR,       NG,       NS,       ML,  &
     &             PLLP,       Z0,      SCC,      RCW,      AC, CSPEC,  &
     &              LAI,      RM0,      ZPD,     FCAP,      WP, RGW,  &
     &             AEST,    GAMMA)

!      if(JLAT.eq.185) then
!         write(0,*)'wzz: SF after DRYDEPO', xrow(14,lev,53),GDREM(14,53,1)
!      endif
!     IF (IDEBUG .GE. 1 .AND. JLAT.EQ. JD)              THEN
!        WRITE (*,*) ' DRYDEPO -> RTDRY  ', RTDRY(ID,DLEV,ITR)
!        WRITE (*,*) ' DRYDEPO -> XROW    ', XROW(ID,DLEV+1,ITR)
!     END IF
      END IF

      end if    !  modx == 2

  150 CONTINUE
!----------------------------------------------------------------------
!
!       SECTION 7: OPTICAL CALCULATIONS
!
!---------------------------------------------------------------------
! zch not used in current version
!      CALL AODEPTH ( XROW,RHOP0,ABCOEF,SCCOEF, AODROW1,AODROW2,
!     1         RHROW(1,2),  DSHJ,  PRESSG, PXNEW(1,1,1), AERONAME,
!     1    RHRROW,  RHSIZE, PXNEW(1,1,2), PXNEW(1,1,3),PXNEW(1,1,4),
!     1                       SHJ,  CLDCV,  EPS0,COLEF,RTCOND,
!     1                       ILG,  ILEV,     LEV, NTR, ISIZE, NTP,
!     1                      IAE1,   IL1,   IL2,
!     1            PXNEW(1,1,5), PXNEW(1,1,6),PXNEW(1,1,7),LAMDA)

      IF (IDEBUG .EQ. 10) THEN
          WRITE (*,*) ' TRACER CONCENTRATION IS TOO HIGH OR NEGATIVE'
          WRITE (*,*) ' OVERFLOW IS LIKELY. CAM STOPS '
          WRITE (*,*) ' TRACER ',ITR, '= ', RGRID(ID,DLEV,ITR)
          WRITE (*,*) ' DLEV    ID      JD    ITR      IT '
          WRITE (*,*) DLEV,    ID,      JD,    ITR,      IT
          CALL XIT                (' CAM_V05', -1)
      END IF
!
      RETURN
      END
