!----------------------------------------------------------------------------
      subroutine chem_trvdiff2(frtr,tr_loc,kt,S,tv,dt,gni,gnk,gntrnb,  &
     &                         trnch)
!----------------------------------------------------------------------------
!     driver to perform vertical diffusion for tracers	
!----------------------------------------------------------------------------
#include "phy_macros_f.h"
#include "impnone.cdk"
!
#include "cam_cons.cdk"
!#include "consphy.cdk"
!
      integer gni,gnk,gntrnb,trnch,status
      real kt(gni,gnk),S(gni,gnk),tv(gni,gnk)
      real frtr(gni,gnk,gntrnb)
      real tr_loc(gntrnb)
      real dt
      real rsg,gam0
!      
      integer i,k,itr
!
      real, dimension(:,:), allocatable :: seloc
      real, dimension(:,:), allocatable :: tu
      real, dimension(:,:), allocatable :: wka
      real, dimension(:,:), allocatable :: wkb
      real, dimension(:,:), allocatable :: wkc
      real, dimension(:,:), allocatable :: wkd
      real, dimension(:,:), allocatable :: ktx
!
      allocate (seloc (gni,gnk))
      allocate (tu    (gni,gnk))
      allocate (wka   (gni,gnk))
      allocate (wkb   (gni,gnk))
      allocate (wkc   (gni,gnk))
      allocate (wkd   (gni,gnk))
      allocate (ktx   (gni,gnk))
       
!
!----------------------------------------------------------------------------
!
      call difuvd9(seloc,.true.,S,gni,gnk,gnk)
!                                  
!      RSG = (GRAV/RGASD)
      RSG = (G/RGAS)
!P ---------------------------------------------ADD FROM NARCM
      DO K=1,gnk
         DO i=1,gni
            KT(i,k)=AMAX1(0.1,KT(i,k))
         END DO
      END DO   
!P-----------------------------------------------------------
      DO K=1,gnk-1
         DO i=1,gni
            GAM0 = RSG*SELOC(i,k)/TV(i,k)
!            write(*,'a6,3i3,4(1pe12.3))'SELOC ',i,trnch,k,gam0,rsg,seloc(i,k),tv(i,k)
!             if(k.gt.gnk-2.and.KT(i,k).lt.0.1)  KT(i,k)=0.1    !  test    !!!!
!P             if(k.eq.gnk-1.and.kt(i,gnk).gt.kt(i,k)) kt(i,k)=kt(i,gnk)  !  test    from ctmdiag!!!!
!x            if(kt(i,k).lt.0.1.and.k.gt.19) write(*,*) 'KT-small',i,k, KT(i,k)
            KTx(i,k) = KT(i,k) * GAM0*GAM0 
!            if((i.eq.78).and.(trnch.eq.5))
!     $             write(*,33) i,trnch,k,TV(i,k),KTx(i,k),KT(i,k)
33	    format('KT-diag:',3i3,6(1pe12.3))
         END DO
      END DO
!      	
      do itr=1,gntrnb
        call zero(tu,gni*gnk)
        if (tr_loc(itr).eq.0) then
!         if ((itr.eq.10).and.(trnch.eq.5))
!     $            write(*,*)'frtr10 b4',frtr(78,23,10),ktx(78,23),
!     $                         s(78,23),seloc(78,23)
!          write(*,*)'CALLING difvchem, itr,trnch=',itr,trnch
        call difvchem(frtr(1,1,itr),tu,ktx,S,seloc,wka,wkb,wkc,wkd, &
     &                dt,gni,gnk)
!         if ((itr.eq.10).and.(trnch.eq.5))
!     $           write(*,*)'frtr10 aft',frtr(78,23,10)
        endif
      end do
!
!----------------------------------------------------------------------------
      deallocate (seloc,stat=status)
      deallocate (tu,stat=status)
      deallocate (wka,stat=status)
      deallocate (wkb,stat=status)
      deallocate (wkc,stat=status)
      deallocate (wkd,stat=status)
      deallocate (ktx,stat=status)
!
      RETURN
      END
!----------------------------------------------------------------------------
      SUBROUTINE DIFVCHEM(U,TU, KU, S, SK, A, B, C, D, TAU, N, NK)
!----------------------------------------------------------------------------
!
      implicit none 
!
      INTEGER N, NK
      REAL TAU
      REAL U(N, NK)
      REAL TU(N, NK), KU(N, NK), S(N,NK), SK(N,NK)
      REAL A(N, NK), B(N, NK), C(N, NK), D(N, NK)
!
!Author
!          R. Benoit (Mar 89)
!
!Revisions
! 001      R. Benoit (Aug 93) -Local sigma: s and sk become 2D
! 002      B. Bilodeau (Dec 94) - "IF" tests on integer 
!          instead of character.
! 003      D. Plummer (June 98) - stripped down version of difuvdfj
!          used for vertical diffusion of chemical tracers
!Object
!          to solve a vertical diffusion equation by finite
!          differences
!
!Arguments
!
!          - Output -
! TU       tendancy due to vertical diffusion
!
!          - Input -
! U        variable to diffuse (U,V,T,Q,E)
! KU       diffusion coefficient
! S        sigma coordinates of full levels
! SK       sigma coordinates of diffusion coefficient levels
! TAU      length of timestep
! A        work space (N,NK)
! B        work space (N,NK)
! C        work space (N,NK)
! D        work space (N,NK)
! N        horizontal dimension
! NK       vertical dimension
!
!Notes
!          D/DT U = D(U) + R
!          D(U) = D/DS J(U)
!          J(U) = KU*(D/DS U + GU)
!          Limiting Conditions where S=ST: J=0(for 'U'), D=0(for 'UT'
!          and ST=1)
!          U=0(for 'E')
!          Limiting Conditions where S=SB: J=ALFA+BETA*U(S(NK))(for
!          'U'/'UT'), J=0(for 'E')
!          ST = S(1)-1/2 (S(2)-S(1)) (except for 'TU')
!          SB = SK(NK)
!
!*
!
      INTEGER I, K, NKX
      REAL SC, ST, SB, HM, HP, HD, SCK1, F
      EXTERNAL DIFUVD1, DIFUVD2
!
      st(i)=s(i,1)
      sb(i)=sk(i,nk)
!
!     these definitions hereunder for st, sb are always true.
!     so use as statement functions in code directly
!     to handle local sigma.
!     ST=S(1)
!     SB=SK(NK)
!
      SC=1
      NKX=NK
      SCK1=1
      F = 1.0
!x
!===

!       write(*,*) 'difvchem: tau=',tau
!       write(*,*) 'difvchem-start: N=',n,' nk=',nk
      
!       do k=1,nk
!           write(*,3344) k,u(1,k),tu(1,k),ku(1,k),s(1,k),sk(1,k)
3344       format('DIFVCHEM: ',3(1x,1pe12.3),2(1x,0pf8.5))
!      end do
!      call flush (6)
!      call abort
!
!=====
!
!
! (1) CONSTRUIRE L'OPERATEUR TRIDIAGONAL DE DIFFUSION N=(A,B,C)
!                ET LE TERME CONTRE-GRADIENT (DANS D)
!
!     K=1
!
      HM=0
      DO 10 I=1,N
         HP=S(i,2)-S(i,1)
         HD=0.5*(S(i,1)+S(i,2))-ST(i)
         A(I,1)=0
         B(I,1)=-SCK1*KU(I,1)/(HP*HD)
         C(I,1)=-SCK1*B(I,1)
         D(I,1)= 0.0
 10   CONTINUE
!
!     K=2...NK-1
!
      DO 11 K=2,NK-1,1
         DO 11 I=1,N
            HM=S(i,K)-S(i,K-1)
            HP=S(i,K+1)-S(i,K)
            HD=0.5*(HM+HP)
            A(I,K)=KU(I,K-1)/(HM*HD)
            B(I,K)=-(KU(I,K-1)/HM +KU(I,K)/HP)/HD
            C(I,K)=KU(I,K)/(HP*HD)
            D(I,K)= 0.0
 11   CONTINUE
!
!     K=NK
!
      HP=0
      DO 12 I=1,N
         HM=S(i,NK)-S(i,NK-1)
         HD=SB(i)-0.5*(S(i,NK-1)+S(i,NK))
         A(I,NK)=KU(I,NK-1)/(HM*HD)
         B(I,NK)=-(KU(I,NK-1)/HM + 0)/HD
         C(I,NK)=0.0
         D(I,NK)=0.0
 12   CONTINUE
!
! (2) CALCULER LE COTE DROIT D=TAU*(SC*N(U)+R+D/DS(KU*GU))
!
!      write(*,*)'difuvd1,AB',U(78,23),A(78,23),B(78,23),c(78,23),d(78,23)
      CALL DIFUVD1 (D, SC, A, B, C, U, D, N, N, NKX)
      DO 20 K=1,NKX
         DO 20 I=1,N
!         if ((k.eq.23).and.(i.eq.78))write(*,*)'after difuvd1 D=',d(i,k)
20       D(I,K)=TAU*D(I,K) 
!
! (3) CALCULER OPERATEUR DU COTE GAUCHE
!
      DO 30 K=1,NKX
         DO 30 I=1,N
            A(I,K)= -F*TAU*A(I,K)
            B(I,K)=1-F*TAU*B(I,K)
30          C(I,K)= -F*TAU*C(I,K)
!
! (4) RESOUDRE SYSTEME TRIDIAGONAL [A,B,C] X = D. METTRE X DANS TU.
!
!      write(*,*)'difuvd2,ABC',A(78,23),B(78,23),c(78,23),D(78,23),N,NKX
      CALL DIFUVD2 (TU, A, B, C, D, D, N, N, NKX)
!
! (5) in the original code:  OBTENIR TENDANCE
!     original code in loop-40  TU(I,K)=TU(I,K)/TAU
!
!
!     for tracers in sef+c: ADD tendencies ... jwk 15.06.2000
!
!          write(*,*)'before 78,23 u,tu,ku,s,sk'
!         write(*,3344) u(78,23),tu(78,23),ku(78,23),s(78,23),sk(78,23)

      DO 40 K=1,NKX
         DO 40 I=1,N
!           if ((k.eq.23).and.(i.eq.78))write(*,*)'jwk',u(i,k),tu(i,k)
            u(i,k)=u(i,k)+tu(i,k)   ! <------ jwk 15.06.2000
 40   CONTINUE
!
!      do k=1,nk
!         write(*,3344) k,u(1,k),tu(1,k),ku(1,k),s(1,k),sk(1,k)
!      end do
       call flush (6)
!      call abort

!=====

      RETURN
      END

!----------------------------------------------------------------------------
      SUBROUTINE print_dif(TU, U, KU, GU, R, ALFA, BETA, S, SK,   &
     &                    TAU, TYPE, F, A, B, C, D, NU, NR, N, NK)
!----------------------------------------------------------------------------
!

      INTEGER NU, NR, N, NK
      REAL TU(NU, NK), U(NU, NK), KU(NR, NK), GU(NR, NK), R(NR,NK)
      REAL ALFA(N), BETA(N), S(n,NK), SK(n,NK), TAU, F
      INTEGER TYPE
      REAL A(N, NK), B(N, NK), C(N, NK), D(N, NK)
      INTEGER I, K, NKX
      REAL SC, SCTU, ST, SB, HM, HP, HD, KUM, KUP, SCK1
!
	j=1

	write(*,*) 'start print_dif'
	write(*,*) 'TAU, TYPE, F=',TAU, TYPE, F
	write(*,*) 'NU, NR, N, NK =',NU, NR, N, NK
	write(*,*)'k,(tu(j,k),u(j,k),ku(j,k),gu(j,k),r(j,k),s(j,k),sk(j,k)'
	do k=1,nk
!	   write(*,33) k,tu(j,k),u(j,k),ku(j,k),gu(j,k),r(j,k),s(j,k),sk(j,k)
33	   format(i3,10(1pe12.3))
	end do

!x	write(*,*) 'TU=',tu
!x	write(*,*) 'U=',u
!x	write(*,*) 'KU=',ku
!x	write(*,*) 'GU=',gu
!x	write(*,*) 'R=',r
!x	write(*,*) 'S=',s
!x	write(*,*) 'SK=',sk

	write(*,*) 'ALFA=',alfa(j)
	write(*,*) 'BETA=',beta(j)
	write(*,*) 'end of print_dif'
          write(0,*)'lqx: step 3-6-6-5'
!
      RETURN
      END


      subroutine zero(a,n)
!------------------------------------------------------------------------
      real a(n)
!------------------------------------------------------------------------
      do i=1,n
         a(i)=0.0
      end do
!------------------------------------------------------------------------
      return
      end

