      SUBROUTINE INCLD (   ILG,   ILEV,    LEV,    NTR,     IAE1,  &
     &                   ISIZE,    MAE,   CAMR,    IL1,      IL2,  &
     &                  PRECTR, RCRITS,   XROW, WRSCAV,     DELT,  &
     &                  WPEVPA, RTICLD,  GDREM, PRESSG,     DSHJ,  &
     &                    ISO2,   IHPO,     NN,      G,      NTP,  &
     &                  ZFPREC,  CLDCV, ASRSO2, ASRHPO )
!-----------------------------------------------------------------------
!
!     HISTORY:
!     --------
!     * DEC 20/1998 - S.L. GONG   INCLOUD PROCESSES
!     *                           RAIN-OUT OF AEROSOLS
!     *                           AND SO2.
!     * WRSCAV - WATER CONDENSATION RATE (KG/M3 S)
!     * ZFPREC - PRECIPITATION PRODUCTION RATE (KG/KG S)
!     * WPEVPA - PRECIPITATION EVAPOURATION RATE (KG/KG S)

      implicit none
!
      integer ILG, ILEV, LEV, IL1, IL2
      integer IAE1, ISIZE, MAE
      integer NTR
      integer ISO2, IHPO, NN, NTP
      real CAMR, DELT, G
!
      REAL PRESSG(ILG),  RTICLD(ILG,ILEV,NTR) , DSHJ(ILG,ILEV)
      REAL RCRITS(ILG,ILEV,2),PRECTR(ILG,NTR)
      REAL WPEVPA(ILG,ILEV), WRSCAV(ILG,ILEV),ZFPREC(ILG,ILEV)
!     REAL TONE(12),CLDCV(ILG,ILEV,2)
      REAL TONE(ISIZE),CLDCV(ILG,ILEV,2)
      REAL GDREM(ILG,NTR,3), XROW(ILG,LEV,NTR)
      REAL ASRSO2(ILG,ILEV), ASRHPO(ILG,ILEV) 
!
      integer I, L, N, NA, NP
      real SCAV, xold, fract, frac1, frac2, ff
      real zevp, beta, aratio

!xjx-----------20090821
      real CVMGT
      external CVMGT
!xjx-----end

!      DATA TONE /1.0,0.7,0.4,0.2,0.1,0.2,0.4,0.7,0.8,0.9,1.0,1.0/

!     DO N=1,12
      DO N=1,ISIZE
         TONE(N)=1.0
      END DO

      CALL PUTZERO(PRECTR, ILG*NTR)
      DO NN=1,NTP
         DO N=1, ISIZE
            NP=ISIZE*(NN-1)+N+(IAE1-1)
            DO L=1+MAE,ILEV
               DO I=IL1,IL2
                  NA=INT(RCRITS(I,L,1))
                  IF (N .GE. NA ) THEN
!
!     AEROSOL RAIN-OUT
!     FROM GIORGI AND CHAMEIDES [1986]
!
!  For stable precipitation here?  wzz, 2008.10.24
                      IF (WRSCAV(I,L) .GT. 1.E-18) THEN
                        ARATIO=0.5E-3/WRSCAV(I,L)
                        BETA=1.E-4 + 1./(0.8*ARATIO)
                        FF=0.8/(1.0+0.8E-4*ARATIO)
                        FRAC1=FF*(EXP(-BETA*2.*DELT)-1.0)
                        XOLD = XROW(I,L+1,NP)

                        SCAV=AMIN1(XOLD*FRAC1/(2.*DELT), 0.)*TONE(N)
                        FRACT=1.- (RCRITS(I,L,1)-REAL(NA))
                        RTICLD(I,L,NP)=CVMGT(SCAV*FRACT,       &
     &                                     SCAV, N .EQ. NA)
!
!     ACCUMULATIVE TRACER FLUX TO PRECIPITATION [KG M-2 S-1]
!
                        PRECTR(I,NP)=PRECTR(I,NP)-RTICLD(I,L,NP)*   &
     &                                         (DSHJ(I,L)*PRESSG(I)/G)
!                      if(i.eq.14.and.np.eq.60.and.l.eq.ilev) then
!                         write(0,*)'wzz: prectr=',prectr(i,np),SCAV,ZFPREC(I,L)
!    &                    ,WRSCAV(I,L)
!                      endif
                      END IF
                  END IF
!
!     AEROSOL PRODUCTION DUE TO EVAPORATION OF CLOUDS
!
                  IF (ZFPREC(I,L) .GT. 1.E-18)  THEN
                     FRAC2=AMAX1(AMIN1(WPEVPA(I,L)/ZFPREC(I,L),1.0),0.0)
                     ZEVP=FRAC2*PRECTR(I,NP)/(DSHJ(I,L)*PRESSG(I)/G)
                     RTICLD(I,L,NP)=RTICLD(I,L,NP)+ZEVP
!                      if(i.eq.14.and.np.eq.60.and.l.eq.ilev) then
!                  if(PRECTR(I,NP).gt.0)write(0,*)'wzz: frac2 =',frac2
!    &            ,WPEVPA(I,L),ZFPREC(I,L)
!                      endif
                     PRECTR(I,NP)=(1.-FRAC2)*PRECTR(I,NP)
                  END IF
                  XROW(I,L+1,NP)=XROW(I,L+1,NP)+2.*DELT*RTICLD(I,L,NP)
                  IF (L .EQ. ILEV) GDREM(I,NP,3)=-PRECTR(I,NP)         
!                      if(i.eq.14.and.np.eq.60.and.l.eq.ilev) then
!                         write(0,*)'wzz: GDREM =',GDREM(I,NP,3),RTICLD(I,L,NP)
!                      endif
               END DO
             END DO
          END DO
      END DO

      IF (CAMR .GE. 10.0) RETURN
!
!    SECTION 5 IN-CLOUD REMOVAL OF SO2 AND H2O2 DUE TO EVOLUTION BY
!              STRATIFORM PRECIPITATION  (MM S-1 = KG M-2 S-1).
!
      DO L=1+MAE,ILEV                                                    
        DO I=IL1,IL2                                                   
           IF (WRSCAV(I,L) .GT. 1.E-18) THEN                               
             ARATIO=0.5E-3/WRSCAV(I,L)
             BETA=1.E-4 + 1./(0.8*ARATIO)
             FF=0.8/(1.0+0.8E-4*ARATIO)
             FRAC1=FF*(EXP(-BETA*2.*DELT)-1.0)
!            
             XOLD = XROW(I,L+1,ISO2)                                              

             RTICLD(I,L,ISO2)=AMIN1(XOLD*FRAC1/(2.*DELT), 0.)
!
!     ACCUMULATIVE TRACER FLUX TO PRECIPITATION [KG M-2 S-1]
!
             PRECTR(I,ISO2)=PRECTR(I,ISO2)-RTICLD(I,L,ISO2)*    &
     &                                         (DSHJ(I,L)*PRESSG(I)/G)

             XOLD = XROW(I,L+1,IHPO)                                              

             RTICLD(I,L,IHPO)=AMIN1(XOLD*FRAC1/(2.*DELT), 0.)
             PRECTR(I,IHPO)=PRECTR(I,IHPO)-RTICLD(I,L,IHPO)*   &
     &                                         (DSHJ(I,L)*PRESSG(I)/G)
           END IF                                                      
!
!     GAS PRODUCTION DUE TO EVAPORATION OF CLOUDS
!
           IF (ZFPREC(I,L) .GT. 1.E-18)  THEN


             FRAC2=AMAX1(AMIN1(WPEVPA(I,L)/ZFPREC(I,L),1.0),0.0)
             ZEVP=FRAC2*PRECTR(I,ISO2)/(DSHJ(I,L)*PRESSG(I)/G)
             RTICLD(I,L,ISO2)=RTICLD(I,L,ISO2)+ZEVP
             PRECTR(I,ISO2)=(1.-FRAC2)*PRECTR(I,ISO2)


             ZEVP=FRAC2*PRECTR(I,IHPO)/(DSHJ(I,L)*PRESSG(I)/G)
             RTICLD(I,L,IHPO)=RTICLD(I,L,IHPO)+ZEVP
             PRECTR(I,IHPO)=(1.-FRAC2)*PRECTR(I,IHPO)

           END IF
           IF (L .EQ. ILEV) THEN
             GDREM(I,ISO2,3)=-PRECTR(I,ISO2)
             GDREM(I,IHPO,3)=-PRECTR(I,IHPO)
           END IF
           XROW(I,L+1,ISO2)=XROW(I,L+1,ISO2)+2.*DELT*RTICLD(I,L,ISO2)
           XROW(I,L+1,IHPO)=XROW(I,L+1,IHPO)+2.*DELT*RTICLD(I,L,IHPO)
        END DO                                                         
      END DO                                                         


      RETURN
      END
