      SUBROUTINE OXISTR(     IL1,     IL2,    ILEV,    ILG,  ISIZE  &
     &                  ,    NTR,    ISO2,    IHPO,     NN,   IAE1  &
     &                  , ROAROW,  AGAMMA,  ASPECI, AGTSO2, AGTSO4  &
     &                  ,  AGTO3,  AGTCO2,  AGTNH3,AGTHNO3,  AGTNA  &
     &                  , AGTHO2,   AEQCA,   AEQCB,  AEQCC, AEQCBI  &
     &                  , AEQCHP,  AEQCHO,  AEQHNO, AEQNH3, AEQHCL  &
     &                  , AORHP1,  AORHP2,   AORHO, ANTSO2, ANTHO2  &
     &                  , ANTSO4,    XROW,  AOH2O2, ARESID,  ZMLWC  &
     &                  ,  CLDCV,   AFRAC,     AMH,  KCALC,  RTSO4  &
     &                  ,  RTHPO,   RCRIT, AMASPE, ASPRVA  &
     &                  , ASRSO2,  ASRHPO,    MAE)
!***********************************************************************
!     Calculates incloud-oxidation for stratiform clouds.
!***********************************************************************
!
!---  history
!     JANUARY 27, 1998 KNUT VON SALZEN     NEW SUBROUTINE
!     FEBRUARY 2, 1998 KNUT VON SALZEN     MODIFIED FOR GCM
!     FEBRUARY 4, 1998 S.L. GONG           VECTORIZED VERSION
!                                          EXTRACTED STRATIFORM PART
!     APRIL 20, 1998   KNUT VON SALZEN     CORRECTED
!
!-----------------------------------------------------------------------
!
      implicit none
!
      integer IL1, IL2, ILEV, ILG
      integer ISIZE, NTR
      integer ISO2, IHPO, NN
      integer IAE1, MAE
!
      real DELT
      COMMON /TIMESc/ DELT
!
      LOGICAL KCALC(ILG,ILEV)
      INTEGER INDTI,IND,IL,JK,N,NF
!
      INTEGER YSUB,YINDMX,ITERP
      PARAMETER ( YSUB   = 2 )
      PARAMETER ( YINDMX = 3 )
      PARAMETER ( ITERP = 3 )
      REAL YCOM3L,YRHOW
      PARAMETER ( YCOM3L = 1.E+03  &
     &           ,YRHOW  = 1.E+03 )
!
      REAL AMSO4,ATVAL,ADELTI,AFO3,AFH2O2,ATIMST,AMSO3  &
     &    ,AMNH4,AMNO3,AMNA,AMCL,AMO3,AGTHCL,ADELTA,AFRAH,AFRAS  &
     &    ,APARD,APARA,APARC,ATVALX,AMASPE(3)
      REAL AGAMMA(ILG,ILEV),CLDCV(ILG,ILEV)  &
     &    ,ARESID(ILG,ILEV),ASPECI(ILG,ILEV),AGTSO2(ILG,ILEV)  &
     &    ,AGTSO4(ILG,ILEV),AGTO3(ILG,ILEV),AGTCO2(ILG,ILEV)  &
     &    ,AGTNH3(ILG,ILEV),AGTHNO3(ILG,ILEV),AGTNA(ILG,ILEV)  &
     &    ,AGTHO2(ILG,ILEV),AEQCA(ILG,ILEV),AEQCB(ILG,ILEV)  &
     &    ,AEQCC(ILG,ILEV),AMH(ILG,ILEV)  &
     &    ,AEQCBI(ILG,ILEV),AEQCHP(ILG,ILEV),AEQCHO(ILG,ILEV)  &
     &    ,AEQHNO(ILG,ILEV),AEQNH3(ILG,ILEV),AEQHCL(ILG,ILEV)  &
     &    ,AORHP1(ILG,ILEV),AORHP2(ILG,ILEV),AORHO(ILG,ILEV)  &
     &    ,ANTSO2(ILG,ILEV),ANTHO2(ILG,ILEV),ANTSO4(ILG,ILEV)
      REAL ZMLWC(ILG,ILEV), RCRIT(ILG,ILEV), ROAROW(ILG,ILEV)  &
     &    ,AOH2O2(ILG,ILEV),AFRAC(ILG,ILEV,ISIZE)  &
     &    ,RTSO4(ILG,ILEV,ISIZE),RTHPO(ILG,ILEV)  &
     &    ,ASPRVA(ILG,ILEV),ASRSO2(ILG,ILEV),ASRHPO(ILG,ILEV)
      REAL XROW(ILG,ILEV+1,NTR)
!
      integer I, L, INDX
      real AFOH, AFCO3, AFHSO, AFNH4, AFCL, AFNO3
      real ADELMS, APARB, ATVO3
!-----------------------------------------------------------------------
!
!     initial values and constants
!
!-----------------------------------------------------------------------
!
      ATIMST = 2. * DELT / REAL (YSUB)
      DO 5 JK=1+MAE,ILEV
      DO 5 IL=IL1,IL2
         KCALC(IL,JK) = .FALSE.
         AGAMMA(IL,JK) = 0.
!         AMH(IL,JK) = 0.1
         AMH(IL,JK) = 1.
         ASRSO2(IL,JK) = 0.
         ASRHPO(IL,JK) = 0.
         ASPRVA(IL,JK) = 0.
 5    CONTINUE
!
      DO 10 JK=1+MAE,ILEV
      DO 10 IL=IL1,IL2
!
!---     check for activation
         IF (       (INT(RCRIT(IL,JK)) .GE. 1)  &
     &        .AND. (INT(RCRIT(IL,JK)) .LE. ISIZE)  &
     &        .AND. (ZMLWC(IL,JK) .GT. 1.E-06)  &
     &        .AND. (CLDCV(IL,JK) .GT. 1.E-03)         ) THEN
!     3        .AND. (CLDCV(IL,JK) .GT. 1.E-04)         ) THEN
            KCALC(IL,JK) = .TRUE.
            AGAMMA(IL,JK) = ZMLWC(IL,JK) * ROAROW(IL,JK) / YRHOW
         END IF
 10   CONTINUE
!
      DO 30 JK=1+MAE,ILEV
      DO 30 IL=IL1,IL2
!
!---     sulphur dioxide. Conversion kg/kg -> mol/l
         ATVAL = XROW(IL,JK+1,ISO2) * ROAROW(IL,JK) / AMASPE(2)
         AGTSO2(IL,JK) = ATVAL / YCOM3L
!
!---     initial values EBI-method
         AOH2O2(IL,JK) = AGTHO2(IL,JK)
         ARESID(IL,JK) = 0.
         ASPECI(IL,JK) = 0.
 30   CONTINUE
!
      DO 35 N=1,ISIZE
         NF=ISIZE*(NN-1)+N+(IAE1-1)
         DO 36 L=1+MAE,ILEV
         DO 36 I=IL1,IL2
            IF ( KCALC(I,L) ) THEN
               IF (N .EQ. INT(RCRIT(I,L))) THEN     
                  AGTSO4(I,L)= XROW(I,L+1,NF)*(1.-AMOD(RCRIT(I,L),1.))  &
     &                         *ROAROW(I,L) / AMASPE(1)/YCOM3L
               ELSE IF (N .GT. INT(RCRIT(I,L)))    THEN
                  AGTSO4(I,L)=AGTSO4(I,L)+XROW(I,L+1,NF)  &
     &                        *ROAROW(I,L) / AMASPE(1)/YCOM3L
               END IF
            END IF
 36      CONTINUE
 35   CONTINUE
!
!-----------------------------------------------------------------------
!
!     Euler Backward Iterations
!
!-----------------------------------------------------------------------
!
      DO 300 INDTI = 1, YSUB                  ! time
!
!---     initialization
         DO 310 JK=1+MAE,ILEV
         DO 310 IL=IL1,IL2
            IF ( KCALC(IL,JK) ) THEN
               ANTSO2(IL,JK) = AGTSO2(IL,JK)
               ANTHO2(IL,JK) = AGTHO2(IL,JK)
               ANTSO4(IL,JK) = AGTSO4(IL,JK)
            END IF
 310     CONTINUE
!
!---     EBI-iteration
!
         DO 320 IND = 1, YINDMX            ! parameter update
         DO 320 JK=1+MAE,ILEV
         DO 320 IL=IL1,IL2
            IF ( KCALC(IL,JK) ) THEN
!
!---           approach for pH from Tremblay with additional iteration
               AMSO3 = 0.                             ! SO3(2-)
               AMNH4 = AGTNH3(IL,JK)  / AGAMMA(IL,JK) ! NH4(+)
               AMNO3 = AGTHNO3(IL,JK) / AGAMMA(IL,JK) ! NO3(-)
               AMSO4 = AGTSO4(IL,JK)  / AGAMMA(IL,JK) ! SO4(2-)
               AMNA  = AGTNA(IL,JK)   / AGAMMA(IL,JK) ! Na(+)
               AMCL  = MAX(AMNA - 2.E-06,0.)          ! Cl(-)
               AGTHCL = AMCL * AGAMMA(IL,JK)
!
!---           O3-concentrations
               ATVO3 = 1. / ( 1. + AGAMMA(IL,JK) * AEQCHO(IL,JK) )
               AMO3 = AGTO3(IL,JK) * ATVO3 * AEQCHO(IL,JK)
!
!---           initial guess
               ADELTA = AMNO3 + 2. * (AMSO4 + AMSO3) + AMCL  &
     &                - AMNH4 - AMNA
               AMH(IL,JK) = 0.5 * ( ADELTA + SQRT (ADELTA**2  &
     &             + 4. * ( 1.E-14 + AEQCB(IL,JK) * AGTSO2(IL,JK)  &
     &             + AEQCBI(IL,JK) * AGTCO2(IL,JK) )) )
               AMH(IL,JK) = MAX (MIN(AMH(IL,JK),1.E-01), 1.E-10)
!
!---           SO2-, NH3-, and NO3-equilibrium parameters
               ATVAL = AEQCA(IL,JK) + AEQCB(IL,JK) / AMH(IL,JK)  &
     &               + AEQCC(IL,JK) / AMH(IL,JK)**2
               AFRAS = 1. / ( 1. + AGAMMA(IL,JK) * ATVAL )
               AFNH4 = (1.+AGTNH3(IL,JK)/(1./AEQNH3(IL,JK)  &
     &               + AGAMMA(IL,JK) * AMH(IL,JK)))**(-1)
               AFNO3 = AGTHNO3(IL,JK) / ( 1./AEQHNO(IL,JK)  &
     &               + AGAMMA(IL,JK) / AMH(IL,JK) )
!
!---           subsequent iterations for pH-calculation
               AFOH  = 1.E-14
               DO 1200 INDX = 1, ITERP
                  AFCL  = AGTHCL / ( 1./AEQHCL(IL,JK)  &
     &                  + AGAMMA(IL,JK) / AMH(IL,JK) )
                  AFHSO = AGTSO2(IL,JK) * AFRAS * AEQCB(IL,JK)
                  AFCO3 = AGTCO2(IL,JK) * AEQCBI(IL,JK)
!                 AFOH  = 1.E-14
                  AMSO3 = ( AGTSO2(IL,JK) * AFRAS * AEQCC(IL,JK) )  &
     &                   / AMH(IL,JK)**2
                  ADELTA = AFNH4 * ( 2. * (AMSO4 + AMSO3) - AMNA )
                  AMH(IL,JK) = 0.5*(ADELTA + SQRT (ADELTA**2  &
     &                      + 4. * AFNH4 * (AFOH + AFCO3 + AFHSO  &
     &                      + AFNO3 + AFCL)))
!
!---              restrict pH to avoid numerical problems
                  AMH(IL,JK) = MAX (MIN(AMH(IL,JK),1.E-01), 1.E-10)
!
!---              SO2-, NH3-, and NO3-equilibrium parameters
                  ATVAL = AEQCA(IL,JK) + AEQCB(IL,JK) / AMH(IL,JK)  &
     &                  + AEQCC(IL,JK) / AMH(IL,JK)**2
                  AFRAS = 1. / ( 1. + AGAMMA(IL,JK) * ATVAL )
                  AFNH4 = (1.+AGTNH3(IL,JK)/(1./AEQNH3(IL,JK)  &
     &                  + AGAMMA(IL,JK) * AMH(IL,JK)))**(-1)
                  AFNO3 = AGTHNO3(IL,JK) / ( 1./AEQHNO(IL,JK)  &
     &                  + AGAMMA(IL,JK) / AMH(IL,JK) )
 1200          CONTINUE
!
!---           O3-oxidation rate parameter AFO3
               AFO3 = ( AORHP1(IL,JK) + AORHP2(IL,JK) / AMH(IL,JK) )  &
     &                * AMO3 * AFRAS * ATVAL
!
!---           H2O2-oxidation rate parameter AFH2O2
               AFRAH = 1. / ( 1. + AGAMMA(IL,JK) * AEQCHP(IL,JK) )
               AFH2O2 = ( AORHO(IL,JK) / (0.1 + AMH(IL,JK)) ) * AFRAS  &
     &                * AEQCA(IL,JK) * AFRAH * AEQCHP(IL,JK)
!
!              scavenging ratios
               ASRSO2(IL,JK) = 1. - AFRAS
               ASRHPO(IL,JK) = 1. - AFRAH
!
!---           new concentrations
               ATVAL = ATIMST * AGAMMA(IL,JK)
               APARD = AGTHO2(IL,JK)
               APARA = ( 1. + ATVAL * AFO3 ) * ATVAL * AFH2O2
               APARC = - AGTSO2(IL,JK)
               APARB = 1. + ATVAL * ( AFO3 + AFH2O2 * ( APARD + APARC) )
               ATVALX = - APARB / ( 2. * APARA )
               ANTSO2(IL,JK) = ATVALX   &
     &                       + SQRT ( ATVALX**2 - APARC / APARA )
               ANTHO2(IL,JK) = APARD   &
     &                      / ( 1. + ATVAL * AFH2O2 * ANTSO2(IL,JK) )
               ADELTA = AGTSO2(IL,JK) - ANTSO2(IL,JK)
               ANTSO4(IL,JK) = AGTSO4(IL,JK) + ADELTA
!
!---           diagnostic parameters
               ADELTI = ( (AFH2O2 * ANTHO2(IL,JK))   &
     &               / (AFH2O2 * ANTHO2(IL,JK) + AFO3) ) * ADELTA
               IF ( IND .EQ. YINDMX ) THEN
                  ASPECI(IL,JK) = ASPECI(IL,JK) + ADELTI
               END IF
            END IF
 320     CONTINUE
!
         DO 330 JK=1+MAE,ILEV
         DO 330 IL=IL1,IL2
            IF ( KCALC(IL,JK) ) THEN
               ADELTA =  AGTSO2(IL,JK) - ANTSO2(IL,JK)
               ARESID(IL,JK) = ARESID(IL,JK) + ADELTA
!
!---           final concentrations after ATIMST
               AGTSO2(IL,JK) = ANTSO2(IL,JK)
               AGTHO2(IL,JK) = ANTHO2(IL,JK)
               AGTSO4(IL,JK) = ANTSO4(IL,JK)
            END IF
 330     CONTINUE
 300  CONTINUE
!
!-----------------------------------------------------------------------
!
!     results
!
!-----------------------------------------------------------------------
!
      DO 500 JK=1+MAE,ILEV
      DO 500 IL=IL1,IL2
         IF ( KCALC(IL,JK) ) THEN
!
!---        sulphate fraction produced by hydrogen peroxide
            ASPECI(IL,JK) = ASPECI(IL,JK) / MAX (ARESID(IL,JK),1.E-33)
            ASPECI(IL,JK) = MAX(ASPECI(IL,JK),0.)
!
!---        limitation of oxidation due to too low hydrogen peroxide
!---        concentrations
            IF ( AGTHO2(IL,JK) .LT. 0.) THEN
               ARESID(IL,JK) = ARESID(IL,JK) + AGTHO2(IL,JK)
               AGTHO2(IL,JK) = 0.
            END IF
!
!---        limitation of oxidation due to too low sulphur dioxide
!---        concentrations
            ADELMS = XROW(IL,JK+1,ISO2) * ROAROW(IL,JK)  &
     &             / (AMASPE(2)*YCOM3L) - ARESID(IL,JK)
            IF ( ADELMS .LT. 0. ) THEN
               ARESID(IL,JK) = ADELMS + ARESID(IL,JK)
            END IF
!
!---        additional sulphate in mol/kg
            ADELTA = CLDCV(IL,JK) * ARESID(IL,JK) * YCOM3L  &
     &             / ROAROW(IL,JK)
!
!---        sulphur dioxide in kg/kg/s
            ASPRVA(IL,JK) = - ( ADELTA * AMASPE(2) ) &
     &                     / ( 2. * DELT )
!
!---        hydrogen peroxide
            ADELTA = CLDCV(IL,JK) * (AGTHO2(IL,JK) - AOH2O2(IL,JK)) &
     &             * YCOM3L / ROAROW(IL,JK)
            RTHPO(IL,JK) = RTHPO(IL,JK) + ( ADELTA * AMASPE(3) ) &
     &                     / ( 2. * DELT )
         END IF
 500  CONTINUE
!
      DO N=1,ISIZE
         DO L=1+MAE,ILEV
            DO I=IL1,IL2
                IF (KCALC(I,L) .AND. (N .GE. INT(RCRIT(I,L))) .AND. &
     &             XROW(I,L+1,ISO2) .GT. 0.0)    THEN
!
!---               sulphate in kg/kg/s
                   RTSO4(I,L,N) = RTSO4(I,L,N) + ( AFRAC(I,L,N) &
     &                            * CLDCV(I,L) * ARESID(I,L) * YCOM3L &
     &                            * AMASPE(1) ) / ( ROAROW(I,L) * 2. &
     &                            * DELT )
                END IF
            END DO
         END DO
      END DO
!
      RETURN
      END
