! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Parameters.f90
! Time                 : Wed Sep 15 16:00:44 2010
! Working directory    : /mnt/lstr04/srv/home/c/ccarouge/KPP/geoschem_kppfiles/v8-03-02/SOA
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Parameters

  USE gckpp_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 119 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 103 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 82 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 16 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 324 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 104 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 950 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 1092 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 104 
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
  INTEGER, PARAMETER :: CNEQN = 325 
! NHESS - Length of Sparse Hessian
  INTEGER, PARAMETER :: NHESS = 881 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 119 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_MONX = 1 
  INTEGER, PARAMETER :: ind_DRYCH2O = 2 
  INTEGER, PARAMETER :: ind_DRYH2O2 = 3 
  INTEGER, PARAMETER :: ind_DRYHNO3 = 4 
  INTEGER, PARAMETER :: ind_DRYN2O5 = 5 
  INTEGER, PARAMETER :: ind_DRYNO2 = 6 
  INTEGER, PARAMETER :: ind_DRYO3 = 7 
  INTEGER, PARAMETER :: ind_DRYPAN = 8 
  INTEGER, PARAMETER :: ind_DRYPMN = 9 
  INTEGER, PARAMETER :: ind_DRYPPN = 10 
  INTEGER, PARAMETER :: ind_DRYR4N2 = 11 
  INTEGER, PARAMETER :: ind_SO4 = 12 
  INTEGER, PARAMETER :: ind_MSA = 13 
  INTEGER, PARAMETER :: ind_LISOPOH = 14 
  INTEGER, PARAMETER :: ind_LBRO2H = 15 
  INTEGER, PARAMETER :: ind_LBRO2N = 16 
  INTEGER, PARAMETER :: ind_LTRO2H = 17 
  INTEGER, PARAMETER :: ind_LTRO2N = 18 
  INTEGER, PARAMETER :: ind_LXRO2H = 19 
  INTEGER, PARAMETER :: ind_LXRO2N = 20 
  INTEGER, PARAMETER :: ind_CO2 = 21 
  INTEGER, PARAMETER :: ind_DRYDEP = 22 
  INTEGER, PARAMETER :: ind_TOLU = 23 
  INTEGER, PARAMETER :: ind_XYLE = 24 
  INTEGER, PARAMETER :: ind_BENZ = 25 
  INTEGER, PARAMETER :: ind_C3H8 = 26 
  INTEGER, PARAMETER :: ind_PPN = 27 
  INTEGER, PARAMETER :: ind_GPAN = 28 
  INTEGER, PARAMETER :: ind_H2O2 = 29 
  INTEGER, PARAMETER :: ind_SO2 = 30 
  INTEGER, PARAMETER :: ind_BRO2 = 31 
  INTEGER, PARAMETER :: ind_TRO2 = 32 
  INTEGER, PARAMETER :: ind_XRO2 = 33 
  INTEGER, PARAMETER :: ind_PAN = 34 
  INTEGER, PARAMETER :: ind_ALK4 = 35 
  INTEGER, PARAMETER :: ind_C2H6 = 36 
  INTEGER, PARAMETER :: ind_HNO2 = 37 
  INTEGER, PARAMETER :: ind_N2O5 = 38 
  INTEGER, PARAMETER :: ind_MP = 39 
  INTEGER, PARAMETER :: ind_R4P = 40 
  INTEGER, PARAMETER :: ind_RA3P = 41 
  INTEGER, PARAMETER :: ind_RB3P = 42 
  INTEGER, PARAMETER :: ind_RP = 43 
  INTEGER, PARAMETER :: ind_DMS = 44 
  INTEGER, PARAMETER :: ind_MAOP = 45 
  INTEGER, PARAMETER :: ind_ETP = 46 
  INTEGER, PARAMETER :: ind_GP = 47 
  INTEGER, PARAMETER :: ind_MAP = 48 
  INTEGER, PARAMETER :: ind_HNO4 = 49 
  INTEGER, PARAMETER :: ind_PP = 50 
  INTEGER, PARAMETER :: ind_PRPN = 51 
  INTEGER, PARAMETER :: ind_INPN = 52 
  INTEGER, PARAMETER :: ind_MRP = 53 
  INTEGER, PARAMETER :: ind_IAP = 54 
  INTEGER, PARAMETER :: ind_VRP = 55 
  INTEGER, PARAMETER :: ind_ISNP = 56 
  INTEGER, PARAMETER :: ind_RIP = 57 
  INTEGER, PARAMETER :: ind_PMN = 58 
  INTEGER, PARAMETER :: ind_ISOP = 59 
  INTEGER, PARAMETER :: ind_CO = 60 
  INTEGER, PARAMETER :: ind_PRPE = 61 
  INTEGER, PARAMETER :: ind_ACET = 62 
  INTEGER, PARAMETER :: ind_GLYC = 63 
  INTEGER, PARAMETER :: ind_MVN2 = 64 
  INTEGER, PARAMETER :: ind_A3O2 = 65 
  INTEGER, PARAMETER :: ind_B3O2 = 66 
  INTEGER, PARAMETER :: ind_HNO3 = 67 
  INTEGER, PARAMETER :: ind_R4N1 = 68 
  INTEGER, PARAMETER :: ind_MAN2 = 69 
  INTEGER, PARAMETER :: ind_RIO1 = 70 
  INTEGER, PARAMETER :: ind_IALD = 71 
  INTEGER, PARAMETER :: ind_MRO2 = 72 
  INTEGER, PARAMETER :: ind_KO2 = 73 
  INTEGER, PARAMETER :: ind_ATO2 = 74 
  INTEGER, PARAMETER :: ind_VRO2 = 75 
  INTEGER, PARAMETER :: ind_PRN1 = 76 
  INTEGER, PARAMETER :: ind_HAC = 77 
  INTEGER, PARAMETER :: ind_INO2 = 78 
  INTEGER, PARAMETER :: ind_IAO2 = 79 
  INTEGER, PARAMETER :: ind_ISN1 = 80 
  INTEGER, PARAMETER :: ind_RCHO = 81 
  INTEGER, PARAMETER :: ind_CH2O = 82 
  INTEGER, PARAMETER :: ind_PO2 = 83 
  INTEGER, PARAMETER :: ind_ALD2 = 84 
  INTEGER, PARAMETER :: ind_R4O2 = 85 
  INTEGER, PARAMETER :: ind_R4N2 = 86 
  INTEGER, PARAMETER :: ind_ETO2 = 87 
  INTEGER, PARAMETER :: ind_MGLY = 88 
  INTEGER, PARAMETER :: ind_MEK = 89 
  INTEGER, PARAMETER :: ind_RCO3 = 90 
  INTEGER, PARAMETER :: ind_MACR = 91 
  INTEGER, PARAMETER :: ind_RIO2 = 92 
  INTEGER, PARAMETER :: ind_MVK = 93 
  INTEGER, PARAMETER :: ind_GCO3 = 94 
  INTEGER, PARAMETER :: ind_MO2 = 95 
  INTEGER, PARAMETER :: ind_HO2 = 96 
  INTEGER, PARAMETER :: ind_MAO3 = 97 
  INTEGER, PARAMETER :: ind_O3 = 98 
  INTEGER, PARAMETER :: ind_NO2 = 99 
  INTEGER, PARAMETER :: ind_NO3 = 100 
  INTEGER, PARAMETER :: ind_MCO3 = 101 
  INTEGER, PARAMETER :: ind_OH = 102 
  INTEGER, PARAMETER :: ind_NO = 103 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_ACTA = 104 
  INTEGER, PARAMETER :: ind_CH4 = 105 
  INTEGER, PARAMETER :: ind_EMISSION = 106 
  INTEGER, PARAMETER :: ind_EOH = 107 
  INTEGER, PARAMETER :: ind_GLCO3 = 108 
  INTEGER, PARAMETER :: ind_GLP = 109 
  INTEGER, PARAMETER :: ind_GLPAN = 110 
  INTEGER, PARAMETER :: ind_GLYX = 111 
  INTEGER, PARAMETER :: ind_H2 = 112 
  INTEGER, PARAMETER :: ind_H2O = 113 
  INTEGER, PARAMETER :: ind_HCOOH = 114 
  INTEGER, PARAMETER :: ind_MNO3 = 115 
  INTEGER, PARAMETER :: ind_MOH = 116 
  INTEGER, PARAMETER :: ind_O2 = 117 
  INTEGER, PARAMETER :: ind_RCOOH = 118 
  INTEGER, PARAMETER :: ind_ROH = 119 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_ACTA = 1 
  INTEGER, PARAMETER :: indf_CH4 = 2 
  INTEGER, PARAMETER :: indf_EMISSION = 3 
  INTEGER, PARAMETER :: indf_EOH = 4 
  INTEGER, PARAMETER :: indf_GLCO3 = 5 
  INTEGER, PARAMETER :: indf_GLP = 6 
  INTEGER, PARAMETER :: indf_GLPAN = 7 
  INTEGER, PARAMETER :: indf_GLYX = 8 
  INTEGER, PARAMETER :: indf_H2 = 9 
  INTEGER, PARAMETER :: indf_H2O = 10 
  INTEGER, PARAMETER :: indf_HCOOH = 11 
  INTEGER, PARAMETER :: indf_MNO3 = 12 
  INTEGER, PARAMETER :: indf_MOH = 13 
  INTEGER, PARAMETER :: indf_O2 = 14 
  INTEGER, PARAMETER :: indf_RCOOH = 15 
  INTEGER, PARAMETER :: indf_ROH = 16 

! NJVRP - Length of sparse Jacobian JVRP
  INTEGER, PARAMETER :: NJVRP = 508 

! NSTOICM - Length of Sparse Stoichiometric Matrix
  INTEGER, PARAMETER :: NSTOICM = 1288 

END MODULE gckpp_Parameters

