! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Function of Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Function.f90
! Time                 : Tue Mar 16 10:29:04 2010
! Working directory    : /mnt/lstr04/srv/home/c/ccarouge/KPP/geoschem_kppfiles/v8-03-01/Paulot_scheme
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Function

  USE gckpp_Parameters
  IMPLICIT NONE

! A - Rate for each equation
  REAL(kind=dp) :: A(NREACT)

!$OMP THREADPRIVATE( A )

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun - time derivatives of variables - Agregate form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      Vdot      - Time derivative of variable species concentrations
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun ( V, F, RCT, Vdot )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! Vdot - Time derivative of variable species concentrations
  REAL(kind=dp) :: Vdot(NVAR)


! Computation of equation rates
  A(1) = RCT(1)*V(134)*V(135)
  A(2) = RCT(2)*V(132)*V(135)
  A(3) = RCT(3)*V(135)*V(136)
  A(4) = RCT(4)*V(128)*V(135)
  A(5) = RCT(5)*V(133)*V(135)
  A(6) = RCT(6)*V(132)*V(132)
  A(7) = RCT(7)*V(132)*V(132)
  A(8) = RCT(8)*V(132)*V(136)
  A(9) = RCT(9)*V(46)*V(132)
  A(10) = RCT(10)*V(134)*V(136)
  A(11) = RCT(11)*V(136)*V(136)
  A(12) = RCT(12)*V(132)*F(4)
  A(13) = RCT(13)*V(91)*V(132)
  A(14) = RCT(14)*V(132)*F(1)
  A(15) = RCT(15)*V(133)*V(134)
  A(16) = RCT(16)*V(133)*V(136)
  A(17) = RCT(17)*V(133)*V(133)
  A(18) = RCT(18)*V(133)*V(133)
  A(19) = RCT(19)*V(62)*V(132)
  A(20) = RCT(20)*V(62)*V(132)
  A(21) = RCT(21)*V(63)*V(132)
  A(22) = RCT(22)*V(63)*V(132)
  A(23) = RCT(23)*V(114)*V(132)
  A(24) = RCT(24)*V(128)*V(132)
  A(25) = RCT(25)*V(99)*V(132)
  A(26) = RCT(26)*V(132)*V(134)
  A(27) = RCT(27)*V(53)*V(132)
  A(28) = RCT(28)*V(128)*V(136)
  A(29) = RCT(29)*V(59)
  A(30) = RCT(30)*V(59)*V(132)
  A(31) = RCT(31)*V(129)*V(136)
  A(32) = RCT(32)*V(129)*V(134)
  A(33) = RCT(33)*V(129)*V(132)
  A(34) = RCT(34)*V(128)*V(129)
  A(35) = RCT(35)*V(55)
  A(36) = RCT(36)*V(72)*V(132)
  A(37) = RCT(37)*V(132)*F(6)
  A(38) = RCT(38)*V(128)*V(129)
  A(39) = RCT(39)*V(114)*V(129)
  A(40) = RCT(40)*V(115)*V(132)
  A(41) = RCT(41)*V(115)*V(129)
  A(42) = RCT(42)*V(128)*V(130)
  A(43) = RCT(43)*V(49)
  A(44) = RCT(44)*V(130)*V(134)
  A(45) = RCT(45)*V(52)*V(132)
  A(46) = RCT(46)*V(112)*V(134)
  A(47) = RCT(47)*V(44)*V(132)
  A(48) = RCT(48)*V(44)*V(132)
  A(49) = RCT(49)*V(94)*V(134)
  A(50) = RCT(50)*V(109)*V(134)
  A(51) = RCT(51)*V(51)*V(132)
  A(52) = RCT(52)*V(126)*V(134)
  A(53) = RCT(53)*V(126)*V(134)
  A(54) = RCT(54)*V(116)*V(134)
  A(55) = RCT(55)*V(108)*V(134)
  A(56) = RCT(56)*V(106)*V(134)
  A(57) = RCT(57)*V(123)*V(134)
  A(58) = RCT(58)*V(101)*V(134)
  A(59) = RCT(59)*V(105)*V(134)
  A(60) = RCT(60)*V(97)*V(134)
  A(61) = RCT(61)*V(98)*V(134)
  A(62) = RCT(62)*V(117)*V(134)
  A(63) = RCT(63)*V(117)*V(129)
  A(64) = RCT(64)*V(117)*V(117)
  A(65) = RCT(65)*V(110)*V(134)
  A(66) = RCT(66)*V(51)*V(129)
  A(67) = RCT(67)*V(132)*V(137)
  A(68) = RCT(68)*V(89)*V(132)
  A(69) = RCT(69)*V(127)*V(132)
  A(70) = RCT(70)*V(113)*V(128)
  A(71) = RCT(71)*V(45)
  A(72) = RCT(72)*V(122)*V(128)
  A(73) = RCT(73)*V(79)
  A(74) = RCT(74)*V(113)*V(134)
  A(75) = RCT(75)*V(122)*V(134)
  A(76) = RCT(76)*V(127)*V(129)
  A(77) = RCT(77)*V(85)*V(132)
  A(78) = RCT(78)*V(85)*V(132)
  A(79) = RCT(79)*V(94)*V(133)
  A(80) = RCT(80)*V(109)*V(133)
  A(81) = RCT(81)*V(126)*V(136)
  A(82) = RCT(82)*V(116)*V(136)
  A(83) = RCT(83)*V(108)*V(136)
  A(84) = RCT(84)*V(106)*V(136)
  A(85) = RCT(85)*V(123)*V(136)
  A(86) = RCT(86)*V(101)*V(136)
  A(87) = RCT(87)*V(105)*V(136)
  A(88) = RCT(88)*V(97)*V(136)
  A(89) = RCT(89)*V(98)*V(136)
  A(90) = RCT(90)*V(117)*V(136)
  A(91) = RCT(91)*V(110)*V(136)
  A(92) = RCT(92)*V(131)*V(132)
  A(93) = RCT(93)*V(112)*V(133)
  A(94) = RCT(94)*V(129)*V(131)
  A(95) = RCT(95)*V(126)*V(133)
  A(96) = RCT(96)*V(116)*V(133)
  A(97) = RCT(97)*V(108)*V(133)
  A(98) = RCT(98)*V(106)*V(133)
  A(99) = RCT(99)*V(123)*V(133)
  A(100) = RCT(100)*V(123)*V(123)
  A(101) = RCT(101)*V(111)*V(133)
  A(102) = RCT(102)*V(101)*V(133)
  A(103) = RCT(103)*V(105)*V(133)
  A(104) = RCT(104)*V(97)*V(133)
  A(105) = RCT(105)*V(98)*V(133)
  A(106) = RCT(106)*V(117)*V(133)
  A(107) = RCT(107)*V(110)*V(133)
  A(108) = RCT(108)*V(132)*F(3)
  A(109) = RCT(109)*V(88)*V(132)
  A(110) = RCT(110)*V(112)*V(112)
  A(111) = RCT(111)*V(112)*V(112)
  A(112) = RCT(112)*V(112)*V(136)
  A(113) = RCT(113)*V(94)*V(136)
  A(114) = RCT(114)*V(109)*V(136)
  A(115) = RCT(115)*V(130)*V(136)
  A(116) = RCT(116)*V(113)*V(136)
  A(117) = RCT(117)*V(122)*V(136)
  A(118) = RCT(118)*V(86)*V(132)
  A(119) = RCT(119)*V(86)*V(135)
  A(120) = RCT(120)*V(79)*V(132)
  A(121) = RCT(121)*V(95)*V(134)
  A(122) = RCT(122)*V(95)*V(136)
  A(123) = RCT(123)*V(79)*V(135)
  A(124) = RCT(124)*V(75)*V(128)
  A(125) = RCT(125)*V(65)
  A(126) = RCT(126)*V(75)*V(134)
  A(127) = RCT(127)*V(75)*V(136)
  A(128) = RCT(128)*V(100)*V(132)
  A(129) = RCT(129)*V(100)*V(132)
  A(130) = RCT(130)*V(86)*V(129)
  A(131) = RCT(131)*V(90)*V(132)
  A(132) = RCT(132)*V(118)*V(132)
  A(133) = RCT(133)*V(90)*V(129)
  A(134) = RCT(134)*V(118)*V(129)
  A(135) = RCT(135)*V(81)*V(132)
  A(136) = RCT(136)*V(120)*V(132)
  A(137) = RCT(137)*V(121)*V(132)
  A(138) = RCT(138)*V(119)*V(132)
  A(139) = RCT(139)*V(119)*V(132)
  A(140) = RCT(140)*V(94)*V(130)
  A(141) = RCT(141)*V(109)*V(130)
  A(142) = RCT(142)*V(94)*V(130)
  A(143) = RCT(143)*V(109)*V(130)
  A(144) = RCT(144)*V(81)*V(135)
  A(145) = RCT(145)*V(120)*V(135)
  A(146) = RCT(146)*V(121)*V(135)
  A(147) = RCT(147)*V(81)*V(129)
  A(148) = RCT(148)*V(121)*V(129)
  A(149) = RCT(149)*V(121)*V(129)
  A(150) = RCT(150)*V(113)*V(133)
  A(151) = RCT(151)*V(122)*V(133)
  A(152) = RCT(152)*V(113)*V(133)
  A(153) = RCT(153)*V(122)*V(133)
  A(154) = RCT(154)*V(71)*V(132)
  A(155) = RCT(155)*V(71)*V(132)
  A(156) = RCT(156)*V(67)*V(132)
  A(157) = RCT(157)*V(61)*V(132)
  A(158) = RCT(158)*V(56)*V(132)
  A(159) = RCT(159)*V(57)*V(132)
  A(160) = RCT(160)*V(66)*V(132)
  A(161) = RCT(161)*V(58)*V(132)
  A(162) = RCT(162)*V(69)*V(132)
  A(163) = RCT(163)*V(74)*V(132)
  A(164) = RCT(164)*V(74)*V(132)
  A(165) = RCT(165)*V(47)*V(132)
  A(166) = RCT(166)*V(84)*V(136)
  A(167) = RCT(167)*V(84)*V(134)
  A(168) = RCT(168)*V(76)*V(132)
  A(169) = RCT(169)*V(73)*V(132)
  A(170) = RCT(170)*V(70)*V(132)
  A(171) = RCT(171)*V(70)*V(132)
  A(172) = RCT(172)*V(64)*V(132)
  A(173) = RCT(173)*V(64)*V(132)
  A(174) = RCT(174)*V(102)*V(130)
  A(175) = RCT(175)*V(102)*V(130)
  A(176) = RCT(176)*V(102)*V(133)
  A(177) = RCT(177)*V(102)*V(102)
  A(178) = RCT(178)*V(102)*V(136)
  A(179) = RCT(179)*V(102)*V(134)
  A(180) = RCT(180)*V(102)*V(134)
  A(181) = RCT(181)*V(54)*V(132)
  A(182) = RCT(182)*V(52)*V(129)
  A(183) = RCT(183)*V(124)*V(135)
  A(184) = RCT(184)*V(130)*V(130)
  A(185) = RCT(185)*V(130)*V(133)
  A(186) = RCT(186)*V(130)*V(133)
  A(187) = RCT(187)*V(126)*V(130)
  A(188) = RCT(188)*V(108)*V(130)
  A(189) = RCT(189)*V(106)*V(130)
  A(190) = RCT(190)*V(123)*V(130)
  A(191) = RCT(191)*V(111)*V(130)
  A(192) = RCT(192)*V(101)*V(130)
  A(193) = RCT(193)*V(105)*V(130)
  A(194) = RCT(194)*V(98)*V(130)
  A(195) = RCT(195)*V(116)*V(130)
  A(196) = RCT(196)*V(97)*V(130)
  A(197) = RCT(197)*V(117)*V(130)
  A(198) = RCT(198)*V(110)*V(130)
  A(199) = RCT(199)*V(126)*V(130)
  A(200) = RCT(200)*V(108)*V(130)
  A(201) = RCT(201)*V(106)*V(130)
  A(202) = RCT(202)*V(123)*V(130)
  A(203) = RCT(203)*V(111)*V(130)
  A(204) = RCT(204)*V(101)*V(130)
  A(205) = RCT(205)*V(105)*V(130)
  A(206) = RCT(206)*V(116)*V(130)
  A(207) = RCT(207)*V(97)*V(130)
  A(208) = RCT(208)*V(117)*V(130)
  A(209) = RCT(209)*V(110)*V(130)
  A(210) = RCT(210)*V(98)*V(130)
  A(211) = RCT(211)*V(112)*V(130)
  A(212) = RCT(212)*V(112)*V(130)
  A(213) = RCT(213)*V(113)*V(130)
  A(214) = RCT(214)*V(122)*V(130)
  A(215) = RCT(215)*V(129)*V(129)
  A(216) = RCT(216)*F(2)
  A(217) = RCT(217)*F(2)
  A(218) = RCT(218)*F(2)
  A(219) = RCT(219)*F(2)
  A(220) = RCT(220)*F(2)
  A(221) = RCT(221)*F(2)
  A(222) = RCT(222)*F(2)
  A(223) = RCT(223)*F(2)
  A(224) = RCT(224)*F(2)
  A(225) = RCT(225)*F(2)
  A(226) = RCT(226)*F(2)
  A(227) = RCT(227)*F(2)
  A(228) = RCT(228)*F(2)
  A(229) = RCT(229)*F(2)
  A(230) = RCT(230)*F(2)
  A(231) = RCT(231)*F(2)
  A(232) = RCT(232)*F(2)
  A(233) = RCT(233)*F(2)
  A(234) = RCT(234)*V(128)
  A(235) = RCT(235)*V(50)
  A(236) = RCT(236)*V(135)
  A(237) = RCT(237)*V(49)
  A(238) = RCT(238)*V(65)
  A(239) = RCT(239)*V(99)
  A(240) = RCT(240)*V(114)
  A(241) = RCT(241)*V(55)
  A(242) = RCT(242)*V(46)
  A(243) = RCT(243)*V(79)
  A(244) = RCT(244)*V(45)
  A(245) = RCT(245)*V(137)
  A(246) = RCT(246)*V(47)
  A(247) = RCT(247)*V(74)
  A(248) = RCT(248)*V(125)
  A(249) = RCT(249)*V(82)
  A(250) = RCT(250)*V(82)*V(135)
  A(251) = RCT(251)*V(125)*V(135)
  A(252) = RCT(252)*V(96)
  A(253) = RCT(253)*V(104)
  A(254) = RCT(254)*V(93)
  A(255) = RCT(255)*V(72)
  A(256) = RCT(256)*V(89)
  A(257) = RCT(257)*V(128)
  A(258) = RCT(258)*V(129)
  A(259) = RCT(259)*V(55)
  A(260) = RCT(260)*V(60)*V(132)
  A(261) = RCT(261)*V(60)*V(132)
  A(262) = RCT(262)*V(60)*V(129)
  A(263) = RCT(263)*V(48)*V(132)
  A(264) = RCT(264)*V(124)*V(132)
  A(265) = RCT(265)*V(111)*V(134)
  A(266) = RCT(266)*V(111)*V(134)
  A(267) = RCT(267)*V(111)*V(136)
  A(268) = RCT(268)*V(125)*V(132)
  A(269) = RCT(269)*V(82)*V(132)
  A(270) = RCT(270)*V(103)*V(134)
  A(271) = RCT(271)*V(103)*V(134)
  A(272) = RCT(272)*V(103)*V(136)
  A(273) = RCT(273)*V(107)*V(134)
  A(274) = RCT(274)*V(107)*V(134)
  A(275) = RCT(275)*V(107)*V(136)
  A(276) = RCT(276)*V(80)*V(132)
  A(277) = RCT(277)*V(93)*V(132)
  A(278) = RCT(278)*V(104)*V(132)
  A(279) = RCT(279)*V(92)*V(134)
  A(280) = RCT(280)*V(92)*V(136)
  A(281) = RCT(281)*V(92)*V(128)
  A(282) = RCT(282)*V(50)
  A(283) = RCT(283)*V(77)*V(132)
  A(284) = RCT(284)*V(83)*V(134)
  A(285) = RCT(285)*V(83)*V(134)
  A(286) = RCT(286)*V(83)*V(136)
  A(287) = RCT(287)*V(78)*V(132)
  A(288) = RCT(288)*V(87)*V(134)
  A(289) = RCT(289)*V(87)*V(134)
  A(290) = RCT(290)*V(87)*V(136)
  A(291) = RCT(291)*V(78)*V(135)
  A(292) = RCT(292)*V(68)*V(132)
  A(293) = RCT(293)*V(96)*V(132)
  A(294) = RCT(294)*V(18)*V(132)
  A(295) = RCT(295)*V(22)*V(132)
  A(296) = RCT(296)*V(26)*V(132)
  A(297) = RCT(297)*V(17)*V(136)
  A(298) = RCT(298)*V(17)*V(134)
  A(299) = RCT(299)*V(21)*V(136)
  A(300) = RCT(300)*V(21)*V(134)
  A(301) = RCT(301)*V(25)*V(136)
  A(302) = RCT(302)*V(25)*V(134)
  A(303) = RCT(303)*V(30)*V(132)
  A(304) = RCT(304)*V(29)*V(136)
  A(305) = RCT(305)*V(29)*V(134)
  A(306) = RCT(306)*V(135)
  A(307) = RCT(307)*V(128)
  A(308) = RCT(308)*V(46)
  A(309) = RCT(309)*V(62)
  A(310) = RCT(310)*V(114)
  A(311) = RCT(311)*V(114)
  A(312) = RCT(312)*V(99)
  A(313) = RCT(313)*V(53)
  A(314) = RCT(314)*V(59)
  A(315) = RCT(315)*V(129)
  A(316) = RCT(316)*V(129)
  A(317) = RCT(317)*V(55)
  A(318) = RCT(318)*V(55)
  A(319) = RCT(319)*V(59)
  A(320) = RCT(320)*V(115)
  A(321) = RCT(321)*V(115)
  A(322) = RCT(322)*V(49)
  A(323) = RCT(323)*V(127)
  A(324) = RCT(324)*V(85)
  A(325) = RCT(325)*V(85)
  A(326) = RCT(326)*V(131)
  A(327) = RCT(327)*V(100)
  A(328) = RCT(328)*V(90)
  A(329) = RCT(329)*V(90)
  A(330) = RCT(330)*V(118)
  A(331) = RCT(331)*V(118)
  A(332) = RCT(332)*V(120)
  A(333) = RCT(333)*V(120)
  A(334) = RCT(334)*V(120)
  A(335) = RCT(335)*V(121)
  A(336) = RCT(336)*V(121)
  A(337) = RCT(337)*V(119)
  A(338) = RCT(338)*V(71)
  A(339) = RCT(339)*V(67)
  A(340) = RCT(340)*V(61)
  A(341) = RCT(341)*V(56)
  A(342) = RCT(342)*V(57)
  A(343) = RCT(343)*V(66)
  A(344) = RCT(344)*V(69)
  A(345) = RCT(345)*V(58)
  A(346) = RCT(346)*V(74)
  A(347) = RCT(347)*V(76)
  A(348) = RCT(348)*V(80)
  A(349) = RCT(349)*V(73)
  A(350) = RCT(350)*V(70)
  A(351) = RCT(351)*V(64)
  A(352) = RCT(352)*V(137)
  A(353) = RCT(353)*V(54)
  A(354) = RCT(354)*V(104)
  A(355) = RCT(355)*V(93)
  A(356) = RCT(356)*V(82)
  A(357) = RCT(357)*V(125)
  A(358) = RCT(358)*V(96)
  A(359) = RCT(359)*V(63)
  A(360) = RCT(360)*V(65)
  A(361) = RCT(361)*V(65)

! Aggregate function
  Vdot(1) = A(240)
  Vdot(2) = A(242)
  Vdot(3) = A(239)
  Vdot(4) = A(241)
  Vdot(5) = A(234)
  Vdot(6) = A(236)
  Vdot(7) = A(237)
  Vdot(8) = A(243)
  Vdot(9) = A(235)
  Vdot(10) = A(244)
  Vdot(11) = A(245)
  Vdot(12) = A(263)
  Vdot(13) = 0.25*A(261)
  Vdot(14) = A(135)
  Vdot(15) = A(297)
  Vdot(16) = A(298)
  Vdot(17) = A(294)-A(297)-A(298)
  Vdot(18) = A(230)-A(294)
  Vdot(19) = A(299)
  Vdot(20) = A(300)
  Vdot(21) = A(295)-A(299)-A(300)
  Vdot(22) = A(231)-A(295)
  Vdot(23) = A(301)
  Vdot(24) = A(302)
  Vdot(25) = A(296)-A(301)-A(302)
  Vdot(26) = A(232)-A(296)
  Vdot(27) = A(304)
  Vdot(28) = A(305)
  Vdot(29) = A(303)-A(304)-A(305)
  Vdot(30) = A(233)-A(303)
  Vdot(31) = 0.35*A(277)
  Vdot(32) = A(248)
  Vdot(33) = A(249)
  Vdot(34) = A(247)
  Vdot(35) = A(246)
  Vdot(36) = A(253)
  Vdot(37) = A(254)
  Vdot(38) = A(252)
  Vdot(39) = A(255)
  Vdot(40) = A(256)
  Vdot(41) = A(238)
  Vdot(42) = A(13)+A(36)+A(44)+A(68)+A(75)+0.87*A(117)+0.54*A(121)+A(122)+A(126)+A(127)+0.26*A(128)+0.81*A(129)+0.5&
               &*A(139)+0.15*A(144)+0.16*A(146)+0.2*A(166)+0.2*A(167)+A(171)+2*A(174)+0.7*A(176)+2*A(177)+A(178)+A(179)&
               &+A(190)+A(196)+0.93*A(279)+0.93*A(280)+A(288)+0.5*A(290)+A(291)+A(292)+A(360)+A(361)
  Vdot(43) = A(234)+A(235)+A(236)+A(237)+A(238)+A(239)+A(240)+A(241)+A(242)+A(243)+A(244)+A(245)+A(246)+A(247)+A(248)&
               &+A(249)+A(252)+A(253)+A(254)+A(255)+A(256)
  Vdot(44) = -A(47)-A(48)+A(223)
  Vdot(45) = A(70)-A(71)-A(244)
  Vdot(46) = A(7)-A(9)+A(11)-A(242)-A(308)
  Vdot(47) = A(164)-A(165)-A(246)
  Vdot(48) = A(260)+0.75*A(261)+A(262)-A(263)
  Vdot(49) = A(42)-A(43)-A(237)-A(322)
  Vdot(50) = 0.1*A(121)-A(235)+A(281)-A(282)
  Vdot(51) = -A(51)-A(66)+A(219)
  Vdot(52) = -A(45)-A(182)+A(224)
  Vdot(53) = A(26)-A(27)+0.5*A(257)-A(313)
  Vdot(54) = 0.41*A(115)-A(181)-A(353)
  Vdot(55) = A(34)-A(35)-A(241)-A(259)-A(317)-A(318)
  Vdot(56) = A(113)-A(158)-A(341)
  Vdot(57) = A(89)-A(159)-A(342)
  Vdot(58) = 0.41*A(116)-A(161)-A(345)
  Vdot(59) = A(28)-A(29)-A(30)-A(314)-A(319)
  Vdot(60) = -A(260)-A(261)-A(262)
  Vdot(61) = A(112)-A(157)-A(340)
  Vdot(62) = A(16)-A(19)-A(20)-A(309)
  Vdot(63) = -A(21)-A(22)+0.85*A(83)-A(359)
  Vdot(64) = 0.1*A(117)-A(172)-A(173)-A(351)
  Vdot(65) = 0.36*A(121)+A(124)-A(125)-A(238)-A(360)-A(361)
  Vdot(66) = A(81)-A(160)+0.5*A(290)-A(343)
  Vdot(67) = A(91)-A(156)-A(339)
  Vdot(68) = 0.5*A(251)+0.13*A(270)+0.065*A(272)-A(292)
  Vdot(69) = A(114)-A(162)-A(344)
  Vdot(70) = 0.02*A(87)-A(170)-A(171)-A(350)
  Vdot(71) = 0.5*A(90)-A(154)-A(155)-A(338)
  Vdot(72) = -A(36)+A(129)+0.5*A(139)+0.074*A(166)+0.074*A(167)+0.2*A(183)-A(255)+0.31*A(270)+0.155*A(272)+0.65*A(277)&
               &+0.07*A(279)+0.07*A(280)
  Vdot(73) = 0.1*A(86)-A(169)-A(349)
  Vdot(74) = 0.88*A(85)-A(163)-A(164)-A(247)-A(346)
  Vdot(75) = -A(124)+A(125)-A(126)-A(127)
  Vdot(76) = -A(168)+0.1*A(267)-A(347)
  Vdot(77) = 0.654*A(168)+0.29*A(191)+0.29*A(265)-A(283)
  Vdot(78) = 0.17*A(191)+0.17*A(265)-A(287)-A(291)
  Vdot(79) = A(72)-A(73)-A(120)-A(123)-A(243)
  Vdot(80) = 0.5*A(272)+0.5*A(275)-A(276)-A(348)
  Vdot(81) = -A(135)-A(144)-A(147)+A(220)
  Vdot(82) = 0.047*A(57)-A(249)-A(250)-A(269)-A(356)
  Vdot(83) = 0.1*A(57)+0.113*A(190)-A(284)-A(285)-A(286)
  Vdot(84) = A(165)-A(166)-A(167)
  Vdot(85) = 0.32*A(52)+A(61)-A(77)-A(78)+0.16*A(95)+0.75*A(105)+0.791*A(159)+0.32*A(187)+A(194)+A(210)+A(221)-A(324)&
               &-A(325)+A(342)+0.32*A(352)
  Vdot(86) = -A(118)-A(119)-A(130)+0.07*A(144)+A(222)+A(332)
  Vdot(87) = A(287)-A(288)-A(289)-A(290)
  Vdot(88) = 0.25*A(79)+0.25*A(80)+0.25*A(95)+0.25*A(96)+0.25*A(98)+0.24*A(99)+0.48*A(100)+0.25*A(101)+0.25*A(102)+0.15&
               &*A(103)+0.25*A(105)+0.25*A(106)+0.25*A(107)-A(109)+0.3*A(176)
  Vdot(89) = -A(68)+0.15*A(115)+0.5*A(139)+A(142)+A(143)+A(175)+A(186)+A(199)+A(200)+A(201)+A(202)+A(203)+A(204)+A(205)&
               &+A(206)+A(207)+A(208)+A(209)+A(210)+A(212)-A(256)+0.08*A(279)+0.08*A(280)
  Vdot(90) = 0.155*A(128)-A(131)-A(133)+0.275*A(166)+0.275*A(167)+0.216*A(191)+0.216*A(265)+0.48*A(284)+0.48*A(286)&
               &-A(328)-A(329)
  Vdot(91) = -A(13)+A(23)+A(39)+0.05*A(40)+0.857*A(59)+0.5*A(60)+0.5*A(75)+0.686*A(87)+0.5*A(88)+0.33*A(101)+0.595&
               &*A(103)+0.375*A(104)+0.42*A(119)+0.58*A(128)+0.19*A(129)+2*A(131)+A(132)+2*A(133)+A(134)+0.5*A(139)+0.05&
               &*A(144)+0.05*A(145)+0.2*A(146)+0.251*A(166)+0.251*A(167)+0.4*A(183)+0.09*A(191)+0.857*A(193)+0.5*A(196)&
               &+A(218)+0.09*A(265)+1.5*A(283)+A(310)+A(311)+A(320)+A(321)+A(323)+A(325)+A(327)+1.5*A(328)+2*A(329)+A(330)&
               &+A(331)+A(332)+A(333)+A(336)+0.67*A(347)+0.5*A(350)+0.5*A(354)+A(358)
  Vdot(92) = A(278)-A(279)-A(280)-A(281)+A(282)
  Vdot(93) = 0.12*A(58)+0.61*A(250)-A(254)+0.14*A(273)+0.07*A(275)-A(277)-A(355)
  Vdot(94) = A(48)-A(49)+0.05*A(52)-A(79)+0.03*A(95)-A(113)-A(140)-A(142)+0.36*A(158)+0.05*A(187)+0.05*A(352)
  Vdot(95) = A(120)-A(121)-A(122)
  Vdot(96) = 0.5*A(60)+0.5*A(88)+0.375*A(104)+0.791*A(156)+0.5*A(196)+0.5*A(251)-A(252)+0.15*A(270)+0.075*A(272)-A(293)&
               &-A(358)
  Vdot(97) = -A(60)-A(88)-A(104)+A(148)-A(196)-A(207)
  Vdot(98) = A(47)+0.18*A(52)-A(61)-A(89)+0.09*A(95)-A(105)+0.209*A(159)+0.18*A(187)-A(194)-A(210)+0.18*A(352)
  Vdot(99) = A(24)-A(25)+A(39)+A(41)+A(66)+A(76)+A(94)+0.425*A(106)+A(133)+A(134)+A(149)+A(180)+A(182)+0.85*A(197)&
               &+A(229)-A(239)+0.5*A(257)+A(258)+2*A(259)+A(262)+A(266)+A(271)+A(274)+A(285)+A(289)-A(312)
  Vdot(100) = 0.53*A(58)+0.578*A(86)+0.13*A(101)+0.36*A(102)-A(128)-A(129)+0.275*A(166)+0.275*A(167)+0.28*A(183)+0.234&
                &*A(191)+0.6*A(192)+0.5*A(251)+0.234*A(265)+0.9*A(267)+0.15*A(270)+0.075*A(272)+0.6*A(273)+0.3*A(275)+0.52&
                &*A(284)+0.52*A(286)-A(327)+0.26*A(347)+0.7*A(349)+A(355)
  Vdot(101) = -A(58)-A(86)-A(102)+A(136)+0.209*A(169)-A(192)-A(204)
  Vdot(102) = A(173)-A(174)-A(175)-A(176)-2*A(177)-A(178)-A(179)-A(180)
  Vdot(103) = A(268)-A(270)-A(271)-A(272)+0.193*A(276)
  Vdot(104) = 0.15*A(59)+0.39*A(250)-A(253)+0.07*A(270)+0.035*A(272)+0.26*A(273)+0.13*A(275)-A(278)-A(354)
  Vdot(105) = -A(59)-A(87)-A(103)+0.47*A(137)+A(170)-A(193)-A(205)
  Vdot(106) = -A(56)-A(84)+A(92)+A(94)-A(98)-A(189)-A(201)
  Vdot(107) = A(269)-A(273)-A(274)-A(275)+0.193*A(276)
  Vdot(108) = A(21)-A(55)+A(77)+A(78)-A(83)-A(97)+0.152*A(117)-A(188)-A(200)
  Vdot(109) = -A(50)-A(80)-A(114)+A(118)-A(141)-A(143)+0.209*A(162)
  Vdot(110) = -A(65)-A(91)-A(107)+A(130)+0.209*A(156)-A(198)-A(209)
  Vdot(111) = -A(101)+0.346*A(168)-A(191)-A(203)+A(264)-A(265)-A(266)-A(267)
  Vdot(112) = A(45)-A(46)+0.32*A(52)+A(74)-A(93)+0.16*A(95)-2*A(110)-2*A(111)-A(112)+0.44*A(116)+A(150)+0.36*A(157)&
                &+A(182)+0.32*A(187)-A(211)-A(212)+A(213)+A(323)+0.85*A(326)+0.32*A(352)
  Vdot(113) = A(69)-A(70)+A(71)-A(74)+A(76)-A(116)-A(150)-A(152)+A(161)-A(213)+0.15*A(326)
  Vdot(114) = A(5)+A(15)+A(17)+2*A(18)+A(20)-A(23)+A(37)-A(39)+0.05*A(40)+A(50)+0.39*A(54)+0.96*A(55)+0.66*A(57)+0.35&
                &*A(58)+0.143*A(59)+0.5*A(60)+A(65)+0.5*A(75)+0.75*A(79)+1.25*A(80)+0.15*A(83)+0.12*A(85)+0.102*A(86)+0.294&
                &*A(87)+0.5*A(88)+0.75*A(93)+0.75*A(95)+0.95*A(96)+0.5*A(97)+0.75*A(98)+1.22*A(99)+0.92*A(100)+0.95*A(101)&
                &+0.89*A(102)+1.255*A(103)+0.625*A(104)+0.75*A(105)+0.83*A(106)+1.25*A(107)+0.435*A(117)+0.535*A(119)+0.54&
                &*A(121)+0.6*A(123)+0.85*A(128)+A(141)+0.9*A(144)+0.8*A(145)+0.7*A(146)+A(150)+2*A(151)+A(152)+A(153)+0.375&
                &*A(166)+0.375*A(167)+A(176)+0.12*A(183)+A(185)+A(186)+A(188)+0.747*A(190)+0.4*A(192)+0.143*A(193)+0.39&
                &*A(195)+0.5*A(196)+0.15*A(197)+A(198)+A(214)+A(227)-A(240)+A(250)+A(260)+A(262)+0.65*A(270)+0.325*A(272)&
                &+0.4*A(273)+0.2*A(275)+0.35*A(277)+0.08*A(279)+0.08*A(280)+A(292)+A(309)-A(310)-A(311)+A(327)+0.5*A(328)&
                &+A(333)+A(336)+A(337)+A(344)+0.71*A(346)+0.3*A(349)+0.5*A(350)+A(351)+0.5*A(354)+A(358)+A(359)
  Vdot(115) = -A(40)-A(41)+A(46)+A(50)+0.32*A(52)+0.75*A(54)+0.93*A(56)+A(65)+0.5*A(80)+A(84)+0.75*A(93)+0.16*A(95)+0.38&
                &*A(96)+0.5*A(98)+0.5*A(107)+A(108)+2*A(110)+A(111)+0.5*A(119)+A(141)+0.04*A(145)+0.64*A(157)+0.32*A(187)&
                &+A(189)+0.75*A(195)+A(198)+A(211)+A(212)+A(226)-A(320)-A(321)+A(331)+A(340)+A(344)+A(345)+0.32*A(352)
  Vdot(116) = -A(54)+A(67)-A(82)-A(96)-A(195)-A(206)+0.612*A(276)
  Vdot(117) = -A(62)-A(63)-2*A(64)-A(90)-A(106)+A(147)+0.36*A(155)-A(197)-A(208)
  Vdot(118) = A(22)+0.35*A(58)+0.143*A(59)+0.5*A(60)+0.102*A(86)+0.294*A(87)+0.5*A(88)+0.5*A(97)+0.29*A(101)+0.14*A(102)&
                &+0.255*A(103)+0.375*A(104)-A(132)-A(134)+A(138)+0.82*A(145)+0.8*A(146)+0.275*A(166)+0.275*A(167)+0.6*A(183)&
                &+0.234*A(191)+0.4*A(192)+0.143*A(193)+0.5*A(196)+A(200)+0.234*A(265)+0.9*A(267)+0.65*A(277)+0.07*A(279)&
                &+0.07*A(280)+0.52*A(284)+0.52*A(286)+A(293)-A(330)-A(331)+0.58*A(347)+0.3*A(349)+A(354)
  Vdot(119) = 0.857*A(59)+0.16*A(80)+0.686*A(87)+0.2*A(97)+0.18*A(101)+0.595*A(103)+0.283*A(117)+0.36*A(121)+A(122)&
                &-A(138)-A(139)+0.65*A(143)+0.791*A(162)+0.725*A(166)+0.725*A(167)+A(171)+A(174)+0.7*A(176)+2*A(177)+A(178)&
                &+A(179)+0.2*A(183)+0.216*A(191)+0.857*A(193)+0.5*A(251)+0.216*A(265)+0.44*A(270)+0.22*A(272)+0.6*A(273)+0.3&
                &*A(275)+0.85*A(279)+0.85*A(280)+0.5*A(283)+0.48*A(284)+0.48*A(286)-A(337)+0.36*A(347)+A(350)+A(354)
  Vdot(120) = 0.4*A(57)+0.073*A(85)+0.28*A(99)+0.56*A(100)+0.03*A(106)-A(136)+0.159*A(144)-A(145)+0.453*A(190)+0.05&
                &*A(197)-A(332)-A(333)-A(334)+0.425*A(346)
  Vdot(121) = 0.26*A(57)+0.047*A(85)+0.18*A(99)+0.36*A(100)+0.05*A(106)-A(137)+0.387*A(144)-A(146)-A(148)-A(149)+0.294&
                &*A(190)+0.1*A(197)-A(335)-A(336)+0.285*A(346)
  Vdot(122) = -A(72)+A(73)-A(75)-A(117)+0.53*A(137)+A(149)-A(151)-A(153)+A(172)-A(214)+A(334)+A(335)
  Vdot(123) = -A(57)-A(85)-A(99)-2*A(100)+A(135)+0.387*A(163)-A(190)-A(202)
  Vdot(124) = 0.123*A(57)+0.2*A(62)+0.2*A(63)+0.28*A(64)+0.3*A(99)+0.5*A(100)+0.613*A(163)-A(183)+0.14*A(190)-A(264)&
                &+0.29*A(346)+A(356)+A(357)
  Vdot(125) = 0.07*A(57)+0.8*A(62)+0.8*A(63)+1.72*A(64)+0.5*A(90)-A(248)-A(251)-A(268)-A(357)
  Vdot(126) = A(51)-A(52)-A(53)+0.3*A(54)+A(66)-A(81)-A(95)+0.15*A(96)+0.209*A(160)-A(187)+0.3*A(195)-A(199)
  Vdot(127) = A(49)+0.13*A(52)+0.57*A(54)-A(69)-A(76)+0.75*A(79)+0.09*A(80)+0.033*A(86)+0.07*A(95)+0.54*A(96)+0.25&
                &*A(106)+0.25*A(107)+A(109)+A(140)+A(142)+0.35*A(143)+0.64*A(158)+0.791*A(160)+0.13*A(187)+0.09*A(191)+0.57&
                &*A(195)+A(206)+A(207)+A(208)+A(209)+0.09*A(265)+A(288)+0.5*A(290)-A(323)+A(338)+A(339)+A(341)+A(343)+A(348)&
                &+0.13*A(352)
  Vdot(128) = A(1)-A(4)+A(10)+A(15)-A(24)+A(27)-A(28)+A(29)+A(30)+A(31)+2*A(32)+A(33)-A(34)+A(35)-A(42)+A(43)+A(44)&
                &+A(46)+A(49)+A(50)+A(52)+2*A(54)+0.96*A(55)+0.93*A(56)+0.883*A(57)+0.88*A(58)+0.85*A(59)+1.5*A(60)+A(61)&
                &+1.2*A(62)+1.2*A(63)+0.28*A(64)+2*A(65)-A(70)+A(71)-A(72)+A(73)+A(74)+A(75)+0.5*A(88)+A(96)+0.375*A(104)&
                &+0.575*A(106)+A(107)+0.9*A(121)+A(122)+A(123)-A(124)+A(125)+A(126)+A(154)+A(167)+A(179)+A(195)+0.5*A(196)&
                &+0.15*A(197)+A(198)+A(206)+A(207)+A(208)+A(209)+2*A(215)+A(217)-A(234)-A(257)+A(265)+1.34*A(270)+0.17&
                &*A(272)+1.6*A(273)+0.3*A(275)+1.85*A(279)+0.85*A(280)-A(281)+A(282)+A(284)+A(288)+A(292)+A(293)-A(307)&
                &+A(312)+A(315)+A(317)+A(319)+0.6*A(322)+A(338)+A(339)+A(348)+A(352)+A(354)+A(355)+A(356)+A(357)+A(358)+0.7&
                &*A(360)
  Vdot(129) = A(4)+A(25)-A(31)-A(32)-A(33)-A(34)+A(35)-A(38)-A(39)-A(41)-A(63)-A(66)-A(76)-A(94)+0.54*A(121)-A(130)&
                &-A(133)-A(134)-A(147)-A(148)-A(149)-A(182)-2*A(215)-A(258)-A(262)+0.31*A(270)+0.155*A(272)+A(277)+0.15&
                &*A(279)+0.15*A(280)+A(314)-A(315)-A(316)+A(317)+A(318)+0.4*A(322)+0.3*A(360)+A(361)
  Vdot(130) = 0.95*A(40)+A(41)-A(42)+A(43)-A(44)+0.96*A(55)+0.93*A(56)+0.53*A(58)+0.5*A(75)+0.15*A(83)+A(84)+0.578*A(86)&
                &+0.3*A(97)+0.5*A(98)+0.36*A(102)-A(115)+A(126)+A(127)+A(132)+A(134)-A(140)-A(141)-A(142)-A(143)+A(151)&
                &-A(174)-A(175)+A(181)-2*A(184)-A(185)-A(186)-A(187)-A(190)-A(191)-0.4*A(192)-A(193)-A(194)-A(195)-A(196)&
                &-A(197)-A(198)-A(199)-A(200)-A(201)-A(202)-A(203)-A(204)-A(205)-A(206)-A(207)-A(208)-A(209)-A(210)-A(211)&
                &-A(212)-A(213)+0.6*A(322)+A(324)+0.85*A(326)+A(330)+A(333)+A(336)+A(337)+0.7*A(349)+A(351)+A(355)+A(359)&
                &+A(360)+A(361)
  Vdot(131) = 0.19*A(52)+0.187*A(86)-A(92)-A(94)+0.35*A(95)+0.25*A(98)+0.25*A(101)+0.25*A(102)+A(154)+0.791*A(169)&
                &+A(175)+0.19*A(187)+A(199)+A(201)+A(202)+A(203)+A(204)+A(205)+A(225)+0.34*A(270)+0.17*A(272)+0.5*A(283)&
                &+A(291)-A(326)+0.19*A(352)
  Vdot(132) = -A(2)+A(3)-2*A(6)-2*A(7)-A(8)-A(9)+A(10)-A(12)-A(13)-A(14)-A(19)-A(21)-A(23)-A(24)-A(25)-A(26)-A(27)-A(30)&
                &+A(31)-A(33)-A(36)-A(37)-A(40)-A(45)-A(47)-A(48)-A(51)+0.5*A(60)-A(67)-A(68)-A(69)-A(77)-A(78)+0.15*A(83)&
                &+A(84)+0.12*A(85)+0.68*A(86)+0.98*A(87)+A(88)+0.5*A(90)-A(92)-A(108)-A(109)+0.44*A(115)+0.44*A(116)+0.87&
                &*A(117)-A(118)+0.135*A(119)-A(120)+A(127)-0.74*A(128)-0.81*A(129)-A(131)-A(132)-A(135)-A(136)-A(137)-A(138)&
                &+0.27*A(144)+0.08*A(145)+0.215*A(146)-0.36*A(155)-0.209*A(156)-0.36*A(157)-0.36*A(158)-0.209*A(159)-0.209&
                &*A(160)-A(161)-0.209*A(162)-0.387*A(163)-A(165)+1.125*A(166)+0.125*A(167)-0.346*A(168)-0.209*A(169)-A(170)&
                &-A(172)-A(173)+A(174)+0.7*A(176)+2*A(177)+2*A(178)+A(179)-A(181)+0.1*A(183)+0.27*A(250)+0.27*A(251)-A(260)&
                &-A(261)-A(263)-A(264)+0.9*A(267)-A(268)-A(269)+0.5*A(272)+0.5*A(275)-0.388*A(276)-A(277)-A(278)+A(280)&
                &-A(283)+A(286)-A(287)+0.5*A(290)+A(291)-A(292)-A(293)+2*A(306)+2*A(308)+A(309)+A(312)+A(313)+A(314)+A(338)&
                &+A(339)+A(340)+A(341)+A(342)+A(343)+A(344)+A(345)+A(346)+A(347)+A(348)+A(349)+A(350)+A(351)+A(353)+A(359)
  Vdot(133) = -A(5)+A(14)-A(15)-A(16)-2*A(17)-2*A(18)+A(19)+A(44)+0.18*A(52)+A(68)+0.5*A(75)-A(79)-A(80)-A(93)-0.91&
                &*A(95)-A(96)-A(97)-A(98)-A(99)-A(101)-A(102)-A(103)-A(104)-A(105)-A(106)-A(107)+0.44*A(115)+0.435*A(117)&
                &+0.305*A(119)+0.5*A(139)+A(140)+A(141)-A(150)-A(151)-A(152)-A(153)+A(174)-A(176)+2*A(184)-A(186)+A(187)&
                &+A(188)+A(189)+A(190)+A(191)+A(192)+A(193)+A(194)+A(195)+A(196)+A(197)+A(198)+A(211)+A(213)+A(214)+A(260)&
                &+A(261)+A(262)+A(320)+0.4*A(322)+A(324)+2*A(325)+0.15*A(326)+A(334)+0.18*A(352)+A(353)+A(358)
  Vdot(134) = -A(1)-A(10)-A(15)-A(26)-A(32)+A(38)-A(44)-A(46)-A(49)-A(50)-A(52)-A(53)-A(54)-A(55)-A(56)-A(57)-A(58)&
                &-A(59)-A(60)-A(61)-A(62)-A(65)-A(74)-A(75)-A(121)-A(126)-A(167)-A(179)-A(180)+A(216)-A(265)-A(266)-A(270)&
                &-A(271)-A(273)-A(274)-A(279)-A(284)-A(285)-A(288)-A(289)+A(307)+A(313)+A(316)+A(318)
  Vdot(135) = -A(1)-A(2)-A(3)-A(4)-A(5)+A(6)+0.15*A(115)+0.15*A(116)+0.03*A(117)-A(119)-A(123)-0.9*A(144)-0.8*A(145)-0.8&
                &*A(146)-0.7*A(183)+A(228)-A(236)-A(250)-A(251)-A(291)-A(306)+A(307)+A(315)+A(318)
  Vdot(136) = A(2)-A(3)+A(5)-A(8)+A(9)-A(10)-2*A(11)+A(12)+A(13)+A(15)-A(16)+2*A(18)+A(23)-A(28)+A(29)-A(31)+A(33)+A(36)&
                &+A(37)+A(39)+0.05*A(40)+A(46)+A(49)+A(50)+0.27*A(52)+0.783*A(57)+0.35*A(58)+0.85*A(59)+A(61)+0.8*A(62)+0.8&
                &*A(63)+1.12*A(64)+A(79)+A(80)-A(81)-A(82)-A(83)-A(84)-0.88*A(85)-0.898*A(86)-0.02*A(87)-0.5*A(88)-A(89)-0.5&
                &*A(90)-A(91)+A(93)+0.64*A(95)+0.5*A(96)+0.3*A(97)+0.5*A(98)+1.1*A(99)+1.28*A(100)+A(101)+0.64*A(102)+1.7&
                &*A(103)+0.375*A(104)+A(105)+0.9*A(106)+0.5*A(107)+A(108)+A(109)+2*A(110)-A(112)-A(113)-A(114)-A(115)-A(116)&
                &-A(117)+0.3*A(119)+0.54*A(121)-A(122)+A(123)-A(127)+0.74*A(128)+0.81*A(129)+A(131)+A(133)+A(138)+A(140)&
                &+A(141)+0.06*A(144)+0.06*A(145)+0.275*A(146)+A(150)+A(151)-0.175*A(166)+0.825*A(167)+0.7*A(176)-A(178)&
                &+A(185)+0.27*A(187)+0.887*A(190)+A(191)+0.4*A(192)+0.85*A(193)+A(194)+0.5*A(196)+0.8*A(197)+A(211)+A(263)&
                &+A(265)-0.1*A(267)+0.35*A(270)-0.825*A(272)+0.4*A(273)-0.8*A(275)-A(280)+A(283)+A(284)+A(288)-0.5*A(290)&
                &+A(291)+A(309)+2*A(310)+A(319)+A(320)+A(323)+2*A(327)+2*A(329)+A(330)+A(333)+A(335)+A(336)+A(337)+A(338)&
                &+A(339)+A(340)+A(341)+A(342)+A(343)+A(344)+A(345)+A(346)+A(347)+A(348)+0.3*A(349)+A(350)+0.27*A(352)+A(354)&
                &+A(356)+A(357)
  Vdot(137) = A(53)+0.04*A(55)+0.07*A(56)-A(67)+A(82)+0.25*A(104)+0.64*A(155)-A(245)-A(352)
      
END SUBROUTINE Fun

! End of Fun function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE gckpp_Function

