! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Utility Data Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Monitor.f90
! Time                 : Tue Mar 16 10:29:04 2010
! Working directory    : /mnt/lstr04/srv/home/c/ccarouge/KPP/geoschem_kppfiles/v8-03-01/Paulot_scheme
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Monitor


  CHARACTER(LEN=12), PARAMETER, DIMENSION(90) :: SPC_NAMES_0 = (/ &
     'DRYCH2O     ','DRYH2O2     ','DRYHNO3     ', &
     'DRYN2O5     ','DRYNO2      ','DRYO3       ', &
     'DRYPAN      ','DRYPMN      ','DRYPMNN     ', &
     'DRYPPN      ','DRYR4N2     ','SO4         ', &
     'MSA         ','LISOPOH     ','LBRO2H      ', &
     'LBRO2N      ','BRO2        ','BENZ        ', &
     'LTRO2H      ','LTRO2N      ','TRO2        ', &
     'TOLU        ','LXRO2H      ','LXRO2N      ', &
     'XRO2        ','XYLE        ','LNRO2H      ', &
     'LNRO2N      ','NRO2        ','NAP         ', &
     'PYAC        ','DRYISOPND   ','DRYISOPNB   ', &
     'DRYRIP      ','DRYIEPOX    ','DRYMACRN    ', &
     'DRYMVKN     ','DRYPROPNN   ','DRYHCOOH    ', &
     'DRYACTA     ','DRYPYPAN    ','CO2         ', &
     'DRYDEP      ','C3H8        ','PPN         ', &
     'H2O2        ','IEPOX       ','SO2         ', &
     'PAN         ','PMNN        ','ALK4        ', &
     'C2H6        ','HNO2        ','MAP         ', &
     'N2O5        ','RA3P        ','RB3P        ', &
     'RP          ','HNO4        ','DMS         ', &
     'ETP         ','MP          ','ATOOH       ', &
     'MAOP        ','PYPAN       ','R4P         ', &
     'PRPN        ','ETHLN       ','PP          ', &
     'MRP         ','INPN        ','HCOOH       ', &
     'VRP         ','RIP         ','PYPO2       ', &
     'IAP         ','DHMOB       ','MOBA        ', &
     'PMN         ','ISNP        ','ISOP        ', &
     'ISOPNB      ','DIBOO       ','IEPOXOO     ', &
     'ACET        ','PRPE        ','MOBAOO      ', &
     'ROH         ','ACTA        ','GLYX        ' /)
  CHARACTER(LEN=12), PARAMETER, DIMENSION(55) :: SPC_NAMES_1 = (/ &
     'CO          ','MACRNO2     ','MVKN        ', &
     'A3O2        ','PMNO2       ','PROPNN      ', &
     'MAN2        ','B3O2        ','HNO3        ', &
     'GLYC        ','VRO2        ','MAOPO2      ', &
     'ISOPNDO2    ','MACRN       ','MRO2        ', &
     'KO2         ','ISOPNBO2    ','ATO2        ', &
     'PO2         ','PRN1        ','HC5OO       ', &
     'ETO2        ','RCO3        ','CH2O        ', &
     'ALD2        ','R4N1        ','INO2        ', &
     'MGLY        ','HAC         ','MVK         ', &
     'MACR        ','MAO3        ','RIO2        ', &
     'HC5         ','ISOPND      ','R4O2        ', &
     'RCHO        ','NO2         ','NO3         ', &
     'MCO3        ','MEK         ','OH          ', &
     'MO2         ','NO          ','O3          ', &
     'HO2         ','R4N2        ','CH4         ', &
     'EMISSION    ','EOH         ','H2          ', &
     'H2O         ','MOH         ','O2          ', &
     'RCOOH       ' /)
  CHARACTER(LEN=12), PARAMETER, DIMENSION(145) :: SPC_NAMES = (/&
    SPC_NAMES_0, SPC_NAMES_1 /)

  INTEGER, PARAMETER, DIMENSION(145) :: LOOKAT = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, &
      13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, &
      25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, &
      37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, &
      49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, &
      61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, &
      73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, &
      85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, &
      97, 98, 99,100,101,102,103,104,105,106,107,108, &
     109,110,111,112,113,114,115,116,117,118,119,120, &
     121,122,123,124,125,126,127,128,129,130,131,132, &
     133,134,135,136,137,138,139,140,141,142,143,144, &
     145 /)

  INTEGER, DIMENSION(1) :: MONITOR
  CHARACTER(LEN=12), DIMENSION(1) :: SMASS
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_0 = (/ &
     '       NO + O3 --> NO2 + O2                                                                         ', &
     '       OH + O3 --> HO2 + O2                                                                         ', &
     '      O3 + HO2 --> OH + 2 O2                                                                        ', &
     '      NO2 + O3 --> NO3 + O2                                                                         ', &
     '      MO2 + O3 --> CH2O + HO2 + 2 O2                                                                ', &
     '          2 OH --> O3 + H2O                                                                         ', &
     '          2 OH --> H2O2                                                                             ', &
     '      OH + HO2 --> H2O + O2                                                                         ', &
     '     H2O2 + OH --> HO2 + H2O                                                                        ', &
     '      NO + HO2 --> NO2 + OH                                                                         ', &
     '         2 HO2 --> H2O2                                                                             ', &
     '       OH + H2 --> HO2 + H2O                                                                        ', &
     '       CO + OH --> CO2 + HO2                                                                        ', &
     '      OH + CH4 --> MO2 + H2O                                                                        ', &
     '      MO2 + NO --> CH2O + NO2 + HO2                                                                 ', &
     '     MO2 + HO2 --> MP + O2                                                                          ', &
     '         2 MO2 --> CH2O + MOH + O2                                                                  ', &
     '         2 MO2 --> 2 CH2O + 2 HO2                                                                   ', &
     '       MP + OH --> MO2 + H2O                                                                        ', &
     '       MP + OH --> CH2O + OH + H2O                                                                  ', &
     '    ATOOH + OH --> ATO2 + H2O                                                                       ', &
     '    ATOOH + OH --> MGLY + OH + H2O                                                                  ', &
     '     CH2O + OH --> CO + HO2 + H2O                                                                   ', &
     '      NO2 + OH --> HNO3                                                                             ', &
     '     HNO3 + OH --> NO3 + H2O                                                                        ', &
     '       OH + NO --> HNO2                                                                             ', &
     '     HNO2 + OH --> NO2 + H2O                                                                        ', &
     '     NO2 + HO2 --> HNO4                                                                             ', &
     '          HNO4 --> NO2 + HO2                                                                        ', &
     '     HNO4 + OH --> NO2 + H2O + O2                                                                   ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_1 = (/ &
     '     NO3 + HO2 --> NO2 + OH + O2                                                                    ', &
     '      NO3 + NO --> 2 NO2                                                                            ', &
     '      NO3 + OH --> NO2 + HO2                                                                        ', &
     '     NO2 + NO3 --> N2O5                                                                             ', &
     '          N2O5 --> NO2 + NO3                                                                        ', &
     '    HCOOH + OH --> CO2 + HO2 + H2O                                                                  ', &
     '      OH + MOH --> CH2O + HO2                                                                       ', &
     '     NO2 + NO3 --> NO2 + NO + O2                                                                    ', &
     '    CH2O + NO3 --> CO + HNO3 + HO2                                                                  ', &
     '     ALD2 + OH --> 0.05 CO + 0.05 CH2O + 0.95 MCO3 + 0.05 HO2                                       ', &
     '    ALD2 + NO3 --> HNO3 + MCO3                                                                      ', &
     '    NO2 + MCO3 --> PAN                                                                              ', &
     '           PAN --> NO2 + MCO3                                                                       ', &
     '     MCO3 + NO --> CO2 + NO2 + MO2                                                                  ', &
     '     C2H6 + OH --> ETO2 + H2O                                                                       ', &
     '     ETO2 + NO --> ALD2 + NO2 + HO2                                                                 ', &
     '     C3H8 + OH --> B3O2                                                                             ', &
     '     C3H8 + OH --> A3O2                                                                             ', &
     '     A3O2 + NO --> RCHO + NO2 + HO2                                                                 ', &
     '      PO2 + NO --> CH2O + ALD2 + NO2 + HO2                                                          ', &
     '     ALK4 + OH --> R4O2                                                                             ', &
     '     R4O2 + NO --> 0.32 ACET + 0.05 A3O2 + 0.18 B3O2 + 0.32 ETO2 + 0.32 ALD2 ... etc.               ', &
     '     R4O2 + NO --> R4N2                                                                             ', &
     '     R4N1 + NO --> 0.39 CH2O + 0.75 ALD2 + 0.3 R4O2 + 0.57 RCHO + 2 NO2 ... etc.                    ', &
     '     ATO2 + NO --> 0.96 CH2O + 0.96 NO2 + 0.96 MCO3 + 0.04 R4N2                                     ', &
     '      KO2 + NO --> 0.93 ALD2 + 0.93 NO2 + 0.93 MCO3 + 0.07 R4N2                                     ', &
     '     RIO2 + NO --> 0.047 ISOPNB + 0.1 DIBOO + 0.66 CH2O + 0.4 MVK + 0.26 MACR ... etc.              ', &
     '     VRO2 + NO --> 0.12 MVKN + 0.53 GLYC + 0.35 CH2O + 0.35 MGLY + 0.88 NO2 ... etc.                ', &
     '     MRO2 + NO --> 0.857 CO + 0.15 MACRN + 0.143 CH2O + 0.143 MGLY + 0.857 HAC ... etc.             ', &
     '     MAN2 + NO --> 0.5 CO + 0.5 PROPNN + 0.5 CH2O + 0.5 MGLY + 1.5 NO2 ... etc.                     ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_2 = (/ &
     '     B3O2 + NO --> ACET + NO2 + HO2                                                                 ', &
     '     INO2 + NO --> 0.2 HC5 + 0.8 ISOPND + 1.2 NO2 + 0.8 HO2                                         ', &
     '    INO2 + NO3 --> 0.2 HC5 + 0.8 ISOPND + 1.2 NO2 + 0.8 HO2                                         ', &
     '        2 INO2 --> 0.28 HC5 + 1.72 ISOPND + 0.28 NO2 + 1.12 HO2                                     ', &
     '     PRN1 + NO --> CH2O + ALD2 + 2 NO2                                                              ', &
     '    ALK4 + NO3 --> HNO3 + R4O2                                                                      ', &
     '     OH + R4N2 --> R4N1 + H2O                                                                       ', &
     '     ACTA + OH --> CO2 + MO2 + H2O                                                                  ', &
     '     RCHO + OH --> RCO3 + H2O                                                                       ', &
     '    RCO3 + NO2 --> PPN                                                                              ', &
     '           PPN --> RCO3 + NO2                                                                       ', &
     '    MAO3 + NO2 --> PMN                                                                              ', &
     '           PMN --> MAO3 + NO2                                                                       ', &
     '     RCO3 + NO --> ETO2 + NO2                                                                       ', &
     '     MAO3 + NO --> CO2 + 0.5 CO + 0.5 CH2O + NO2 + 0.5 MCO3 + 0.5 MO2                               ', &
     '    RCHO + NO3 --> HNO3 + RCO3                                                                      ', &
     '     ACET + OH --> ATO2 + H2O                                                                       ', &
     '     ACET + OH --> ATO2 + H2O                                                                       ', &
     '    A3O2 + MO2 --> 0.25 ROH + 0.75 CH2O + 0.75 RCHO + HO2 + 0.25 MOH                                ', &
     '     PO2 + MO2 --> 0.25 ROH + 1.25 CH2O + 0.5 ALD2 + 0.16 HAC + 0.09 RCHO ... etc.                  ', &
     '    R4O2 + HO2 --> R4P                                                                              ', &
     '    R4N1 + HO2 --> R4N2                                                                             ', &
     '    ATO2 + HO2 --> 0.85 ATOOH + 0.15 CH2O + 0.15 MCO3 + 0.15 OH                                     ', &
     '     KO2 + HO2 --> ALD2 + MCO3 + OH                                                                 ', &
     '    RIO2 + HO2 --> 0.88 RIP + 0.12 CH2O + 0.073 MVK + 0.047 MACR + 0.12 OH ... etc.                 ', &
     '    VRO2 + HO2 --> 0.1 VRP + 0.578 GLYC + 0.102 CH2O + 0.102 MGLY + 0.033 RCHO ... etc.             ', &
     '    MRO2 + HO2 --> 0.02 MRP + 0.686 CO + 0.294 CH2O + 0.294 MGLY + 0.686 HAC ... etc.               ', &
     '    MAN2 + HO2 --> 0.5 CO + 0.5 PROPNN + 0.5 CH2O + 0.5 MGLY + 0.5 NO2 ... etc.                     ', &
     '    B3O2 + HO2 --> RB3P                                                                             ', &
     '    INO2 + HO2 --> 0.5 INPN + 0.5 ISOPND + 0.5 OH + 0.5 HO2                                         ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_3 = (/ &
     '    PRN1 + HO2 --> PRPN                                                                             ', &
     '      MEK + OH --> KO2 + H2O                                                                        ', &
     '    ETO2 + MO2 --> 0.75 CH2O + 0.75 ALD2 + HO2 + 0.25 EOH + 0.25 MOH                                ', &
     '     NO3 + MEK --> HNO3 + KO2                                                                       ', &
     '    R4O2 + MO2 --> 0.16 ACET + 0.25 ROH + 0.03 A3O2 + 0.09 B3O2 + 0.16 ETO2 ... etc.                ', &
     '    R4N1 + MO2 --> 0.25 ROH + 0.95 CH2O + 0.38 ALD2 + 0.15 R4O2 + 0.54 RCHO ... etc.                ', &
     '    ATO2 + MO2 --> 0.5 CH2O + 0.5 MGLY + 0.2 HAC + 0.3 MCO3 + 0.3 HO2 + 0.5 MOH ... etc.            ', &
     '     KO2 + MO2 --> 0.25 ROH + 0.75 CH2O + 0.5 ALD2 + 0.5 MCO3 + 0.25 MEK ... etc.                   ', &
     '    RIO2 + MO2 --> 0.24 ROH + 1.22 CH2O + 0.28 MVK + 0.18 MACR + 0.3 HC5 ... etc.                   ', &
     '        2 RIO2 --> 0.48 ROH + 0.92 CH2O + 0.56 MVK + 0.36 MACR + 0.5 HC5 ... etc.                   ', &
     '   HC5OO + MO2 --> 0.25 ROH + 0.33 CO + 0.13 GLYC + 0.95 CH2O + 0.29 MGLY ... etc.                  ', &
     '    VRO2 + MO2 --> 0.25 ROH + 0.36 GLYC + 0.89 CH2O + 0.14 MGLY + 0.36 MCO3 ... etc.                ', &
     '    MRO2 + MO2 --> 0.15 ROH + 0.595 CO + 1.255 CH2O + 0.255 MGLY + 0.595 HAC ... etc.               ', &
     '    MAN2 + MO2 --> 0.375 CO + 0.375 PROPNN + 0.625 CH2O + 0.375 MGLY + 0.375 NO2 ... etc.           ', &
     '    B3O2 + MO2 --> 0.75 ACET + 0.25 ROH + 0.75 CH2O + HO2 + 0.25 MOH                                ', &
     '    INO2 + MO2 --> 0.25 ROH + 0.425 HNO3 + 0.83 CH2O + 0.03 MVK + 0.05 MACR ... etc.                ', &
     '    PRN1 + MO2 --> 0.25 ROH + 1.25 CH2O + 0.5 ALD2 + 0.25 RCHO + NO2 + 0.5 HO2 ... etc.             ', &
     '      OH + EOH --> ALD2 + HO2                                                                       ', &
     '      ROH + OH --> RCHO + HO2                                                                       ', &
     '        2 ETO2 --> 2 ALD2 + 2 HO2                                                                   ', &
     '        2 ETO2 --> ALD2 + EOH                                                                       ', &
     '    ETO2 + HO2 --> ETP                                                                              ', &
     '    A3O2 + HO2 --> RA3P                                                                             ', &
     '     PO2 + HO2 --> PP                                                                               ', &
     '    MCO3 + HO2 --> 0.41 MAP + 0.15 ACTA + 0.44 OH + 0.44 MO2 + 0.15 O3 ... etc.                     ', &
     '    RCO3 + HO2 --> 0.41 RP + 0.44 ETO2 + 0.44 OH + 0.15 O3 + 0.15 RCOOH ... etc.                    ', &
     '    MAO3 + HO2 --> 0.87 CO2 + 0.1 MAOP + 0.152 ATO2 + 0.435 CH2O + 0.283 HAC ... etc.               ', &
     '     PRPE + OH --> PO2                                                                              ', &
     '     PRPE + O3 --> 0.42 CO + 0.535 CH2O + 0.5 ALD2 + 0.135 OH + 0.305 MO2 ... etc.                  ', &
     '      PMN + OH --> PMNO2                                                                            ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_4 = (/ &
     '    PMNO2 + NO --> 0.54 CO2 + 0.1 PMNN + 0.36 PYPAN + 0.54 CH2O + 0.36 HAC ... etc.                 ', &
     '   PMNO2 + HO2 --> CO2 + HAC + NO2                                                                  ', &
     '      PMN + O3 --> 0.6 CH2O + NO2 + HO2                                                             ', &
     '   PYPO2 + NO2 --> PYPAN                                                                            ', &
     '         PYPAN --> PYPO2 + NO2                                                                      ', &
     '    PYPO2 + NO --> CO2 + NO2 + MCO3                                                                 ', &
     '   PYPO2 + HO2 --> CO2 + MCO3 + OH                                                                  ', &
     '     GLYC + OH --> 0.26 CO2 + 0.155 GLYX + 0.58 CO + 0.85 CH2O + 0.26 OH ... etc.                   ', &
     '     GLYC + OH --> 0.81 CO2 + HCOOH + 0.19 CO + 0.19 OH + 0.81 HO2                                  ', &
     '    PRPE + NO3 --> PRN1                                                                             ', &
     '     GLYX + OH --> 2 CO + HO2                                                                       ', &
     '     MGLY + OH --> CO + MCO3                                                                        ', &
     '    GLYX + NO3 --> 2 CO + HNO3 + HO2                                                                ', &
     '    MGLY + NO3 --> CO + HNO3 + MCO3                                                                 ', &
     '     ISOP + OH --> LISOPOH + RIO2                                                                   ', &
     '      MVK + OH --> VRO2                                                                             ', &
     '     MACR + OH --> 0.47 MRO2 + 0.53 MAO3                                                            ', &
     '      HAC + OH --> MGLY + HO2                                                                       ', &
     '      HAC + OH --> 0.5 CO2 + 0.5 HCOOH + 0.5 ACTA + 0.5 CO + OH + 0.5 MO2 ... etc.                  ', &
     '   A3O2 + MCO3 --> RCHO + MO2 + HO2                                                                 ', &
     '    PO2 + MCO3 --> CH2O + ALD2 + MO2 + HO2                                                          ', &
     '   A3O2 + MCO3 --> ACTA + RCHO                                                                      ', &
     '    PO2 + MCO3 --> ACTA + 0.65 HAC + 0.35 RCHO                                                      ', &
     '     ISOP + O3 --> 0.15 CO2 + 0.07 PRPE + 0.05 CO + 0.9 CH2O + 0.159 MVK ... etc.                   ', &
     '      MVK + O3 --> 0.05 CO + 0.8 CH2O + 0.04 ALD2 + 0.82 MGLY + 0.08 OH ... etc.                    ', &
     '     MACR + O3 --> 0.16 CO2 + 0.2 CO + 0.7 CH2O + 0.8 MGLY + 0.215 OH + 0.2 O3 ... etc.             ', &
     '    ISOP + NO3 --> INO2                                                                             ', &
     '    MACR + NO3 --> MAN2                                                                             ', &
     '    MACR + NO3 --> HNO3 + MAO3                                                                      ', &
     '    RCO3 + MO2 --> ETO2 + CH2O + HO2                                                                ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_5 = (/ &
     '    MAO3 + MO2 --> 2 CH2O + MCO3 + HO2                                                              ', &
     '    RCO3 + MO2 --> CH2O + RCOOH                                                                     ', &
     '    MAO3 + MO2 --> CH2O + RCOOH                                                                     ', &
     '     INPN + OH --> NO2 + MEK + OH                                                                   ', &
     '     INPN + OH --> 0.36 INO2 + 0.64 OH + 0.64 R4N2                                                  ', &
     '     PRPN + OH --> 0.791 PROPNN + 0.209 PRN1 + 0.791 OH                                             ', &
     '      ETP + OH --> 0.36 ETO2 + 0.64 ALD2 + 0.64 OH                                                  ', &
     '     RA3P + OH --> 0.36 A3O2 + 0.64 RCHO + 0.64 OH                                                  ', &
     '     RB3P + OH --> 0.791 ACET + 0.209 B3O2 + 0.791 OH                                               ', &
     '      R4P + OH --> 0.209 R4O2 + 0.791 RCHO + 0.791 OH                                               ', &
     '       RP + OH --> RCO3                                                                             ', &
     '       PP + OH --> 0.209 PO2 + 0.791 HAC + 0.791 OH                                                 ', &
     '      RIP + OH --> 0.387 RIO2 + 0.613 HC5 + 0.613 OH                                                ', &
     '      RIP + OH --> IEPOX + OH                                                                       ', &
     '    IEPOX + OH --> IEPOXOO                                                                          ', &
     ' IEPOXOO + HO2 --> 0.2 CO2 + 0.074 HCOOH + 0.275 GLYX + 0.251 CO + 0.275 GLYC ... etc.              ', &
     '  IEPOXOO + NO --> 0.2 CO2 + 0.074 HCOOH + 0.275 GLYX + 0.251 CO + 0.275 GLYC ... etc.              ', &
     '      IAP + OH --> 0.654 DHMOB + 0.346 HC5OO + 0.654 OH                                             ', &
     '      VRP + OH --> 0.209 VRO2 + 0.791 MEK + 0.791 OH                                                ', &
     '      MRP + OH --> MRO2                                                                             ', &
     '      MRP + OH --> CO2 + HAC + OH                                                                   ', &
     '     MAOP + OH --> MAO3                                                                             ', &
     '     MAOP + OH --> MAOPO2                                                                           ', &
     ' MAOPO2 + MCO3 --> 2 CO2 + HAC + OH + MO2                                                           ', &
     ' MAOPO2 + MCO3 --> ACTA + MEK                                                                       ', &
     '  MAOPO2 + MO2 --> 0.7 CO2 + 0.3 ROH + CH2O + 0.7 HAC + 0.7 OH + 0.7 HO2 ... etc.                   ', &
     '      2 MAOPO2 --> 2 CO2 + 2 HAC + 2 OH                                                             ', &
     '  MAOPO2 + HO2 --> CO2 + HAC + 2 OH                                                                 ', &
     '   MAOPO2 + NO --> CO2 + HAC + NO2 + OH                                                             ', &
     '   MAOPO2 + NO --> HNO3                                                                             ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_6 = (/ &
     '      MAP + OH --> MCO3                                                                             ', &
     '    C2H6 + NO3 --> HNO3 + ETO2                                                                      ', &
     '      HC5 + O3 --> 0.2 HCOOH + 0.4 CO + 0.28 GLYC + 0.12 CH2O + 0.6 MGLY ... etc.                   ', &
     '        2 MCO3 --> 2 MO2                                                                            ', &
     '    MCO3 + MO2 --> CH2O + MO2 + HO2                                                                 ', &
     '    MCO3 + MO2 --> ACTA + CH2O                                                                      ', &
     '   R4O2 + MCO3 --> 0.32 ACET + 0.05 A3O2 + 0.18 B3O2 + 0.32 ETO2 + 0.32 ALD2 ... etc.               ', &
     '   ATO2 + MCO3 --> CH2O + MCO3 + MO2                                                                ', &
     '    KO2 + MCO3 --> ALD2 + MCO3 + MO2                                                                ', &
     '   RIO2 + MCO3 --> CO2 + 0.113 DIBOO + 0.747 CH2O + 0.453 MVK + 0.294 MACR ... etc.                 ', &
     '  HC5OO + MCO3 --> 0.29 DHMOB + 0.17 MOBA + 0.216 GLYX + 0.09 CO + 0.234 GLYC ... etc.              ', &
     '   VRO2 + MCO3 --> 0.6 GLYC + 0.4 CH2O + 0.4 MGLY + 0.6 MCO3 + MO2 + 0.4 HO2 ... etc.               ', &
     '   MRO2 + MCO3 --> 0.857 CO + 0.143 CH2O + 0.143 MGLY + 0.857 HAC + MO2 ... etc.                    ', &
     '   B3O2 + MCO3 --> ACET + MO2 + HO2                                                                 ', &
     '   R4N1 + MCO3 --> 0.39 CH2O + 0.75 ALD2 + 0.3 R4O2 + 0.57 RCHO + NO2 + MO2 ... etc.                ', &
     '   MAN2 + MCO3 --> CO2 + 0.5 CO + 0.5 PROPNN + 0.5 CH2O + 0.5 MGLY + 0.5 NO2 ... etc.               ', &
     '   INO2 + MCO3 --> 0.85 HNO3 + 0.15 CH2O + 0.05 MVK + 0.1 MACR + 0.15 NO2 ... etc.                  ', &
     '   PRN1 + MCO3 --> CH2O + ALD2 + NO2 + MO2                                                          ', &
     '   R4O2 + MCO3 --> ACTA + MEK                                                                       ', &
     '   ATO2 + MCO3 --> ACTA + MGLY                                                                      ', &
     '    KO2 + MCO3 --> ACTA + MEK                                                                       ', &
     '   RIO2 + MCO3 --> ACTA + MEK                                                                       ', &
     '  HC5OO + MCO3 --> ACTA + MEK                                                                       ', &
     '   VRO2 + MCO3 --> ACTA + MEK                                                                       ', &
     '   MRO2 + MCO3 --> ACTA + MEK                                                                       ', &
     '   R4N1 + MCO3 --> ACTA + RCHO + NO2                                                                ', &
     '   MAN2 + MCO3 --> ACTA + RCHO + NO2                                                                ', &
     '   INO2 + MCO3 --> ACTA + RCHO + NO2                                                                ', &
     '   PRN1 + MCO3 --> ACTA + RCHO + NO2                                                                ', &
     '   B3O2 + MCO3 --> ACET + ACTA                                                                      ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_7 = (/ &
     '   ETO2 + MCO3 --> ALD2 + MO2 + HO2                                                                 ', &
     '   ETO2 + MCO3 --> ACTA + ALD2                                                                      ', &
     '   RCO3 + MCO3 --> ETO2 + MO2                                                                       ', &
     '   MAO3 + MCO3 --> CH2O + MCO3 + MO2                                                                ', &
     '         2 NO3 --> 2 NO2 + O2                                                                       ', &
     '      EMISSION --> NO                                                                               ', &
     '      EMISSION --> NO2                                                                              ', &
     '      EMISSION --> CO                                                                               ', &
     '      EMISSION --> ALK4                                                                             ', &
     '      EMISSION --> ISOP                                                                             ', &
     '      EMISSION --> ACET                                                                             ', &
     '      EMISSION --> PRPE                                                                             ', &
     '      EMISSION --> C3H8                                                                             ', &
     '      EMISSION --> C2H6                                                                             ', &
     '      EMISSION --> MEK                                                                              ', &
     '      EMISSION --> ALD2                                                                             ', &
     '      EMISSION --> CH2O                                                                             ', &
     '      EMISSION --> O3                                                                               ', &
     '      EMISSION --> HNO3                                                                             ', &
     '      EMISSION --> BENZ                                                                             ', &
     '      EMISSION --> TOLU                                                                             ', &
     '      EMISSION --> XYLE                                                                             ', &
     '      EMISSION --> NAP                                                                              ', &
     '           NO2 --> DRYNO2 + DRYDEP                                                                  ', &
     '          PMNN --> DRYPMNN + DRYDEP                                                                 ', &
     '            O3 --> DRYO3 + DRYDEP                                                                   ', &
     '           PAN --> DRYPAN + DRYDEP                                                                  ', &
     '         PYPAN --> DRYPYPAN + DRYDEP                                                                ', &
     '          HNO3 --> DRYHNO3 + DRYDEP                                                                 ', &
     '          CH2O --> DRYCH2O + DRYDEP                                                                 ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_8 = (/ &
     '          N2O5 --> DRYN2O5 + DRYDEP                                                                 ', &
     '          H2O2 --> DRYH2O2 + DRYDEP                                                                 ', &
     '           PMN --> DRYPMN + DRYDEP                                                                  ', &
     '           PPN --> DRYPPN + DRYDEP                                                                  ', &
     '          R4N2 --> DRYR4N2 + DRYDEP                                                                 ', &
     '         IEPOX --> DRYIEPOX + DRYDEP                                                                ', &
     '           RIP --> DRYRIP + DRYDEP                                                                  ', &
     '        ISOPND --> DRYISOPND + DRYDEP                                                               ', &
     '        ISOPNB --> DRYISOPNB + DRYDEP                                                               ', &
     '   ISOPNB + O3 --> 0.61 MVKN + 0.39 MACRN + CH2O + 0.27 OH                                          ', &
     '   ISOPND + O3 --> 0.5 ETHLN + 0.5 PROPNN + 0.5 GLYC + 0.5 HAC + 0.27 OH ... etc.                   ', &
     '        PROPNN --> DRYPROPNN + DRYDEP                                                               ', &
     '         MACRN --> DRYMACRN + DRYDEP                                                                ', &
     '          MVKN --> DRYMVKN + DRYDEP                                                                 ', &
     '         HCOOH --> DRYHCOOH + DRYDEP                                                                ', &
     '          ACTA --> DRYACTA + DRYDEP                                                                 ', &
     '           NO2 --> 0.5 HNO2 + 0.5 HNO3                                                              ', &
     '           NO3 --> HNO3                                                                             ', &
     '          N2O5 --> 2 HNO3                                                                           ', &
     '      DMS + OH --> SO2 + CH2O + MO2                                                                 ', &
     '      DMS + OH --> 0.25 MSA + 0.75 SO2 + MO2                                                        ', &
     '     DMS + NO3 --> SO2 + HNO3 + CH2O + MO2                                                          ', &
     '      SO2 + OH --> SO4 + HO2                                                                        ', &
     '      HC5 + OH --> HC5OO                                                                            ', &
     '    HC5OO + NO --> 0.29 DHMOB + 0.17 MOBA + 0.216 GLYX + 0.09 CO + 0.234 GLYC ... etc.              ', &
     '    HC5OO + NO --> HNO3                                                                             ', &
     '   HC5OO + HO2 --> 0.1 IAP + 0.9 GLYC + 0.9 MGLY + 0.9 OH + 0.9 HO2                                 ', &
     '   ISOPND + OH --> ISOPNDO2                                                                         ', &
     '   ISOPNB + OH --> ISOPNBO2                                                                         ', &
     ' ISOPNDO2 + NO --> 0.13 ETHLN + 0.31 HCOOH + 0.15 PROPNN + 0.15 GLYC + 0.07 MACRN ... etc.          ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_9 = (/ &
     ' ISOPNDO2 + NO --> HNO3                                                                             ', &
     'ISOPNDO2 + HO2 --> 0.065 ETHLN + 0.155 HCOOH + 0.5 ISNP + 0.075 PROPNN ... etc.                     ', &
     ' ISOPNBO2 + NO --> 0.14 MVKN + 0.6 GLYC + 0.26 MACRN + 0.4 CH2O + 0.6 HAC ... etc.                  ', &
     ' ISOPNBO2 + NO --> HNO3                                                                             ', &
     'ISOPNBO2 + HO2 --> 0.5 ISNP + 0.07 MVKN + 0.3 GLYC + 0.13 MACRN + 0.2 CH2O ... etc.                 ', &
     '     ISNP + OH --> 0.193 ISOPNDO2 + 0.193 ISOPNBO2 + 0.612 R4N1 + 0.612 OH ... etc.                 ', &
     '     MVKN + OH --> 0.35 PYAC + 0.65 HCOOH + 0.35 CH2O + 0.65 MGLY + NO3 ... etc.                    ', &
     '    MACRN + OH --> MACRNO2                                                                          ', &
     '  MACRNO2 + NO --> 0.93 CO2 + 0.07 HCOOH + 0.08 ACTA + 0.08 CH2O + 0.07 MGLY ... etc.               ', &
     ' MACRNO2 + HO2 --> 0.93 CO2 + 0.07 HCOOH + 0.08 ACTA + 0.08 CH2O + 0.07 MGLY ... etc.               ', &
     ' MACRNO2 + NO2 --> PMNN                                                                             ', &
     '          PMNN --> MACRNO2 + NO2                                                                    ', &
     '    DHMOB + OH --> 1.5 CO + 0.5 HAC + 0.5 MEK + HO2                                                 ', &
     '    DIBOO + NO --> 0.48 GLYX + 0.52 GLYC + 0.52 MGLY + 0.48 HAC + NO2 + HO2 ... etc.                ', &
     '    DIBOO + NO --> HNO3                                                                             ', &
     '   DIBOO + HO2 --> 0.48 GLYX + 0.52 GLYC + 0.52 MGLY + 0.48 HAC + OH + HO2 ... etc.                 ', &
     '     MOBA + OH --> MOBAOO                                                                           ', &
     '   MOBAOO + NO --> CO2 + RCHO + NO2 + HO2                                                           ', &
     '   MOBAOO + NO --> HNO3                                                                             ', &
     '  MOBAOO + HO2 --> 0.5 CO2 + 0.5 R4P + 0.5 RCHO + 0.5 OH + 0.5 HO2                                  ', &
     '     MOBA + O3 --> CO2 + MEK + OH + HO2                                                             ', &
     '    ETHLN + OH --> CO2 + CH2O + NO2                                                                 ', &
     '   PROPNN + OH --> MGLY + NO2                                                                       ', &
     '     BENZ + OH --> BRO2 + OH                                                                        ', &
     '     TOLU + OH --> TRO2 + OH                                                                        ', &
     '     XYLE + OH --> XRO2 + OH                                                                        ', &
     '    BRO2 + HO2 --> LBRO2H + HO2                                                                     ', &
     '     BRO2 + NO --> LBRO2N + NO                                                                      ', &
     '    TRO2 + HO2 --> LTRO2H + HO2                                                                     ', &
     '     TRO2 + NO --> LTRO2N + NO                                                                      ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_10 = (/ &
     '    XRO2 + HO2 --> LXRO2H + HO2                                                                     ', &
     '     XRO2 + NO --> LXRO2N + NO                                                                      ', &
     '      NAP + OH --> NRO2 + OH                                                                        ', &
     '    NRO2 + HO2 --> LNRO2H + HO2                                                                     ', &
     '     NRO2 + NO --> LNRO2N + NO                                                                      ', &
     '            O3 --> 2 OH                                                                             ', &
     '           NO2 --> NO + O3                                                                          ', &
     '          H2O2 --> 2 OH                                                                             ', &
     '            MP --> CH2O + OH + HO2                                                                  ', &
     '          CH2O --> CO + 2 HO2                                                                       ', &
     '          CH2O --> CO + H2                                                                          ', &
     '          HNO3 --> NO2 + OH                                                                         ', &
     '          HNO2 --> OH + NO                                                                          ', &
     '          HNO4 --> NO3 + OH                                                                         ', &
     '           NO3 --> NO2 + O3                                                                         ', &
     '           NO3 --> NO + O2                                                                          ', &
     '          N2O5 --> NO2 + NO3                                                                        ', &
     '          N2O5 --> NO3 + NO + O3                                                                    ', &
     '          HNO4 --> NO2 + HO2                                                                        ', &
     '          ALD2 --> CO + MO2 + HO2                                                                   ', &
     '          ALD2 --> CO + CH4                                                                         ', &
     '           PAN --> 0.6 NO2 + 0.4 NO3 + 0.6 MCO3 + 0.4 MO2                                           ', &
     '          RCHO --> CO + ETO2 + HO2                                                                  ', &
     '          ACET --> MCO3 + MO2                                                                       ', &
     '          ACET --> CO + 2 MO2                                                                       ', &
     '           MEK --> 0.85 ETO2 + 0.15 RCO3 + 0.85 MCO3 + 0.15 MO2                                     ', &
     '          GLYC --> CO + CH2O + 2 HO2                                                                ', &
     '          GLYX --> 1.5 CO + 0.5 CH2O + 0.5 H2                                                       ', &
     '          GLYX --> 2 CO + 2 HO2                                                                     ', &
     '          MGLY --> CO + MCO3 + HO2                                                                  ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(30) :: EQN_NAMES_11 = (/ &
     '          MGLY --> CO + ALD2                                                                        ', &
     '           MVK --> PRPE + CO                                                                        ', &
     '           MVK --> CO + CH2O + MCO3 + HO2                                                           ', &
     '           MVK --> MAO3 + MO2                                                                       ', &
     '          MACR --> MAO3 + HO2                                                                       ', &
     '          MACR --> CO + CH2O + MCO3 + HO2                                                           ', &
     '           HAC --> CH2O + MCO3 + HO2                                                                ', &
     '          INPN --> RCHO + NO2 + OH + HO2                                                            ', &
     '          PRPN --> RCHO + NO2 + OH + HO2                                                            ', &
     '           ETP --> ALD2 + OH + HO2                                                                  ', &
     '          RA3P --> RCHO + OH + HO2                                                                  ', &
     '          RB3P --> ACET + OH + HO2                                                                  ', &
     '           R4P --> RCHO + OH + HO2                                                                  ', &
     '            PP --> CH2O + ALD2 + OH + HO2                                                           ', &
     '            RP --> ALD2 + OH + HO2                                                                  ', &
     '           RIP --> 0.71 CH2O + 0.425 MVK + 0.285 MACR + 0.29 HC5 + OH + HO2 ... etc.                ', &
     '           IAP --> 0.67 CO + 0.26 GLYC + 0.58 MGLY + 0.36 HAC + OH + HO2 ... etc.                   ', &
     '          ISNP --> RCHO + NO2 + OH + HO2                                                            ', &
     '           VRP --> 0.7 GLYC + 0.3 CH2O + 0.3 MGLY + 0.7 MCO3 + OH + 0.3 HO2 ... etc.                ', &
     '           MRP --> 0.5 CO + 0.5 CH2O + HAC + OH + HO2                                               ', &
     '          MAOP --> CH2O + MCO3 + OH                                                                 ', &
     '          R4N2 --> 0.32 ACET + 0.05 A3O2 + 0.18 B3O2 + 0.32 ETO2 + 0.32 ALD2 ... etc.               ', &
     '           MAP --> OH + MO2                                                                         ', &
     '         MACRN --> 0.5 CO + 0.5 CH2O + MGLY + HAC + NO2 + HO2                                       ', &
     '          MVKN --> GLYC + NO2 + MCO3                                                                ', &
     '        ISOPNB --> HC5 + NO2 + HO2                                                                  ', &
     '        ISOPND --> HC5 + NO2 + HO2                                                                  ', &
     '        PROPNN --> CO + CH2O + NO2 + MO2                                                            ', &
     '         ATOOH --> CH2O + MCO3 + OH                                                                 ', &
     '         PYPAN --> CO2 + 0.7 NO2 + 0.3 NO3 + MCO3                                                   ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(1) :: EQN_NAMES_12 = (/ &
     '         PYPAN --> CO2 + NO3 + MCO3                                                                 ' /)
  CHARACTER(LEN=100), PARAMETER, DIMENSION(361) :: EQN_NAMES = (/&
    EQN_NAMES_0, EQN_NAMES_1, EQN_NAMES_2, EQN_NAMES_3, EQN_NAMES_4, &
    EQN_NAMES_5, EQN_NAMES_6, EQN_NAMES_7, EQN_NAMES_8, EQN_NAMES_9, &
    EQN_NAMES_10, EQN_NAMES_11, EQN_NAMES_12 /)

! INLINED global variables

! End INLINED global variables


END MODULE gckpp_Monitor
