! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Parameters.f90
! Time                 : Tue Mar 16 10:29:04 2010
! Working directory    : /mnt/lstr04/srv/home/c/ccarouge/KPP/geoschem_kppfiles/v8-03-01/Paulot_scheme
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Parameters

  USE gckpp_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 145 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 137 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 102 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 8 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 361 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 138 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 1288 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 1481 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 138 
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
  INTEGER, PARAMETER :: CNEQN = 362 
! NHESS - Length of Sparse Hessian
  INTEGER, PARAMETER :: NHESS = 1157 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 145 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_DRYCH2O = 1 
  INTEGER, PARAMETER :: ind_DRYH2O2 = 2 
  INTEGER, PARAMETER :: ind_DRYHNO3 = 3 
  INTEGER, PARAMETER :: ind_DRYN2O5 = 4 
  INTEGER, PARAMETER :: ind_DRYNO2 = 5 
  INTEGER, PARAMETER :: ind_DRYO3 = 6 
  INTEGER, PARAMETER :: ind_DRYPAN = 7 
  INTEGER, PARAMETER :: ind_DRYPMN = 8 
  INTEGER, PARAMETER :: ind_DRYPMNN = 9 
  INTEGER, PARAMETER :: ind_DRYPPN = 10 
  INTEGER, PARAMETER :: ind_DRYR4N2 = 11 
  INTEGER, PARAMETER :: ind_SO4 = 12 
  INTEGER, PARAMETER :: ind_MSA = 13 
  INTEGER, PARAMETER :: ind_LISOPOH = 14 
  INTEGER, PARAMETER :: ind_LBRO2H = 15 
  INTEGER, PARAMETER :: ind_LBRO2N = 16 
  INTEGER, PARAMETER :: ind_BRO2 = 17 
  INTEGER, PARAMETER :: ind_BENZ = 18 
  INTEGER, PARAMETER :: ind_LTRO2H = 19 
  INTEGER, PARAMETER :: ind_LTRO2N = 20 
  INTEGER, PARAMETER :: ind_TRO2 = 21 
  INTEGER, PARAMETER :: ind_TOLU = 22 
  INTEGER, PARAMETER :: ind_LXRO2H = 23 
  INTEGER, PARAMETER :: ind_LXRO2N = 24 
  INTEGER, PARAMETER :: ind_XRO2 = 25 
  INTEGER, PARAMETER :: ind_XYLE = 26 
  INTEGER, PARAMETER :: ind_LNRO2H = 27 
  INTEGER, PARAMETER :: ind_LNRO2N = 28 
  INTEGER, PARAMETER :: ind_NRO2 = 29 
  INTEGER, PARAMETER :: ind_NAP = 30 
  INTEGER, PARAMETER :: ind_PYAC = 31 
  INTEGER, PARAMETER :: ind_DRYISOPND = 32 
  INTEGER, PARAMETER :: ind_DRYISOPNB = 33 
  INTEGER, PARAMETER :: ind_DRYRIP = 34 
  INTEGER, PARAMETER :: ind_DRYIEPOX = 35 
  INTEGER, PARAMETER :: ind_DRYMACRN = 36 
  INTEGER, PARAMETER :: ind_DRYMVKN = 37 
  INTEGER, PARAMETER :: ind_DRYPROPNN = 38 
  INTEGER, PARAMETER :: ind_DRYHCOOH = 39 
  INTEGER, PARAMETER :: ind_DRYACTA = 40 
  INTEGER, PARAMETER :: ind_DRYPYPAN = 41 
  INTEGER, PARAMETER :: ind_CO2 = 42 
  INTEGER, PARAMETER :: ind_DRYDEP = 43 
  INTEGER, PARAMETER :: ind_C3H8 = 44 
  INTEGER, PARAMETER :: ind_PPN = 45 
  INTEGER, PARAMETER :: ind_H2O2 = 46 
  INTEGER, PARAMETER :: ind_IEPOX = 47 
  INTEGER, PARAMETER :: ind_SO2 = 48 
  INTEGER, PARAMETER :: ind_PAN = 49 
  INTEGER, PARAMETER :: ind_PMNN = 50 
  INTEGER, PARAMETER :: ind_ALK4 = 51 
  INTEGER, PARAMETER :: ind_C2H6 = 52 
  INTEGER, PARAMETER :: ind_HNO2 = 53 
  INTEGER, PARAMETER :: ind_MAP = 54 
  INTEGER, PARAMETER :: ind_N2O5 = 55 
  INTEGER, PARAMETER :: ind_RA3P = 56 
  INTEGER, PARAMETER :: ind_RB3P = 57 
  INTEGER, PARAMETER :: ind_RP = 58 
  INTEGER, PARAMETER :: ind_HNO4 = 59 
  INTEGER, PARAMETER :: ind_DMS = 60 
  INTEGER, PARAMETER :: ind_ETP = 61 
  INTEGER, PARAMETER :: ind_MP = 62 
  INTEGER, PARAMETER :: ind_ATOOH = 63 
  INTEGER, PARAMETER :: ind_MAOP = 64 
  INTEGER, PARAMETER :: ind_PYPAN = 65 
  INTEGER, PARAMETER :: ind_R4P = 66 
  INTEGER, PARAMETER :: ind_PRPN = 67 
  INTEGER, PARAMETER :: ind_ETHLN = 68 
  INTEGER, PARAMETER :: ind_PP = 69 
  INTEGER, PARAMETER :: ind_MRP = 70 
  INTEGER, PARAMETER :: ind_INPN = 71 
  INTEGER, PARAMETER :: ind_HCOOH = 72 
  INTEGER, PARAMETER :: ind_VRP = 73 
  INTEGER, PARAMETER :: ind_RIP = 74 
  INTEGER, PARAMETER :: ind_PYPO2 = 75 
  INTEGER, PARAMETER :: ind_IAP = 76 
  INTEGER, PARAMETER :: ind_DHMOB = 77 
  INTEGER, PARAMETER :: ind_MOBA = 78 
  INTEGER, PARAMETER :: ind_PMN = 79 
  INTEGER, PARAMETER :: ind_ISNP = 80 
  INTEGER, PARAMETER :: ind_ISOP = 81 
  INTEGER, PARAMETER :: ind_ISOPNB = 82 
  INTEGER, PARAMETER :: ind_DIBOO = 83 
  INTEGER, PARAMETER :: ind_IEPOXOO = 84 
  INTEGER, PARAMETER :: ind_ACET = 85 
  INTEGER, PARAMETER :: ind_PRPE = 86 
  INTEGER, PARAMETER :: ind_MOBAOO = 87 
  INTEGER, PARAMETER :: ind_ROH = 88 
  INTEGER, PARAMETER :: ind_ACTA = 89 
  INTEGER, PARAMETER :: ind_GLYX = 90 
  INTEGER, PARAMETER :: ind_CO = 91 
  INTEGER, PARAMETER :: ind_MACRNO2 = 92 
  INTEGER, PARAMETER :: ind_MVKN = 93 
  INTEGER, PARAMETER :: ind_A3O2 = 94 
  INTEGER, PARAMETER :: ind_PMNO2 = 95 
  INTEGER, PARAMETER :: ind_PROPNN = 96 
  INTEGER, PARAMETER :: ind_MAN2 = 97 
  INTEGER, PARAMETER :: ind_B3O2 = 98 
  INTEGER, PARAMETER :: ind_HNO3 = 99 
  INTEGER, PARAMETER :: ind_GLYC = 100 
  INTEGER, PARAMETER :: ind_VRO2 = 101 
  INTEGER, PARAMETER :: ind_MAOPO2 = 102 
  INTEGER, PARAMETER :: ind_ISOPNDO2 = 103 
  INTEGER, PARAMETER :: ind_MACRN = 104 
  INTEGER, PARAMETER :: ind_MRO2 = 105 
  INTEGER, PARAMETER :: ind_KO2 = 106 
  INTEGER, PARAMETER :: ind_ISOPNBO2 = 107 
  INTEGER, PARAMETER :: ind_ATO2 = 108 
  INTEGER, PARAMETER :: ind_PO2 = 109 
  INTEGER, PARAMETER :: ind_PRN1 = 110 
  INTEGER, PARAMETER :: ind_HC5OO = 111 
  INTEGER, PARAMETER :: ind_ETO2 = 112 
  INTEGER, PARAMETER :: ind_RCO3 = 113 
  INTEGER, PARAMETER :: ind_CH2O = 114 
  INTEGER, PARAMETER :: ind_ALD2 = 115 
  INTEGER, PARAMETER :: ind_R4N1 = 116 
  INTEGER, PARAMETER :: ind_INO2 = 117 
  INTEGER, PARAMETER :: ind_MGLY = 118 
  INTEGER, PARAMETER :: ind_HAC = 119 
  INTEGER, PARAMETER :: ind_MVK = 120 
  INTEGER, PARAMETER :: ind_MACR = 121 
  INTEGER, PARAMETER :: ind_MAO3 = 122 
  INTEGER, PARAMETER :: ind_RIO2 = 123 
  INTEGER, PARAMETER :: ind_HC5 = 124 
  INTEGER, PARAMETER :: ind_ISOPND = 125 
  INTEGER, PARAMETER :: ind_R4O2 = 126 
  INTEGER, PARAMETER :: ind_RCHO = 127 
  INTEGER, PARAMETER :: ind_NO2 = 128 
  INTEGER, PARAMETER :: ind_NO3 = 129 
  INTEGER, PARAMETER :: ind_MCO3 = 130 
  INTEGER, PARAMETER :: ind_MEK = 131 
  INTEGER, PARAMETER :: ind_OH = 132 
  INTEGER, PARAMETER :: ind_MO2 = 133 
  INTEGER, PARAMETER :: ind_NO = 134 
  INTEGER, PARAMETER :: ind_O3 = 135 
  INTEGER, PARAMETER :: ind_HO2 = 136 
  INTEGER, PARAMETER :: ind_R4N2 = 137 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_CH4 = 138 
  INTEGER, PARAMETER :: ind_EMISSION = 139 
  INTEGER, PARAMETER :: ind_EOH = 140 
  INTEGER, PARAMETER :: ind_H2 = 141 
  INTEGER, PARAMETER :: ind_H2O = 142 
  INTEGER, PARAMETER :: ind_MOH = 143 
  INTEGER, PARAMETER :: ind_O2 = 144 
  INTEGER, PARAMETER :: ind_RCOOH = 145 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_CH4 = 1 
  INTEGER, PARAMETER :: indf_EMISSION = 2 
  INTEGER, PARAMETER :: indf_EOH = 3 
  INTEGER, PARAMETER :: indf_H2 = 4 
  INTEGER, PARAMETER :: indf_H2O = 5 
  INTEGER, PARAMETER :: indf_MOH = 6 
  INTEGER, PARAMETER :: indf_O2 = 7 
  INTEGER, PARAMETER :: indf_RCOOH = 8 

! NJVRP - Length of sparse Jacobian JVRP
  INTEGER, PARAMETER :: NJVRP = 583 

! NSTOICM - Length of Sparse Stoichiometric Matrix
  INTEGER, PARAMETER :: NSTOICM = 1595 

END MODULE gckpp_Parameters

