! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Function of Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Function.f90
! Time                 : Tue Jul 24 13:27:00 2012
! Working directory    : /home/mpayer/KPP
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Function

  USE gckpp_Parameters
  IMPLICIT NONE

! A - Rate for each equation
  REAL(kind=dp) :: A(NREACT)

!$OMP THREADPRIVATE( A )

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun - time derivatives of variables - Agregate form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      Vdot      - Time derivative of variable species concentrations
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun ( V, F, RCT, Vdot )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! Vdot - Time derivative of variable species concentrations
  REAL(kind=dp) :: Vdot(NVAR)


! Computation of equation rates
  A(1) = RCT(1)*V(131)*V(134)
  A(2) = RCT(2)*V(134)*V(135)
  A(3) = RCT(3)*V(130)*V(134)
  A(4) = RCT(4)*V(132)*V(134)
  A(5) = RCT(5)*V(129)*V(134)
  A(6) = RCT(6)*V(135)*V(135)
  A(7) = RCT(7)*V(135)*V(135)
  A(8) = RCT(8)*V(130)*V(135)
  A(9) = RCT(9)*V(58)*V(135)
  A(10) = RCT(10)*V(130)*V(131)
  A(11) = RCT(11)*V(130)*V(130)
  A(12) = RCT(12)*V(135)*F(5)
  A(13) = RCT(13)*V(92)*V(135)
  A(14) = RCT(14)*V(135)*F(2)
  A(15) = RCT(15)*V(129)*V(131)
  A(16) = RCT(16)*V(129)*V(130)
  A(17) = RCT(17)*V(129)*V(129)
  A(18) = RCT(18)*V(129)*V(129)
  A(19) = RCT(19)*V(75)*V(135)
  A(20) = RCT(20)*V(75)*V(135)
  A(21) = RCT(21)*V(117)*V(135)
  A(22) = RCT(22)*V(132)*V(135)
  A(23) = RCT(23)*V(99)*V(135)
  A(24) = RCT(24)*V(131)*V(135)
  A(25) = RCT(25)*V(62)*V(135)
  A(26) = RCT(26)*V(130)*V(132)
  A(27) = RCT(27)*V(72)
  A(28) = RCT(28)*V(72)*V(135)
  A(29) = RCT(29)*V(130)*V(133)
  A(30) = RCT(30)*V(131)*V(133)
  A(31) = RCT(31)*V(133)*V(135)
  A(32) = RCT(32)*V(132)*V(133)
  A(33) = RCT(33)*V(63)
  A(34) = RCT(34)*V(135)*F(8)
  A(35) = RCT(35)*V(132)*V(133)
  A(36) = RCT(36)*V(117)*V(133)
  A(37) = RCT(37)*V(123)*V(135)
  A(38) = RCT(38)*V(123)*V(133)
  A(39) = RCT(39)*V(128)*V(132)
  A(40) = RCT(40)*V(61)
  A(41) = RCT(41)*V(128)*V(131)
  A(42) = RCT(42)*V(83)*V(135)
  A(43) = RCT(43)*V(126)*V(131)
  A(44) = RCT(44)*V(67)*V(135)
  A(45) = RCT(45)*V(67)*V(135)
  A(46) = RCT(46)*V(100)*V(131)
  A(47) = RCT(47)*V(111)*V(131)
  A(48) = RCT(48)*V(60)*V(135)
  A(49) = RCT(49)*V(119)*V(131)
  A(50) = RCT(50)*V(119)*V(131)
  A(51) = RCT(51)*V(101)*V(131)
  A(52) = RCT(52)*V(112)*V(131)
  A(53) = RCT(53)*V(115)*V(131)
  A(54) = RCT(54)*V(124)*V(131)
  A(55) = RCT(55)*V(104)*V(131)
  A(56) = RCT(56)*V(104)*V(131)
  A(57) = RCT(57)*V(113)*V(131)
  A(58) = RCT(58)*V(109)*V(131)
  A(59) = RCT(59)*V(106)*V(131)
  A(60) = RCT(60)*V(106)*V(131)
  A(61) = RCT(61)*V(102)*V(131)
  A(62) = RCT(62)*V(102)*V(131)
  A(63) = RCT(63)*V(98)*V(131)
  A(64) = RCT(64)*V(110)*V(131)
  A(65) = RCT(65)*V(108)*V(131)
  A(66) = RCT(66)*V(107)*V(131)
  A(67) = RCT(67)*V(60)*V(133)
  A(68) = RCT(68)*V(120)*V(135)
  A(69) = RCT(69)*V(116)*V(135)
  A(70) = RCT(70)*V(132)*V(136)
  A(71) = RCT(71)*V(57)
  A(72) = RCT(72)*V(121)*V(132)
  A(73) = RCT(73)*V(90)
  A(74) = RCT(74)*V(131)*V(136)
  A(75) = RCT(75)*V(114)*V(131)
  A(76) = RCT(76)*V(121)*V(131)
  A(77) = RCT(77)*V(116)*V(133)
  A(78) = RCT(78)*V(96)*V(135)
  A(79) = RCT(79)*V(96)*V(135)
  A(80) = RCT(80)*V(100)*V(129)
  A(81) = RCT(81)*V(111)*V(129)
  A(82) = RCT(82)*V(119)*V(130)
  A(83) = RCT(83)*V(101)*V(130)
  A(84) = RCT(84)*V(112)*V(130)
  A(85) = RCT(85)*V(115)*V(130)
  A(86) = RCT(86)*V(124)*V(130)
  A(87) = RCT(87)*V(104)*V(130)
  A(88) = RCT(88)*V(113)*V(130)
  A(89) = RCT(89)*V(109)*V(130)
  A(90) = RCT(90)*V(106)*V(130)
  A(91) = RCT(91)*V(102)*V(130)
  A(92) = RCT(92)*V(98)*V(130)
  A(93) = RCT(93)*V(110)*V(130)
  A(94) = RCT(94)*V(108)*V(130)
  A(95) = RCT(95)*V(107)*V(130)
  A(96) = RCT(96)*V(127)*V(135)
  A(97) = RCT(97)*V(126)*V(129)
  A(98) = RCT(98)*V(127)*V(133)
  A(99) = RCT(99)*V(119)*V(129)
  A(100) = RCT(100)*V(101)*V(129)
  A(101) = RCT(101)*V(112)*V(129)
  A(102) = RCT(102)*V(115)*V(129)
  A(103) = RCT(103)*V(124)*V(129)
  A(104) = RCT(104)*V(104)*V(129)
  A(105) = RCT(105)*V(113)*V(129)
  A(106) = RCT(106)*V(109)*V(129)
  A(107) = RCT(107)*V(106)*V(129)
  A(108) = RCT(108)*V(102)*V(129)
  A(109) = RCT(109)*V(98)*V(129)
  A(110) = RCT(110)*V(110)*V(129)
  A(111) = RCT(111)*V(108)*V(129)
  A(112) = RCT(112)*V(107)*V(129)
  A(113) = RCT(113)*V(95)*V(135)
  A(114) = RCT(114)*V(126)*V(126)
  A(115) = RCT(115)*V(126)*V(126)
  A(116) = RCT(116)*V(126)*V(130)
  A(117) = RCT(117)*V(100)*V(130)
  A(118) = RCT(118)*V(111)*V(130)
  A(119) = RCT(119)*V(128)*V(130)
  A(120) = RCT(120)*V(130)*V(136)
  A(121) = RCT(121)*V(114)*V(130)
  A(122) = RCT(122)*V(121)*V(130)
  A(123) = RCT(123)*V(93)*V(135)
  A(124) = RCT(124)*V(93)*V(134)
  A(125) = RCT(125)*V(90)*V(135)
  A(126) = RCT(126)*V(90)*V(134)
  A(127) = RCT(127)*V(94)*V(135)
  A(128) = RCT(128)*V(93)*V(133)
  A(129) = RCT(129)*V(69)*V(135)
  A(130) = RCT(130)*V(118)*V(135)
  A(131) = RCT(131)*V(69)*V(133)
  A(132) = RCT(132)*V(118)*V(133)
  A(133) = RCT(133)*V(91)*V(135)
  A(134) = RCT(134)*V(125)*V(135)
  A(135) = RCT(135)*V(122)*V(135)
  A(136) = RCT(136)*V(103)*V(135)
  A(137) = RCT(137)*V(100)*V(128)
  A(138) = RCT(138)*V(111)*V(128)
  A(139) = RCT(139)*V(100)*V(128)
  A(140) = RCT(140)*V(111)*V(128)
  A(141) = RCT(141)*V(91)*V(134)
  A(142) = RCT(142)*V(125)*V(134)
  A(143) = RCT(143)*V(122)*V(134)
  A(144) = RCT(144)*V(91)*V(133)
  A(145) = RCT(145)*V(122)*V(133)
  A(146) = RCT(146)*V(122)*V(133)
  A(147) = RCT(147)*V(129)*V(136)
  A(148) = RCT(148)*V(114)*V(129)
  A(149) = RCT(149)*V(121)*V(129)
  A(150) = RCT(150)*V(129)*V(136)
  A(151) = RCT(151)*V(114)*V(129)
  A(152) = RCT(152)*V(121)*V(129)
  A(153) = RCT(153)*V(82)*V(135)
  A(154) = RCT(154)*V(81)*V(135)
  A(155) = RCT(155)*V(68)*V(135)
  A(156) = RCT(156)*V(76)*V(135)
  A(157) = RCT(157)*V(64)*V(135)
  A(158) = RCT(158)*V(71)*V(135)
  A(159) = RCT(159)*V(65)*V(135)
  A(160) = RCT(160)*V(80)*V(135)
  A(161) = RCT(161)*V(70)*V(135)
  A(162) = RCT(162)*V(89)*V(135)
  A(163) = RCT(163)*V(87)*V(135)
  A(164) = RCT(164)*V(86)*V(135)
  A(165) = RCT(165)*V(88)*V(135)
  A(166) = RCT(166)*V(85)*V(135)
  A(167) = RCT(167)*V(73)*V(135)
  A(168) = RCT(168)*V(74)*V(135)
  A(169) = RCT(169)*V(83)*V(133)
  A(170) = RCT(170)*V(105)*V(135)
  A(171) = RCT(171)*V(105)*V(134)
  A(172) = RCT(172)*V(128)*V(128)
  A(173) = RCT(173)*V(128)*V(129)
  A(174) = RCT(174)*V(128)*V(129)
  A(175) = RCT(175)*V(119)*V(128)
  A(176) = RCT(176)*V(112)*V(128)
  A(177) = RCT(177)*V(115)*V(128)
  A(178) = RCT(178)*V(124)*V(128)
  A(179) = RCT(179)*V(104)*V(128)
  A(180) = RCT(180)*V(113)*V(128)
  A(181) = RCT(181)*V(109)*V(128)
  A(182) = RCT(182)*V(106)*V(128)
  A(183) = RCT(183)*V(102)*V(128)
  A(184) = RCT(184)*V(110)*V(128)
  A(185) = RCT(185)*V(101)*V(128)
  A(186) = RCT(186)*V(98)*V(128)
  A(187) = RCT(187)*V(108)*V(128)
  A(188) = RCT(188)*V(107)*V(128)
  A(189) = RCT(189)*V(119)*V(128)
  A(190) = RCT(190)*V(112)*V(128)
  A(191) = RCT(191)*V(115)*V(128)
  A(192) = RCT(192)*V(124)*V(128)
  A(193) = RCT(193)*V(104)*V(128)
  A(194) = RCT(194)*V(113)*V(128)
  A(195) = RCT(195)*V(106)*V(128)
  A(196) = RCT(196)*V(102)*V(128)
  A(197) = RCT(197)*V(101)*V(128)
  A(198) = RCT(198)*V(109)*V(128)
  A(199) = RCT(199)*V(98)*V(128)
  A(200) = RCT(200)*V(108)*V(128)
  A(201) = RCT(201)*V(107)*V(128)
  A(202) = RCT(202)*V(110)*V(128)
  A(203) = RCT(203)*V(126)*V(128)
  A(204) = RCT(204)*V(126)*V(128)
  A(205) = RCT(205)*V(128)*V(136)
  A(206) = RCT(206)*V(114)*V(128)
  A(207) = RCT(207)*V(121)*V(128)
  A(208) = RCT(208)*V(133)*V(133)
  A(209) = RCT(209)*F(3)
  A(210) = RCT(210)*F(3)
  A(211) = RCT(211)*F(3)
  A(212) = RCT(212)*F(3)
  A(213) = RCT(213)*F(3)
  A(214) = RCT(214)*F(3)
  A(215) = RCT(215)*F(3)
  A(216) = RCT(216)*F(3)
  A(217) = RCT(217)*F(3)
  A(218) = RCT(218)*F(3)
  A(219) = RCT(219)*F(3)
  A(220) = RCT(220)*F(3)
  A(221) = RCT(221)*F(3)
  A(222) = RCT(222)*F(3)
  A(223) = RCT(223)*F(3)
  A(224) = RCT(224)*F(3)
  A(225) = RCT(225)*F(3)
  A(226) = RCT(226)*V(132)
  A(227) = RCT(227)*V(134)
  A(228) = RCT(228)*V(61)
  A(229) = RCT(229)*V(99)
  A(230) = RCT(230)*V(117)
  A(231) = RCT(231)*V(63)
  A(232) = RCT(232)*V(58)
  A(233) = RCT(233)*V(90)
  A(234) = RCT(234)*V(57)
  A(235) = RCT(235)*V(120)
  A(236) = RCT(236)*V(125)
  A(237) = RCT(237)*V(122)
  A(238) = RCT(238)*V(130)
  A(239) = RCT(239)*V(132)
  A(240) = RCT(240)*V(133)
  A(241) = RCT(241)*V(63)
  A(242) = RCT(242)*V(66)*V(135)
  A(243) = RCT(243)*V(66)*V(135)
  A(244) = RCT(244)*V(66)*V(133)
  A(245) = RCT(245)*V(59)*V(135)
  A(246) = RCT(246)*V(134)*V(137)
  A(247) = RCT(247)*V(97)*V(130)
  A(248) = RCT(248)*V(130)*V(137)
  A(249) = RCT(249)*V(79)*V(135)
  A(250) = RCT(250)*V(97)*V(97)
  A(251) = RCT(251)*V(97)*V(97)
  A(252) = RCT(252)*V(97)*V(131)
  A(253) = RCT(253)*V(84)*V(137)
  A(254) = RCT(254)*V(78)*V(135)
  A(255) = RCT(255)*V(97)*V(135)
  A(256) = RCT(256)*V(133)*V(137)
  A(257) = RCT(257)*V(117)*V(137)
  A(258) = RCT(258)*V(123)*V(137)
  A(259) = RCT(259)*V(96)*V(137)
  A(260) = RCT(260)*V(83)*V(137)
  A(261) = RCT(261)*V(67)*V(137)
  A(262) = RCT(262)*V(132)*V(137)
  A(263) = RCT(263)*V(97)*V(132)
  A(264) = RCT(264)*V(53)*V(135)
  A(265) = RCT(265)*V(54)*V(135)
  A(266) = RCT(266)*V(55)*V(135)
  A(267) = RCT(267)*V(84)
  A(268) = RCT(268)*V(77)
  A(269) = RCT(269)*V(79)
  A(270) = RCT(270)*V(77)
  A(271) = RCT(271)*V(79)
  A(272) = RCT(272)*V(77)
  A(273) = RCT(273)*V(79)
  A(274) = RCT(274)*V(84)
  A(275) = RCT(275)*V(78)
  A(276) = RCT(276)*V(134)
  A(277) = RCT(277)*V(132)
  A(278) = RCT(278)*V(58)
  A(279) = RCT(279)*V(75)
  A(280) = RCT(280)*V(117)
  A(281) = RCT(281)*V(117)
  A(282) = RCT(282)*V(99)
  A(283) = RCT(283)*V(62)
  A(284) = RCT(284)*V(72)
  A(285) = RCT(285)*V(133)
  A(286) = RCT(286)*V(133)
  A(287) = RCT(287)*V(63)
  A(288) = RCT(288)*V(63)
  A(289) = RCT(289)*V(72)
  A(290) = RCT(290)*V(123)
  A(291) = RCT(291)*V(123)
  A(292) = RCT(292)*V(61)
  A(293) = RCT(293)*V(116)
  A(294) = RCT(294)*V(96)
  A(295) = RCT(295)*V(96)
  A(296) = RCT(296)*V(127)
  A(297) = RCT(297)*V(94)
  A(298) = RCT(298)*V(69)
  A(299) = RCT(299)*V(69)
  A(300) = RCT(300)*V(118)
  A(301) = RCT(301)*V(118)
  A(302) = RCT(302)*V(125)
  A(303) = RCT(303)*V(125)
  A(304) = RCT(304)*V(125)
  A(305) = RCT(305)*V(122)
  A(306) = RCT(306)*V(122)
  A(307) = RCT(307)*V(103)
  A(308) = RCT(308)*V(82)
  A(309) = RCT(309)*V(81)
  A(310) = RCT(310)*V(68)
  A(311) = RCT(311)*V(76)
  A(312) = RCT(312)*V(64)
  A(313) = RCT(313)*V(71)
  A(314) = RCT(314)*V(80)
  A(315) = RCT(315)*V(65)
  A(316) = RCT(316)*V(70)
  A(317) = RCT(317)*V(89)
  A(318) = RCT(318)*V(87)
  A(319) = RCT(319)*V(86)
  A(320) = RCT(320)*V(88)
  A(321) = RCT(321)*V(85)
  A(322) = RCT(322)*V(73)
  A(323) = RCT(323)*V(120)
  A(324) = RCT(324)*V(74)
  A(325) = RCT(325)*V(78)
  A(326) = RCT(326)*V(97)
  A(327) = RCT(327)*V(77)
  A(328) = RCT(328)*V(84)
  A(329) = RCT(329)*V(84)
  A(330) = RCT(330)*V(56)
  A(331) = RCT(331)*V(53)

! Aggregate function
  Vdot(1) = A(230)
  Vdot(2) = A(232)
  Vdot(3) = A(229)
  Vdot(4) = A(231)
  Vdot(5) = A(226)
  Vdot(6) = A(227)
  Vdot(7) = A(228)
  Vdot(8) = A(233)
  Vdot(9) = A(234)
  Vdot(10) = A(235)
  Vdot(11) = A(236)
  Vdot(12) = A(237)
  Vdot(13) = A(245)
  Vdot(14) = 0.25*A(243)
  Vdot(15) = A(272)
  Vdot(16) = A(273)
  Vdot(17) = A(274)
  Vdot(18) = A(275)
  Vdot(19) = A(246)
  Vdot(20) = A(247)
  Vdot(21) = A(248)
  Vdot(22) = A(249)
  Vdot(23) = A(250)
  Vdot(24) = A(251)
  Vdot(25) = A(252)
  Vdot(26) = A(253)
  Vdot(27) = A(254)
  Vdot(28) = A(255)
  Vdot(29) = A(256)
  Vdot(30) = A(257)
  Vdot(31) = A(258)
  Vdot(32) = A(259)
  Vdot(33) = A(260)
  Vdot(34) = A(261)
  Vdot(35) = A(262)
  Vdot(36) = A(263)
  Vdot(37) = A(264)
  Vdot(38) = A(267)
  Vdot(39) = A(268)
  Vdot(40) = A(269)
  Vdot(41) = A(325)
  Vdot(42) = A(326)
  Vdot(43) = A(327)
  Vdot(44) = A(328)
  Vdot(45) = A(329)
  Vdot(46) = A(330)
  Vdot(47) = A(331)
  Vdot(48) = A(270)
  Vdot(49) = A(271)
  Vdot(50) = A(13)+A(41)+0.15*A(141)+0.16*A(143)
  Vdot(51) = A(226)+A(227)+A(228)+A(229)+A(230)+A(231)+A(232)+A(233)+A(234)+A(235)+A(236)+A(237)+A(272)+A(273)+A(274)&
               &+A(275)
  Vdot(52) = A(133)
  Vdot(53) = A(223)-A(264)-A(331)
  Vdot(54) = A(224)-A(265)
  Vdot(55) = -A(266)
  Vdot(56) = A(262)-A(330)
  Vdot(57) = A(70)-A(71)-A(234)
  Vdot(58) = A(7)-A(9)+A(11)-A(232)+0.5*A(238)-A(278)
  Vdot(59) = A(242)+0.75*A(243)+A(244)-A(245)
  Vdot(60) = -A(48)-A(67)+A(212)
  Vdot(61) = A(39)-A(40)-A(228)-A(292)
  Vdot(62) = A(24)-A(25)+0.5*A(239)-A(283)
  Vdot(63) = A(32)-A(33)-A(231)-A(241)-A(287)-A(288)
  Vdot(64) = A(93)-A(157)-A(312)
  Vdot(65) = 0.7*A(120)-A(159)-A(315)
  Vdot(66) = -A(242)-A(243)-A(244)
  Vdot(67) = -A(44)-A(45)+A(216)-A(261)
  Vdot(68) = A(116)-A(155)-A(310)
  Vdot(69) = -A(129)-A(131)-A(298)-A(299)
  Vdot(70) = 0.71*A(121)-A(161)-A(316)
  Vdot(71) = A(82)-A(158)-A(313)
  Vdot(72) = A(26)-A(27)-A(28)-A(284)-A(289)
  Vdot(73) = 0.7*A(122)-A(167)-A(322)
  Vdot(74) = 0.41*A(119)-A(168)-A(324)
  Vdot(75) = A(16)-A(19)-A(20)-A(279)
  Vdot(76) = A(117)-A(156)-A(311)
  Vdot(77) = A(247)+A(254)+A(267)-A(268)-A(270)-A(272)-A(327)
  Vdot(78) = A(225)+A(251)+A(253)-A(254)+0.5*A(268)+0.5*A(269)+0.5*A(270)+0.5*A(271)-A(275)-A(325)
  Vdot(79) = A(248)-A(249)+A(257)+A(258)+A(259)+A(260)+A(261)-A(269)-A(271)-A(273)
  Vdot(80) = A(118)-A(160)-A(314)
  Vdot(81) = A(95)-A(154)-A(309)
  Vdot(82) = A(94)-A(153)-A(308)
  Vdot(83) = -A(42)-A(169)+A(217)-A(260)
  Vdot(84) = -A(253)+A(263)-A(267)-A(274)-A(328)-A(329)
  Vdot(85) = A(91)-A(166)-A(321)
  Vdot(86) = A(89)+A(92)-A(164)-A(319)
  Vdot(87) = A(88)-A(163)-A(318)
  Vdot(88) = A(90)-A(165)-A(320)
  Vdot(89) = A(86)+A(87)-A(162)-A(317)
  Vdot(90) = A(72)-A(73)-A(125)-A(126)-A(233)
  Vdot(91) = -A(133)-A(141)-A(144)+A(213)
  Vdot(92) = -A(13)+A(21)+A(36)+0.05*A(37)+0.61*A(57)+0.33*A(105)+0.15*A(108)+0.42*A(124)+0.4*A(127)+2*A(129)+A(130)+2&
               &*A(131)+A(132)+0.05*A(141)+0.05*A(142)+0.2*A(143)+0.4*A(171)+0.65*A(180)+0.83*A(183)+A(211)+A(257)+A(258)&
               &+A(259)+A(260)+A(261)+A(280)+A(281)+A(290)+A(291)+A(293)+A(295)+A(297)+1.5*A(298)+2*A(299)+A(300)+A(301)&
               &+A(302)+A(303)+A(306)+0.67*A(318)+0.5*A(321)
  Vdot(93) = -A(123)-A(124)-A(128)+0.07*A(141)+A(215)+A(302)
  Vdot(94) = 0.24*A(57)+0.95*A(58)+0.72*A(59)+0.13*A(105)+0.5*A(106)+0.36*A(107)-A(127)+0.28*A(171)+0.26*A(180)+A(181)&
               &+0.72*A(182)-A(297)+0.26*A(318)+0.7*A(320)
  Vdot(95) = 0.25*A(80)+0.25*A(81)+0.25*A(99)+0.25*A(100)+0.25*A(102)+0.25*A(103)+0.25*A(104)+0.25*A(105)+0.25*A(106)&
               &+0.25*A(107)+0.25*A(109)+0.25*A(110)+0.25*A(111)+0.25*A(112)-A(113)
  Vdot(96) = 0.32*A(49)+A(64)-A(78)-A(79)+0.16*A(99)+0.75*A(110)+0.5*A(157)+0.32*A(175)+A(184)+A(202)+A(214)-A(259)&
               &-A(294)-A(295)+A(312)+0.32*A(323)
  Vdot(97) = A(246)-A(247)-2*A(250)-2*A(251)-A(252)-A(255)+A(256)-A(263)-A(326)+A(329)
  Vdot(98) = -A(63)-A(92)-A(109)+A(145)-A(186)-A(199)
  Vdot(99) = A(22)-A(23)+A(36)+A(38)+A(56)+0.08*A(57)+0.05*A(58)+A(60)+A(62)+0.85*A(65)+A(67)+A(77)+A(98)+0.425*A(111)&
               &+A(131)+A(132)+A(146)+A(169)+0.85*A(187)+A(222)-A(229)+0.5*A(239)+A(240)+2*A(241)+A(244)+A(267)-A(282)
  Vdot(100) = A(45)-A(46)+0.05*A(49)-A(80)+0.03*A(99)-A(117)-A(137)-A(139)+0.5*A(156)+0.05*A(175)+A(261)+0.05*A(323)
  Vdot(101) = -A(51)+A(68)-A(83)-A(100)-A(185)-A(197)
  Vdot(102) = -A(61)-A(62)-A(91)-A(108)+0.43*A(135)+A(166)-A(183)-A(196)
  Vdot(103) = 0.33*A(57)+0.95*A(58)+A(61)+0.16*A(81)+0.2*A(101)+0.18*A(105)+0.5*A(106)+A(108)+0.59*A(125)-A(136)+0.65&
                &*A(140)+0.2*A(171)+0.36*A(180)+A(181)+0.83*A(183)-A(307)+0.36*A(318)+A(321)
  Vdot(104) = -A(55)-A(56)-A(87)+0.07*A(103)-A(104)+0.136*A(178)-A(179)-A(193)
  Vdot(105) = 0.34*A(54)+A(55)+0.06*A(103)+0.5*A(104)+0.509*A(162)-A(170)-A(171)+0.127*A(178)+A(179)+0.373*A(317)
  Vdot(106) = -A(59)-A(60)-A(90)-A(107)+A(134)+0.5*A(165)-A(182)-A(195)
  Vdot(107) = -A(66)-A(95)-A(112)+A(128)+A(154)-A(188)-A(201)
  Vdot(108) = -A(65)-A(94)-A(111)+A(144)+A(153)-A(187)-A(200)
  Vdot(109) = -A(58)-A(89)-A(106)+0.5*A(164)-A(181)-A(198)
  Vdot(110) = A(44)+0.18*A(49)-A(64)-A(93)+0.09*A(99)-A(110)+0.5*A(157)+0.18*A(175)-A(184)-A(202)+0.18*A(323)
  Vdot(111) = -A(47)-A(81)-A(118)+A(123)-A(138)-A(140)+A(160)
  Vdot(112) = -A(52)+A(78)+A(79)-A(84)-A(101)-A(176)-A(190)+A(259)
  Vdot(113) = -A(57)-A(88)-A(105)+A(163)+0.44*A(170)-A(180)-A(194)
  Vdot(114) = -A(75)-A(121)+0.8*A(127)-A(148)-A(151)+A(161)-A(206)
  Vdot(115) = -A(53)-A(85)+A(96)+A(98)-A(102)-A(177)-A(191)
  Vdot(116) = A(46)+0.13*A(49)+0.57*A(51)-A(69)-A(77)+0.75*A(80)+0.09*A(81)+0.07*A(99)+0.54*A(100)+0.25*A(106)+0.25&
                &*A(109)+0.25*A(111)+0.25*A(112)+A(113)+A(137)+A(139)+0.35*A(140)+0.5*A(156)+0.5*A(158)+0.5*A(164)+0.5&
                &*A(165)+0.13*A(175)+0.57*A(185)+A(197)+A(198)+A(199)+A(200)+A(201)-A(293)+A(308)+A(309)+A(311)+A(313)&
                &+A(319)+0.13*A(323)
  Vdot(117) = A(5)+A(15)+A(17)+2*A(18)+A(20)-A(21)+A(34)-A(36)+0.05*A(37)+A(47)+0.39*A(51)+0.96*A(52)+0.56*A(54)+0.75&
                &*A(55)+0.35*A(57)+0.28*A(59)+A(61)+A(63)+0.15*A(65)+A(66)+A(75)+A(76)+0.75*A(80)+1.25*A(81)+0.75*A(97)+0.75&
                &*A(99)+0.95*A(100)+0.5*A(101)+0.75*A(102)+1.1*A(103)+1.13*A(104)+0.95*A(105)+0.75*A(106)+0.89*A(107)+0.85&
                &*A(108)+1.25*A(109)+0.75*A(110)+0.83*A(111)+1.25*A(112)+0.29*A(121)+0.535*A(124)+2.23*A(125)+0.6*A(126)&
                &+A(138)+0.9*A(141)+0.8*A(142)+0.7*A(143)+A(147)+2*A(148)+2*A(149)+A(150)+A(151)+A(152)+0.5*A(168)+0.12&
                &*A(171)+A(173)+A(174)+0.2*A(176)+0.69*A(178)+0.75*A(179)+0.4*A(180)+0.28*A(182)+0.17*A(183)+0.39*A(185)&
                &+A(186)+0.15*A(187)+A(188)+A(206)+A(207)+A(220)-A(230)+A(242)+A(244)-A(257)+A(279)-A(280)-A(281)+A(297)+0.5&
                &*A(298)+A(303)+A(306)+A(307)+A(314)+A(316)+0.627*A(317)+0.3*A(320)+0.5*A(321)+A(322)
  Vdot(118) = 0.53*A(57)+0.28*A(59)+A(63)+A(85)+0.5*A(101)+0.29*A(105)+0.14*A(107)+0.5*A(109)-A(130)-A(132)+A(136)+0.82&
                &*A(142)+0.8*A(143)+0.6*A(171)+0.8*A(176)+0.58*A(180)+0.28*A(182)+0.17*A(183)+A(186)-A(300)-A(301)+0.58&
                &*A(318)+0.3*A(320)
  Vdot(119) = A(48)-A(49)-A(50)+0.3*A(51)+A(67)-A(82)-A(99)+0.15*A(100)+0.5*A(158)-A(175)+0.3*A(185)-A(189)
  Vdot(120) = A(50)+0.04*A(52)+0.07*A(53)-A(68)+A(83)-A(235)-A(323)
  Vdot(121) = -A(72)+A(73)-A(76)-A(122)+0.57*A(135)+A(146)-A(149)-A(152)+A(167)+0.41*A(170)-A(207)+A(304)+A(305)
  Vdot(122) = 0.22*A(54)+0.1*A(65)+0.14*A(103)+0.05*A(111)-A(135)+0.387*A(141)-A(143)-A(145)-A(146)+0.288*A(178)+0.1&
                &*A(187)-A(237)-A(305)-A(306)+0.259*A(317)
  Vdot(123) = -A(37)-A(38)+A(43)+A(47)+0.32*A(49)+0.75*A(51)+0.93*A(53)+A(66)+0.5*A(81)+0.75*A(97)+0.16*A(99)+0.38&
                &*A(100)+0.5*A(102)+0.5*A(112)+2*A(114)+A(115)+0.5*A(124)+A(138)+0.04*A(142)+0.5*A(155)+0.5*A(159)+0.32&
                &*A(175)+A(177)+0.75*A(185)+A(188)+A(203)+A(204)+A(219)-A(258)-A(290)-A(291)+A(301)+A(310)+A(314)+A(315)&
                &+0.32*A(323)
  Vdot(124) = -A(54)-A(86)-A(103)+A(133)+0.491*A(162)-A(178)-A(192)
  Vdot(125) = 0.34*A(54)+0.05*A(65)+0.2*A(103)+0.03*A(111)-A(134)+0.159*A(141)-A(142)+0.402*A(178)+0.05*A(187)-A(236)&
                &-A(302)-A(303)-A(304)+0.368*A(317)
  Vdot(126) = A(42)-A(43)+0.32*A(49)+A(74)-A(97)+0.16*A(99)-2*A(114)-2*A(115)-A(116)+A(147)+0.5*A(155)+A(169)+0.32&
                &*A(175)-A(203)-A(204)+A(205)+A(260)+A(293)+0.85*A(296)+0.32*A(323)
  Vdot(127) = 0.19*A(49)-A(96)-A(98)+0.35*A(99)+0.25*A(102)+0.25*A(103)+0.25*A(104)+0.25*A(105)+0.25*A(107)+0.19*A(175)&
                &+A(189)+A(190)+A(191)+A(192)+A(193)+A(194)+A(195)+A(196)+A(218)-A(296)+0.19*A(323)
  Vdot(128) = 0.95*A(37)+A(38)-A(39)+A(40)-A(41)+0.96*A(52)+0.93*A(53)+0.72*A(59)+A(76)+A(84)+0.3*A(101)+0.5*A(102)+0.36&
                &*A(107)-A(119)+A(130)+A(132)-A(137)-A(138)-A(139)-A(140)+A(149)+0.5*A(168)-2*A(172)-A(173)-A(174)-A(175)&
                &-0.8*A(176)-A(178)-A(179)-A(180)-A(181)-0.28*A(182)-A(183)-A(184)-A(185)-A(186)-A(187)-A(188)-A(189)-A(190)&
                &-A(191)-A(192)-A(193)-A(194)-A(195)-A(196)-A(197)-A(198)-A(199)-A(200)-A(201)-A(202)-A(203)-A(204)-A(205)&
                &-A(206)+A(258)+0.6*A(292)+A(294)+0.85*A(296)+A(300)+A(303)+A(306)+A(307)+0.7*A(320)+A(322)
  Vdot(129) = -A(5)+A(14)-A(15)-A(16)-2*A(17)-2*A(18)+A(19)+A(41)+0.18*A(49)-A(80)-A(81)+A(84)+A(85)-A(97)-0.91*A(99)&
                &-A(100)-A(101)-A(102)-A(103)-A(104)-A(105)-A(106)-A(107)-A(108)-A(109)-A(110)-A(111)-A(112)+0.44*A(119)&
                &+0.305*A(124)+A(137)+A(138)-A(147)-A(148)-A(149)-A(150)-A(151)-A(152)+2*A(172)-A(174)+1.18*A(175)+A(176)&
                &+A(177)+A(178)+A(179)+A(180)+A(181)+A(182)+A(183)+A(184)+A(185)+A(186)+A(187)+A(188)+A(203)+A(205)+A(206)&
                &+A(207)+A(242)+A(243)+A(244)+A(290)+0.4*A(292)+A(294)+2*A(295)+0.15*A(296)+A(304)+0.18*A(323)+A(324)
  Vdot(130) = A(2)-A(3)+A(5)-A(8)+A(9)-A(10)-2*A(11)+A(12)+A(13)+A(15)-A(16)+2*A(18)+A(21)-A(26)+A(27)-A(29)+A(31)+A(34)&
                &+A(36)+0.05*A(37)+A(43)+A(46)+A(47)+0.27*A(49)+0.9*A(54)+A(55)+0.92*A(57)+0.05*A(58)+0.28*A(59)+A(61)+A(64)&
                &+0.8*A(65)+A(75)+A(80)+A(81)-A(82)-A(83)-A(84)-A(85)-A(86)-A(87)-A(88)-A(89)-A(90)-A(91)-A(92)-A(93)-A(94)&
                &-A(95)+A(97)+0.64*A(99)+0.5*A(100)+0.3*A(101)+0.5*A(102)+0.92*A(103)+A(104)+A(105)+0.5*A(106)+0.64*A(107)&
                &+1.15*A(108)+0.5*A(109)+A(110)+0.45*A(111)+0.5*A(112)+A(113)+2*A(114)-A(116)-A(117)-A(118)-A(119)-A(120)&
                &-A(121)-A(122)+0.3*A(124)+2*A(125)+A(126)+0.2*A(127)+A(129)+A(131)+A(136)+A(137)+A(138)+0.06*A(141)+0.06&
                &*A(142)+0.275*A(143)+A(147)+2*A(148)+A(149)+0.15*A(170)+A(173)+0.27*A(175)+0.8*A(176)+0.864*A(178)+A(179)&
                &+A(180)+0.28*A(182)+A(183)+A(184)+0.8*A(187)+A(203)+A(206)-A(238)+A(245)-A(247)-A(248)+A(255)+A(257)+A(279)&
                &+2*A(280)+A(289)+A(290)+A(293)+2*A(297)+2*A(299)+A(300)+A(303)+A(305)+A(306)+A(307)+A(308)+A(309)+A(310)&
                &+A(311)+A(312)+A(313)+A(314)+A(315)+A(316)+A(317)+A(318)+A(319)+0.3*A(320)+A(321)+0.27*A(323)
  Vdot(131) = -A(1)-A(10)-A(15)-A(24)-A(30)+A(35)-A(41)-A(43)-A(46)-A(47)-A(49)-A(50)-A(51)-A(52)-A(53)-A(54)-A(55)&
                &-A(56)-A(57)-A(58)-A(59)-A(60)-A(61)-A(62)-A(63)-A(64)-A(65)-A(66)-A(74)-A(75)-A(76)+A(209)-A(252)+A(277)&
                &+A(283)+A(286)+A(288)
  Vdot(132) = A(1)-A(4)+A(10)+A(15)-A(22)+A(25)-A(26)+A(27)+A(28)+A(29)+2*A(30)+A(31)-A(32)+A(33)-A(39)+A(40)+A(41)&
                &+A(43)+A(46)+A(47)+A(49)+2*A(51)+0.96*A(52)+0.93*A(53)+0.9*A(54)+A(55)+0.92*A(57)+1.95*A(58)+A(59)+A(61)+2&
                &*A(63)+A(64)+1.15*A(65)+2*A(66)-A(70)+A(71)-A(72)+A(73)+A(74)+A(75)+A(76)+A(100)+A(106)+A(109)+0.575*A(111)&
                &+A(112)+A(125)+A(126)+0.5*A(164)+A(181)+A(185)+A(186)+0.15*A(187)+A(188)+A(197)+A(198)+A(199)+A(200)+A(201)&
                &+2*A(208)+A(210)-A(226)-A(239)+A(252)+A(256)-A(262)-A(263)-A(277)+A(282)+A(285)+A(287)+A(289)+0.6*A(292)&
                &+A(308)+A(309)+A(319)+A(323)+A(329)+A(330)
  Vdot(133) = A(4)+A(23)-A(29)-A(30)-A(31)-A(32)+A(33)-A(35)-A(36)-A(38)-A(67)-A(77)-A(98)-A(128)-A(131)-A(132)-A(144)&
                &-A(145)-A(146)-A(169)-2*A(208)-A(240)-A(244)+A(253)-A(256)+A(284)-A(285)-A(286)+A(287)+A(288)+0.4*A(292)&
                &+A(328)
  Vdot(134) = -A(1)-A(2)-A(3)-A(4)-A(5)+A(6)+0.15*A(119)+0.3*A(120)+0.29*A(121)+0.3*A(122)-A(124)-A(126)-0.9*A(141)-0.8&
                &*A(142)-0.8*A(143)-0.7*A(171)+A(221)-A(227)-A(246)-A(276)+A(277)+A(285)+A(288)+A(326)
  Vdot(135) = -A(2)+A(3)-2*A(6)-2*A(7)-A(8)-A(9)+A(10)-A(12)-A(13)-A(14)-A(19)-A(21)-A(22)-A(23)-A(24)-A(25)-A(28)+A(29)&
                &-A(31)-A(34)-A(37)-A(42)-A(44)-A(45)-A(48)-A(68)-A(69)-A(78)-A(79)-A(96)-A(113)+0.44*A(119)-A(123)+0.135&
                &*A(124)-A(125)-A(127)-A(129)-A(130)-A(133)-A(134)-A(135)-A(136)+0.27*A(141)+0.08*A(142)+0.215*A(143)-A(153)&
                &-A(154)-0.5*A(155)-0.5*A(156)-0.5*A(157)-0.5*A(158)-0.5*A(159)-A(160)-A(161)-0.491*A(162)-A(163)-0.5*A(164)&
                &-0.5*A(165)-A(166)-A(167)-0.5*A(168)-A(170)+0.1*A(171)-A(242)-A(243)-A(245)-A(249)-A(254)-A(255)-A(264)&
                &-A(265)-A(266)+2*A(276)+2*A(278)+A(279)+A(282)+A(283)+A(284)+A(308)+A(309)+A(310)+A(311)+A(312)+A(313)&
                &+A(314)+A(315)+A(316)+A(317)+A(318)+A(319)+A(320)+A(321)+A(322)+A(324)+A(327)
  Vdot(136) = A(69)-A(70)+A(71)-A(74)+A(77)-A(120)-A(147)-A(150)+0.5*A(159)-A(205)+0.15*A(296)
  Vdot(137) = -A(246)-A(248)+A(249)+2*A(250)+A(252)-A(253)+A(254)+A(255)-A(256)-A(257)-A(258)-A(259)-A(260)-A(261)&
                &-A(262)+3*A(264)+2*A(265)+A(266)+2*A(325)+A(326)+A(327)+A(328)+A(330)+3*A(331)
      
END SUBROUTINE Fun

! End of Fun function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE gckpp_Function

