! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Parameters.f90
! Time                 : Tue Jul 24 13:27:00 2012
! Working directory    : /home/mpayer/KPP
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Parameters

  USE gckpp_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 147 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 137 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 85 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 10 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 331 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 138 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 1100 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 1273 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 138 
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
  INTEGER, PARAMETER :: CNEQN = 332 
! NHESS - Length of Sparse Hessian
  INTEGER, PARAMETER :: NHESS = 944 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 147 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_DRYCH2O = 1 
  INTEGER, PARAMETER :: ind_DRYH2O2 = 2 
  INTEGER, PARAMETER :: ind_DRYHNO3 = 3 
  INTEGER, PARAMETER :: ind_DRYN2O5 = 4 
  INTEGER, PARAMETER :: ind_DRYNO2 = 5 
  INTEGER, PARAMETER :: ind_DRYO3 = 6 
  INTEGER, PARAMETER :: ind_DRYPAN = 7 
  INTEGER, PARAMETER :: ind_DRYPMN = 8 
  INTEGER, PARAMETER :: ind_DRYPPN = 9 
  INTEGER, PARAMETER :: ind_DRYR4N2 = 10 
  INTEGER, PARAMETER :: ind_DRYMVK = 11 
  INTEGER, PARAMETER :: ind_DRYMACR = 12 
  INTEGER, PARAMETER :: ind_SO4 = 13 
  INTEGER, PARAMETER :: ind_MSA = 14 
  INTEGER, PARAMETER :: ind_DRYHOBr = 15 
  INTEGER, PARAMETER :: ind_DRYHBr = 16 
  INTEGER, PARAMETER :: ind_DRYBrNO3 = 17 
  INTEGER, PARAMETER :: ind_DRYBr2 = 18 
  INTEGER, PARAMETER :: ind_LR1 = 19 
  INTEGER, PARAMETER :: ind_LR2 = 20 
  INTEGER, PARAMETER :: ind_LR3 = 21 
  INTEGER, PARAMETER :: ind_LR4 = 22 
  INTEGER, PARAMETER :: ind_LR5 = 23 
  INTEGER, PARAMETER :: ind_LR6 = 24 
  INTEGER, PARAMETER :: ind_LR7 = 25 
  INTEGER, PARAMETER :: ind_LR8 = 26 
  INTEGER, PARAMETER :: ind_LR9 = 27 
  INTEGER, PARAMETER :: ind_LR10 = 28 
  INTEGER, PARAMETER :: ind_LR11 = 29 
  INTEGER, PARAMETER :: ind_LR12 = 30 
  INTEGER, PARAMETER :: ind_LR13 = 31 
  INTEGER, PARAMETER :: ind_LR14 = 32 
  INTEGER, PARAMETER :: ind_LR15 = 33 
  INTEGER, PARAMETER :: ind_LR16 = 34 
  INTEGER, PARAMETER :: ind_LR17 = 35 
  INTEGER, PARAMETER :: ind_LR18 = 36 
  INTEGER, PARAMETER :: ind_LR19 = 37 
  INTEGER, PARAMETER :: ind_LR20 = 38 
  INTEGER, PARAMETER :: ind_LR21 = 39 
  INTEGER, PARAMETER :: ind_LR22 = 40 
  INTEGER, PARAMETER :: ind_LR23 = 41 
  INTEGER, PARAMETER :: ind_LR24 = 42 
  INTEGER, PARAMETER :: ind_LR25 = 43 
  INTEGER, PARAMETER :: ind_LR26 = 44 
  INTEGER, PARAMETER :: ind_LR27 = 45 
  INTEGER, PARAMETER :: ind_LR28 = 46 
  INTEGER, PARAMETER :: ind_LR29 = 47 
  INTEGER, PARAMETER :: ind_LR30 = 48 
  INTEGER, PARAMETER :: ind_LR31 = 49 
  INTEGER, PARAMETER :: ind_CO2 = 50 
  INTEGER, PARAMETER :: ind_DRYDEP = 51 
  INTEGER, PARAMETER :: ind_LISOPOH = 52 
  INTEGER, PARAMETER :: ind_CHBr3 = 53 
  INTEGER, PARAMETER :: ind_CH2Br2 = 54 
  INTEGER, PARAMETER :: ind_CH3Br = 55 
  INTEGER, PARAMETER :: ind_BrNO2 = 56 
  INTEGER, PARAMETER :: ind_PPN = 57 
  INTEGER, PARAMETER :: ind_H2O2 = 58 
  INTEGER, PARAMETER :: ind_SO2 = 59 
  INTEGER, PARAMETER :: ind_ALK4 = 60 
  INTEGER, PARAMETER :: ind_PAN = 61 
  INTEGER, PARAMETER :: ind_HNO2 = 62 
  INTEGER, PARAMETER :: ind_N2O5 = 63 
  INTEGER, PARAMETER :: ind_RB3P = 64 
  INTEGER, PARAMETER :: ind_RP = 65 
  INTEGER, PARAMETER :: ind_DMS = 66 
  INTEGER, PARAMETER :: ind_C3H8 = 67 
  INTEGER, PARAMETER :: ind_ETP = 68 
  INTEGER, PARAMETER :: ind_GLYX = 69 
  INTEGER, PARAMETER :: ind_GP = 70 
  INTEGER, PARAMETER :: ind_R4P = 71 
  INTEGER, PARAMETER :: ind_HNO4 = 72 
  INTEGER, PARAMETER :: ind_MAOP = 73 
  INTEGER, PARAMETER :: ind_MAP = 74 
  INTEGER, PARAMETER :: ind_MP = 75 
  INTEGER, PARAMETER :: ind_RA3P = 76 
  INTEGER, PARAMETER :: ind_HOBr = 77 
  INTEGER, PARAMETER :: ind_Br2 = 78 
  INTEGER, PARAMETER :: ind_HBr = 79 
  INTEGER, PARAMETER :: ind_PP = 80 
  INTEGER, PARAMETER :: ind_PRPN = 81 
  INTEGER, PARAMETER :: ind_INPN = 82 
  INTEGER, PARAMETER :: ind_C2H6 = 83 
  INTEGER, PARAMETER :: ind_BrNO3 = 84 
  INTEGER, PARAMETER :: ind_MRP = 85 
  INTEGER, PARAMETER :: ind_ISNP = 86 
  INTEGER, PARAMETER :: ind_IAP = 87 
  INTEGER, PARAMETER :: ind_VRP = 88 
  INTEGER, PARAMETER :: ind_RIP = 89 
  INTEGER, PARAMETER :: ind_PMN = 90 
  INTEGER, PARAMETER :: ind_ISOP = 91 
  INTEGER, PARAMETER :: ind_CO = 92 
  INTEGER, PARAMETER :: ind_PRPE = 93 
  INTEGER, PARAMETER :: ind_GLYC = 94 
  INTEGER, PARAMETER :: ind_ROH = 95 
  INTEGER, PARAMETER :: ind_ACET = 96 
  INTEGER, PARAMETER :: ind_BrO = 97 
  INTEGER, PARAMETER :: ind_MAN2 = 98 
  INTEGER, PARAMETER :: ind_HNO3 = 99 
  INTEGER, PARAMETER :: ind_A3O2 = 100 
  INTEGER, PARAMETER :: ind_R4N1 = 101 
  INTEGER, PARAMETER :: ind_MRO2 = 102 
  INTEGER, PARAMETER :: ind_HAC = 103 
  INTEGER, PARAMETER :: ind_RIO1 = 104 
  INTEGER, PARAMETER :: ind_IALD = 105 
  INTEGER, PARAMETER :: ind_VRO2 = 106 
  INTEGER, PARAMETER :: ind_PRN1 = 107 
  INTEGER, PARAMETER :: ind_INO2 = 108 
  INTEGER, PARAMETER :: ind_ISN1 = 109 
  INTEGER, PARAMETER :: ind_B3O2 = 110 
  INTEGER, PARAMETER :: ind_PO2 = 111 
  INTEGER, PARAMETER :: ind_ATO2 = 112 
  INTEGER, PARAMETER :: ind_IAO2 = 113 
  INTEGER, PARAMETER :: ind_GCO3 = 114 
  INTEGER, PARAMETER :: ind_KO2 = 115 
  INTEGER, PARAMETER :: ind_RCHO = 116 
  INTEGER, PARAMETER :: ind_CH2O = 117 
  INTEGER, PARAMETER :: ind_MGLY = 118 
  INTEGER, PARAMETER :: ind_R4O2 = 119 
  INTEGER, PARAMETER :: ind_R4N2 = 120 
  INTEGER, PARAMETER :: ind_MAO3 = 121 
  INTEGER, PARAMETER :: ind_MACR = 122 
  INTEGER, PARAMETER :: ind_ALD2 = 123 
  INTEGER, PARAMETER :: ind_RIO2 = 124 
  INTEGER, PARAMETER :: ind_MVK = 125 
  INTEGER, PARAMETER :: ind_ETO2 = 126 
  INTEGER, PARAMETER :: ind_MEK = 127 
  INTEGER, PARAMETER :: ind_MCO3 = 128 
  INTEGER, PARAMETER :: ind_MO2 = 129 
  INTEGER, PARAMETER :: ind_HO2 = 130 
  INTEGER, PARAMETER :: ind_NO = 131 
  INTEGER, PARAMETER :: ind_NO2 = 132 
  INTEGER, PARAMETER :: ind_NO3 = 133 
  INTEGER, PARAMETER :: ind_O3 = 134 
  INTEGER, PARAMETER :: ind_OH = 135 
  INTEGER, PARAMETER :: ind_RCO3 = 136 
  INTEGER, PARAMETER :: ind_Br = 137 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_ACTA = 138 
  INTEGER, PARAMETER :: ind_CH4 = 139 
  INTEGER, PARAMETER :: ind_EMISSION = 140 
  INTEGER, PARAMETER :: ind_EOH = 141 
  INTEGER, PARAMETER :: ind_H2 = 142 
  INTEGER, PARAMETER :: ind_H2O = 143 
  INTEGER, PARAMETER :: ind_HCOOH = 144 
  INTEGER, PARAMETER :: ind_MOH = 145 
  INTEGER, PARAMETER :: ind_O2 = 146 
  INTEGER, PARAMETER :: ind_RCOOH = 147 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_ACTA = 1 
  INTEGER, PARAMETER :: indf_CH4 = 2 
  INTEGER, PARAMETER :: indf_EMISSION = 3 
  INTEGER, PARAMETER :: indf_EOH = 4 
  INTEGER, PARAMETER :: indf_H2 = 5 
  INTEGER, PARAMETER :: indf_H2O = 6 
  INTEGER, PARAMETER :: indf_HCOOH = 7 
  INTEGER, PARAMETER :: indf_MOH = 8 
  INTEGER, PARAMETER :: indf_O2 = 9 
  INTEGER, PARAMETER :: indf_RCOOH = 10 

! NJVRP - Length of sparse Jacobian JVRP
  INTEGER, PARAMETER :: NJVRP = 528 

! NSTOICM - Length of Sparse Stoichiometric Matrix
  INTEGER, PARAMETER :: NSTOICM = 1358 

END MODULE gckpp_Parameters

