! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The Stoichiometric Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : gckpp_Stoichiom.f90
! Time                 : Tue Jul 24 13:27:00 2012
! Working directory    : /home/mpayer/KPP
! Equation file        : gckpp.kpp
! Output root filename : gckpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE gckpp_Stoichiom

  USE gckpp_Parameters
  USE gckpp_StoichiomSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! ReactantProd - Reactant Products in each equation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      ARP       - Reactant product in each equation
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE ReactantProd ( V, F, ARP )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! ARP - Reactant product in each equation
  REAL(kind=dp) :: ARP(NREACT)


! Reactant Products in each equation are useful in the
!     stoichiometric formulation of mass action law
  ARP(1) = V(131)*V(134)
  ARP(2) = V(134)*V(135)
  ARP(3) = V(130)*V(134)
  ARP(4) = V(132)*V(134)
  ARP(5) = V(129)*V(134)
  ARP(6) = V(135)*V(135)
  ARP(7) = V(135)*V(135)
  ARP(8) = V(130)*V(135)
  ARP(9) = V(58)*V(135)
  ARP(10) = V(130)*V(131)
  ARP(11) = V(130)*V(130)
  ARP(12) = V(135)*F(5)
  ARP(13) = V(92)*V(135)
  ARP(14) = V(135)*F(2)
  ARP(15) = V(129)*V(131)
  ARP(16) = V(129)*V(130)
  ARP(17) = V(129)*V(129)
  ARP(18) = V(129)*V(129)
  ARP(19) = V(75)*V(135)
  ARP(20) = V(75)*V(135)
  ARP(21) = V(117)*V(135)
  ARP(22) = V(132)*V(135)
  ARP(23) = V(99)*V(135)
  ARP(24) = V(131)*V(135)
  ARP(25) = V(62)*V(135)
  ARP(26) = V(130)*V(132)
  ARP(27) = V(72)
  ARP(28) = V(72)*V(135)
  ARP(29) = V(130)*V(133)
  ARP(30) = V(131)*V(133)
  ARP(31) = V(133)*V(135)
  ARP(32) = V(132)*V(133)
  ARP(33) = V(63)
  ARP(34) = V(135)*F(8)
  ARP(35) = V(132)*V(133)
  ARP(36) = V(117)*V(133)
  ARP(37) = V(123)*V(135)
  ARP(38) = V(123)*V(133)
  ARP(39) = V(128)*V(132)
  ARP(40) = V(61)
  ARP(41) = V(128)*V(131)
  ARP(42) = V(83)*V(135)
  ARP(43) = V(126)*V(131)
  ARP(44) = V(67)*V(135)
  ARP(45) = V(67)*V(135)
  ARP(46) = V(100)*V(131)
  ARP(47) = V(111)*V(131)
  ARP(48) = V(60)*V(135)
  ARP(49) = V(119)*V(131)
  ARP(50) = V(119)*V(131)
  ARP(51) = V(101)*V(131)
  ARP(52) = V(112)*V(131)
  ARP(53) = V(115)*V(131)
  ARP(54) = V(124)*V(131)
  ARP(55) = V(104)*V(131)
  ARP(56) = V(104)*V(131)
  ARP(57) = V(113)*V(131)
  ARP(58) = V(109)*V(131)
  ARP(59) = V(106)*V(131)
  ARP(60) = V(106)*V(131)
  ARP(61) = V(102)*V(131)
  ARP(62) = V(102)*V(131)
  ARP(63) = V(98)*V(131)
  ARP(64) = V(110)*V(131)
  ARP(65) = V(108)*V(131)
  ARP(66) = V(107)*V(131)
  ARP(67) = V(60)*V(133)
  ARP(68) = V(120)*V(135)
  ARP(69) = V(116)*V(135)
  ARP(70) = V(132)*V(136)
  ARP(71) = V(57)
  ARP(72) = V(121)*V(132)
  ARP(73) = V(90)
  ARP(74) = V(131)*V(136)
  ARP(75) = V(114)*V(131)
  ARP(76) = V(121)*V(131)
  ARP(77) = V(116)*V(133)
  ARP(78) = V(96)*V(135)
  ARP(79) = V(96)*V(135)
  ARP(80) = V(100)*V(129)
  ARP(81) = V(111)*V(129)
  ARP(82) = V(119)*V(130)
  ARP(83) = V(101)*V(130)
  ARP(84) = V(112)*V(130)
  ARP(85) = V(115)*V(130)
  ARP(86) = V(124)*V(130)
  ARP(87) = V(104)*V(130)
  ARP(88) = V(113)*V(130)
  ARP(89) = V(109)*V(130)
  ARP(90) = V(106)*V(130)
  ARP(91) = V(102)*V(130)
  ARP(92) = V(98)*V(130)
  ARP(93) = V(110)*V(130)
  ARP(94) = V(108)*V(130)
  ARP(95) = V(107)*V(130)
  ARP(96) = V(127)*V(135)
  ARP(97) = V(126)*V(129)
  ARP(98) = V(127)*V(133)
  ARP(99) = V(119)*V(129)
  ARP(100) = V(101)*V(129)
  ARP(101) = V(112)*V(129)
  ARP(102) = V(115)*V(129)
  ARP(103) = V(124)*V(129)
  ARP(104) = V(104)*V(129)
  ARP(105) = V(113)*V(129)
  ARP(106) = V(109)*V(129)
  ARP(107) = V(106)*V(129)
  ARP(108) = V(102)*V(129)
  ARP(109) = V(98)*V(129)
  ARP(110) = V(110)*V(129)
  ARP(111) = V(108)*V(129)
  ARP(112) = V(107)*V(129)
  ARP(113) = V(95)*V(135)
  ARP(114) = V(126)*V(126)
  ARP(115) = V(126)*V(126)
  ARP(116) = V(126)*V(130)
  ARP(117) = V(100)*V(130)
  ARP(118) = V(111)*V(130)
  ARP(119) = V(128)*V(130)
  ARP(120) = V(130)*V(136)
  ARP(121) = V(114)*V(130)
  ARP(122) = V(121)*V(130)
  ARP(123) = V(93)*V(135)
  ARP(124) = V(93)*V(134)
  ARP(125) = V(90)*V(135)
  ARP(126) = V(90)*V(134)
  ARP(127) = V(94)*V(135)
  ARP(128) = V(93)*V(133)
  ARP(129) = V(69)*V(135)
  ARP(130) = V(118)*V(135)
  ARP(131) = V(69)*V(133)
  ARP(132) = V(118)*V(133)
  ARP(133) = V(91)*V(135)
  ARP(134) = V(125)*V(135)
  ARP(135) = V(122)*V(135)
  ARP(136) = V(103)*V(135)
  ARP(137) = V(100)*V(128)
  ARP(138) = V(111)*V(128)
  ARP(139) = V(100)*V(128)
  ARP(140) = V(111)*V(128)
  ARP(141) = V(91)*V(134)
  ARP(142) = V(125)*V(134)
  ARP(143) = V(122)*V(134)
  ARP(144) = V(91)*V(133)
  ARP(145) = V(122)*V(133)
  ARP(146) = V(122)*V(133)
  ARP(147) = V(129)*V(136)
  ARP(148) = V(114)*V(129)
  ARP(149) = V(121)*V(129)
  ARP(150) = V(129)*V(136)
  ARP(151) = V(114)*V(129)
  ARP(152) = V(121)*V(129)
  ARP(153) = V(82)*V(135)
  ARP(154) = V(81)*V(135)
  ARP(155) = V(68)*V(135)
  ARP(156) = V(76)*V(135)
  ARP(157) = V(64)*V(135)
  ARP(158) = V(71)*V(135)
  ARP(159) = V(65)*V(135)
  ARP(160) = V(80)*V(135)
  ARP(161) = V(70)*V(135)
  ARP(162) = V(89)*V(135)
  ARP(163) = V(87)*V(135)
  ARP(164) = V(86)*V(135)
  ARP(165) = V(88)*V(135)
  ARP(166) = V(85)*V(135)
  ARP(167) = V(73)*V(135)
  ARP(168) = V(74)*V(135)
  ARP(169) = V(83)*V(133)
  ARP(170) = V(105)*V(135)
  ARP(171) = V(105)*V(134)
  ARP(172) = V(128)*V(128)
  ARP(173) = V(128)*V(129)
  ARP(174) = V(128)*V(129)
  ARP(175) = V(119)*V(128)
  ARP(176) = V(112)*V(128)
  ARP(177) = V(115)*V(128)
  ARP(178) = V(124)*V(128)
  ARP(179) = V(104)*V(128)
  ARP(180) = V(113)*V(128)
  ARP(181) = V(109)*V(128)
  ARP(182) = V(106)*V(128)
  ARP(183) = V(102)*V(128)
  ARP(184) = V(110)*V(128)
  ARP(185) = V(101)*V(128)
  ARP(186) = V(98)*V(128)
  ARP(187) = V(108)*V(128)
  ARP(188) = V(107)*V(128)
  ARP(189) = V(119)*V(128)
  ARP(190) = V(112)*V(128)
  ARP(191) = V(115)*V(128)
  ARP(192) = V(124)*V(128)
  ARP(193) = V(104)*V(128)
  ARP(194) = V(113)*V(128)
  ARP(195) = V(106)*V(128)
  ARP(196) = V(102)*V(128)
  ARP(197) = V(101)*V(128)
  ARP(198) = V(109)*V(128)
  ARP(199) = V(98)*V(128)
  ARP(200) = V(108)*V(128)
  ARP(201) = V(107)*V(128)
  ARP(202) = V(110)*V(128)
  ARP(203) = V(126)*V(128)
  ARP(204) = V(126)*V(128)
  ARP(205) = V(128)*V(136)
  ARP(206) = V(114)*V(128)
  ARP(207) = V(121)*V(128)
  ARP(208) = V(133)*V(133)
  ARP(209) = F(3)
  ARP(210) = F(3)
  ARP(211) = F(3)
  ARP(212) = F(3)
  ARP(213) = F(3)
  ARP(214) = F(3)
  ARP(215) = F(3)
  ARP(216) = F(3)
  ARP(217) = F(3)
  ARP(218) = F(3)
  ARP(219) = F(3)
  ARP(220) = F(3)
  ARP(221) = F(3)
  ARP(222) = F(3)
  ARP(223) = F(3)
  ARP(224) = F(3)
  ARP(225) = F(3)
  ARP(226) = V(132)
  ARP(227) = V(134)
  ARP(228) = V(61)
  ARP(229) = V(99)
  ARP(230) = V(117)
  ARP(231) = V(63)
  ARP(232) = V(58)
  ARP(233) = V(90)
  ARP(234) = V(57)
  ARP(235) = V(120)
  ARP(236) = V(125)
  ARP(237) = V(122)
  ARP(238) = V(130)
  ARP(239) = V(132)
  ARP(240) = V(133)
  ARP(241) = V(63)
  ARP(242) = V(66)*V(135)
  ARP(243) = V(66)*V(135)
  ARP(244) = V(66)*V(133)
  ARP(245) = V(59)*V(135)
  ARP(246) = V(134)*V(137)
  ARP(247) = V(97)*V(130)
  ARP(248) = V(130)*V(137)
  ARP(249) = V(79)*V(135)
  ARP(250) = V(97)*V(97)
  ARP(251) = V(97)*V(97)
  ARP(252) = V(97)*V(131)
  ARP(253) = V(84)*V(137)
  ARP(254) = V(78)*V(135)
  ARP(255) = V(97)*V(135)
  ARP(256) = V(133)*V(137)
  ARP(257) = V(117)*V(137)
  ARP(258) = V(123)*V(137)
  ARP(259) = V(96)*V(137)
  ARP(260) = V(83)*V(137)
  ARP(261) = V(67)*V(137)
  ARP(262) = V(132)*V(137)
  ARP(263) = V(97)*V(132)
  ARP(264) = V(53)*V(135)
  ARP(265) = V(54)*V(135)
  ARP(266) = V(55)*V(135)
  ARP(267) = V(84)
  ARP(268) = V(77)
  ARP(269) = V(79)
  ARP(270) = V(77)
  ARP(271) = V(79)
  ARP(272) = V(77)
  ARP(273) = V(79)
  ARP(274) = V(84)
  ARP(275) = V(78)
  ARP(276) = V(134)
  ARP(277) = V(132)
  ARP(278) = V(58)
  ARP(279) = V(75)
  ARP(280) = V(117)
  ARP(281) = V(117)
  ARP(282) = V(99)
  ARP(283) = V(62)
  ARP(284) = V(72)
  ARP(285) = V(133)
  ARP(286) = V(133)
  ARP(287) = V(63)
  ARP(288) = V(63)
  ARP(289) = V(72)
  ARP(290) = V(123)
  ARP(291) = V(123)
  ARP(292) = V(61)
  ARP(293) = V(116)
  ARP(294) = V(96)
  ARP(295) = V(96)
  ARP(296) = V(127)
  ARP(297) = V(94)
  ARP(298) = V(69)
  ARP(299) = V(69)
  ARP(300) = V(118)
  ARP(301) = V(118)
  ARP(302) = V(125)
  ARP(303) = V(125)
  ARP(304) = V(125)
  ARP(305) = V(122)
  ARP(306) = V(122)
  ARP(307) = V(103)
  ARP(308) = V(82)
  ARP(309) = V(81)
  ARP(310) = V(68)
  ARP(311) = V(76)
  ARP(312) = V(64)
  ARP(313) = V(71)
  ARP(314) = V(80)
  ARP(315) = V(65)
  ARP(316) = V(70)
  ARP(317) = V(89)
  ARP(318) = V(87)
  ARP(319) = V(86)
  ARP(320) = V(88)
  ARP(321) = V(85)
  ARP(322) = V(73)
  ARP(323) = V(120)
  ARP(324) = V(74)
  ARP(325) = V(78)
  ARP(326) = V(97)
  ARP(327) = V(77)
  ARP(328) = V(84)
  ARP(329) = V(84)
  ARP(330) = V(56)
  ARP(331) = V(53)
      
END SUBROUTINE ReactantProd

! End of ReactantProd function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacReactantProd - Jacobian of Reactant Products vector
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      JVRP      - d ARP(1:NREACT)/d VAR (1:NVAR)
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacReactantProd ( V, F, JVRP )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! JVRP - d ARP(1:NREACT)/d VAR (1:NVAR)
  REAL(kind=dp) :: JVRP(NJVRP)


! Reactant Products in each equation are useful in the
!    stoichiometric formulation of mass action law
! Below we compute the Jacobian of the Reactant Products vector
!    w.r.t. variable species: d ARP(1:NREACT) / d Var(1:NVAR)

! JVRP(1) = dARP(1)/dV(131)
  JVRP(1) = V(134)
! JVRP(2) = dARP(1)/dV(134)
  JVRP(2) = V(131)
! JVRP(3) = dARP(2)/dV(134)
  JVRP(3) = V(135)
! JVRP(4) = dARP(2)/dV(135)
  JVRP(4) = V(134)
! JVRP(5) = dARP(3)/dV(130)
  JVRP(5) = V(134)
! JVRP(6) = dARP(3)/dV(134)
  JVRP(6) = V(130)
! JVRP(7) = dARP(4)/dV(132)
  JVRP(7) = V(134)
! JVRP(8) = dARP(4)/dV(134)
  JVRP(8) = V(132)
! JVRP(9) = dARP(5)/dV(129)
  JVRP(9) = V(134)
! JVRP(10) = dARP(5)/dV(134)
  JVRP(10) = V(129)
! JVRP(11) = dARP(6)/dV(135)
  JVRP(11) = 2*V(135)
! JVRP(12) = dARP(7)/dV(135)
  JVRP(12) = 2*V(135)
! JVRP(13) = dARP(8)/dV(130)
  JVRP(13) = V(135)
! JVRP(14) = dARP(8)/dV(135)
  JVRP(14) = V(130)
! JVRP(15) = dARP(9)/dV(58)
  JVRP(15) = V(135)
! JVRP(16) = dARP(9)/dV(135)
  JVRP(16) = V(58)
! JVRP(17) = dARP(10)/dV(130)
  JVRP(17) = V(131)
! JVRP(18) = dARP(10)/dV(131)
  JVRP(18) = V(130)
! JVRP(19) = dARP(11)/dV(130)
  JVRP(19) = 2*V(130)
! JVRP(20) = dARP(12)/dV(135)
  JVRP(20) = F(5)
! JVRP(21) = dARP(13)/dV(92)
  JVRP(21) = V(135)
! JVRP(22) = dARP(13)/dV(135)
  JVRP(22) = V(92)
! JVRP(23) = dARP(14)/dV(135)
  JVRP(23) = F(2)
! JVRP(24) = dARP(15)/dV(129)
  JVRP(24) = V(131)
! JVRP(25) = dARP(15)/dV(131)
  JVRP(25) = V(129)
! JVRP(26) = dARP(16)/dV(129)
  JVRP(26) = V(130)
! JVRP(27) = dARP(16)/dV(130)
  JVRP(27) = V(129)
! JVRP(28) = dARP(17)/dV(129)
  JVRP(28) = 2*V(129)
! JVRP(29) = dARP(18)/dV(129)
  JVRP(29) = 2*V(129)
! JVRP(30) = dARP(19)/dV(75)
  JVRP(30) = V(135)
! JVRP(31) = dARP(19)/dV(135)
  JVRP(31) = V(75)
! JVRP(32) = dARP(20)/dV(75)
  JVRP(32) = V(135)
! JVRP(33) = dARP(20)/dV(135)
  JVRP(33) = V(75)
! JVRP(34) = dARP(21)/dV(117)
  JVRP(34) = V(135)
! JVRP(35) = dARP(21)/dV(135)
  JVRP(35) = V(117)
! JVRP(36) = dARP(22)/dV(132)
  JVRP(36) = V(135)
! JVRP(37) = dARP(22)/dV(135)
  JVRP(37) = V(132)
! JVRP(38) = dARP(23)/dV(99)
  JVRP(38) = V(135)
! JVRP(39) = dARP(23)/dV(135)
  JVRP(39) = V(99)
! JVRP(40) = dARP(24)/dV(131)
  JVRP(40) = V(135)
! JVRP(41) = dARP(24)/dV(135)
  JVRP(41) = V(131)
! JVRP(42) = dARP(25)/dV(62)
  JVRP(42) = V(135)
! JVRP(43) = dARP(25)/dV(135)
  JVRP(43) = V(62)
! JVRP(44) = dARP(26)/dV(130)
  JVRP(44) = V(132)
! JVRP(45) = dARP(26)/dV(132)
  JVRP(45) = V(130)
! JVRP(46) = dARP(27)/dV(72)
  JVRP(46) = 1
! JVRP(47) = dARP(28)/dV(72)
  JVRP(47) = V(135)
! JVRP(48) = dARP(28)/dV(135)
  JVRP(48) = V(72)
! JVRP(49) = dARP(29)/dV(130)
  JVRP(49) = V(133)
! JVRP(50) = dARP(29)/dV(133)
  JVRP(50) = V(130)
! JVRP(51) = dARP(30)/dV(131)
  JVRP(51) = V(133)
! JVRP(52) = dARP(30)/dV(133)
  JVRP(52) = V(131)
! JVRP(53) = dARP(31)/dV(133)
  JVRP(53) = V(135)
! JVRP(54) = dARP(31)/dV(135)
  JVRP(54) = V(133)
! JVRP(55) = dARP(32)/dV(132)
  JVRP(55) = V(133)
! JVRP(56) = dARP(32)/dV(133)
  JVRP(56) = V(132)
! JVRP(57) = dARP(33)/dV(63)
  JVRP(57) = 1
! JVRP(58) = dARP(34)/dV(135)
  JVRP(58) = F(8)
! JVRP(59) = dARP(35)/dV(132)
  JVRP(59) = V(133)
! JVRP(60) = dARP(35)/dV(133)
  JVRP(60) = V(132)
! JVRP(61) = dARP(36)/dV(117)
  JVRP(61) = V(133)
! JVRP(62) = dARP(36)/dV(133)
  JVRP(62) = V(117)
! JVRP(63) = dARP(37)/dV(123)
  JVRP(63) = V(135)
! JVRP(64) = dARP(37)/dV(135)
  JVRP(64) = V(123)
! JVRP(65) = dARP(38)/dV(123)
  JVRP(65) = V(133)
! JVRP(66) = dARP(38)/dV(133)
  JVRP(66) = V(123)
! JVRP(67) = dARP(39)/dV(128)
  JVRP(67) = V(132)
! JVRP(68) = dARP(39)/dV(132)
  JVRP(68) = V(128)
! JVRP(69) = dARP(40)/dV(61)
  JVRP(69) = 1
! JVRP(70) = dARP(41)/dV(128)
  JVRP(70) = V(131)
! JVRP(71) = dARP(41)/dV(131)
  JVRP(71) = V(128)
! JVRP(72) = dARP(42)/dV(83)
  JVRP(72) = V(135)
! JVRP(73) = dARP(42)/dV(135)
  JVRP(73) = V(83)
! JVRP(74) = dARP(43)/dV(126)
  JVRP(74) = V(131)
! JVRP(75) = dARP(43)/dV(131)
  JVRP(75) = V(126)
! JVRP(76) = dARP(44)/dV(67)
  JVRP(76) = V(135)
! JVRP(77) = dARP(44)/dV(135)
  JVRP(77) = V(67)
! JVRP(78) = dARP(45)/dV(67)
  JVRP(78) = V(135)
! JVRP(79) = dARP(45)/dV(135)
  JVRP(79) = V(67)
! JVRP(80) = dARP(46)/dV(100)
  JVRP(80) = V(131)
! JVRP(81) = dARP(46)/dV(131)
  JVRP(81) = V(100)
! JVRP(82) = dARP(47)/dV(111)
  JVRP(82) = V(131)
! JVRP(83) = dARP(47)/dV(131)
  JVRP(83) = V(111)
! JVRP(84) = dARP(48)/dV(60)
  JVRP(84) = V(135)
! JVRP(85) = dARP(48)/dV(135)
  JVRP(85) = V(60)
! JVRP(86) = dARP(49)/dV(119)
  JVRP(86) = V(131)
! JVRP(87) = dARP(49)/dV(131)
  JVRP(87) = V(119)
! JVRP(88) = dARP(50)/dV(119)
  JVRP(88) = V(131)
! JVRP(89) = dARP(50)/dV(131)
  JVRP(89) = V(119)
! JVRP(90) = dARP(51)/dV(101)
  JVRP(90) = V(131)
! JVRP(91) = dARP(51)/dV(131)
  JVRP(91) = V(101)
! JVRP(92) = dARP(52)/dV(112)
  JVRP(92) = V(131)
! JVRP(93) = dARP(52)/dV(131)
  JVRP(93) = V(112)
! JVRP(94) = dARP(53)/dV(115)
  JVRP(94) = V(131)
! JVRP(95) = dARP(53)/dV(131)
  JVRP(95) = V(115)
! JVRP(96) = dARP(54)/dV(124)
  JVRP(96) = V(131)
! JVRP(97) = dARP(54)/dV(131)
  JVRP(97) = V(124)
! JVRP(98) = dARP(55)/dV(104)
  JVRP(98) = V(131)
! JVRP(99) = dARP(55)/dV(131)
  JVRP(99) = V(104)
! JVRP(100) = dARP(56)/dV(104)
  JVRP(100) = V(131)
! JVRP(101) = dARP(56)/dV(131)
  JVRP(101) = V(104)
! JVRP(102) = dARP(57)/dV(113)
  JVRP(102) = V(131)
! JVRP(103) = dARP(57)/dV(131)
  JVRP(103) = V(113)
! JVRP(104) = dARP(58)/dV(109)
  JVRP(104) = V(131)
! JVRP(105) = dARP(58)/dV(131)
  JVRP(105) = V(109)
! JVRP(106) = dARP(59)/dV(106)
  JVRP(106) = V(131)
! JVRP(107) = dARP(59)/dV(131)
  JVRP(107) = V(106)
! JVRP(108) = dARP(60)/dV(106)
  JVRP(108) = V(131)
! JVRP(109) = dARP(60)/dV(131)
  JVRP(109) = V(106)
! JVRP(110) = dARP(61)/dV(102)
  JVRP(110) = V(131)
! JVRP(111) = dARP(61)/dV(131)
  JVRP(111) = V(102)
! JVRP(112) = dARP(62)/dV(102)
  JVRP(112) = V(131)
! JVRP(113) = dARP(62)/dV(131)
  JVRP(113) = V(102)
! JVRP(114) = dARP(63)/dV(98)
  JVRP(114) = V(131)
! JVRP(115) = dARP(63)/dV(131)
  JVRP(115) = V(98)
! JVRP(116) = dARP(64)/dV(110)
  JVRP(116) = V(131)
! JVRP(117) = dARP(64)/dV(131)
  JVRP(117) = V(110)
! JVRP(118) = dARP(65)/dV(108)
  JVRP(118) = V(131)
! JVRP(119) = dARP(65)/dV(131)
  JVRP(119) = V(108)
! JVRP(120) = dARP(66)/dV(107)
  JVRP(120) = V(131)
! JVRP(121) = dARP(66)/dV(131)
  JVRP(121) = V(107)
! JVRP(122) = dARP(67)/dV(60)
  JVRP(122) = V(133)
! JVRP(123) = dARP(67)/dV(133)
  JVRP(123) = V(60)
! JVRP(124) = dARP(68)/dV(120)
  JVRP(124) = V(135)
! JVRP(125) = dARP(68)/dV(135)
  JVRP(125) = V(120)
! JVRP(126) = dARP(69)/dV(116)
  JVRP(126) = V(135)
! JVRP(127) = dARP(69)/dV(135)
  JVRP(127) = V(116)
! JVRP(128) = dARP(70)/dV(132)
  JVRP(128) = V(136)
! JVRP(129) = dARP(70)/dV(136)
  JVRP(129) = V(132)
! JVRP(130) = dARP(71)/dV(57)
  JVRP(130) = 1
! JVRP(131) = dARP(72)/dV(121)
  JVRP(131) = V(132)
! JVRP(132) = dARP(72)/dV(132)
  JVRP(132) = V(121)
! JVRP(133) = dARP(73)/dV(90)
  JVRP(133) = 1
! JVRP(134) = dARP(74)/dV(131)
  JVRP(134) = V(136)
! JVRP(135) = dARP(74)/dV(136)
  JVRP(135) = V(131)
! JVRP(136) = dARP(75)/dV(114)
  JVRP(136) = V(131)
! JVRP(137) = dARP(75)/dV(131)
  JVRP(137) = V(114)
! JVRP(138) = dARP(76)/dV(121)
  JVRP(138) = V(131)
! JVRP(139) = dARP(76)/dV(131)
  JVRP(139) = V(121)
! JVRP(140) = dARP(77)/dV(116)
  JVRP(140) = V(133)
! JVRP(141) = dARP(77)/dV(133)
  JVRP(141) = V(116)
! JVRP(142) = dARP(78)/dV(96)
  JVRP(142) = V(135)
! JVRP(143) = dARP(78)/dV(135)
  JVRP(143) = V(96)
! JVRP(144) = dARP(79)/dV(96)
  JVRP(144) = V(135)
! JVRP(145) = dARP(79)/dV(135)
  JVRP(145) = V(96)
! JVRP(146) = dARP(80)/dV(100)
  JVRP(146) = V(129)
! JVRP(147) = dARP(80)/dV(129)
  JVRP(147) = V(100)
! JVRP(148) = dARP(81)/dV(111)
  JVRP(148) = V(129)
! JVRP(149) = dARP(81)/dV(129)
  JVRP(149) = V(111)
! JVRP(150) = dARP(82)/dV(119)
  JVRP(150) = V(130)
! JVRP(151) = dARP(82)/dV(130)
  JVRP(151) = V(119)
! JVRP(152) = dARP(83)/dV(101)
  JVRP(152) = V(130)
! JVRP(153) = dARP(83)/dV(130)
  JVRP(153) = V(101)
! JVRP(154) = dARP(84)/dV(112)
  JVRP(154) = V(130)
! JVRP(155) = dARP(84)/dV(130)
  JVRP(155) = V(112)
! JVRP(156) = dARP(85)/dV(115)
  JVRP(156) = V(130)
! JVRP(157) = dARP(85)/dV(130)
  JVRP(157) = V(115)
! JVRP(158) = dARP(86)/dV(124)
  JVRP(158) = V(130)
! JVRP(159) = dARP(86)/dV(130)
  JVRP(159) = V(124)
! JVRP(160) = dARP(87)/dV(104)
  JVRP(160) = V(130)
! JVRP(161) = dARP(87)/dV(130)
  JVRP(161) = V(104)
! JVRP(162) = dARP(88)/dV(113)
  JVRP(162) = V(130)
! JVRP(163) = dARP(88)/dV(130)
  JVRP(163) = V(113)
! JVRP(164) = dARP(89)/dV(109)
  JVRP(164) = V(130)
! JVRP(165) = dARP(89)/dV(130)
  JVRP(165) = V(109)
! JVRP(166) = dARP(90)/dV(106)
  JVRP(166) = V(130)
! JVRP(167) = dARP(90)/dV(130)
  JVRP(167) = V(106)
! JVRP(168) = dARP(91)/dV(102)
  JVRP(168) = V(130)
! JVRP(169) = dARP(91)/dV(130)
  JVRP(169) = V(102)
! JVRP(170) = dARP(92)/dV(98)
  JVRP(170) = V(130)
! JVRP(171) = dARP(92)/dV(130)
  JVRP(171) = V(98)
! JVRP(172) = dARP(93)/dV(110)
  JVRP(172) = V(130)
! JVRP(173) = dARP(93)/dV(130)
  JVRP(173) = V(110)
! JVRP(174) = dARP(94)/dV(108)
  JVRP(174) = V(130)
! JVRP(175) = dARP(94)/dV(130)
  JVRP(175) = V(108)
! JVRP(176) = dARP(95)/dV(107)
  JVRP(176) = V(130)
! JVRP(177) = dARP(95)/dV(130)
  JVRP(177) = V(107)
! JVRP(178) = dARP(96)/dV(127)
  JVRP(178) = V(135)
! JVRP(179) = dARP(96)/dV(135)
  JVRP(179) = V(127)
! JVRP(180) = dARP(97)/dV(126)
  JVRP(180) = V(129)
! JVRP(181) = dARP(97)/dV(129)
  JVRP(181) = V(126)
! JVRP(182) = dARP(98)/dV(127)
  JVRP(182) = V(133)
! JVRP(183) = dARP(98)/dV(133)
  JVRP(183) = V(127)
! JVRP(184) = dARP(99)/dV(119)
  JVRP(184) = V(129)
! JVRP(185) = dARP(99)/dV(129)
  JVRP(185) = V(119)
! JVRP(186) = dARP(100)/dV(101)
  JVRP(186) = V(129)
! JVRP(187) = dARP(100)/dV(129)
  JVRP(187) = V(101)
! JVRP(188) = dARP(101)/dV(112)
  JVRP(188) = V(129)
! JVRP(189) = dARP(101)/dV(129)
  JVRP(189) = V(112)
! JVRP(190) = dARP(102)/dV(115)
  JVRP(190) = V(129)
! JVRP(191) = dARP(102)/dV(129)
  JVRP(191) = V(115)
! JVRP(192) = dARP(103)/dV(124)
  JVRP(192) = V(129)
! JVRP(193) = dARP(103)/dV(129)
  JVRP(193) = V(124)
! JVRP(194) = dARP(104)/dV(104)
  JVRP(194) = V(129)
! JVRP(195) = dARP(104)/dV(129)
  JVRP(195) = V(104)
! JVRP(196) = dARP(105)/dV(113)
  JVRP(196) = V(129)
! JVRP(197) = dARP(105)/dV(129)
  JVRP(197) = V(113)
! JVRP(198) = dARP(106)/dV(109)
  JVRP(198) = V(129)
! JVRP(199) = dARP(106)/dV(129)
  JVRP(199) = V(109)
! JVRP(200) = dARP(107)/dV(106)
  JVRP(200) = V(129)
! JVRP(201) = dARP(107)/dV(129)
  JVRP(201) = V(106)
! JVRP(202) = dARP(108)/dV(102)
  JVRP(202) = V(129)
! JVRP(203) = dARP(108)/dV(129)
  JVRP(203) = V(102)
! JVRP(204) = dARP(109)/dV(98)
  JVRP(204) = V(129)
! JVRP(205) = dARP(109)/dV(129)
  JVRP(205) = V(98)
! JVRP(206) = dARP(110)/dV(110)
  JVRP(206) = V(129)
! JVRP(207) = dARP(110)/dV(129)
  JVRP(207) = V(110)
! JVRP(208) = dARP(111)/dV(108)
  JVRP(208) = V(129)
! JVRP(209) = dARP(111)/dV(129)
  JVRP(209) = V(108)
! JVRP(210) = dARP(112)/dV(107)
  JVRP(210) = V(129)
! JVRP(211) = dARP(112)/dV(129)
  JVRP(211) = V(107)
! JVRP(212) = dARP(113)/dV(95)
  JVRP(212) = V(135)
! JVRP(213) = dARP(113)/dV(135)
  JVRP(213) = V(95)
! JVRP(214) = dARP(114)/dV(126)
  JVRP(214) = 2*V(126)
! JVRP(215) = dARP(115)/dV(126)
  JVRP(215) = 2*V(126)
! JVRP(216) = dARP(116)/dV(126)
  JVRP(216) = V(130)
! JVRP(217) = dARP(116)/dV(130)
  JVRP(217) = V(126)
! JVRP(218) = dARP(117)/dV(100)
  JVRP(218) = V(130)
! JVRP(219) = dARP(117)/dV(130)
  JVRP(219) = V(100)
! JVRP(220) = dARP(118)/dV(111)
  JVRP(220) = V(130)
! JVRP(221) = dARP(118)/dV(130)
  JVRP(221) = V(111)
! JVRP(222) = dARP(119)/dV(128)
  JVRP(222) = V(130)
! JVRP(223) = dARP(119)/dV(130)
  JVRP(223) = V(128)
! JVRP(224) = dARP(120)/dV(130)
  JVRP(224) = V(136)
! JVRP(225) = dARP(120)/dV(136)
  JVRP(225) = V(130)
! JVRP(226) = dARP(121)/dV(114)
  JVRP(226) = V(130)
! JVRP(227) = dARP(121)/dV(130)
  JVRP(227) = V(114)
! JVRP(228) = dARP(122)/dV(121)
  JVRP(228) = V(130)
! JVRP(229) = dARP(122)/dV(130)
  JVRP(229) = V(121)
! JVRP(230) = dARP(123)/dV(93)
  JVRP(230) = V(135)
! JVRP(231) = dARP(123)/dV(135)
  JVRP(231) = V(93)
! JVRP(232) = dARP(124)/dV(93)
  JVRP(232) = V(134)
! JVRP(233) = dARP(124)/dV(134)
  JVRP(233) = V(93)
! JVRP(234) = dARP(125)/dV(90)
  JVRP(234) = V(135)
! JVRP(235) = dARP(125)/dV(135)
  JVRP(235) = V(90)
! JVRP(236) = dARP(126)/dV(90)
  JVRP(236) = V(134)
! JVRP(237) = dARP(126)/dV(134)
  JVRP(237) = V(90)
! JVRP(238) = dARP(127)/dV(94)
  JVRP(238) = V(135)
! JVRP(239) = dARP(127)/dV(135)
  JVRP(239) = V(94)
! JVRP(240) = dARP(128)/dV(93)
  JVRP(240) = V(133)
! JVRP(241) = dARP(128)/dV(133)
  JVRP(241) = V(93)
! JVRP(242) = dARP(129)/dV(69)
  JVRP(242) = V(135)
! JVRP(243) = dARP(129)/dV(135)
  JVRP(243) = V(69)
! JVRP(244) = dARP(130)/dV(118)
  JVRP(244) = V(135)
! JVRP(245) = dARP(130)/dV(135)
  JVRP(245) = V(118)
! JVRP(246) = dARP(131)/dV(69)
  JVRP(246) = V(133)
! JVRP(247) = dARP(131)/dV(133)
  JVRP(247) = V(69)
! JVRP(248) = dARP(132)/dV(118)
  JVRP(248) = V(133)
! JVRP(249) = dARP(132)/dV(133)
  JVRP(249) = V(118)
! JVRP(250) = dARP(133)/dV(91)
  JVRP(250) = V(135)
! JVRP(251) = dARP(133)/dV(135)
  JVRP(251) = V(91)
! JVRP(252) = dARP(134)/dV(125)
  JVRP(252) = V(135)
! JVRP(253) = dARP(134)/dV(135)
  JVRP(253) = V(125)
! JVRP(254) = dARP(135)/dV(122)
  JVRP(254) = V(135)
! JVRP(255) = dARP(135)/dV(135)
  JVRP(255) = V(122)
! JVRP(256) = dARP(136)/dV(103)
  JVRP(256) = V(135)
! JVRP(257) = dARP(136)/dV(135)
  JVRP(257) = V(103)
! JVRP(258) = dARP(137)/dV(100)
  JVRP(258) = V(128)
! JVRP(259) = dARP(137)/dV(128)
  JVRP(259) = V(100)
! JVRP(260) = dARP(138)/dV(111)
  JVRP(260) = V(128)
! JVRP(261) = dARP(138)/dV(128)
  JVRP(261) = V(111)
! JVRP(262) = dARP(139)/dV(100)
  JVRP(262) = V(128)
! JVRP(263) = dARP(139)/dV(128)
  JVRP(263) = V(100)
! JVRP(264) = dARP(140)/dV(111)
  JVRP(264) = V(128)
! JVRP(265) = dARP(140)/dV(128)
  JVRP(265) = V(111)
! JVRP(266) = dARP(141)/dV(91)
  JVRP(266) = V(134)
! JVRP(267) = dARP(141)/dV(134)
  JVRP(267) = V(91)
! JVRP(268) = dARP(142)/dV(125)
  JVRP(268) = V(134)
! JVRP(269) = dARP(142)/dV(134)
  JVRP(269) = V(125)
! JVRP(270) = dARP(143)/dV(122)
  JVRP(270) = V(134)
! JVRP(271) = dARP(143)/dV(134)
  JVRP(271) = V(122)
! JVRP(272) = dARP(144)/dV(91)
  JVRP(272) = V(133)
! JVRP(273) = dARP(144)/dV(133)
  JVRP(273) = V(91)
! JVRP(274) = dARP(145)/dV(122)
  JVRP(274) = V(133)
! JVRP(275) = dARP(145)/dV(133)
  JVRP(275) = V(122)
! JVRP(276) = dARP(146)/dV(122)
  JVRP(276) = V(133)
! JVRP(277) = dARP(146)/dV(133)
  JVRP(277) = V(122)
! JVRP(278) = dARP(147)/dV(129)
  JVRP(278) = V(136)
! JVRP(279) = dARP(147)/dV(136)
  JVRP(279) = V(129)
! JVRP(280) = dARP(148)/dV(114)
  JVRP(280) = V(129)
! JVRP(281) = dARP(148)/dV(129)
  JVRP(281) = V(114)
! JVRP(282) = dARP(149)/dV(121)
  JVRP(282) = V(129)
! JVRP(283) = dARP(149)/dV(129)
  JVRP(283) = V(121)
! JVRP(284) = dARP(150)/dV(129)
  JVRP(284) = V(136)
! JVRP(285) = dARP(150)/dV(136)
  JVRP(285) = V(129)
! JVRP(286) = dARP(151)/dV(114)
  JVRP(286) = V(129)
! JVRP(287) = dARP(151)/dV(129)
  JVRP(287) = V(114)
! JVRP(288) = dARP(152)/dV(121)
  JVRP(288) = V(129)
! JVRP(289) = dARP(152)/dV(129)
  JVRP(289) = V(121)
! JVRP(290) = dARP(153)/dV(82)
  JVRP(290) = V(135)
! JVRP(291) = dARP(153)/dV(135)
  JVRP(291) = V(82)
! JVRP(292) = dARP(154)/dV(81)
  JVRP(292) = V(135)
! JVRP(293) = dARP(154)/dV(135)
  JVRP(293) = V(81)
! JVRP(294) = dARP(155)/dV(68)
  JVRP(294) = V(135)
! JVRP(295) = dARP(155)/dV(135)
  JVRP(295) = V(68)
! JVRP(296) = dARP(156)/dV(76)
  JVRP(296) = V(135)
! JVRP(297) = dARP(156)/dV(135)
  JVRP(297) = V(76)
! JVRP(298) = dARP(157)/dV(64)
  JVRP(298) = V(135)
! JVRP(299) = dARP(157)/dV(135)
  JVRP(299) = V(64)
! JVRP(300) = dARP(158)/dV(71)
  JVRP(300) = V(135)
! JVRP(301) = dARP(158)/dV(135)
  JVRP(301) = V(71)
! JVRP(302) = dARP(159)/dV(65)
  JVRP(302) = V(135)
! JVRP(303) = dARP(159)/dV(135)
  JVRP(303) = V(65)
! JVRP(304) = dARP(160)/dV(80)
  JVRP(304) = V(135)
! JVRP(305) = dARP(160)/dV(135)
  JVRP(305) = V(80)
! JVRP(306) = dARP(161)/dV(70)
  JVRP(306) = V(135)
! JVRP(307) = dARP(161)/dV(135)
  JVRP(307) = V(70)
! JVRP(308) = dARP(162)/dV(89)
  JVRP(308) = V(135)
! JVRP(309) = dARP(162)/dV(135)
  JVRP(309) = V(89)
! JVRP(310) = dARP(163)/dV(87)
  JVRP(310) = V(135)
! JVRP(311) = dARP(163)/dV(135)
  JVRP(311) = V(87)
! JVRP(312) = dARP(164)/dV(86)
  JVRP(312) = V(135)
! JVRP(313) = dARP(164)/dV(135)
  JVRP(313) = V(86)
! JVRP(314) = dARP(165)/dV(88)
  JVRP(314) = V(135)
! JVRP(315) = dARP(165)/dV(135)
  JVRP(315) = V(88)
! JVRP(316) = dARP(166)/dV(85)
  JVRP(316) = V(135)
! JVRP(317) = dARP(166)/dV(135)
  JVRP(317) = V(85)
! JVRP(318) = dARP(167)/dV(73)
  JVRP(318) = V(135)
! JVRP(319) = dARP(167)/dV(135)
  JVRP(319) = V(73)
! JVRP(320) = dARP(168)/dV(74)
  JVRP(320) = V(135)
! JVRP(321) = dARP(168)/dV(135)
  JVRP(321) = V(74)
! JVRP(322) = dARP(169)/dV(83)
  JVRP(322) = V(133)
! JVRP(323) = dARP(169)/dV(133)
  JVRP(323) = V(83)
! JVRP(324) = dARP(170)/dV(105)
  JVRP(324) = V(135)
! JVRP(325) = dARP(170)/dV(135)
  JVRP(325) = V(105)
! JVRP(326) = dARP(171)/dV(105)
  JVRP(326) = V(134)
! JVRP(327) = dARP(171)/dV(134)
  JVRP(327) = V(105)
! JVRP(328) = dARP(172)/dV(128)
  JVRP(328) = 2*V(128)
! JVRP(329) = dARP(173)/dV(128)
  JVRP(329) = V(129)
! JVRP(330) = dARP(173)/dV(129)
  JVRP(330) = V(128)
! JVRP(331) = dARP(174)/dV(128)
  JVRP(331) = V(129)
! JVRP(332) = dARP(174)/dV(129)
  JVRP(332) = V(128)
! JVRP(333) = dARP(175)/dV(119)
  JVRP(333) = V(128)
! JVRP(334) = dARP(175)/dV(128)
  JVRP(334) = V(119)
! JVRP(335) = dARP(176)/dV(112)
  JVRP(335) = V(128)
! JVRP(336) = dARP(176)/dV(128)
  JVRP(336) = V(112)
! JVRP(337) = dARP(177)/dV(115)
  JVRP(337) = V(128)
! JVRP(338) = dARP(177)/dV(128)
  JVRP(338) = V(115)
! JVRP(339) = dARP(178)/dV(124)
  JVRP(339) = V(128)
! JVRP(340) = dARP(178)/dV(128)
  JVRP(340) = V(124)
! JVRP(341) = dARP(179)/dV(104)
  JVRP(341) = V(128)
! JVRP(342) = dARP(179)/dV(128)
  JVRP(342) = V(104)
! JVRP(343) = dARP(180)/dV(113)
  JVRP(343) = V(128)
! JVRP(344) = dARP(180)/dV(128)
  JVRP(344) = V(113)
! JVRP(345) = dARP(181)/dV(109)
  JVRP(345) = V(128)
! JVRP(346) = dARP(181)/dV(128)
  JVRP(346) = V(109)
! JVRP(347) = dARP(182)/dV(106)
  JVRP(347) = V(128)
! JVRP(348) = dARP(182)/dV(128)
  JVRP(348) = V(106)
! JVRP(349) = dARP(183)/dV(102)
  JVRP(349) = V(128)
! JVRP(350) = dARP(183)/dV(128)
  JVRP(350) = V(102)
! JVRP(351) = dARP(184)/dV(110)
  JVRP(351) = V(128)
! JVRP(352) = dARP(184)/dV(128)
  JVRP(352) = V(110)
! JVRP(353) = dARP(185)/dV(101)
  JVRP(353) = V(128)
! JVRP(354) = dARP(185)/dV(128)
  JVRP(354) = V(101)
! JVRP(355) = dARP(186)/dV(98)
  JVRP(355) = V(128)
! JVRP(356) = dARP(186)/dV(128)
  JVRP(356) = V(98)
! JVRP(357) = dARP(187)/dV(108)
  JVRP(357) = V(128)
! JVRP(358) = dARP(187)/dV(128)
  JVRP(358) = V(108)
! JVRP(359) = dARP(188)/dV(107)
  JVRP(359) = V(128)
! JVRP(360) = dARP(188)/dV(128)
  JVRP(360) = V(107)
! JVRP(361) = dARP(189)/dV(119)
  JVRP(361) = V(128)
! JVRP(362) = dARP(189)/dV(128)
  JVRP(362) = V(119)
! JVRP(363) = dARP(190)/dV(112)
  JVRP(363) = V(128)
! JVRP(364) = dARP(190)/dV(128)
  JVRP(364) = V(112)
! JVRP(365) = dARP(191)/dV(115)
  JVRP(365) = V(128)
! JVRP(366) = dARP(191)/dV(128)
  JVRP(366) = V(115)
! JVRP(367) = dARP(192)/dV(124)
  JVRP(367) = V(128)
! JVRP(368) = dARP(192)/dV(128)
  JVRP(368) = V(124)
! JVRP(369) = dARP(193)/dV(104)
  JVRP(369) = V(128)
! JVRP(370) = dARP(193)/dV(128)
  JVRP(370) = V(104)
! JVRP(371) = dARP(194)/dV(113)
  JVRP(371) = V(128)
! JVRP(372) = dARP(194)/dV(128)
  JVRP(372) = V(113)
! JVRP(373) = dARP(195)/dV(106)
  JVRP(373) = V(128)
! JVRP(374) = dARP(195)/dV(128)
  JVRP(374) = V(106)
! JVRP(375) = dARP(196)/dV(102)
  JVRP(375) = V(128)
! JVRP(376) = dARP(196)/dV(128)
  JVRP(376) = V(102)
! JVRP(377) = dARP(197)/dV(101)
  JVRP(377) = V(128)
! JVRP(378) = dARP(197)/dV(128)
  JVRP(378) = V(101)
! JVRP(379) = dARP(198)/dV(109)
  JVRP(379) = V(128)
! JVRP(380) = dARP(198)/dV(128)
  JVRP(380) = V(109)
! JVRP(381) = dARP(199)/dV(98)
  JVRP(381) = V(128)
! JVRP(382) = dARP(199)/dV(128)
  JVRP(382) = V(98)
! JVRP(383) = dARP(200)/dV(108)
  JVRP(383) = V(128)
! JVRP(384) = dARP(200)/dV(128)
  JVRP(384) = V(108)
! JVRP(385) = dARP(201)/dV(107)
  JVRP(385) = V(128)
! JVRP(386) = dARP(201)/dV(128)
  JVRP(386) = V(107)
! JVRP(387) = dARP(202)/dV(110)
  JVRP(387) = V(128)
! JVRP(388) = dARP(202)/dV(128)
  JVRP(388) = V(110)
! JVRP(389) = dARP(203)/dV(126)
  JVRP(389) = V(128)
! JVRP(390) = dARP(203)/dV(128)
  JVRP(390) = V(126)
! JVRP(391) = dARP(204)/dV(126)
  JVRP(391) = V(128)
! JVRP(392) = dARP(204)/dV(128)
  JVRP(392) = V(126)
! JVRP(393) = dARP(205)/dV(128)
  JVRP(393) = V(136)
! JVRP(394) = dARP(205)/dV(136)
  JVRP(394) = V(128)
! JVRP(395) = dARP(206)/dV(114)
  JVRP(395) = V(128)
! JVRP(396) = dARP(206)/dV(128)
  JVRP(396) = V(114)
! JVRP(397) = dARP(207)/dV(121)
  JVRP(397) = V(128)
! JVRP(398) = dARP(207)/dV(128)
  JVRP(398) = V(121)
! JVRP(399) = dARP(208)/dV(133)
  JVRP(399) = 2*V(133)
! JVRP(400) = dARP(226)/dV(132)
  JVRP(400) = 1
! JVRP(401) = dARP(227)/dV(134)
  JVRP(401) = 1
! JVRP(402) = dARP(228)/dV(61)
  JVRP(402) = 1
! JVRP(403) = dARP(229)/dV(99)
  JVRP(403) = 1
! JVRP(404) = dARP(230)/dV(117)
  JVRP(404) = 1
! JVRP(405) = dARP(231)/dV(63)
  JVRP(405) = 1
! JVRP(406) = dARP(232)/dV(58)
  JVRP(406) = 1
! JVRP(407) = dARP(233)/dV(90)
  JVRP(407) = 1
! JVRP(408) = dARP(234)/dV(57)
  JVRP(408) = 1
! JVRP(409) = dARP(235)/dV(120)
  JVRP(409) = 1
! JVRP(410) = dARP(236)/dV(125)
  JVRP(410) = 1
! JVRP(411) = dARP(237)/dV(122)
  JVRP(411) = 1
! JVRP(412) = dARP(238)/dV(130)
  JVRP(412) = 1
! JVRP(413) = dARP(239)/dV(132)
  JVRP(413) = 1
! JVRP(414) = dARP(240)/dV(133)
  JVRP(414) = 1
! JVRP(415) = dARP(241)/dV(63)
  JVRP(415) = 1
! JVRP(416) = dARP(242)/dV(66)
  JVRP(416) = V(135)
! JVRP(417) = dARP(242)/dV(135)
  JVRP(417) = V(66)
! JVRP(418) = dARP(243)/dV(66)
  JVRP(418) = V(135)
! JVRP(419) = dARP(243)/dV(135)
  JVRP(419) = V(66)
! JVRP(420) = dARP(244)/dV(66)
  JVRP(420) = V(133)
! JVRP(421) = dARP(244)/dV(133)
  JVRP(421) = V(66)
! JVRP(422) = dARP(245)/dV(59)
  JVRP(422) = V(135)
! JVRP(423) = dARP(245)/dV(135)
  JVRP(423) = V(59)
! JVRP(424) = dARP(246)/dV(134)
  JVRP(424) = V(137)
! JVRP(425) = dARP(246)/dV(137)
  JVRP(425) = V(134)
! JVRP(426) = dARP(247)/dV(97)
  JVRP(426) = V(130)
! JVRP(427) = dARP(247)/dV(130)
  JVRP(427) = V(97)
! JVRP(428) = dARP(248)/dV(130)
  JVRP(428) = V(137)
! JVRP(429) = dARP(248)/dV(137)
  JVRP(429) = V(130)
! JVRP(430) = dARP(249)/dV(79)
  JVRP(430) = V(135)
! JVRP(431) = dARP(249)/dV(135)
  JVRP(431) = V(79)
! JVRP(432) = dARP(250)/dV(97)
  JVRP(432) = 2*V(97)
! JVRP(433) = dARP(251)/dV(97)
  JVRP(433) = 2*V(97)
! JVRP(434) = dARP(252)/dV(97)
  JVRP(434) = V(131)
! JVRP(435) = dARP(252)/dV(131)
  JVRP(435) = V(97)
! JVRP(436) = dARP(253)/dV(84)
  JVRP(436) = V(137)
! JVRP(437) = dARP(253)/dV(137)
  JVRP(437) = V(84)
! JVRP(438) = dARP(254)/dV(78)
  JVRP(438) = V(135)
! JVRP(439) = dARP(254)/dV(135)
  JVRP(439) = V(78)
! JVRP(440) = dARP(255)/dV(97)
  JVRP(440) = V(135)
! JVRP(441) = dARP(255)/dV(135)
  JVRP(441) = V(97)
! JVRP(442) = dARP(256)/dV(133)
  JVRP(442) = V(137)
! JVRP(443) = dARP(256)/dV(137)
  JVRP(443) = V(133)
! JVRP(444) = dARP(257)/dV(117)
  JVRP(444) = V(137)
! JVRP(445) = dARP(257)/dV(137)
  JVRP(445) = V(117)
! JVRP(446) = dARP(258)/dV(123)
  JVRP(446) = V(137)
! JVRP(447) = dARP(258)/dV(137)
  JVRP(447) = V(123)
! JVRP(448) = dARP(259)/dV(96)
  JVRP(448) = V(137)
! JVRP(449) = dARP(259)/dV(137)
  JVRP(449) = V(96)
! JVRP(450) = dARP(260)/dV(83)
  JVRP(450) = V(137)
! JVRP(451) = dARP(260)/dV(137)
  JVRP(451) = V(83)
! JVRP(452) = dARP(261)/dV(67)
  JVRP(452) = V(137)
! JVRP(453) = dARP(261)/dV(137)
  JVRP(453) = V(67)
! JVRP(454) = dARP(262)/dV(132)
  JVRP(454) = V(137)
! JVRP(455) = dARP(262)/dV(137)
  JVRP(455) = V(132)
! JVRP(456) = dARP(263)/dV(97)
  JVRP(456) = V(132)
! JVRP(457) = dARP(263)/dV(132)
  JVRP(457) = V(97)
! JVRP(458) = dARP(264)/dV(53)
  JVRP(458) = V(135)
! JVRP(459) = dARP(264)/dV(135)
  JVRP(459) = V(53)
! JVRP(460) = dARP(265)/dV(54)
  JVRP(460) = V(135)
! JVRP(461) = dARP(265)/dV(135)
  JVRP(461) = V(54)
! JVRP(462) = dARP(266)/dV(55)
  JVRP(462) = V(135)
! JVRP(463) = dARP(266)/dV(135)
  JVRP(463) = V(55)
! JVRP(464) = dARP(267)/dV(84)
  JVRP(464) = 1
! JVRP(465) = dARP(268)/dV(77)
  JVRP(465) = 1
! JVRP(466) = dARP(269)/dV(79)
  JVRP(466) = 1
! JVRP(467) = dARP(270)/dV(77)
  JVRP(467) = 1
! JVRP(468) = dARP(271)/dV(79)
  JVRP(468) = 1
! JVRP(469) = dARP(272)/dV(77)
  JVRP(469) = 1
! JVRP(470) = dARP(273)/dV(79)
  JVRP(470) = 1
! JVRP(471) = dARP(274)/dV(84)
  JVRP(471) = 1
! JVRP(472) = dARP(275)/dV(78)
  JVRP(472) = 1
! JVRP(473) = dARP(276)/dV(134)
  JVRP(473) = 1
! JVRP(474) = dARP(277)/dV(132)
  JVRP(474) = 1
! JVRP(475) = dARP(278)/dV(58)
  JVRP(475) = 1
! JVRP(476) = dARP(279)/dV(75)
  JVRP(476) = 1
! JVRP(477) = dARP(280)/dV(117)
  JVRP(477) = 1
! JVRP(478) = dARP(281)/dV(117)
  JVRP(478) = 1
! JVRP(479) = dARP(282)/dV(99)
  JVRP(479) = 1
! JVRP(480) = dARP(283)/dV(62)
  JVRP(480) = 1
! JVRP(481) = dARP(284)/dV(72)
  JVRP(481) = 1
! JVRP(482) = dARP(285)/dV(133)
  JVRP(482) = 1
! JVRP(483) = dARP(286)/dV(133)
  JVRP(483) = 1
! JVRP(484) = dARP(287)/dV(63)
  JVRP(484) = 1
! JVRP(485) = dARP(288)/dV(63)
  JVRP(485) = 1
! JVRP(486) = dARP(289)/dV(72)
  JVRP(486) = 1
! JVRP(487) = dARP(290)/dV(123)
  JVRP(487) = 1
! JVRP(488) = dARP(291)/dV(123)
  JVRP(488) = 1
! JVRP(489) = dARP(292)/dV(61)
  JVRP(489) = 1
! JVRP(490) = dARP(293)/dV(116)
  JVRP(490) = 1
! JVRP(491) = dARP(294)/dV(96)
  JVRP(491) = 1
! JVRP(492) = dARP(295)/dV(96)
  JVRP(492) = 1
! JVRP(493) = dARP(296)/dV(127)
  JVRP(493) = 1
! JVRP(494) = dARP(297)/dV(94)
  JVRP(494) = 1
! JVRP(495) = dARP(298)/dV(69)
  JVRP(495) = 1
! JVRP(496) = dARP(299)/dV(69)
  JVRP(496) = 1
! JVRP(497) = dARP(300)/dV(118)
  JVRP(497) = 1
! JVRP(498) = dARP(301)/dV(118)
  JVRP(498) = 1
! JVRP(499) = dARP(302)/dV(125)
  JVRP(499) = 1
! JVRP(500) = dARP(303)/dV(125)
  JVRP(500) = 1
! JVRP(501) = dARP(304)/dV(125)
  JVRP(501) = 1
! JVRP(502) = dARP(305)/dV(122)
  JVRP(502) = 1
! JVRP(503) = dARP(306)/dV(122)
  JVRP(503) = 1
! JVRP(504) = dARP(307)/dV(103)
  JVRP(504) = 1
! JVRP(505) = dARP(308)/dV(82)
  JVRP(505) = 1
! JVRP(506) = dARP(309)/dV(81)
  JVRP(506) = 1
! JVRP(507) = dARP(310)/dV(68)
  JVRP(507) = 1
! JVRP(508) = dARP(311)/dV(76)
  JVRP(508) = 1
! JVRP(509) = dARP(312)/dV(64)
  JVRP(509) = 1
! JVRP(510) = dARP(313)/dV(71)
  JVRP(510) = 1
! JVRP(511) = dARP(314)/dV(80)
  JVRP(511) = 1
! JVRP(512) = dARP(315)/dV(65)
  JVRP(512) = 1
! JVRP(513) = dARP(316)/dV(70)
  JVRP(513) = 1
! JVRP(514) = dARP(317)/dV(89)
  JVRP(514) = 1
! JVRP(515) = dARP(318)/dV(87)
  JVRP(515) = 1
! JVRP(516) = dARP(319)/dV(86)
  JVRP(516) = 1
! JVRP(517) = dARP(320)/dV(88)
  JVRP(517) = 1
! JVRP(518) = dARP(321)/dV(85)
  JVRP(518) = 1
! JVRP(519) = dARP(322)/dV(73)
  JVRP(519) = 1
! JVRP(520) = dARP(323)/dV(120)
  JVRP(520) = 1
! JVRP(521) = dARP(324)/dV(74)
  JVRP(521) = 1
! JVRP(522) = dARP(325)/dV(78)
  JVRP(522) = 1
! JVRP(523) = dARP(326)/dV(97)
  JVRP(523) = 1
! JVRP(524) = dARP(327)/dV(77)
  JVRP(524) = 1
! JVRP(525) = dARP(328)/dV(84)
  JVRP(525) = 1
! JVRP(526) = dARP(329)/dV(84)
  JVRP(526) = 1
! JVRP(527) = dARP(330)/dV(56)
  JVRP(527) = 1
! JVRP(528) = dARP(331)/dV(53)
  JVRP(528) = 1
      
END SUBROUTINE JacReactantProd

! End of JacReactantProd function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



! Begin Derivative w.r.t. Rate Coefficients

! ------------------------------------------------------------------------------
! Subroutine for the derivative of Fun with respect to rate coefficients
! -----------------------------------------------------------------------------

      SUBROUTINE  dFun_dRcoeff( V, F, NCOEFF, JCOEFF, DFDR )
       
      USE gckpp_Parameters
      USE gckpp_StoichiomSP
      IMPLICIT NONE 

! V - Concentrations of variable/radical/fixed species            
      REAL(kind=dp) V(NVAR), F(NFIX)
! NCOEFF - the number of rate coefficients with respect to which we differentiate
      INTEGER NCOEFF       
! JCOEFF - a vector of integers containing the indices of reactions (rate
!          coefficients) with respect to which we differentiate
      INTEGER JCOEFF(NCOEFF)       
! DFDR  - a matrix containg derivative values; specifically, 
!         column j contains d Fun(1:NVAR) / d RCT( JCOEFF(j) )
!         for each 1 <= j <= NCOEFF
!         This matrix is stored in a column-wise linearized format
      REAL(kind=dp) DFDR(NVAR*NCOEFF)

! Local vector with reactant products
      REAL(kind=dp) A_RPROD(NREACT)
      REAL(kind=dp) aj
      INTEGER i,j,k
      
! Compute the reactant products of all reactions     
      CALL ReactantProd ( V, F, A_RPROD )

! Compute the derivatives by multiplying column JCOEFF(j) of the stoichiometric matrix with A_RPROD       
      DO j=1,NCOEFF
!                  Initialize the j-th column of derivative matrix to zero       
         DO i=1,NVAR
           DFDR(i+NVAR*(j-1)) = 0.0_dp 
         END DO
!                  Column JCOEFF(j) in the stoichiometric matrix times the
!                  reactant product  of the JCOEFF(j)-th reaction      
!                  give the j-th column of the derivative matrix   
         aj = A_RPROD(JCOEFF(j))
         DO k=CCOL_STOICM(JCOEFF(j)),CCOL_STOICM(JCOEFF(j)+1)-1
           DFDR(IROW_STOICM(k)+NVAR*(j-1)) = STOICM(k)*aj
         END DO
      END DO
      
      END SUBROUTINE  dFun_dRcoeff

! End Derivative w.r.t. Rate Coefficients


! Begin Jacobian Derivative w.r.t. Rate Coefficients

! ------------------------------------------------------------------------------
! Subroutine for the derivative of Jac with respect to rate coefficients
! Times a user vector
! -----------------------------------------------------------------------------

      SUBROUTINE  dJac_dRcoeff( V, F, U, NCOEFF, JCOEFF, DJDR )
       
      USE gckpp_Parameters
      USE gckpp_StoichiomSP
      IMPLICIT NONE 

! V - Concentrations of variable/fixed species            
      REAL(kind=dp) V(NVAR), F(NFIX)
! U - User-supplied Vector           
      REAL(kind=dp) U(NVAR)
! NCOEFF - the number of rate coefficients with respect to which we differentiate
      INTEGER NCOEFF       
! JCOEFF - a vector of integers containing the indices of reactions (rate
!          coefficients) with respect to which we differentiate
      INTEGER JCOEFF(NCOEFF)       
! DFDR  - a matrix containg derivative values; specifically, 
!         column j contains d Jac(1:NVAR) / d RCT( JCOEFF(j) ) * U
!                     for each 1 <= j <= NCOEFF
!         This matrix is stored in a column-wise linearized format
      REAL(kind=dp) DJDR(NVAR*NCOEFF)

! Local vector for Jacobian of reactant products
      REAL(kind=dp) JV_RPROD(NJVRP)
      REAL(kind=dp) aj
      INTEGER i,j,k
      
! Compute the Jacobian of all reactant products   
      CALL JacReactantProd( V, F, JV_RPROD )

! Compute the derivatives by multiplying column JCOEFF(j) of the stoichiometric matrix with A_PROD       
      DO j=1,NCOEFF
!                  Initialize the j-th column of derivative matrix to zero       
         DO i=1,NVAR
           DJDR(i+NVAR*(j-1)) = 0.0_dp
         END DO
!                  Column JCOEFF(j) in the stoichiometric matrix times the
!                  ( Gradient of reactant product of the JCOEFF(j)-th reaction X user vector )    
!                  give the j-th column of the derivative matrix   
!
!          Row JCOEFF(j) of JV_RPROD times the user vector
         aj = 0.0_dp
         DO k=CROW_JVRP(JCOEFF(j)),CROW_JVRP(JCOEFF(j)+1)-1
             aj = aj + JV_RPROD(k)*U(ICOL_JVRP(k))
         END DO
!          Column JCOEFF(j) of Stoichiom. matrix times aj         
         DO k=CCOL_STOICM(JCOEFF(j)),CCOL_STOICM(JCOEFF(j)+1)-1
           DJDR(IROW_STOICM(k)+NVAR*(j-1)) = STOICM(k)*aj
         END DO
      END DO
      
      END SUBROUTINE  dJac_dRcoeff

! End Jacobian Derivative w.r.t. Rate Coefficients


END MODULE gckpp_Stoichiom

