
      module gc_chemini

      private
      public :: gc_cheminit

      contains

      subroutine gc_cheminit( plonl, platl )
!-----------------------------------------------------------------------
! 	... Chemistry module intialization
!-----------------------------------------------------------------------

        use logical_mod,   only : DO_DIAG_WRITE
        use CMN_SIZE_MOD,  only : JJPAR, IIPAR
        use ppgrid,        only : pcols

        implicit none

!-----------------------------------------------------------------------
! 	... Dummy arguments
!-----------------------------------------------------------------------
        integer, intent(in) :: plonl, platl

!-----------------------------------------------------------------------
!       Initialize GEOS-Chem runtime environment
!-----------------------------------------------------------------------

        DO_DIAG_WRITE = .FALSE. ! Don't want to write diagnostics files!

        ! Set model dimensions
        IIPAR = 1
        JJPAR =pcols

!-----------------------------------------------------------------------
! 	... Read GEOS-Chem emissions datasets 
!-----------------------------------------------------------------------
        call gc_emis_inti( plonl, platl, 1 )
!-----------------------------------------------------------------------
      end subroutine gc_cheminit
      
      subroutine gc_emis_inti( plonl, platl, pplon )
        
      	use gc_emis_edgar, only: gc_edgar_emis_inti
        
      	implicit none

      	integer, intent(in) :: plonl, platl, pplon
!----------------------------------------------------------------------
! This section will establish the emissions fields for each set
! of GEOS-Chem emissions used. <<USE GC NAMELIST or MODIFY BCC's?>>
!----------------------------------------------------------------------
      	call gc_edgar_emis_inti( plonl, platl, pplon )

      end subroutine gc_emis_inti

      end module gc_chemini
