   
   module iceLPact
     use shr_kind_mod,  only:  r8 => shr_kind_r8
     implicit none
     private
     save
     public IceLP,IceLP_nlim ,LPhet     ! ! Public interfaces
   contains
   
    subroutine IceLP(T, P, nso4, ndust, nbc,wbar, relhum, &
                     ni_in,hom_ni, &
                     nice, nhom, nhet, nlim,treg )
       implicit none
       real(r8),intent(in) :: T, P, nso4, ndust, nbc,wbar  !SCI unit  k Pa #/m3 m/s
       real(r8),intent(in) :: relhum  ! wrt water  
       real(r8),intent(in) :: ni_in   ! previous ice number #/m3
       logical, intent(in) ::  hom_ni ! hom_ni =.TRUE.  ! dont care about ni_in 
       real(r8), intent(out) :: nice, nhom, nhet, nlim    ! #/m3
       real(r8), intent(out) :: treg                      !  0C
       real(r8) :: tc,niimm,nidep,nihf,A,B,C,RHw,n1,subgrid,regm
       real(r8) :: nlim_out,nhom_out,nhet_out
       real(r8) :: so4_num,soot_num,dst_num,wbari
       logical :: purehom
       real(r8) A_hom,B_hom,C_hom,RHw_hom
       tc=T-273.15
       so4_num =nso4*1.0e-6_r8  ! #/cm3
       soot_num=nbc*1.0e-6_r8    ! #/cm3
       dst_num =ndust*1.0e-6_r8   ! #/cm3
       !soot_num=0. ! do not consider soot !****
       niimm=0._r8  ! #/cm3
       nidep=0._r8  ! #/cm3
       nihf=0._r8   ! #/cm3
       nhom_out=0.  ! #/m3
       nhet_out=0.  ! #/m3
       nlim_out=0.  ! #/m3
       nice=0. ! #/m3
       nhom=0. ! #/m3
       nhet=0. ! #/m3
       nlim=0. ! #/m3
       subgrid = 1.2_r8
       treg =0
       wbari=wbar
       
    A_hom = 6.0e-4_r8*log(wbar)+6.6e-3_r8
    B_hom = 6.0e-2_r8*log(wbar)+1.052_r8
    C_hom = 1.68_r8  *log(wbar)+129.35_r8
    RHw_hom=(A_hom*tc*tc+B_hom*tc+C_hom)*0.01_r8
    

    !purehom=.TRUE.       ! only hom
    purehom=.FALSE.
   if (purehom) then
     if((so4_num.ge.1.0e-10_r8 .or. (soot_num+dst_num).ge.1.0e-10_r8)) then ! same as het&hom
     if((tc.le.-37.0_r8) .and. ((relhum*subgrid).ge.RHw_hom)) then
     if ((ni_in.le.2e4).or.hom_ni) then  ! default 1e4
        call hf(tc,wbar,relhum,subgrid,so4_num,nihf)   !nihf in #/cm3
        nhom_out=nihf*1e6_r8 ! #/m3
        nhet_out=0._r8       ! #/m3
     endif
     endif
     endif
   else  !not pure hom if (purehom) then
       if((so4_num.ge.1.0e-10_r8 .or. (soot_num+dst_num).ge.1.0e-10_r8) ) then 
         A = 0.0073_r8
         B = 1.477_r8
         C = 131.74_r8
         RHw=(A*tc*tc+B*tc+C)*0.01_r8   ! RHi ~ 120-130%
         !write(*,*) "RHw  ",RHw
         !write(*,*) "soot_num",soot_num
         ! RHw parameterization for heterogeneous immersion nucleation
         !if((tc.le.-37.0_r8) .and. ((relhum*polysvp(T,0)/polysvp(T,1)*subgrid).ge.1.2_r8)) then  ! sxj change -35 to -37
         if((tc.le.0.0_r8) .and. ((relhum*polysvp(T,0)/polysvp(T,1)*subgrid).ge.1.2_r8)) then  ! sxj change -37 to 0,  but just pure ice cloud cal this subroutine
         !@@@@ this subroutine be called in pure ice cloud @@@@
          if ((soot_num+dst_num).gt.1e-12) then 
             A = -1.4938_r8 * log(soot_num+dst_num) + 12.884_r8
             B = -10.41_r8  * log(soot_num+dst_num) - 67.69_r8
             !write(*,*) A,B,dst_num,log(soot_num+dst_num)
              regm = A * log(wbar) + B
              !write(*,*) "regm ",regm
          else
              regm=999.                       ! if soot_num+dst_num =0 , only hom
          endif
          if (so4_num.lt.1e-12_r8) then       ! if nsul =0  , only  het
             regm=-999.
             wbari=min(wbar,0.99_r8)
          end if 
          treg = regm
          A=12.884_r8*log(wbar)-67.69_r8-tc
          B=1.4938_r8*log(wbar)+10.41_r8
          nlim_out=exp(A/B)*1.0e6_r8  ! #/cm3 to #/m3  
          !write(*,*) tc,nlim_out,regm
          if(tc.gt.regm) then    ! heterogeneous nucleation only
            if(tc.lt.-40._r8 .and. wbari.gt.1._r8) then ! exclude T<-40 & W>1m/s from hetero. nucleation
              if ((ni_in.le.2e4).or.hom_ni) then  ! default 1e4
                 call hf(tc,wbar,relhum,subgrid,so4_num,nihf)
                 nhom_out=nihf*1e6_r8 ! #/m3
                 nhet_out=0._r8       ! #/m3
              endif
            else
              call hetero(tc,wbar,soot_num+dst_num,niimm,nidep)
              n1=niimm+nidep
              nhom_out=0._r8        ! #/m3
              nhet_out=n1*1e6_r8    ! #/m3
            endif
          elseif (tc.lt.regm-5._r8) then ! homogeneous nucleation only
            if ((ni_in.le.2e4).or.hom_ni) then
               call hf(tc,wbar,relhum,subgrid,so4_num,nihf)
               niimm=0._r8
	       nidep=0._r8
               n1=nihf
               nhom_out=nihf*1e6_r8 ! #/m3
               nhet_out=0._r8       ! #/m3
            endif
          else        ! transition between homogeneous and heterogeneous: interpolate in-between
            if(tc.lt.-40._r8 .and. wbar.gt.1._r8) then ! exclude T<-40 & W>1m/s from hetero. nucleation
              if ((ni_in.le.2e4).or.hom_ni) then
                 call hf(tc,wbar,relhum,subgrid,so4_num,nihf)
                 niimm=0._r8
	         nidep=0._r8
                 n1=nihf
                 nhom_out=nihf*1e6_r8 ! #/m3
                 nhet_out=0._r8       ! #/m3
              endif
            else
              if ((ni_in.le.2e4).or.hom_ni) then
                  call hf(regm-5._r8,wbar,relhum,subgrid,so4_num,nihf)
              endif
              call hetero(regm,wbar,soot_num+dst_num,niimm,nidep)
              if(nihf.le.(niimm+nidep)) then
                n1=nihf
                nhom_out=nihf*1e6_r8 ! #/m3
                nhet_out=0._r8       ! #/m3
              else
                n1=(niimm+nidep)*((niimm+nidep)/nihf)**((tc-regm)/5._r8)
                !write(*,*) nihf,niimm+nidep,n1
                nhom_out=0._r8           ! #/m3
                nhet_out=n1*1e6_r8       ! #/m3
              endif
            endif
          endif
         endif ! tc<-37 Rhi*subgird>1.2 
       endif ! aerosol and cloud exit
   endif !if (purehom) then
    
       nice=nhom_out+nhet_out
       nhet=nhet_out
       nhom=nhom_out
       nlim=nlim_out
    
       
       
    end subroutine IceLP
!++sxj 1111
     subroutine IceLP_nlim(T,wbar,nlim)
       implicit none
       real(r8), intent(in)  :: T,wbar  ! SCI unit  k Pa  m/s
       real(r8), intent(out) :: nlim    ! #/m3
       real(r8) :: tc,A,B
       tc=T-273.15
       A=12.884*log(wbar)-67.69-tc
       B=1.4938*log(wbar)+10.41
       nlim=exp(A/B)*1e6   ! #/m3 
     end subroutine IceLP_nlim
!--sxj
!+++sxj 
    subroutine LPhet(T,wbar,Ndust,Nbc,NI)
       implicit none 
       real(r8), intent(in) :: T,wbar ! T in K,wbar in m/s
       real(r8), intent(in) :: Ndust,Nbc ! #/m3
       real(r8), intent(out) :: NI
       real(r8) :: tc,Ns,Nis,Nid
       tc=T-273.15
       Ns=(Ndust+Nbc)*1e-6
       call hetero(tc,wbar,Ns,Nis,Nid)
       NI=(Nis+Nid)*1e6
    end subroutine LPhet
!---sxj

    subroutine hetero(T,ww,Ns,Nis,Nid)
      real(r8), intent(in)  :: T, ww, Ns
      real(r8), intent(out) :: Nis, Nid
      real(r8) A11,A12,A21,A22,B11,B12,B21,B22
      real(r8) A,B,C
      A11 = 0.0263_r8
      A12 = -0.0185_r8
      A21 = 2.758_r8
      A22 = 1.3221_r8
      B11 = -0.008_r8
      B12 = -0.0468_r8
      B21 = -0.2667_r8
      B22 = -1.4588_r8
      B = (A11+B11*log(Ns)) * log(ww) + (A12+B12*log(Ns))
      C =  A21+B21*log(Ns)
      Nis = exp(A22) * Ns**B22 * exp(B*T) * ww**C
      Nis = min(Nis,Ns)
      Nid = 0.0_r8    ! don't include deposition nucleation for cirrus clouds when T<-37C
      return
    end subroutine hetero
 



    subroutine hf(T,ww,RH,subgrid,Na,Ni)
      real(r8), intent(in)  :: T, ww, RH, subgrid, Na
      real(r8), intent(out) :: Ni
      real(r8)    A1_fast,A21_fast,A22_fast,B1_fast,B21_fast,B22_fast
      real(r8)    A2_fast,B2_fast
      real(r8)    C1_fast,C2_fast,k1_fast,k2_fast
      real(r8)    A1_slow,A2_slow,B1_slow,B2_slow,B3_slow
      real(r8)    C1_slow,C2_slow,k1_slow,k2_slow
      real(r8)    regm
      real(r8)    A,B,C
      real(r8)    RHw
      A1_fast  =0.0231_r8
      A21_fast =-1.6387_r8  !(T>-64 deg)
      A22_fast =-6.045_r8   !(T<=-64 deg)
      B1_fast  =-0.008_r8
      B21_fast =-0.042_r8   !(T>-64 deg)
      B22_fast =-0.112_r8   !(T<=-64 deg)
      C1_fast  =0.0739_r8
      C2_fast  =1.2372_r8
      A1_slow  =-0.3949_r8
      A2_slow  =1.282_r8
      B1_slow  =-0.0156_r8
      B2_slow  =0.0111_r8
      B3_slow  =0.0217_r8
      C1_slow  =0.120_r8
      C2_slow  =2.312_r8
      Ni = 0.0_r8
      A = 6.0e-4_r8*log(ww)+6.6e-3_r8
      B = 6.0e-2_r8*log(ww)+1.052_r8
      C = 1.68_r8  *log(ww)+129.35_r8
      RHw=(A*T*T+B*T+C)*0.01_r8
      if((T.le.-37.0_r8) .and. ((RH*subgrid).ge.RHw)) then
        regm = 6.07_r8*log(ww)-55.0_r8
        if(T.ge.regm) then    ! fast-growth regime
          if(T.gt.-64.0_r8) then
            A2_fast=A21_fast
            B2_fast=B21_fast
          else
            A2_fast=A22_fast
            B2_fast=B22_fast
          endif
          k1_fast = exp(A2_fast + B2_fast*T + C2_fast*log(ww))
          k2_fast = A1_fast+B1_fast*T+C1_fast*log(ww)

          Ni = k1_fast*Na**(k2_fast)
          Ni = min(Ni,Na)
        else       ! slow-growth regime
          k1_slow = exp(A2_slow + (B2_slow+B3_slow*log(ww))*T + C2_slow*log(ww))
          k2_slow = A1_slow+B1_slow*T+C1_slow*log(ww)
          Ni = k1_slow*Na**(k2_slow)
          Ni = min(Ni,Na)
        endif
      end if
      return
    end subroutine hf
    
    function polysvp (T,type)
    !  Compute saturation vapor pressure by using
    ! function from Goff and Gatch (1946)
    
    !  Polysvp returned in units of pa.
    !  T is input in units of K.
    !  type refers to saturation with respect to liquid (0) or ice (1)
    
          implicit none
    
          real(r8) dum
    
          real(r8) T,polysvp
    
          integer type
    
    ! ice
    
          if (type.eq.1) then
    
    ! Goff Gatch equation (good down to -100 C)
    
             polysvp = 10._r8**(-9.09718_r8*(273.16_r8/t-1._r8)-3.56654_r8* &
              log10(273.16_r8/t)+0.876793_r8*(1._r8-t/273.16_r8)+ &
              log10(6.1071_r8))*100._r8
    
          end if
    
    ! Goff Gatch equation, uncertain below -70 C
    
          if (type.eq.0) then
             polysvp = 10._r8**(-7.90298_r8*(373.16_r8/t-1._r8)+ &
                 5.02808_r8*log10(373.16_r8/t)- &
                 1.3816e-7_r8*(10._r8**(11.344_r8*(1._r8-t/373.16_r8))-1._r8)+ &
                 8.1328e-3_r8*(10._r8**(-3.49149_r8*(373.16_r8/t-1._r8))-1._r8)+ &
                 log10(1013.246_r8))*100._r8
             end if
    
    
          end function polysvp
!--xl

   endmodule iceLPact

    


 
   

  
