      module mo_imp_lin_matrix
      contains
      subroutine imp_linmat01( mat, y, rxt, het_rates )
!----------------------------------------------
! ... Linear Matrix entries for Implicit species
!----------------------------------------------
      use mo_grid, only : pcnstm1
      use mo_chem_mods, only : rxntot, hetcnt, imp_nzcnt, clsze
      implicit none
!----------------------------------------------
! ... Dummy args
!----------------------------------------------
      real, intent(in) :: y(clsze,pcnstm1)
      real, intent(in) :: rxt(clsze,rxntot)
      real, intent(in) :: het_rates(clsze,hetcnt)
      real, intent(inout) :: mat(clsze,imp_nzcnt)
!----------------------------------------------
! ... Local variables
!----------------------------------------------
      integer :: k
      do k = 1,clsze
         mat(k,556) = -( rxt(k,38) + rxt(k,39)*y(k,2) + rxt(k,40)*y(k,2) &
                      + rxt(k,56)*y(k,10) + rxt(k,65)*y(k,61) )
         mat(k,586) = rxt(k,5)
         mat(k,407) = rxt(k,6)
         mat(k,510) = .890*rxt(k,9)
         mat(k,2) = rxt(k,133)
         mat(k,1) = -( rxt(k,133) )
         mat(k,558) = rxt(k,5)
         mat(k,587) = -( rxt(k,5) )
         mat(k,408) = rxt(k,6)
         mat(k,511) = .110*rxt(k,9)
         mat(k,3) = rxt(k,133)
         mat(k,557) = 2.000*rxt(k,39)*y(k,2)
         mat(k,401) = -( rxt(k,6) )
         mat(k,18) = rxt(k,7) + rxt(k,47)
         mat(k,105) = rxt(k,8)
         mat(k,504) = .890*rxt(k,9)
         mat(k,37) = rxt(k,10) + rxt(k,54)
         mat(k,88) = .600*rxt(k,19) + rxt(k,88)
         mat(k,111) = rxt(k,20) + rxt(k,127)
         mat(k,206) = rxt(k,30)
         mat(k,508) = -( rxt(k,9) + rxt(k,132) )
         mat(k,19) = rxt(k,7) + rxt(k,47)
         mat(k,90) = .400*rxt(k,19)
         mat(k,103) = -( rxt(k,8) + het_rates(k,2) )
         mat(k,17) = 2.000*rxt(k,48) + 2.000*rxt(k,131)
         mat(k,487) = rxt(k,132)
         mat(k,35) = -( rxt(k,10) + rxt(k,54) + het_rates(k,7) )
         mat(k,16) = -( rxt(k,7) + rxt(k,47) + rxt(k,48) + rxt(k,131) )
         mat(k,227) = rxt(k,16)
         mat(k,83) = rxt(k,18)
         mat(k,89) = .400*rxt(k,19)
         mat(k,284) = .300*rxt(k,23)
         mat(k,126) = rxt(k,27)
         mat(k,387) = rxt(k,55)*y(k,10)
         mat(k,552) = .750*rxt(k,56)*y(k,10)
         mat(k,65) = -( rxt(k,11) + het_rates(k,4) )
         mat(k,251) = -( rxt(k,12) + rxt(k,13) + het_rates(k,3) )
         mat(k,66) = rxt(k,11)
         mat(k,99) = rxt(k,17)
         mat(k,265) = 1.340*rxt(k,21)
         mat(k,62) = rxt(k,26)
         mat(k,203) = rxt(k,30)
         mat(k,116) = .690*rxt(k,31)
         mat(k,257) = rxt(k,32)
         mat(k,149) = rxt(k,33)
         mat(k,22) = 2.000*rxt(k,100)
         mat(k,542) = .250*rxt(k,56)*y(k,10)
         mat(k,384) = -( rxt(k,55)*y(k,10) + rxt(k,64)*y(k,14) + rxt(k,74)*y(k,61) )
         mat(k,104) = rxt(k,8)
         mat(k,67) = rxt(k,11)
         mat(k,14) = 2.000*rxt(k,15)
         mat(k,101) = rxt(k,17)
         mat(k,82) = rxt(k,18)
         mat(k,268) = .660*rxt(k,22)
         mat(k,53) = rxt(k,24)
         mat(k,58) = rxt(k,25)
         mat(k,63) = rxt(k,26)
         mat(k,26) = rxt(k,29)
         mat(k,549) = 2.000*rxt(k,38) + .750*rxt(k,56)*y(k,10) + rxt(k,65)*y(k,61)
         mat(k,38) = rxt(k,10) + rxt(k,54)
         mat(k,69) = rxt(k,11)
         mat(k,254) = 2.000*rxt(k,12)
         mat(k,228) = rxt(k,16)
         mat(k,102) = rxt(k,17)
         mat(k,271) = 1.340*rxt(k,21)
         mat(k,54) = rxt(k,24)
         mat(k,59) = rxt(k,25)
         mat(k,247) = rxt(k,28)
         mat(k,207) = rxt(k,30)
         mat(k,122) = rxt(k,31)
         mat(k,261) = rxt(k,32)
         mat(k,152) = 2.000*rxt(k,33)
         mat(k,23) = rxt(k,99) + rxt(k,100)
         mat(k,553) = .400*rxt(k,56)*y(k,10) + rxt(k,65)*y(k,61)
         mat(k,388) = rxt(k,64)*y(k,14) + rxt(k,74)*y(k,61)
         mat(k,13) = -( rxt(k,15) + het_rates(k,1) )
         mat(k,275) = .700*rxt(k,23)
         mat(k,224) = -( rxt(k,16) + het_rates(k,25) )
         mat(k,98) = rxt(k,17)
         mat(k,52) = rxt(k,24)
         mat(k,96) = -( rxt(k,17) + het_rates(k,5) )
         mat(k,91) = .600*rxt(k,19) + rxt(k,88)
         mat(k,273) = 1.340*rxt(k,21)
         mat(k,287) = .300*rxt(k,23)
         mat(k,64) = rxt(k,26)
         mat(k,127) = rxt(k,27)
         mat(k,249) = rxt(k,28)
         mat(k,263) = rxt(k,32)
         mat(k,80) = -( rxt(k,18) + het_rates(k,6) )
         mat(k,85) = -( rxt(k,19) + rxt(k,88) )
         mat(k,27) = -( het_rates(k,8) )
         mat(k,107) = -( rxt(k,20) + rxt(k,127) )
         mat(k,280) = -( rxt(k,23) + het_rates(k,9) )
         mat(k,118) = .402*rxt(k,31)
         mat(k,266) = -( rxt(k,21) + rxt(k,22) + het_rates(k,10) )
         mat(k,117) = .288*rxt(k,31)
         mat(k,45) = -( het_rates(k,16) )
         mat(k,112) = rxt(k,20) + rxt(k,127)
         mat(k,270) = .660*rxt(k,21)
         mat(k,50) = -( rxt(k,24) + het_rates(k,11) )
         mat(k,55) = -( rxt(k,25) + het_rates(k,12) )
         mat(k,123) = -( rxt(k,27) )
         mat(k,56) = .820*rxt(k,25)
         mat(k,60) = -( rxt(k,26) + het_rates(k,13) )
         mat(k,92) = -( het_rates(k,20) )
         mat(k,31) = -( het_rates(k,21) )
         mat(k,148) = -( rxt(k,33) + het_rates(k,22) )
         mat(k,21) = rxt(k,99)
         mat(k,258) = -( rxt(k,32) + het_rates(k,23) )
         mat(k,20) = -( rxt(k,99) + rxt(k,100) )
         mat(k,70) = -( het_rates(k,24) )
         mat(k,244) = -( rxt(k,28) + het_rates(k,14) )
         mat(k,233) = -( het_rates(k,26) )
         mat(k,202) = -( rxt(k,30) + het_rates(k,18) )
         mat(k,24) = -( rxt(k,29) + het_rates(k,17) )
         mat(k,115) = -( rxt(k,31) + het_rates(k,19) )
      end do
      end subroutine imp_linmat01
      subroutine imp_linmat( mat, y, rxt, het_rates )
!----------------------------------------------
! ... Linear Matrix entries for Implicit species
!----------------------------------------------
      use mo_grid, only : pcnstm1
      use mo_chem_mods, only : rxntot, hetcnt, imp_nzcnt, clsze
      implicit none
!----------------------------------------------
! ... Dummy args
!----------------------------------------------
      real, intent(in) :: y(clsze,pcnstm1)
      real, intent(in) :: rxt(clsze,rxntot)
      real, intent(in) :: het_rates(clsze,hetcnt)
      real, intent(inout) :: mat(clsze,imp_nzcnt)
      call imp_linmat01( mat, y, rxt, het_rates )
      end subroutine imp_linmat
      end module mo_imp_lin_matrix
