      module mo_imp_prod_loss
      contains
      subroutine imp_prod_loss( prod, loss, y, rxt, het_rates )
      use mo_chem_mods, only : clscnt4, rxntot, hetcnt, clsze
      use mo_grid, only : pcnstm1
      implicit none
!--------------------------------------------------------------------
! ... Dummy args
!--------------------------------------------------------------------
      real, dimension(:,:), intent(out) :: &
            prod, &
            loss
      real, intent(in) :: y(:,:)
      real, intent(in) :: rxt(:,:)
      real, intent(in) :: het_rates(:,:)
!--------------------------------------------------------------------
! ... Local variables
!--------------------------------------------------------------------
      integer :: k
!--------------------------------------------------------------------
! ... Loss and production for Implicit method
!--------------------------------------------------------------------
      do k = 1,clsze
         loss(k,54) = (2.*rxt(k,35)* y(k,1) + (rxt(k,39) +rxt(k,40))* y(k,2) &
                  +rxt(k,42)* y(k,4) + (rxt(k,43) +rxt(k,44))* y(k,5) +rxt(k,56) &
                 * y(k,10) + (rxt(k,66) +rxt(k,68))* y(k,15) + (rxt(k,67) +rxt(k,69)) &
                 * y(k,16) +rxt(k,76)* y(k,18) +rxt(k,90)* y(k,19) +rxt(k,101) &
                 * y(k,28) +rxt(k,110)* y(k,32) +rxt(k,112)* y(k,33) +rxt(k,129) &
                 * y(k,39) +rxt(k,65)* y(k,61) + rxt(k,38))* y(k,1)
!zf                 * y(k,39) +rxt(k,65)* y(k,61) + 2.0*rxt(k,38))* y(k,1)   !zf20150228
         prod(k,54) = (.100*rxt(k,90)*y(k,19) +.200*rxt(k,110)*y(k,32) + &
                 .200*rxt(k,112)*y(k,33) +.765*rxt(k,129)*y(k,39))*y(k,1) &
                  + (rxt(k,133) +rxt(k,134)*y(k,4))*y(k,3) + (.300*rxt(k,85)*y(k,23) + &
                 .300*rxt(k,122)*y(k,36))*y(k,16) +rxt(k,5)*y(k,4) +rxt(k,6)*y(k,5) &
                  +.890*rxt(k,9)*y(k,6) +rxt(k,73)*y(k,15)*y(k,15)
         loss(k,1) = (rxt(k,134)* y(k,4) + rxt(k,133))* y(k,3)
         prod(k,1) =rxt(k,5)*y(k,4)
         loss(k,55) = (rxt(k,42)* y(k,1) +rxt(k,134)* y(k,3) +rxt(k,51)* y(k,6) &
                  +rxt(k,57)* y(k,11) +rxt(k,41)* y(k,16) +rxt(k,78)* y(k,20) &
                  +rxt(k,83)* y(k,23) +rxt(k,104)* y(k,31) + (rxt(k,113) +rxt(k,114)) &
                 * y(k,34) +rxt(k,120)* y(k,36) +rxt(k,92)* y(k,37) +rxt(k,136) &
                 * y(k,41) +rxt(k,98)* y(k,49) +rxt(k,141)* y(k,52) +rxt(k,146) &
                 * y(k,56) +rxt(k,154)* y(k,58) + rxt(k,5))* y(k,4)
         prod(k,55) = (2.000*rxt(k,39)*y(k,2) +rxt(k,43)*y(k,5))*y(k,1) +rxt(k,133) &
                 *y(k,3) +rxt(k,6)*y(k,5) +.110*rxt(k,9)*y(k,6)
         loss(k,48) = ((rxt(k,43) +rxt(k,44))* y(k,1) +rxt(k,46)* y(k,6) +rxt(k,49) &
                 * y(k,15) +rxt(k,52)* y(k,16) +rxt(k,84)* y(k,23) +rxt(k,126) &
                 * y(k,36) + rxt(k,6))* y(k,5)
         prod(k,48) = (rxt(k,41)*y(k,16) +rxt(k,42)*y(k,1) +2.000*rxt(k,51)*y(k,6) + &
                 rxt(k,57)*y(k,11) +rxt(k,78)*y(k,20) +rxt(k,83)*y(k,23) + &
                 rxt(k,92)*y(k,37) +rxt(k,98)*y(k,49) +.920*rxt(k,104)*y(k,31) + &
                 rxt(k,113)*y(k,34) +rxt(k,120)*y(k,36) +rxt(k,136)*y(k,41) + &
                 rxt(k,141)*y(k,52) +1.206*rxt(k,146)*y(k,56) +rxt(k,154)*y(k,58)) &
                 *y(k,4) + (.890*rxt(k,9) +rxt(k,45)*y(k,16) +rxt(k,105)*y(k,31) + &
                 rxt(k,115)*y(k,34) +rxt(k,121)*y(k,36) +rxt(k,130)*y(k,39) + &
                 1.206*rxt(k,147)*y(k,56) +rxt(k,152)*y(k,57) +rxt(k,155)*y(k,58)) &
                 *y(k,6) + (rxt(k,10) +rxt(k,54) +rxt(k,53)*y(k,15))*y(k,8) &
                  + (rxt(k,7) +rxt(k,47))*y(k,9) + (rxt(k,144)*y(k,26) + &
                 rxt(k,151)*y(k,57))*y(k,15) + (.600*rxt(k,19) +rxt(k,88))*y(k,25) &
                  + (rxt(k,20) +rxt(k,127))*y(k,30) +rxt(k,8)*y(k,7) &
                  +.206*rxt(k,148)*y(k,56)*y(k,16) +rxt(k,30)*y(k,57)
         loss(k,52) = (rxt(k,51)* y(k,4) +rxt(k,46)* y(k,5) +rxt(k,62)* y(k,13) &
                  +rxt(k,45)* y(k,16) +rxt(k,77)* y(k,18) +rxt(k,145)* y(k,19) &
                  +rxt(k,82)* y(k,21) +rxt(k,105)* y(k,31) +rxt(k,115)* y(k,34) &
                  +rxt(k,121)* y(k,36) +rxt(k,130)* y(k,39) +rxt(k,150)* y(k,53) &
                  +rxt(k,147)* y(k,56) +rxt(k,152)* y(k,57) +rxt(k,155)* y(k,58) &
                  + rxt(k,9) + rxt(k,132))* y(k,6)
         prod(k,52) = (rxt(k,50)*y(k,7) +.500*rxt(k,164)*y(k,30) +rxt(k,165)*y(k,25)) &
                 *y(k,15) + (rxt(k,7) +rxt(k,47))*y(k,9) +rxt(k,44)*y(k,5)*y(k,1) &
                  +.400*rxt(k,19)*y(k,25)
         loss(k,24) = (rxt(k,50)* y(k,15) + rxt(k,8) + het_rates(k,2))* y(k,7)
         prod(k,24) = (rxt(k,132) +rxt(k,62)*y(k,13) +rxt(k,82)*y(k,21) + &
                 rxt(k,150)*y(k,53))*y(k,6) + (2.000*rxt(k,48) +2.000*rxt(k,131)) &
                 *y(k,9) +rxt(k,49)*y(k,15)*y(k,5)
         loss(k,11) = (rxt(k,53)* y(k,15) + rxt(k,10) + rxt(k,54) + het_rates(k,7)) &
                 * y(k,8)
         prod(k,11) =rxt(k,52)*y(k,16)*y(k,5)
         loss(k,6) = ( + rxt(k,7) + rxt(k,47) + rxt(k,48) + rxt(k,131))* y(k,9)
         prod(k,6) =rxt(k,46)*y(k,6)*y(k,5)
         loss(k,50) = (rxt(k,57)* y(k,4) + 2.*(rxt(k,58) +rxt(k,59))* y(k,11) &
                  +rxt(k,60)* y(k,16) +rxt(k,86)* y(k,23) +rxt(k,107)* y(k,31) &
                  +rxt(k,117)* y(k,34) +rxt(k,123)* y(k,36) +rxt(k,94)* y(k,37) &
                  +rxt(k,138)* y(k,41) +rxt(k,157)* y(k,58))* y(k,11)
         prod(k,50) = (rxt(k,83)*y(k,4) +.900*rxt(k,86)*y(k,11) + &
                 2.000*rxt(k,89)*y(k,23) +rxt(k,108)*y(k,31) +rxt(k,118)*y(k,34) + &
                 rxt(k,124)*y(k,36) +rxt(k,158)*y(k,58))*y(k,23) &
                  + (.750*rxt(k,56)*y(k,10) +.310*rxt(k,76)*y(k,18))*y(k,1) &
                  + (rxt(k,55)*y(k,10) +.700*rxt(k,61)*y(k,12))*y(k,15) +rxt(k,16) &
                 *y(k,21) +rxt(k,18)*y(k,24) +.400*rxt(k,19)*y(k,25) +.300*rxt(k,23) &
                 *y(k,32) +rxt(k,27)*y(k,43)
         loss(k,17) = (rxt(k,61)* y(k,15) + rxt(k,11) + het_rates(k,4))* y(k,12)
         prod(k,17) =rxt(k,60)*y(k,16)*y(k,11)
         loss(k,40) = (rxt(k,62)* y(k,6) +rxt(k,63)* y(k,15) + rxt(k,12) + rxt(k,13) &
                  + het_rates(k,3))* y(k,13)
         prod(k,40) = (rxt(k,57)*y(k,4) +2.000*rxt(k,58)*y(k,11) +rxt(k,59)*y(k,11) + &
                 rxt(k,86)*y(k,23) +.700*rxt(k,94)*y(k,37) +1.200*rxt(k,107)*y(k,31) + &
                 .880*rxt(k,117)*y(k,34) +2.000*rxt(k,123)*y(k,36) + &
                 rxt(k,138)*y(k,41) +.700*rxt(k,157)*y(k,58))*y(k,11) &
                  + (.250*rxt(k,56)*y(k,10) +.540*rxt(k,76)*y(k,18) + &
                 .600*rxt(k,90)*y(k,19) +rxt(k,101)*y(k,28) +.800*rxt(k,110)*y(k,32) + &
                 .700*rxt(k,112)*y(k,33) +1.326*rxt(k,129)*y(k,39))*y(k,1) &
                  + (.300*rxt(k,61)*y(k,12) +.500*rxt(k,87)*y(k,24) + &
                 .500*rxt(k,97)*y(k,28) +.500*rxt(k,151)*y(k,57) +rxt(k,162)*y(k,45) + &
                 .500*rxt(k,164)*y(k,30) +rxt(k,165)*y(k,25))*y(k,15) &
                  + (rxt(k,78)*y(k,20) +.510*rxt(k,104)*y(k,31) + &
                 .250*rxt(k,113)*y(k,34) +rxt(k,120)*y(k,36) +rxt(k,141)*y(k,52) + &
                 .072*rxt(k,146)*y(k,56))*y(k,4) + (.600*rxt(k,105)*y(k,31) + &
                 .250*rxt(k,115)*y(k,34) +rxt(k,121)*y(k,36) +.072*rxt(k,147)*y(k,56)) &
                 *y(k,6) + (.600*rxt(k,108)*y(k,31) +.250*rxt(k,118)*y(k,34) + &
                 rxt(k,124)*y(k,36))*y(k,23) +rxt(k,11)*y(k,12) &
                  +.008*rxt(k,148)*y(k,56)*y(k,16) +rxt(k,17)*y(k,22) +1.340*rxt(k,21) &
                 *y(k,33) +2.000*rxt(k,125)*y(k,36)*y(k,36) +rxt(k,26)*y(k,44) &
                  +rxt(k,33)*y(k,47) +rxt(k,32)*y(k,48) +2.000*rxt(k,100)*y(k,50) &
                  +rxt(k,30)*y(k,57) +.690*rxt(k,31)*y(k,60)
         loss(k,47) = ((rxt(k,66) +rxt(k,68))* y(k,1) +rxt(k,49)* y(k,5) +rxt(k,50) &
                 * y(k,7) +rxt(k,53)* y(k,8) +rxt(k,55)* y(k,10) +rxt(k,61)* y(k,12) &
                  +rxt(k,63)* y(k,13) +rxt(k,64)* y(k,14) + 2.*rxt(k,73)* y(k,15) &
                  +rxt(k,72)* y(k,16) +rxt(k,71)* y(k,17) +rxt(k,75)* y(k,18) &
                  +rxt(k,102)* y(k,19) +rxt(k,81)* y(k,21) +rxt(k,80)* y(k,22) &
                  +rxt(k,87)* y(k,24) +rxt(k,165)* y(k,25) +rxt(k,144)* y(k,26) &
                  +rxt(k,91)* y(k,27) +rxt(k,97)* y(k,28) +rxt(k,103)* y(k,29) &
                  +rxt(k,164)* y(k,30) +rxt(k,109)* y(k,32) +rxt(k,111)* y(k,33) &
                  +rxt(k,119)* y(k,35) +rxt(k,96)* y(k,38) +rxt(k,128)* y(k,39) &
                  +rxt(k,135)* y(k,40) +rxt(k,139)* y(k,42) +rxt(k,140)* y(k,43) &
                  +rxt(k,143)* y(k,44) +rxt(k,162)* y(k,45) +rxt(k,163)* y(k,46) &
                  +rxt(k,167)* y(k,47) +rxt(k,166)* y(k,48) +rxt(k,153)* y(k,51) &
                  +rxt(k,149)* y(k,53) +rxt(k,151)* y(k,57) +rxt(k,159)* y(k,59) &
                  +rxt(k,161)* y(k,60) +rxt(k,74)* y(k,61))* y(k,15)
         prod(k,47) = (2.000*rxt(k,38) +.750*rxt(k,56)*y(k,10) +rxt(k,65)*y(k,61) + &
                 rxt(k,67)*y(k,16) +rxt(k,69)*y(k,16) +.330*rxt(k,76)*y(k,18) + &
                 .270*rxt(k,90)*y(k,19) +.120*rxt(k,101)*y(k,28) + &
                 .080*rxt(k,110)*y(k,32) +.215*rxt(k,112)*y(k,33) + &
                 1.156*rxt(k,129)*y(k,39))*y(k,1) + (.300*rxt(k,61)*y(k,12) + &
                 .500*rxt(k,80)*y(k,22) +.500*rxt(k,96)*y(k,38) + &
                 .100*rxt(k,119)*y(k,35))*y(k,15) + (rxt(k,41)*y(k,4) + &
                 rxt(k,45)*y(k,6))*y(k,16) +rxt(k,8)*y(k,7) +rxt(k,11)*y(k,12) &
                  +2.000*rxt(k,15)*y(k,17) +rxt(k,17)*y(k,22) +rxt(k,18)*y(k,24) &
                  +.660*rxt(k,22)*y(k,33) +rxt(k,24)*y(k,38) +rxt(k,25)*y(k,42) &
                  +rxt(k,26)*y(k,44) +rxt(k,29)*y(k,59)
         loss(k,51) = ((rxt(k,67) +rxt(k,69))* y(k,1) +rxt(k,41)* y(k,4) +rxt(k,52) &
                 * y(k,5) +rxt(k,45)* y(k,6) +rxt(k,60)* y(k,11) +rxt(k,72)* y(k,15) &
                  + 2.*rxt(k,70)* y(k,16) +rxt(k,79)* y(k,20) +rxt(k,85)* y(k,23) &
                  +rxt(k,106)* y(k,31) +rxt(k,116)* y(k,34) +rxt(k,122)* y(k,36) &
                  +rxt(k,93)* y(k,37) +rxt(k,137)* y(k,41) +rxt(k,142)* y(k,52) &
                  +rxt(k,148)* y(k,56) +rxt(k,156)* y(k,58))* y(k,16)
         prod(k,51) = (rxt(k,64)*y(k,14) +rxt(k,74)*y(k,61) +rxt(k,63)*y(k,13) + &
                 rxt(k,66)*y(k,1) +rxt(k,68)*y(k,1) +rxt(k,71)*y(k,17) + &
                 .250*rxt(k,97)*y(k,28) +.200*rxt(k,119)*y(k,35) +rxt(k,151)*y(k,57) + &
                 rxt(k,162)*y(k,45) +rxt(k,163)*y(k,46) +.500*rxt(k,164)*y(k,30) + &
                 rxt(k,166)*y(k,48) +.600*rxt(k,167)*y(k,47))*y(k,15) &
                  + (rxt(k,57)*y(k,4) +2.000*rxt(k,58)*y(k,11) + &
                 .900*rxt(k,86)*y(k,23) +rxt(k,94)*y(k,37) +rxt(k,107)*y(k,31) + &
                 .730*rxt(k,117)*y(k,34) +rxt(k,123)*y(k,36) +rxt(k,138)*y(k,41) + &
                 rxt(k,157)*y(k,58))*y(k,11) + (.400*rxt(k,56)*y(k,10) + &
                 rxt(k,65)*y(k,61) +.190*rxt(k,76)*y(k,18) +.060*rxt(k,90)*y(k,19) + &
                 .120*rxt(k,101)*y(k,28) +.060*rxt(k,110)*y(k,32) + &
                 .275*rxt(k,112)*y(k,33) +.102*rxt(k,129)*y(k,39))*y(k,1) &
                  + (rxt(k,78)*y(k,20) +rxt(k,92)*y(k,37) +rxt(k,104)*y(k,31) + &
                 .470*rxt(k,113)*y(k,34) +rxt(k,136)*y(k,41) + &
                 .794*rxt(k,146)*y(k,56) +1.500*rxt(k,154)*y(k,58))*y(k,4) &
                  + (rxt(k,62)*y(k,13) +rxt(k,105)*y(k,31) +.470*rxt(k,115)*y(k,34) + &
                 .794*rxt(k,147)*y(k,56) +rxt(k,152)*y(k,57) + &
                 1.500*rxt(k,155)*y(k,58))*y(k,6) + (rxt(k,108)*y(k,31) + &
                 .470*rxt(k,118)*y(k,34) +1.500*rxt(k,158)*y(k,58))*y(k,23) &
                  + (rxt(k,10) +rxt(k,54))*y(k,8) + (rxt(k,99) +rxt(k,100))*y(k,50) &
                  +rxt(k,11)*y(k,12) +2.000*rxt(k,12)*y(k,13) +.794*rxt(k,148)*y(k,56) &
                 *y(k,16) +rxt(k,16)*y(k,21) +rxt(k,17)*y(k,22) +1.340*rxt(k,21) &
                 *y(k,33) +1.200*rxt(k,95)*y(k,37)*y(k,37) +rxt(k,24)*y(k,38) &
                  +rxt(k,25)*y(k,42) +2.000*rxt(k,33)*y(k,47) +rxt(k,32)*y(k,48) &
                  +rxt(k,28)*y(k,53) +rxt(k,30)*y(k,57) +rxt(k,31)*y(k,60)
         loss(k,5) = (rxt(k,71)* y(k,15) + rxt(k,15) + het_rates(k,1))* y(k,17)
         prod(k,5) =rxt(k,70)*y(k,16)*y(k,16)
         loss(k,36) = (rxt(k,76)* y(k,1) +rxt(k,77)* y(k,6) +rxt(k,75)* y(k,15)) &
                 * y(k,18)
         prod(k,36) = (.070*rxt(k,90)*y(k,19) +.119*rxt(k,129)*y(k,39))*y(k,1) &
                  +.700*rxt(k,23)*y(k,32)
         loss(k,31) = (rxt(k,90)* y(k,1) +rxt(k,145)* y(k,6) +rxt(k,102)* y(k,15)) &
                 * y(k,19)
         prod(k,31) = 0.
         loss(k,29) = (rxt(k,78)* y(k,4) +rxt(k,79)* y(k,16))* y(k,20)
         prod(k,29) = (rxt(k,75)*y(k,18) +.500*rxt(k,80)*y(k,22))*y(k,15)
         loss(k,37) = (rxt(k,82)* y(k,6) +rxt(k,81)* y(k,15) + rxt(k,16) &
                  + het_rates(k,25))* y(k,21)
         prod(k,37) = (rxt(k,78)*y(k,20) +rxt(k,92)*y(k,37) +.270*rxt(k,136)*y(k,41)) &
                 *y(k,4) + (.500*rxt(k,76)*y(k,18) +.040*rxt(k,110)*y(k,32))*y(k,1) &
                  + (.500*rxt(k,96)*y(k,38) +rxt(k,163)*y(k,46))*y(k,15) &
                  + (.800*rxt(k,94)*y(k,11) +1.600*rxt(k,95)*y(k,37))*y(k,37) &
                  +rxt(k,17)*y(k,22) +rxt(k,24)*y(k,38)
         loss(k,23) = (rxt(k,80)* y(k,15) + rxt(k,17) + het_rates(k,5))* y(k,22)
         prod(k,23) =rxt(k,79)*y(k,20)*y(k,16)
         loss(k,53) = (rxt(k,83)* y(k,4) +rxt(k,84)* y(k,5) +rxt(k,86)* y(k,11) &
                  +rxt(k,85)* y(k,16) + 2.*rxt(k,89)* y(k,23) +rxt(k,108)* y(k,31) &
                  +rxt(k,118)* y(k,34) +rxt(k,158)* y(k,58))* y(k,23)
         prod(k,53) = (rxt(k,82)*y(k,21) +.530*rxt(k,115)*y(k,34) + &
                 rxt(k,121)*y(k,36) +rxt(k,150)*y(k,53))*y(k,6) &
                  + (.530*rxt(k,113)*y(k,34) +rxt(k,120)*y(k,36) +rxt(k,141)*y(k,52)) &
                 *y(k,4) + (rxt(k,81)*y(k,21) +.500*rxt(k,87)*y(k,24) + &
                 rxt(k,149)*y(k,53))*y(k,15) + (.260*rxt(k,117)*y(k,34) + &
                 rxt(k,123)*y(k,36))*y(k,11) + (.600*rxt(k,19) +rxt(k,88))*y(k,25) &
                  +.530*rxt(k,118)*y(k,34)*y(k,23) +.300*rxt(k,23)*y(k,32) &
                  +1.340*rxt(k,21)*y(k,33) +2.000*rxt(k,125)*y(k,36)*y(k,36) &
                  +rxt(k,27)*y(k,43) +rxt(k,26)*y(k,44) +rxt(k,32)*y(k,48) +rxt(k,28) &
                 *y(k,53)
         loss(k,20) = (rxt(k,87)* y(k,15) + rxt(k,18) + het_rates(k,6))* y(k,24)
         prod(k,20) = (.700*rxt(k,85)*y(k,23) +.700*rxt(k,122)*y(k,36))*y(k,16)
         loss(k,21) = (rxt(k,165)* y(k,15) + rxt(k,19) + rxt(k,88))* y(k,25)
         prod(k,21) =rxt(k,84)*y(k,23)*y(k,5)
         loss(k,9) = (rxt(k,144)* y(k,15) + het_rates(k,8))* y(k,26)
         prod(k,9) =rxt(k,77)*y(k,18)*y(k,6)
         loss(k,2) = (rxt(k,91)* y(k,15))* y(k,27)
         prod(k,2) = 0.
         loss(k,12) = (rxt(k,101)* y(k,1) +rxt(k,97)* y(k,15))* y(k,28)
         prod(k,12) = 0.
         loss(k,3) = (rxt(k,103)* y(k,15))* y(k,29)
         prod(k,3) = 0.
         loss(k,25) = (rxt(k,164)* y(k,15) + rxt(k,20) + rxt(k,127))* y(k,30)
         prod(k,25) =rxt(k,126)*y(k,36)*y(k,5)
         loss(k,46) = (rxt(k,104)* y(k,4) +rxt(k,105)* y(k,6) +rxt(k,107)* y(k,11) &
                  +rxt(k,106)* y(k,16) +rxt(k,108)* y(k,23))* y(k,31)
         prod(k,46) = (rxt(k,102)*y(k,19) +1.640*rxt(k,128)*y(k,39) + &
                 .500*rxt(k,161)*y(k,60))*y(k,15) +1.700*rxt(k,130)*y(k,39)*y(k,6)
         loss(k,43) = (rxt(k,110)* y(k,1) +rxt(k,109)* y(k,15) + rxt(k,23) &
                  + het_rates(k,9))* y(k,32)
         prod(k,43) = (.320*rxt(k,104)*y(k,4) +.350*rxt(k,105)*y(k,6) + &
                 .260*rxt(k,107)*y(k,11) +.350*rxt(k,108)*y(k,23))*y(k,31) &
                  + (.039*rxt(k,146)*y(k,4) +.039*rxt(k,147)*y(k,6) + &
                 .039*rxt(k,148)*y(k,16))*y(k,56) + (.200*rxt(k,90)*y(k,19) + &
                 .442*rxt(k,129)*y(k,39))*y(k,1) +.402*rxt(k,31)*y(k,60)
         loss(k,42) = (rxt(k,112)* y(k,1) +rxt(k,111)* y(k,15) + rxt(k,21) + rxt(k,22) &
                  + het_rates(k,10))* y(k,33)
         prod(k,42) = (.230*rxt(k,104)*y(k,4) +.250*rxt(k,105)*y(k,6) + &
                 .190*rxt(k,107)*y(k,11) +.250*rxt(k,108)*y(k,23))*y(k,31) &
                  + (.167*rxt(k,146)*y(k,4) +.167*rxt(k,147)*y(k,6) + &
                 .167*rxt(k,148)*y(k,16))*y(k,56) + (.400*rxt(k,90)*y(k,19) + &
                 1.122*rxt(k,129)*y(k,39))*y(k,1) +.288*rxt(k,31)*y(k,60)
         loss(k,44) = ((rxt(k,113) +rxt(k,114))* y(k,4) +rxt(k,115)* y(k,6) &
                  +rxt(k,117)* y(k,11) +rxt(k,116)* y(k,16) +rxt(k,118)* y(k,23)) &
                 * y(k,34)
         prod(k,44) = (rxt(k,109)*y(k,32) +.500*rxt(k,111)*y(k,33) + &
                 .200*rxt(k,119)*y(k,35))*y(k,15)
         loss(k,13) = (rxt(k,119)* y(k,15) + het_rates(k,16))* y(k,35)
         prod(k,13) =rxt(k,116)*y(k,34)*y(k,16)
         loss(k,49) = (rxt(k,120)* y(k,4) +rxt(k,126)* y(k,5) +rxt(k,121)* y(k,6) &
                  +rxt(k,123)* y(k,11) +rxt(k,122)* y(k,16) +rxt(k,124)* y(k,23) &
                  + 2.*rxt(k,125)* y(k,36))* y(k,36)
         prod(k,49) = (.500*rxt(k,111)*y(k,33) +.500*rxt(k,119)*y(k,35) + &
                 .800*rxt(k,167)*y(k,47))*y(k,15) + (rxt(k,20) +rxt(k,127))*y(k,30) &
                  +.200*rxt(k,90)*y(k,19)*y(k,1) +.660*rxt(k,21)*y(k,33)
         loss(k,28) = (rxt(k,92)* y(k,4) +rxt(k,94)* y(k,11) +rxt(k,93)* y(k,16) &
                  + 2.*rxt(k,95)* y(k,37))* y(k,37)
         prod(k,28) = (rxt(k,91)*y(k,27) +.500*rxt(k,96)*y(k,38))*y(k,15)
         loss(k,14) = (rxt(k,96)* y(k,15) + rxt(k,24) + het_rates(k,11))* y(k,38)
         prod(k,14) =rxt(k,93)*y(k,37)*y(k,16)
         loss(k,34) = (rxt(k,129)* y(k,1) +rxt(k,130)* y(k,6) +rxt(k,128)* y(k,15)) &
                 * y(k,39)
         prod(k,34) = 0.
         loss(k,4) = (rxt(k,135)* y(k,15))* y(k,40)
         prod(k,4) = 0.
         loss(k,32) = (rxt(k,136)* y(k,4) +rxt(k,138)* y(k,11) +rxt(k,137)* y(k,16)) &
                 * y(k,41)
         prod(k,32) = (1.330*rxt(k,103)*y(k,29) +rxt(k,135)*y(k,40) + &
                 rxt(k,139)*y(k,42))*y(k,15)
         loss(k,15) = (rxt(k,139)* y(k,15) + rxt(k,25) + het_rates(k,12))* y(k,42)
         prod(k,15) =rxt(k,137)*y(k,41)*y(k,16)
         loss(k,27) = (rxt(k,140)* y(k,15) + rxt(k,27))* y(k,43)
         prod(k,27) = (.820*rxt(k,136)*y(k,4) +.820*rxt(k,138)*y(k,11))*y(k,41) &
                  +.100*rxt(k,128)*y(k,39)*y(k,15) +.820*rxt(k,25)*y(k,42)
         loss(k,16) = (rxt(k,143)* y(k,15) + rxt(k,26) + het_rates(k,13))* y(k,44)
         prod(k,16) =rxt(k,142)*y(k,52)*y(k,16)
         loss(k,22) = (rxt(k,162)* y(k,15) + het_rates(k,20))* y(k,45)
         prod(k,22) = (rxt(k,59)*y(k,11) +.300*rxt(k,94)*y(k,37) + &
                 .250*rxt(k,107)*y(k,31) +.250*rxt(k,117)*y(k,34) + &
                 .300*rxt(k,157)*y(k,58))*y(k,11)
         loss(k,10) = (rxt(k,163)* y(k,15) + het_rates(k,21))* y(k,46)
         prod(k,10) = (.200*rxt(k,94)*y(k,11) +.400*rxt(k,95)*y(k,37))*y(k,37)
         loss(k,30) = (rxt(k,167)* y(k,15) + rxt(k,33) + het_rates(k,22))* y(k,47)
         prod(k,30) = (.530*rxt(k,113)*y(k,4) +.530*rxt(k,115)*y(k,6) + &
                 .260*rxt(k,117)*y(k,11) +.530*rxt(k,118)*y(k,23))*y(k,34) &
                  + (.250*rxt(k,154)*y(k,4) +.250*rxt(k,155)*y(k,6) + &
                 .100*rxt(k,157)*y(k,11) +.250*rxt(k,158)*y(k,23))*y(k,58) +rxt(k,99) &
                 *y(k,50)
         loss(k,41) = (rxt(k,166)* y(k,15) + rxt(k,32) + het_rates(k,23))* y(k,48)
         prod(k,41) = (.220*rxt(k,113)*y(k,4) +.220*rxt(k,115)*y(k,6) + &
                 .230*rxt(k,117)*y(k,11) +.220*rxt(k,118)*y(k,23))*y(k,34) &
                  + (.250*rxt(k,154)*y(k,4) +.250*rxt(k,155)*y(k,6) + &
                 .100*rxt(k,157)*y(k,11) +.250*rxt(k,158)*y(k,23))*y(k,58) &
                  + (.500*rxt(k,80)*y(k,22) +.500*rxt(k,164)*y(k,30))*y(k,15)
         loss(k,19) = (rxt(k,98)* y(k,4))* y(k,49)
         prod(k,19) =.750*rxt(k,97)*y(k,28)*y(k,15)
         loss(k,7) = ( + rxt(k,99) + rxt(k,100))* y(k,50)
         prod(k,7) =rxt(k,98)*y(k,49)*y(k,4)
         loss(k,18) = (rxt(k,153)* y(k,15) + het_rates(k,24))* y(k,51)
         prod(k,18) = (.370*rxt(k,104)*y(k,4) +.400*rxt(k,105)*y(k,6) + &
                 .300*rxt(k,107)*y(k,11) +.400*rxt(k,108)*y(k,23))*y(k,31) &
                  + (rxt(k,151)*y(k,15) +rxt(k,152)*y(k,6))*y(k,57)
         loss(k,33) = (rxt(k,141)* y(k,4) +rxt(k,142)* y(k,16))* y(k,52)
         prod(k,33) = (rxt(k,140)*y(k,43) +rxt(k,143)*y(k,44))*y(k,15)
         loss(k,39) = (rxt(k,150)* y(k,6) +rxt(k,149)* y(k,15) + rxt(k,28) &
                  + het_rates(k,14))* y(k,53)
         prod(k,39) = (.250*rxt(k,113)*y(k,4) +.250*rxt(k,115)*y(k,6) + &
                 .240*rxt(k,117)*y(k,11) +.250*rxt(k,118)*y(k,23))*y(k,34) &
                  + (.250*rxt(k,154)*y(k,4) +.250*rxt(k,155)*y(k,6) + &
                 .100*rxt(k,157)*y(k,11) +.250*rxt(k,158)*y(k,23))*y(k,58) &
                  + (.950*rxt(k,110)*y(k,32) +.800*rxt(k,112)*y(k,33))*y(k,1) &
                  + (rxt(k,144)*y(k,26) +rxt(k,166)*y(k,48))*y(k,15)
         loss(k,38) = (rxt(k,146)* y(k,4) +rxt(k,147)* y(k,6) +rxt(k,148)* y(k,16) &
                  + het_rates(k,26))* y(k,56)
         prod(k,38) =rxt(k,145)*y(k,19)*y(k,6)
         loss(k,35) = (rxt(k,152)* y(k,6) +rxt(k,151)* y(k,15) + rxt(k,30) &
                  + het_rates(k,18))* y(k,57)
         prod(k,35) = (.080*rxt(k,104)*y(k,31) +rxt(k,114)*y(k,34) + &
                 .794*rxt(k,146)*y(k,56))*y(k,4) + (.794*rxt(k,147)*y(k,6) + &
                 .794*rxt(k,148)*y(k,16))*y(k,56)
         loss(k,45) = (rxt(k,154)* y(k,4) +rxt(k,155)* y(k,6) +rxt(k,157)* y(k,11) &
                  +rxt(k,156)* y(k,16) +rxt(k,158)* y(k,23))* y(k,58)
         prod(k,45) = (rxt(k,153)*y(k,51) +rxt(k,159)*y(k,59) + &
                 .500*rxt(k,161)*y(k,60))*y(k,15)
         loss(k,8) = ((rxt(k,159) +rxt(k,160))* y(k,15) + rxt(k,29) + het_rates(k,17)) &
                 * y(k,59)
         prod(k,8) = (rxt(k,148)*y(k,56) +rxt(k,156)*y(k,58))*y(k,16)
         loss(k,26) = (rxt(k,161)* y(k,15) + rxt(k,31) + het_rates(k,19))* y(k,60)
         prod(k,26) =rxt(k,106)*y(k,31)*y(k,16)
      end do
      end subroutine imp_prod_loss
      end module mo_imp_prod_loss
