      module mo_setrxt
      private
      public :: setrxt
      public :: vexp
      contains
      subroutine setrxt( rate, temp, m, plonl )
      use mo_grid,      only : plnplv
      use pmgrid,       only : plev
      use mo_chem_mods, only : rxntot
      use mo_jpl,       only : jpl
      implicit none
!-------------------------------------------------------
! ... Dummy arguments
!-------------------------------------------------------
      integer, intent(in) :: plonl
      real, intent(in) :: temp(plonl,plev), m(plonl,plev)
      real, intent(inout) :: rate(plonl,plev,rxntot)
!-------------------------------------------------------
! ... Local variables
!-------------------------------------------------------
      integer :: n
      real :: itemp(plonl,plev), exp_fac(plonl,plev)
      real, dimension(plonl,plev) :: ko, kinf
      rate(:,:,38) = 2.2e-10
      rate(:,:,39) = 6.7e-11
      rate(:,:,40) = 4.9e-11
      rate(:,:,48) = 0.
      rate(:,:,56) = 1.5e-10
      rate(:,:,63) = 1e-11
      rate(:,:,65) = 1.1e-10
      rate(:,:,87) = 1e-12
      rate(:,:,94) = 2.e-13
      rate(:,:,95) = 6.8e-14
      rate(:,:,99) = 1.e-14
      rate(:,:,105) = 2.4e-12
      rate(:,:,108) = 1.4e-11
      rate(:,:,115) = 2.4e-12
      rate(:,:,118) = 1.4e-11
      rate(:,:,121) = 5.e-12
      rate(:,:,144) = 6.8e-13
      rate(:,:,147) = 2.4e-12
      rate(:,:,151) = 1.5e-11
      rate(:,:,155) = 2.4e-12
      rate(:,:,165) = 4.e-14
      rate(:,:,166) = 3.e-12
      rate(:,:,167) = 1.e-11
      rate(:,:,168) = 2.1e-6
      itemp(:,:) = 1. / temp(:,:)
      n = plonl*plev
      call vexp( exp_fac, -2060.*itemp, n )
      rate(:,:,35) = 8e-12 * exp_fac(:,:)
      call vexp( exp_fac, 110.*itemp, n )
      rate(:,:,36) = 1.8e-11 * exp_fac(:,:)
      call vexp( exp_fac, 70.*itemp, n )
      rate(:,:,37) = 3.2e-11 * exp_fac(:,:)
      call vexp( exp_fac, 250. * itemp, n )
      rate(:,:,41) = 3.5e-12 * exp_fac(:,:)
      rate(:,:,72) = 4.8e-11 * exp_fac(:,:)
      call vexp( exp_fac, -1500.*itemp, n )
      rate(:,:,42) = 3e-12 * exp_fac(:,:)
      call vexp( exp_fac, 180. * itemp, n )
      rate(:,:,43) = 5.6e-12 * exp_fac(:,:)
      rate(:,:,78) = 4.2e-12 * exp_fac(:,:)
      rate(:,:,98) = 4.2e-12 * exp_fac(:,:)
      rate(:,:,104) = 2.2e-12 * exp_fac(:,:)
      rate(:,:,136) = 4.2e-12 * exp_fac(:,:)
      rate(:,:,141) = 4.2e-12 * exp_fac(:,:)
      call vexp( exp_fac, -2450.*itemp, n )
      rate(:,:,44) = 1.2e-13 * exp_fac(:,:)
      call vexp( exp_fac, 170. * itemp, n )
      rate(:,:,45) = 2.3e-12 * exp_fac(:,:)
      rate(:,:,51) = 1.5e-11 * exp_fac(:,:)
      call vexp( exp_fac, 380.*itemp, n )
      rate(:,:,53) = 1.3e-12 * exp_fac(:,:)
      call vexp( exp_fac, -1775.*itemp, n )
!zf      rate(:,:,55) = 2.45e-12 * exp_fac(:,:)
!     rate(:,:,55) = 2.45e-12 * exp_fac(:,:)*3.72  !1.47 zftest 20160803
      rate(:,:,55) = 2.45e-12 * exp_fac(:,:)*3.60  !1.47 zftest 20160803

      call vexp( exp_fac, 280.*itemp, n )
      rate(:,:,57) = 3.e-12 * exp_fac(:,:)
      call vexp( exp_fac, -424.*itemp, n )
      rate(:,:,58) = 5.e-13 * exp_fac(:,:)
      call vexp( exp_fac, 706.*itemp, n )
      rate(:,:,59) = 1.9e-14 * exp_fac(:,:)
      call vexp( exp_fac, 800.*itemp, n )
      rate(:,:,60) = 3.8e-13 * exp_fac(:,:)
      call vexp( exp_fac, 200. * itemp, n )
      rate(:,:,61) = 3.8e-12 * exp_fac(:,:)
      rate(:,:,67) = 3e-11 * exp_fac(:,:)
      rate(:,:,80) = 3.8e-12 * exp_fac(:,:)
      rate(:,:,96) = 3.8e-12 * exp_fac(:,:)
      rate(:,:,119) = 2.3e-11 * exp_fac(:,:)
      rate(:,:,139) = 3.8e-12 * exp_fac(:,:)
      rate(:,:,143) = 3.8e-12 * exp_fac(:,:)
      rate(:,:,161) = 3.8e-12 * exp_fac(:,:)
      call vexp( exp_fac, -2058.*itemp, n )
      rate(:,:,62) = 6.0e-13 * exp_fac(:,:)
      call vexp( exp_fac, 120.*itemp, n )
      rate(:,:,66) = 2.2e-11 * exp_fac(:,:)
      call vexp( exp_fac, -880.*itemp, n )
      rate(:,:,68) = 1.5e-12 * exp_fac(:,:)
      call vexp( exp_fac, -680.*itemp, n )
      rate(:,:,69) = 2e-14 * exp_fac(:,:)
      call vexp( exp_fac, -160.*itemp, n )
      rate(:,:,71) = 2.9e-12 * exp_fac(:,:)
      call vexp( exp_fac, -240.*itemp, n )
      rate(:,:,73) = 4.2e-12 * exp_fac(:,:)
      call vexp( exp_fac, -2000. * itemp, n )
      rate(:,:,74) = 5.5e-12 * exp_fac(:,:)
      rate(:,:,90) = 1.05e-14 * exp_fac(:,:)
      call vexp( exp_fac, -1900. * itemp, n )
      rate(:,:,76) = 6.5e-15 * exp_fac(:,:)
      rate(:,:,82) = 1.4e-12 * exp_fac(:,:)
      call vexp( exp_fac, -1156.*itemp, n )
      rate(:,:,77) = 4.6e-13 * exp_fac(:,:)
      call vexp( exp_fac, 700. * itemp, n )
      rate(:,:,79) = 7.5e-13 * exp_fac(:,:)
      rate(:,:,93) = 7.5e-13 * exp_fac(:,:)
      rate(:,:,106) = 8.e-13 * exp_fac(:,:)
      rate(:,:,116) = 8.e-13 * exp_fac(:,:)
      rate(:,:,137) = 7.5e-13 * exp_fac(:,:)
      rate(:,:,142) = 7.5e-13 * exp_fac(:,:)
      rate(:,:,148) = 8.e-13 * exp_fac(:,:)
      rate(:,:,156) = 8.e-13 * exp_fac(:,:)
      call vexp( exp_fac, 270. * itemp, n )
      rate(:,:,81) = 5.6e-12 * exp_fac(:,:)
      rate(:,:,83) = 8.1e-12 * exp_fac(:,:)
      call vexp( exp_fac, 1040. * itemp, n )
      rate(:,:,85) = 4.3e-13 * exp_fac(:,:)
      rate(:,:,122) = 4.30e-13 * exp_fac(:,:)
      call vexp( exp_fac, 640. * itemp, n )
      rate(:,:,86) = 1.3e-12 * exp_fac(:,:)
      rate(:,:,123) = 1.3e-12 * exp_fac(:,:)
      rate(:,:,158) = 1.3e-12 * exp_fac(:,:)
      call vexp( exp_fac, 500.*itemp, n )
      rate(:,:,89) = 2.5e-12 * exp_fac(:,:)
      call vexp( exp_fac, -1070.*itemp, n )
      rate(:,:,91) = 8.7e-12 * exp_fac(:,:)
      call vexp( exp_fac, 365.*itemp, n )
      rate(:,:,92) = 2.6e-12 * exp_fac(:,:)
      call vexp( exp_fac, -4150.*itemp, n )
      rate(:,:,100) = 1.6e11 * exp_fac(:,:)
      call vexp( exp_fac, -2630.*itemp, n )
      rate(:,:,101) = 1.2e-14 * exp_fac(:,:)
      call vexp( exp_fac, 410.*itemp, n )
      rate(:,:,102) = 2.54e-11 * exp_fac(:,:)
      call vexp( exp_fac, -540.*itemp, n )
      rate(:,:,103) = 1.55e-11 * exp_fac(:,:)
      call vexp( exp_fac, 400. * itemp, n )
      rate(:,:,107) = 5.e-13 * exp_fac(:,:)
      rate(:,:,117) = 5.e-13 * exp_fac(:,:)
      rate(:,:,157) = 5.e-13 * exp_fac(:,:)
      call vexp( exp_fac, 452.*itemp, n )
      rate(:,:,109) = 4.13e-12 * exp_fac(:,:)
      call vexp( exp_fac, -1521.*itemp, n )
      rate(:,:,110) = 7.52e-16 * exp_fac(:,:)
      call vexp( exp_fac, 175. * itemp, n )
      rate(:,:,111) = 1.86e-11 * exp_fac(:,:)
      rate(:,:,153) = 1.86e-11 * exp_fac(:,:)
      call vexp( exp_fac, -2500.*itemp, n )
      rate(:,:,112) = 4.4e-15 * exp_fac(:,:)
      call vexp( exp_fac, 360. * itemp, n )
      rate(:,:,113) = 2.7e-12 * exp_fac(:,:)
      rate(:,:,114) = 1.3e-13 * exp_fac(:,:)
      rate(:,:,120) = 5.3e-12 * exp_fac(:,:)
      rate(:,:,146) = 2.7e-12 * exp_fac(:,:)
      rate(:,:,154) = 2.7e-12 * exp_fac(:,:)
      call vexp( exp_fac, 530. * itemp, n )
      rate(:,:,124) = 4.6e-12 * exp_fac(:,:)
      rate(:,:,125) = 2.3e-12 * exp_fac(:,:)
      call vexp( exp_fac, 444.*itemp, n )
      rate(:,:,128) = 1.2e-11 * exp_fac(:,:)
      call vexp( exp_fac, -730.*itemp, n )
      rate(:,:,129) = 9.9e-15 * exp_fac(:,:)
      call vexp( exp_fac, -650.*itemp, n )
      rate(:,:,130) = 5.6e-11 * exp_fac(:,:)
      call vexp( exp_fac, -3600.*itemp, n )
      rate(:,:,133) = 1.5e-11 * exp_fac(:,:)
      call vexp( exp_fac, 100.*itemp, n )
      rate(:,:,134) = 2.1e-11 * exp_fac(:,:)
      call vexp( exp_fac, -660.*itemp, n )
      rate(:,:,135) = 1.0e-11 * exp_fac(:,:)
      call vexp( exp_fac, -40.*itemp, n )
      rate(:,:,138) = 3.75e-13 * exp_fac(:,:)
      call vexp( exp_fac, -446.*itemp, n )
      rate(:,:,145) = 3.03e-12 * exp_fac(:,:)
      call vexp( exp_fac, 830.*itemp, n )
      rate(:,:,149) = 8.4e-13 * exp_fac(:,:)
      call vexp( exp_fac, -1860. * itemp, n )
      rate(:,:,150) = 1.4e-12 * exp_fac(:,:)
      rate(:,:,152) = 1.4e-12 * exp_fac(:,:)
      call vexp( exp_fac, 190.*itemp, n )
      rate(:,:,159) = 1.90e-12 * exp_fac(:,:)
      call vexp( exp_fac, -600.*itemp, n )
      rate(:,:,162) = 6.7e-12 * exp_fac(:,:)
      call vexp( exp_fac, -235.*itemp, n )
      rate(:,:,163) = 7.e-12 * exp_fac(:,:)
      itemp(:,:) = 300. * itemp(:,:)
      ko(:,:) = 2.e-30 * itemp(:,:)**4.4
      kinf(:,:) = 1.4e-12 * itemp(:,:)**.7
      call jpl( rate(1,1,46), m, .6, ko, kinf, plnplv )
      ko(:,:) = 2.4e-30 * itemp(:,:)**3.1
      kinf(:,:) = 1.7e-11 * itemp(:,:)**2.1
      call jpl( rate(1,1,49), m, .6, ko, kinf, plnplv )
      ko(:,:) = 1.8e-31 * itemp(:,:)**3.2
      kinf(:,:) = 4.7e-12 * itemp(:,:)**1.4
      call jpl( rate(1,1,52), m, .6, ko, kinf, plnplv )
      ko(:,:) = 8.e-27 * itemp(:,:)**3.5
      kinf(:,:) = 3.e-11
      call jpl( rate(1,1,75), m, .5, ko, kinf, plnplv )
      ko(:,:) = 8.5e-29 * itemp(:,:)**6.5
      kinf(:,:) = 1.1e-11 * itemp(:,:)
      call jpl( rate(1,1,84), m, .6, ko, kinf, plnplv )
      ko(:,:) = 1.e-28 * itemp(:,:)**.8
      kinf(:,:) = 8.8e-12
      call jpl( rate(1,1,97), m, .6, ko, kinf, plnplv )
      ko(:,:) = 8.e-27 * itemp(:,:)**3.5
      kinf(:,:) = 3.e-11
      call jpl( rate(1,1,164), m, .5, ko, kinf, plnplv )
      end subroutine setrxt

      subroutine vexp (y, x , n)
         integer :: n,i
         real:: y(n),x(n)

         do i=1,n
            y(i)=exp(x(i))
         enddo
      
      end subroutine vexp

      end module mo_setrxt
