      module chem_mods
!--------------------------------------------------------------
! ... Basic chemistry parameters and arrays
!--------------------------------------------------------------

      use shr_kind_mod, only : r8 => shr_kind_r8
      use constituents, only: ppcnst

      implicit none

      save

      integer, parameter :: hetcnt = 12, & ! number of heterogeneous processes
                            phtcnt = 72, & ! number of photolysis reactions
                            rxntot = 221, & ! number of total reactions
                            gascnt = 149, & ! number of gas phase reactions
                            nabscol = 2, & ! number of absorbing column densities
                            gas_pcnst = 57, & ! number of "gas phase" species
                            nfs = 2, & ! number of "fixed" species
                            relcnt = 0, & ! number of relationship species
                            grpcnt = 0, & ! number of group members
                            nzcnt = 481, & ! number of non-zero matrix entries
                            extcnt = 9, & ! number of species with external forcing
                            clscnt1 = 15, & ! number of species in explicit class
                            clscnt2 = 0, & ! number of species in hov class
                            clscnt3 = 0, & ! number of species in ebi class
                            clscnt4 = 42, & ! number of species in implicit class
                            clscnt5 = 0, & ! number of species in rodas class
                            indexm = 1, & ! index of total atm density in invariant array
                            indexh2o = 0, & ! index of water vapor density
                            clsze = 4 ! loop length for implicit chemistry

      integer :: clscnt(5)
      integer :: cls_rxt_cnt(4,5)
      integer :: clsmap(gas_pcnst,5)
      integer :: permute(gas_pcnst,5)

      integer :: diag_map(clscnt4)
      real(r8) :: adv_mass(gas_pcnst)

      integer :: imozart
      integer :: map2chm(ppcnst)
      end module chem_mods
