
      module mag_parms

      use shr_kind_mod,   only : r8 => shr_kind_r8
      use mo_solar_parms, only : get_solar_parms

      implicit none

      private
      public :: get_mag_parms

      contains

      subroutine get_mag_parms( by, bz, hpower, ctpoten )
!---------------------------------------------------------------
!	... retrieve magnetic field parmaters
!---------------------------------------------------------------

      implicit none

!---------------------------------------------------------------
!	... dummy arguments
!---------------------------------------------------------------
      real(r8), optional, intent(out) :: by
      real(r8), optional, intent(out) :: bz
      real(r8), optional, intent(out) :: hpower
      real(r8), optional, intent(out) :: ctpoten

!---------------------------------------------------------------
!	... local variables
!---------------------------------------------------------------
      real(r8) :: wkp                                             ! wrk solar mag factor
      real(r8) :: wf107                                           ! wrk solar mag factor

      call get_solar_parms( kp_s = wkp, f107_s = wf107 )
      if( present( by ) ) then
         by  =  0._r8
      end if
      if( present( bz ) ) then
         bz = .433726_r8 - wkp*(.0849999_r8*wkp + .0810363_r8) &
              + wf107*(.00793738_r8 - .00219316_r8*wkp)
      end if
      if( present( hpower ) ) then
	 hpower = max( 3._r8,-2.78_r8 + 9.39_r8*wkp )
      end if
      if( present( ctpoten ) ) then
	 ctpoten = 29._r8 + 11._r8 * wkp
      end if

      end subroutine get_mag_parms

      end module mag_parms
