      module mo_indprd

      use shr_kind_mod, only : r8 => shr_kind_r8

      private
      public :: indprd

      contains

      subroutine indprd( class, prod, nprod, y, extfrc, rxt, ncol )

      use chem_mods, only : gas_pcnst, extcnt, rxntot
      use ppgrid, only : pver

      implicit none

!--------------------------------------------------------------------
! ... dummy arguments
!--------------------------------------------------------------------
      integer, intent(in) :: class
      integer, intent(in) :: ncol
      integer, intent(in) :: nprod
      real(r8), intent(in) :: y(ncol,pver,gas_pcnst)
      real(r8), intent(in) :: rxt(ncol,pver,rxntot)
      real(r8), intent(in) :: extfrc(ncol,pver,extcnt)
      real(r8), intent(inout) :: prod(ncol,pver,nprod)

!--------------------------------------------------------------------
! ... "independent" production for Explicit species
!--------------------------------------------------------------------
      if( class == 1 ) then
         prod(:,:,1) = 0._r8

         prod(:,:,2) = 0._r8

         prod(:,:,3) = (rxt(:,:,17) +rxt(:,:,18) +rxt(:,:,127)*y(:,:,11) + &
                 rxt(:,:,128)*y(:,:,22) +rxt(:,:,129)*y(:,:,2) + &
                 rxt(:,:,152)*y(:,:,25) +rxt(:,:,175)*y(:,:,34))*y(:,:,18) &
                  + extfrc(:,:,2)

         prod(:,:,4) =rxt(:,:,18)*y(:,:,18) +rxt(:,:,134)*y(:,:,23)*y(:,:,21) &
                  +rxt(:,:,20)*y(:,:,57)

         prod(:,:,5) = 0._r8

         prod(:,:,6) = 0._r8

         prod(:,:,7) = 0._r8

         prod(:,:,8) = 0._r8

         prod(:,:,9) = 0._r8

         prod(:,:,10) = 0._r8

         prod(:,:,11) = 0._r8

         prod(:,:,12) = 0._r8

         prod(:,:,13) = 0._r8

         prod(:,:,14) = 0._r8

         prod(:,:,15) = 0._r8

!--------------------------------------------------------------------
! ... "independent" production for Implicit species
!--------------------------------------------------------------------
      else if( class == 4 ) then
         prod(:,:,40) = 0._r8

         prod(:,:,32) =.180_r8*rxt(:,:,47)*y(:,:,15) +rxt(:,:,45)*y(:,:,49)

         prod(:,:,41) =rxt(:,:,5)*y(:,:,7)

         prod(:,:,27) = 0._r8

         prod(:,:,3) = 0._r8

         prod(:,:,2) = 0._r8

         prod(:,:,20) = (rxt(:,:,57) +.800_r8*rxt(:,:,60) +rxt(:,:,69) + &
                 .800_r8*rxt(:,:,72)) + extfrc(:,:,8)

         prod(:,:,33) = + extfrc(:,:,1)

         prod(:,:,35) = 0._r8

         prod(:,:,39) =.660_r8*rxt(:,:,47)*y(:,:,15)

         prod(:,:,34) = 0._r8

         prod(:,:,18) = 0._r8

         prod(:,:,11) = 0._r8

         prod(:,:,7) = 0._r8

         prod(:,:,23) =rxt(:,:,46)*y(:,:,15) +rxt(:,:,35)*y(:,:,39) +rxt(:,:,42) &
                 *y(:,:,40)

         prod(:,:,10) = 0._r8

         prod(:,:,28) =.180_r8*rxt(:,:,47)*y(:,:,15)

         prod(:,:,29) =rxt(:,:,46)*y(:,:,15)

         prod(:,:,37) = 0._r8

         prod(:,:,16) = 0._r8

         prod(:,:,26) =.050_r8*rxt(:,:,47)*y(:,:,15)

         prod(:,:,42) =rxt(:,:,35)*y(:,:,39) +3.000_r8*rxt(:,:,38)*y(:,:,41) &
                  +2.000_r8*rxt(:,:,39)*y(:,:,42) +3.000_r8*rxt(:,:,40)*y(:,:,43) &
                  +rxt(:,:,41)*y(:,:,44) +4.000_r8*rxt(:,:,36)*y(:,:,45) &
                  +3.000_r8*rxt(:,:,37)*y(:,:,46) +rxt(:,:,44)*y(:,:,48)

         prod(:,:,5) = 0._r8

         prod(:,:,31) = 0._r8

         prod(:,:,4) = 0._r8

         prod(:,:,1) = 0._r8

         prod(:,:,38) = 0._r8

         prod(:,:,24) = 0._r8

         prod(:,:,25) = 0._r8

         prod(:,:,6) = 0._r8

         prod(:,:,36) =rxt(:,:,42)*y(:,:,40) +rxt(:,:,43)*y(:,:,47) +rxt(:,:,44) &
                 *y(:,:,48)

         prod(:,:,30) = 0._r8

         prod(:,:,8) = 0._r8

         prod(:,:,13) = 0._r8

         prod(:,:,9) = 0._r8

         prod(:,:,17) = (rxt(:,:,53) +rxt(:,:,65)) + extfrc(:,:,6)

         prod(:,:,19) = + extfrc(:,:,4)

         prod(:,:,12) = (rxt(:,:,57) +rxt(:,:,58) +rxt(:,:,69) +rxt(:,:,70)) &
                  + extfrc(:,:,5)

         prod(:,:,14) = + extfrc(:,:,3)

         prod(:,:,21) = 0._r8

         prod(:,:,15) = (rxt(:,:,58) +1.200_r8*rxt(:,:,60) +rxt(:,:,70) + &
                 1.200_r8*rxt(:,:,72)) + extfrc(:,:,7)

         prod(:,:,22) = (rxt(:,:,53) +rxt(:,:,57) +rxt(:,:,58) +rxt(:,:,65) + &
                 rxt(:,:,69) +rxt(:,:,70)) + extfrc(:,:,9)

      end if

      end subroutine indprd

      end module mo_indprd
