      module mo_lin_matrix

      private
      public :: linmat

      contains

      subroutine linmat01( mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------

      use chem_mods, only : gas_pcnst, rxntot, hetcnt, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(in) :: het_rates(max(1,hetcnt))
      real(r8), intent(inout) :: mat(nzcnt)

         mat(441) = -( rxt(3) + rxt(4) )

         mat(268) = -( rxt(48) + rxt(49) + rxt(50) + rxt(61) + rxt(62) + rxt(63) )
         mat(178) = rxt(1) + 2.000_r8*rxt(2) + rxt(54) + rxt(55) + rxt(56) &
                      + 2.000_r8*rxt(59) + rxt(66) + rxt(67) + rxt(68) + 2.000_r8*rxt(71)
         mat(433) = rxt(4)
         mat(290) = rxt(6)
         mat(329) = rxt(8)
         mat(19) = rxt(10)
         mat(307) = rxt(12)
         mat(163) = rxt(21)
         mat(11) = rxt(24)
         mat(216) = rxt(31)
         mat(450) = rxt(76)

         mat(459) = -( rxt(76) + rxt(80)*y(7) + rxt(81)*y(7) + rxt(83)*y(41) &
                      + rxt(84)*y(42) + rxt(85)*y(43) + rxt(86)*y(44) + rxt(87)*y(15) &
                      + rxt(88)*y(15) + rxt(89)*y(15) + rxt(90)*y(20) )
         mat(182) = rxt(1)
         mat(442) = rxt(3)
         mat(165) = rxt(20)

         mat(176) = -( rxt(1) + rxt(2) + rxt(52) + rxt(54) + rxt(55) + rxt(56) + rxt(59) &
                      + rxt(64) + rxt(66) + rxt(67) + rxt(68) + rxt(71) )
         mat(429) = rxt(4)
         mat(304) = rxt(13)
         mat(8) = rxt(97)
         mat(5) = rxt(100) + rxt(101)
         mat(447) = rxt(81)*y(7)

         mat(7) = -( rxt(94) + rxt(97) + rxt(96)*y(49) )

         mat(4) = -( rxt(100) + rxt(101) )
         mat(427) = rxt(3)
         mat(6) = rxt(94) + rxt(96)*y(49)

         mat(106) = -( rxt(51) )
         mat(280) = rxt(6)
         mat(63) = rxt(209)

         mat(291) = -( rxt(6) + rxt(7) )
         mat(330) = rxt(8)
         mat(20) = rxt(10)
         mat(308) = rxt(13)
         mat(101) = rxt(217)
         mat(451) = 2.000_r8*rxt(80)*y(7)

         mat(332) = -( rxt(8) )
         mat(22) = rxt(9) + rxt(113)
         mat(93) = rxt(11)
         mat(310) = rxt(12)
         mat(44) = rxt(15) + rxt(122)
         mat(157) = rxt(29)
         mat(32) = rxt(34)

         mat(423) = -( rxt(123)*y(15) + rxt(130)*y(19) + rxt(141)*y(20) + rxt(187)*y(39) &
                      + rxt(188)*y(46) + rxt(189)*y(44) + rxt(190)*y(40) )
         mat(94) = rxt(11)
         mat(46) = rxt(14)
         mat(39) = rxt(16)
         mat(164) = rxt(19)
         mat(77) = 2.000_r8*rxt(22)
         mat(147) = rxt(26)
         mat(59) = rxt(32)
         mat(457) = rxt(87)*y(15) + rxt(90)*y(20)

         mat(309) = -( rxt(12) + rxt(13) )
         mat(21) = rxt(9) + rxt(10) + rxt(113)
         mat(43) = rxt(14)
         mat(156) = rxt(28)
         mat(31) = rxt(33)

         mat(90) = -( rxt(11) + het_rates(2) )
         mat(18) = 2.000_r8*rxt(191) + 2.000_r8*rxt(197) + 2.000_r8*rxt(202)
         mat(150) = rxt(192) + rxt(198) + rxt(203)
         mat(29) = rxt(193) + rxt(201) + rxt(204)

         mat(40) = -( rxt(14) + rxt(15) + rxt(122) + het_rates(5) )

         mat(17) = -( rxt(9) + rxt(10) + rxt(113) + rxt(191) + rxt(197) + rxt(202) &
                 + het_rates(9) )

         mat(445) = rxt(87)*y(15)
         mat(407) = rxt(123)*y(15)
         mat(463) = rxt(153)*y(15)

         mat(34) = -( rxt(16) + het_rates(4) )

         mat(186) = -( rxt(17) + rxt(18) + het_rates(3) )
         mat(37) = rxt(16)
         mat(448) = rxt(88)*y(15) + rxt(89)*y(15)

         mat(38) = rxt(16)
         mat(187) = 2.000_r8*rxt(17)
         mat(162) = rxt(19) + 2.000_r8*rxt(21)
         mat(389) = rxt(27)
         mat(449) = rxt(88)*y(15) + rxt(90)*y(20)
         mat(413) = rxt(130)*y(19) + rxt(141)*y(20)
         mat(469) = rxt(148)*y(20)

         mat(45) = rxt(15) + rxt(122)
         mat(455) = rxt(88)*y(15)
         mat(476) = rxt(186)*y(39)
         mat(421) = rxt(187)*y(39) + rxt(190)*y(40)

         mat(72) = -( rxt(22) + het_rates(1) )

         mat(161) = -( rxt(19) + rxt(20) + rxt(21) )
         mat(410) = rxt(123)*y(15) + rxt(141)*y(20) + rxt(187)*y(39) + rxt(188)*y(46) &
                      + rxt(189)*y(44) + rxt(190)*y(40)

         mat(481) = -( rxt(148)*y(20) + rxt(153)*y(15) + rxt(186)*y(39) )
         mat(13) = 2.000_r8*rxt(23)
         mat(3) = 2.000_r8*rxt(25)
         mat(148) = rxt(26)
         mat(401) = rxt(27)
         mat(160) = rxt(28)
         mat(16) = rxt(30)
         mat(460) = 3.000_r8*rxt(83)*y(41) + 2.000_r8*rxt(84)*y(42) &
                      + 3.000_r8*rxt(85)*y(43) + rxt(86)*y(44)
         mat(426) = rxt(187)*y(39) + 3.000_r8*rxt(188)*y(46) + rxt(189)*y(44)

         mat(12) = -( rxt(23) )

         mat(10) = rxt(24)
         mat(154) = rxt(29)
         mat(2) = 2.000_r8*rxt(164)

         mat(9) = -( rxt(24) )

         mat(1) = -( rxt(25) + rxt(164) )

         mat(397) = -( rxt(27) + het_rates(8) )
         mat(477) = rxt(148)*y(20) + rxt(153)*y(15) + 2.000_r8*rxt(186)*y(39)

         mat(142) = -( rxt(26) + het_rates(10) )
         mat(151) = rxt(192) + rxt(198) + rxt(203)

         mat(152) = -( rxt(28) + rxt(29) + rxt(192) + rxt(198) + rxt(203) + het_rates(6) &
       )

         mat(14) = -( rxt(30) )

         mat(15) = rxt(30)
         mat(220) = rxt(31)
         mat(57) = rxt(32)
         mat(33) = rxt(33)
         mat(420) = rxt(190)*y(40)

         mat(214) = -( rxt(31) )
         mat(30) = rxt(34)

         mat(23) = -( het_rates(12) )

         mat(55) = -( rxt(32) + het_rates(11) )
         mat(28) = rxt(193) + rxt(201) + rxt(204)

         mat(27) = -( rxt(33) + rxt(34) + rxt(193) + rxt(201) + rxt(204) + het_rates(7) )


         mat(95) = -( rxt(217) )
         mat(172) = rxt(52) + rxt(64)

         mat(103) = rxt(51)

         mat(61) = -( rxt(209) )
         mat(252) = rxt(48) + rxt(49) + rxt(50) + rxt(61) + rxt(62) + rxt(63)
         mat(169) = rxt(54) + rxt(55) + rxt(56) + rxt(66) + rxt(67) + rxt(68)

         mat(281) = rxt(7)
         mat(64) = rxt(209)
         mat(97) = rxt(217)


         mat(282) = rxt(7)
         mat(259) = rxt(48) + rxt(49) + rxt(50) + rxt(61) + rxt(62) + rxt(63)
         mat(108) = rxt(51)
         mat(175) = rxt(52) + rxt(54) + rxt(55) + rxt(56) + rxt(64) + rxt(66) + rxt(67) &
                      + rxt(68)


      end subroutine linmat01

      subroutine linmat( mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------

      use chem_mods, only : gas_pcnst, rxntot, hetcnt, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(in) :: het_rates(max(1,hetcnt))
      real(r8), intent(inout) :: mat(nzcnt)

      call linmat01( mat, y, rxt, het_rates )

      end subroutine linmat

      end module mo_lin_matrix
