      module mo_nln_matrix

      use shr_kind_mod, only : r8 => shr_kind_r8

      private
      public :: nlnmat

      contains

      subroutine nlnmat01( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(441) = -(rxt(74)*y(2) + rxt(82)*y(3) + rxt(108)*y(9) + rxt(111)*y(10) &
                      + rxt(132)*y(21) + rxt(137)*y(22) + rxt(144)*y(23) + rxt(147) &
                      *y(25) + rxt(173)*y(34))
         mat(276) = -rxt(74)*y(1)
         mat(458) = -rxt(82)*y(1)
         mat(298) = -rxt(108)*y(1)
         mat(337) = -rxt(111)*y(1)
         mat(204) = -rxt(132)*y(1)
         mat(424) = -rxt(137)*y(1)
         mat(379) = -rxt(144)*y(1)
         mat(479) = -rxt(147)*y(1)
         mat(355) = -rxt(173)*y(1)

         mat(276) = mat(276) + rxt(73)*y(4)
         mat(181) = rxt(73)*y(2)

         mat(268) = -(rxt(73)*y(4) + rxt(74)*y(1) + 4._r8*rxt(75)*y(2) + rxt(106)*y(9) &
                      + (rxt(109) + rxt(110)) * y(10) + rxt(117)*y(11) + rxt(129) &
                      *y(18) + rxt(136)*y(22) + rxt(143)*y(23) + rxt(146)*y(24) &
                      + rxt(154)*y(27) + rxt(166)*y(30) + rxt(167)*y(31) + rxt(170) &
                      *y(32) + rxt(176)*y(35) + (rxt(210) + rxt(218)) * y(50) + rxt(215) &
                      *y(52))
         mat(178) = -rxt(73)*y(2)
         mat(433) = -rxt(74)*y(2)
         mat(290) = -rxt(106)*y(2)
         mat(329) = -(rxt(109) + rxt(110)) * y(2)
         mat(307) = -rxt(117)*y(2)
         mat(188) = -rxt(129)*y(2)
         mat(416) = -rxt(136)*y(2)
         mat(371) = -rxt(143)*y(2)
         mat(74) = -rxt(146)*y(2)
         mat(238) = -rxt(154)*y(2)
         mat(391) = -rxt(166)*y(2)
         mat(145) = -rxt(167)*y(2)
         mat(155) = -rxt(170)*y(2)
         mat(216) = -rxt(176)*y(2)
         mat(87) = -(rxt(210) + rxt(218)) * y(2)
         mat(53) = -rxt(215)*y(2)

         mat(450) = (rxt(77)+rxt(78))*y(4)
         mat(178) = mat(178) + (rxt(77)+rxt(78))*y(3) + rxt(104)*y(8) + rxt(214)*y(52) &
                      + rxt(208)*y(53)
         mat(110) = rxt(104)*y(4) + rxt(105)*y(9) + rxt(211)*y(51)
         mat(290) = mat(290) + rxt(105)*y(8)
         mat(416) = mat(416) + 2.000_r8*rxt(139)*y(22)
         mat(200) = rxt(135)*y(23)
         mat(371) = mat(371) + rxt(135)*y(21)
         mat(100) = rxt(211)*y(8) + 1.150_r8*rxt(220)*y(55)
         mat(53) = mat(53) + rxt(214)*y(4)
         mat(66) = rxt(208)*y(4)
         mat(118) = rxt(219)*y(55)
         mat(128) = 1.150_r8*rxt(220)*y(51) + rxt(219)*y(54)

         mat(459) = -((rxt(77) + rxt(78)) * y(4) + rxt(79)*y(57) + rxt(82)*y(1) + rxt(91) &
                      *y(30))
         mat(182) = -(rxt(77) + rxt(78)) * y(3)
         mat(165) = -rxt(79)*y(3)
         mat(442) = -rxt(82)*y(3)
         mat(400) = -rxt(91)*y(3)

         mat(182) = mat(182) + rxt(102)*y(56)
         mat(102) = .850_r8*rxt(220)*y(55)
         mat(71) = rxt(102)*y(4)
         mat(130) = .850_r8*rxt(220)*y(51)

         mat(176) = -(rxt(73)*y(2) + rxt(77)*y(3) + rxt(99)*y(6) + rxt(102)*y(56) &
                      + rxt(104)*y(8) + rxt(131)*y(21) + rxt(208)*y(53) + (rxt(213) &
                      + rxt(214)) * y(52) + rxt(216)*y(50))
         mat(263) = -rxt(73)*y(4)
         mat(447) = -rxt(77)*y(4)
         mat(5) = -rxt(99)*y(4)
         mat(69) = -rxt(102)*y(4)
         mat(109) = -rxt(104)*y(4)
         mat(198) = -rxt(131)*y(4)
         mat(65) = -rxt(208)*y(4)
         mat(52) = -(rxt(213) + rxt(214)) * y(4)
         mat(86) = -rxt(216)*y(4)

         mat(429) = 2.000_r8*rxt(74)*y(2) + 2.000_r8*rxt(82)*y(3) + rxt(108)*y(9) &
                      + rxt(111)*y(10) + rxt(137)*y(22) + rxt(132)*y(21) &
                      + 2.000_r8*rxt(144)*y(23) + rxt(147)*y(25) + rxt(173)*y(34)
         mat(263) = mat(263) + 2.000_r8*rxt(74)*y(1) + 2.000_r8*rxt(75)*y(2) + rxt(98) &
                      *y(6) + rxt(109)*y(10) + rxt(136)*y(22) + rxt(117)*y(11) &
                      + rxt(143)*y(23) + rxt(154)*y(27) + rxt(176)*y(35)
         mat(447) = mat(447) + 2.000_r8*rxt(82)*y(1)
         mat(176) = mat(176) + 2.000_r8*rxt(99)*y(6)
         mat(5) = mat(5) + rxt(98)*y(2) + 2.000_r8*rxt(99)*y(4)
         mat(285) = rxt(108)*y(1) + rxt(212)*y(51)
         mat(325) = rxt(111)*y(1) + rxt(109)*y(2)
         mat(411) = rxt(137)*y(1) + rxt(136)*y(2) + rxt(121)*y(13) + rxt(138)*y(23) &
                      + rxt(156)*y(27)
         mat(304) = rxt(117)*y(2) + rxt(119)*y(23)
         mat(42) = rxt(121)*y(22)
         mat(134) = rxt(125)*y(23)
         mat(198) = mat(198) + rxt(132)*y(1) + rxt(134)*y(23)
         mat(366) = 2.000_r8*rxt(144)*y(1) + rxt(143)*y(2) + rxt(138)*y(22) + rxt(119) &
                      *y(11) + rxt(125)*y(16) + rxt(134)*y(21) + 2.000_r8*rxt(145) &
                      *y(23) + rxt(150)*y(25) + rxt(157)*y(27) + rxt(174)*y(34) &
                      + rxt(178)*y(35)
         mat(467) = rxt(147)*y(1) + rxt(150)*y(23)
         mat(234) = rxt(154)*y(2) + rxt(156)*y(22) + rxt(157)*y(23) + ( &
                      + 2.000_r8*rxt(160)+2.000_r8*rxt(161))*y(27) + (rxt(182) &
                       +rxt(183))*y(35)
         mat(342) = rxt(173)*y(1) + rxt(174)*y(23)
         mat(212) = rxt(176)*y(2) + rxt(178)*y(23) + (rxt(182)+rxt(183))*y(27) &
                      + 2.000_r8*rxt(184)*y(35)
         mat(99) = rxt(212)*y(9)

         mat(7) = -(rxt(92)*y(2) + rxt(93)*y(4) + rxt(95)*y(1))
         mat(250) = -rxt(92)*y(5)
         mat(167) = -rxt(93)*y(5)
         mat(428) = -rxt(95)*y(5)

         mat(444) = rxt(77)*y(4)
         mat(167) = mat(167) + rxt(77)*y(3)

         mat(4) = -(rxt(98)*y(2) + rxt(99)*y(4))
         mat(249) = -rxt(98)*y(6)
         mat(166) = -rxt(99)*y(6)

         mat(427) = rxt(95)*y(5)
         mat(249) = mat(249) + rxt(92)*y(5)
         mat(166) = mat(166) + rxt(93)*y(5)
         mat(6) = rxt(95)*y(1) + rxt(92)*y(2) + rxt(93)*y(4)

         mat(106) = -(rxt(104)*y(4) + rxt(105)*y(9) + rxt(211)*y(51))
         mat(173) = -rxt(104)*y(8)
         mat(280) = -rxt(105)*y(8)
         mat(96) = -rxt(211)*y(8)

         mat(257) = rxt(215)*y(52) + rxt(103)*y(56)
         mat(173) = mat(173) + rxt(213)*y(52)
         mat(83) = 1.100_r8*rxt(221)*y(55)
         mat(50) = rxt(215)*y(2) + rxt(213)*y(4)
         mat(114) = .200_r8*rxt(219)*y(55)
         mat(68) = rxt(103)*y(2)
         mat(124) = 1.100_r8*rxt(221)*y(50) + .200_r8*rxt(219)*y(54)

         mat(291) = -(rxt(105)*y(8) + rxt(106)*y(2) + rxt(107)*y(23) + rxt(108)*y(1) &
                      + rxt(116)*y(11) + rxt(124)*y(16) + rxt(158)*y(27) + rxt(179) &
                      *y(35) + rxt(212)*y(51))
         mat(111) = -rxt(105)*y(9)
         mat(269) = -rxt(106)*y(9)
         mat(372) = -rxt(107)*y(9)
         mat(434) = -rxt(108)*y(9)
         mat(308) = -rxt(116)*y(9)
         mat(137) = -rxt(124)*y(9)
         mat(239) = -rxt(158)*y(9)
         mat(217) = -rxt(179)*y(9)
         mat(101) = -rxt(212)*y(9)

         mat(269) = mat(269) + rxt(109)*y(10)
         mat(179) = rxt(104)*y(8) + rxt(102)*y(56)
         mat(111) = mat(111) + rxt(104)*y(4)
         mat(330) = rxt(109)*y(2)
         mat(70) = rxt(102)*y(4)

         mat(332) = -((rxt(109) + rxt(110)) * y(2) + rxt(111)*y(1) + rxt(112)*y(11) &
                      + rxt(114)*y(22) + rxt(120)*y(23) + rxt(159)*y(27) + rxt(180) &
                      *y(35))
         mat(271) = -(rxt(109) + rxt(110)) * y(10)
         mat(436) = -rxt(111)*y(10)
         mat(310) = -rxt(112)*y(10)
         mat(419) = -rxt(114)*y(10)
         mat(374) = -rxt(120)*y(10)
         mat(241) = -rxt(159)*y(10)
         mat(219) = -rxt(180)*y(10)

         mat(436) = mat(436) + rxt(108)*y(9)
         mat(271) = mat(271) + rxt(106)*y(9) + rxt(117)*y(11)
         mat(293) = rxt(108)*y(1) + rxt(106)*y(2) + 2.000_r8*rxt(116)*y(11) + rxt(124) &
                      *y(16) + rxt(107)*y(23) + rxt(158)*y(27) + rxt(179)*y(35)
         mat(419) = mat(419) + rxt(118)*y(11) + rxt(121)*y(13)
         mat(310) = mat(310) + rxt(117)*y(2) + 2.000_r8*rxt(116)*y(9) + rxt(118)*y(22) &
                      + rxt(119)*y(23)
         mat(44) = rxt(121)*y(22)
         mat(138) = rxt(124)*y(9)
         mat(374) = mat(374) + rxt(107)*y(9) + rxt(119)*y(11)
         mat(241) = mat(241) + rxt(158)*y(9)
         mat(219) = mat(219) + rxt(179)*y(9)

         mat(423) = -(rxt(114)*y(10) + rxt(115)*y(12) + rxt(118)*y(11) + rxt(121) &
                      *y(13) + rxt(126)*y(17) + rxt(128)*y(18) + rxt(136)*y(2) + rxt(137) &
                      *y(1) + rxt(138)*y(23) + (4._r8*rxt(139) + 4._r8*rxt(140) &
                      ) * y(22) + rxt(142)*y(24) + (rxt(155) + rxt(156)) * y(27) &
                      + rxt(165)*y(30) + rxt(169)*y(31) + rxt(171)*y(32) + rxt(177) &
                      *y(35) + rxt(185)*y(36))
         mat(336) = -rxt(114)*y(22)
         mat(94) = -rxt(115)*y(22)
         mat(314) = -rxt(118)*y(22)
         mat(46) = -rxt(121)*y(22)
         mat(39) = -rxt(126)*y(22)
         mat(194) = -rxt(128)*y(22)
         mat(275) = -rxt(136)*y(22)
         mat(440) = -rxt(137)*y(22)
         mat(378) = -rxt(138)*y(22)
         mat(77) = -rxt(142)*y(22)
         mat(245) = -(rxt(155) + rxt(156)) * y(22)
         mat(398) = -rxt(165)*y(22)
         mat(147) = -rxt(169)*y(22)
         mat(159) = -rxt(171)*y(22)
         mat(223) = -rxt(177)*y(22)
         mat(26) = -rxt(185)*y(22)

         mat(440) = mat(440) + rxt(132)*y(21) + rxt(144)*y(23)
         mat(275) = mat(275) + rxt(129)*y(18) + rxt(143)*y(23) + rxt(146)*y(24) &
                      + rxt(166)*y(30) + rxt(167)*y(31)
         mat(457) = 2.000_r8*rxt(79)*y(57) + rxt(91)*y(30)
         mat(297) = rxt(107)*y(23)
         mat(314) = mat(314) + rxt(119)*y(23)
         mat(194) = mat(194) + rxt(129)*y(2)
         mat(203) = rxt(132)*y(1) + 2.000_r8*rxt(133)*y(23)
         mat(378) = mat(378) + rxt(144)*y(1) + rxt(143)*y(2) + rxt(107)*y(9) &
                      + rxt(119)*y(11) + 2.000_r8*rxt(133)*y(21) + rxt(151)*y(25)
         mat(77) = mat(77) + rxt(146)*y(2)
         mat(164) = 2.000_r8*rxt(79)*y(3)
         mat(478) = rxt(151)*y(23)
         mat(398) = mat(398) + rxt(166)*y(2) + rxt(91)*y(3)
         mat(147) = mat(147) + rxt(167)*y(2)

         mat(309) = -(rxt(112)*y(10) + rxt(116)*y(9) + rxt(117)*y(2) + rxt(118)*y(22) &
                      + rxt(119)*y(23) + rxt(127)*y(18))
         mat(331) = -rxt(112)*y(11)
         mat(292) = -rxt(116)*y(11)
         mat(270) = -rxt(117)*y(11)
         mat(418) = -rxt(118)*y(11)
         mat(373) = -rxt(119)*y(11)
         mat(189) = -rxt(127)*y(11)

         mat(435) = rxt(111)*y(10)
         mat(270) = mat(270) + rxt(110)*y(10) + rxt(170)*y(32)
         mat(331) = mat(331) + rxt(111)*y(1) + rxt(110)*y(2)
         mat(418) = mat(418) + rxt(115)*y(12) + rxt(171)*y(32)
         mat(92) = rxt(115)*y(22)
         mat(473) = rxt(172)*y(32)
         mat(156) = rxt(170)*y(2) + rxt(171)*y(22) + rxt(172)*y(25)


      end subroutine nlnmat01

      subroutine nlnmat02( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(90) = -(rxt(115)*y(22))
         mat(406) = -rxt(115)*y(12)

         mat(322) = rxt(114)*y(22)
         mat(406) = mat(406) + rxt(114)*y(10)
         mat(302) = rxt(127)*y(18)
         mat(184) = rxt(127)*y(11)
         mat(385) = (rxt(194)+rxt(199)+rxt(205))*y(32)
         mat(150) = (rxt(194)+rxt(199)+rxt(205))*y(30)

         mat(40) = -(rxt(121)*y(22))
         mat(404) = -rxt(121)*y(13)

         mat(320) = rxt(120)*y(23)
         mat(360) = rxt(120)*y(10)


         mat(318) = rxt(112)*y(11)
         mat(301) = rxt(112)*y(10)

         mat(132) = -(rxt(124)*y(9) + rxt(125)*y(23))
         mat(283) = -rxt(124)*y(16)
         mat(363) = -rxt(125)*y(16)

         mat(407) = rxt(126)*y(17)
         mat(35) = rxt(126)*y(22)

         mat(34) = -(rxt(126)*y(22))
         mat(403) = -rxt(126)*y(17)

         mat(131) = rxt(125)*y(23)
         mat(359) = rxt(125)*y(16)

         mat(186) = -(rxt(127)*y(11) + rxt(128)*y(22) + rxt(129)*y(2) + rxt(152)*y(25) &
                      + rxt(175)*y(34))
         mat(305) = -rxt(127)*y(18)
         mat(412) = -rxt(128)*y(18)
         mat(264) = -rxt(129)*y(18)
         mat(468) = -rxt(152)*y(18)
         mat(343) = -rxt(175)*y(18)

         mat(286) = rxt(124)*y(16)
         mat(135) = rxt(124)*y(9)

         mat(199) = -(rxt(131)*y(4) + rxt(132)*y(1) + (rxt(133) + rxt(134) + rxt(135) &
                      ) * y(23))
         mat(177) = -rxt(131)*y(21)
         mat(430) = -rxt(132)*y(21)
         mat(368) = -(rxt(133) + rxt(134) + rxt(135)) * y(21)

         mat(265) = rxt(136)*y(22)
         mat(413) = rxt(136)*y(2) + rxt(128)*y(18)
         mat(187) = rxt(128)*y(22)

         mat(376) = -(rxt(107)*y(9) + rxt(119)*y(11) + rxt(120)*y(10) + rxt(125)*y(16) &
                      + (rxt(133) + rxt(134) + rxt(135)) * y(21) + rxt(138)*y(22) &
                      + rxt(143)*y(2) + rxt(144)*y(1) + 4._r8*rxt(145)*y(23) + (rxt(150) &
                      + rxt(151)) * y(25) + rxt(157)*y(27) + rxt(174)*y(34) + rxt(178) &
                      *y(35))
         mat(295) = -rxt(107)*y(23)
         mat(312) = -rxt(119)*y(23)
         mat(334) = -rxt(120)*y(23)
         mat(139) = -rxt(125)*y(23)
         mat(202) = -(rxt(133) + rxt(134) + rxt(135)) * y(23)
         mat(421) = -rxt(138)*y(23)
         mat(273) = -rxt(143)*y(23)
         mat(438) = -rxt(144)*y(23)
         mat(476) = -(rxt(150) + rxt(151)) * y(23)
         mat(243) = -rxt(157)*y(23)
         mat(352) = -rxt(174)*y(23)
         mat(221) = -rxt(178)*y(23)

         mat(438) = mat(438) + rxt(137)*y(22)
         mat(273) = mat(273) + rxt(129)*y(18) + rxt(146)*y(24)
         mat(180) = rxt(131)*y(21)
         mat(295) = mat(295) + rxt(124)*y(16)
         mat(421) = mat(421) + rxt(137)*y(1) + rxt(118)*y(11) + rxt(142)*y(24) &
                      + rxt(155)*y(27) + rxt(177)*y(35)
         mat(312) = mat(312) + rxt(118)*y(22) + rxt(127)*y(18)
         mat(139) = mat(139) + rxt(124)*y(9)
         mat(192) = rxt(129)*y(2) + rxt(127)*y(11) + rxt(152)*y(25) + rxt(175)*y(34)
         mat(202) = mat(202) + rxt(131)*y(4)
         mat(75) = rxt(146)*y(2) + rxt(142)*y(22) + rxt(149)*y(25)
         mat(476) = mat(476) + rxt(152)*y(18) + rxt(149)*y(24)
         mat(243) = mat(243) + rxt(155)*y(22)
         mat(352) = mat(352) + rxt(175)*y(18)
         mat(221) = mat(221) + rxt(177)*y(22)

         mat(72) = -(rxt(142)*y(22) + rxt(146)*y(2) + rxt(149)*y(25))
         mat(405) = -rxt(142)*y(24)
         mat(254) = -rxt(146)*y(24)
         mat(462) = -rxt(149)*y(24)

         mat(405) = mat(405) + 2.000_r8*rxt(140)*y(22)
         mat(362) = 2.000_r8*rxt(145)*y(23)

         mat(161) = -(rxt(79)*y(3))
         mat(446) = -rxt(79)*y(57)

         mat(410) = 2.000_r8*rxt(139)*y(22) + rxt(115)*y(12) + rxt(121)*y(13) &
                      + rxt(126)*y(17) + rxt(128)*y(18) + rxt(138)*y(23) + rxt(142) &
                      *y(24) + rxt(165)*y(30) + rxt(169)*y(31) + rxt(185)*y(36)
         mat(91) = rxt(115)*y(22)
         mat(41) = rxt(121)*y(22)
         mat(36) = rxt(126)*y(22)
         mat(185) = rxt(128)*y(22)
         mat(197) = rxt(135)*y(23)
         mat(365) = rxt(138)*y(22) + rxt(135)*y(21)
         mat(73) = rxt(142)*y(22)
         mat(388) = rxt(165)*y(22) + (rxt(195)+rxt(200)+rxt(206))*y(31) + (rxt(196) &
                       +rxt(207))*y(37)
         mat(143) = rxt(169)*y(22) + (rxt(195)+rxt(200)+rxt(206))*y(30)
         mat(24) = rxt(185)*y(22)
         mat(56) = (rxt(196)+rxt(207))*y(30)

         mat(481) = -(rxt(147)*y(1) + rxt(149)*y(24) + (rxt(150) + rxt(151)) * y(23) &
                      + rxt(152)*y(18) + rxt(168)*y(31) + rxt(172)*y(32))
         mat(443) = -rxt(147)*y(25)
         mat(78) = -rxt(149)*y(25)
         mat(381) = -(rxt(150) + rxt(151)) * y(25)
         mat(196) = -rxt(152)*y(25)
         mat(148) = -rxt(168)*y(25)
         mat(160) = -rxt(172)*y(25)

         mat(278) = rxt(154)*y(27) + rxt(166)*y(30)
         mat(460) = rxt(91)*y(30)
         mat(300) = rxt(158)*y(27)
         mat(426) = rxt(155)*y(27) + rxt(165)*y(30)
         mat(248) = rxt(154)*y(2) + rxt(158)*y(9) + rxt(155)*y(22) + ( &
                      + 4.000_r8*rxt(160)+2.000_r8*rxt(162))*y(27) + rxt(182)*y(35)
         mat(401) = rxt(166)*y(2) + rxt(91)*y(3) + rxt(165)*y(22)
         mat(226) = rxt(182)*y(27)


         mat(461) = rxt(172)*y(32)
         mat(229) = 2.000_r8*rxt(161)*y(27)
         mat(382) = (rxt(195)+rxt(200)+rxt(206))*y(31) + (rxt(194)+rxt(199)+rxt(205)) &
                      *y(32)
         mat(141) = (rxt(195)+rxt(200)+rxt(206))*y(30)
         mat(149) = rxt(172)*y(25) + (rxt(194)+rxt(199)+rxt(205))*y(30)

         mat(237) = -(rxt(154)*y(2) + (rxt(155) + rxt(156)) * y(22) + rxt(157)*y(23) &
                      + rxt(158)*y(9) + rxt(159)*y(10) + (4._r8*rxt(160) + 4._r8*rxt(161) &
                      + 4._r8*rxt(162) + 4._r8*rxt(163)) * y(27) + (rxt(181) + rxt(182) &
                      + rxt(183)) * y(35))
         mat(267) = -rxt(154)*y(27)
         mat(415) = -(rxt(155) + rxt(156)) * y(27)
         mat(370) = -rxt(157)*y(27)
         mat(289) = -rxt(158)*y(27)
         mat(328) = -rxt(159)*y(27)
         mat(215) = -(rxt(181) + rxt(182) + rxt(183)) * y(27)

         mat(432) = rxt(147)*y(25)
         mat(267) = mat(267) + rxt(167)*y(31) + rxt(170)*y(32)
         mat(415) = mat(415) + rxt(169)*y(31)
         mat(370) = mat(370) + rxt(151)*y(25)
         mat(470) = rxt(147)*y(1) + rxt(151)*y(23) + rxt(168)*y(31)
         mat(144) = rxt(167)*y(2) + rxt(169)*y(22) + rxt(168)*y(25)
         mat(154) = rxt(170)*y(2)


         mat(228) = 2.000_r8*rxt(162)*y(27) + rxt(181)*y(35)
         mat(206) = rxt(181)*y(27)


         mat(227) = 2.000_r8*rxt(163)*y(27)

         mat(397) = -(rxt(91)*y(3) + rxt(165)*y(22) + rxt(166)*y(2) + (rxt(194) &
                      + rxt(199) + rxt(205)) * y(32) + (rxt(195) + rxt(200) + rxt(206) &
                      ) * y(31) + (rxt(196) + rxt(207)) * y(37))
         mat(456) = -rxt(91)*y(30)
         mat(422) = -rxt(165)*y(30)
         mat(274) = -rxt(166)*y(30)
         mat(158) = -(rxt(194) + rxt(199) + rxt(205)) * y(30)
         mat(146) = -(rxt(195) + rxt(200) + rxt(206)) * y(30)
         mat(58) = -(rxt(196) + rxt(207)) * y(30)

         mat(422) = mat(422) + rxt(156)*y(27)
         mat(193) = rxt(152)*y(25)
         mat(377) = rxt(150)*y(25)
         mat(76) = rxt(149)*y(25)
         mat(477) = rxt(152)*y(18) + rxt(150)*y(23) + rxt(149)*y(24) + rxt(168)*y(31)
         mat(244) = rxt(156)*y(22)
         mat(146) = mat(146) + rxt(168)*y(25)

         mat(142) = -(rxt(167)*y(2) + rxt(168)*y(25) + rxt(169)*y(22) + (rxt(195) &
                      + rxt(200) + rxt(206)) * y(30))
         mat(260) = -rxt(167)*y(31)
         mat(464) = -rxt(168)*y(31)
         mat(408) = -rxt(169)*y(31)
         mat(386) = -(rxt(195) + rxt(200) + rxt(206)) * y(31)

         mat(408) = mat(408) + rxt(171)*y(32)
         mat(364) = rxt(157)*y(27)
         mat(231) = rxt(157)*y(23)
         mat(151) = rxt(171)*y(22)

         mat(152) = -(rxt(170)*y(2) + rxt(171)*y(22) + rxt(172)*y(25) + (rxt(194) &
                      + rxt(199) + rxt(205)) * y(30))
         mat(261) = -rxt(170)*y(32)
         mat(409) = -rxt(171)*y(32)
         mat(465) = -rxt(172)*y(32)
         mat(387) = -(rxt(194) + rxt(199) + rxt(205)) * y(32)

         mat(323) = rxt(159)*y(27)
         mat(232) = rxt(159)*y(10)


         mat(230) = rxt(183)*y(35)
         mat(383) = (rxt(196)+rxt(207))*y(37)
         mat(207) = rxt(183)*y(27)
         mat(54) = (rxt(196)+rxt(207))*y(30)

         mat(351) = -(rxt(173)*y(1) + rxt(174)*y(23) + rxt(175)*y(18))
         mat(437) = -rxt(173)*y(34)
         mat(375) = -rxt(174)*y(34)
         mat(191) = -rxt(175)*y(34)

         mat(272) = rxt(176)*y(35)
         mat(294) = rxt(179)*y(35)
         mat(420) = rxt(177)*y(35) + rxt(185)*y(36)
         mat(242) = (rxt(181)+rxt(182))*y(35)
         mat(220) = rxt(176)*y(2) + rxt(179)*y(9) + rxt(177)*y(22) + (rxt(181) &
                       +rxt(182))*y(27) + 4.000_r8*rxt(184)*y(35)
         mat(25) = rxt(185)*y(22)

         mat(214) = -(rxt(176)*y(2) + rxt(177)*y(22) + rxt(178)*y(23) + rxt(179)*y(9) &
                      + rxt(180)*y(10) + (rxt(181) + rxt(182) + rxt(183)) * y(27) &
                      + 4._r8*rxt(184)*y(35))
         mat(266) = -rxt(176)*y(35)
         mat(414) = -rxt(177)*y(35)
         mat(369) = -rxt(178)*y(35)
         mat(288) = -rxt(179)*y(35)
         mat(327) = -rxt(180)*y(35)
         mat(236) = -(rxt(181) + rxt(182) + rxt(183)) * y(35)

         mat(431) = rxt(173)*y(34)
         mat(345) = rxt(173)*y(1)

         mat(23) = -(rxt(185)*y(22))
         mat(402) = -rxt(185)*y(36)

         mat(183) = rxt(175)*y(34)
         mat(358) = rxt(174)*y(34)
         mat(340) = rxt(175)*y(18) + rxt(174)*y(23)


      end subroutine nlnmat02

      subroutine nlnmat03( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(55) = -((rxt(196) + rxt(207)) * y(30))
         mat(384) = -(rxt(196) + rxt(207)) * y(37)

         mat(361) = rxt(178)*y(35)
         mat(209) = rxt(178)*y(23)


         mat(319) = rxt(180)*y(35)
         mat(208) = rxt(180)*y(10)

         mat(81) = -((rxt(210) + rxt(218)) * y(2) + rxt(216)*y(4) + rxt(221)*y(55))
         mat(255) = -(rxt(210) + rxt(218)) * y(50)
         mat(171) = -rxt(216)*y(50)
         mat(122) = -rxt(221)*y(50)

         mat(95) = -(rxt(211)*y(8) + rxt(212)*y(9) + rxt(220)*y(55))
         mat(105) = -rxt(211)*y(51)
         mat(279) = -rxt(212)*y(51)
         mat(123) = -rxt(220)*y(51)

         mat(172) = rxt(216)*y(50) + rxt(213)*y(52) + rxt(208)*y(53)
         mat(82) = rxt(216)*y(4)
         mat(49) = rxt(213)*y(4)
         mat(62) = rxt(208)*y(4)

         mat(47) = -((rxt(213) + rxt(214)) * y(4) + rxt(215)*y(2))
         mat(168) = -(rxt(213) + rxt(214)) * y(52)
         mat(251) = -rxt(215)*y(52)

         mat(61) = -(rxt(208)*y(4))
         mat(169) = -rxt(208)*y(53)

         mat(252) = rxt(218)*y(50) + rxt(215)*y(52)
         mat(79) = rxt(218)*y(2)
         mat(48) = rxt(215)*y(2)

         mat(115) = -(rxt(219)*y(55))
         mat(125) = -rxt(219)*y(54)

         mat(258) = rxt(210)*y(50)
         mat(174) = rxt(214)*y(52)
         mat(107) = rxt(211)*y(51)
         mat(281) = rxt(212)*y(51)
         mat(84) = rxt(210)*y(2)
         mat(97) = rxt(211)*y(8) + rxt(212)*y(9)
         mat(51) = rxt(214)*y(4)

         mat(67) = -(rxt(102)*y(4) + rxt(103)*y(2))
         mat(170) = -rxt(102)*y(56)
         mat(253) = -rxt(103)*y(56)

         mat(253) = mat(253) + rxt(210)*y(50)
         mat(80) = rxt(210)*y(2) + .900_r8*rxt(221)*y(55)
         mat(113) = .800_r8*rxt(219)*y(55)
         mat(121) = .900_r8*rxt(221)*y(50) + .800_r8*rxt(219)*y(54)

         mat(126) = -(rxt(219)*y(54) + rxt(220)*y(51) + rxt(221)*y(50))
         mat(116) = -rxt(219)*y(55)
         mat(98) = -rxt(220)*y(55)
         mat(85) = -rxt(221)*y(55)


      end subroutine nlnmat03

      subroutine nlnmat_finit( mat, lmat, dti )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(nzcnt)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat( 1) = lmat( 1)
         mat( 2) = lmat( 2)
         mat( 3) = lmat( 3)
         mat( 4) = mat( 4) + lmat( 4)
         mat( 5) = mat( 5) + lmat( 5)
         mat( 6) = mat( 6) + lmat( 6)
         mat( 7) = mat( 7) + lmat( 7)
         mat( 8) = lmat( 8)
         mat( 9) = lmat( 9)
         mat( 10) = lmat( 10)
         mat( 11) = lmat( 11)
         mat( 12) = lmat( 12)
         mat( 13) = lmat( 13)
         mat( 14) = lmat( 14)
         mat( 15) = lmat( 15)
         mat( 16) = lmat( 16)
         mat( 17) = lmat( 17)
         mat( 18) = lmat( 18)
         mat( 19) = lmat( 19)
         mat( 20) = lmat( 20)
         mat( 21) = lmat( 21)
         mat( 22) = lmat( 22)
         mat( 23) = mat( 23) + lmat( 23)
         mat( 27) = lmat( 27)
         mat( 28) = lmat( 28)
         mat( 29) = lmat( 29)
         mat( 30) = lmat( 30)
         mat( 31) = lmat( 31)
         mat( 32) = lmat( 32)
         mat( 33) = lmat( 33)
         mat( 34) = mat( 34) + lmat( 34)
         mat( 37) = lmat( 37)
         mat( 38) = lmat( 38)
         mat( 39) = mat( 39) + lmat( 39)
         mat( 40) = mat( 40) + lmat( 40)
         mat( 43) = lmat( 43)
         mat( 44) = mat( 44) + lmat( 44)
         mat( 45) = lmat( 45)
         mat( 46) = mat( 46) + lmat( 46)
         mat( 55) = mat( 55) + lmat( 55)
         mat( 57) = lmat( 57)
         mat( 59) = lmat( 59)
         mat( 61) = mat( 61) + lmat( 61)
         mat( 63) = lmat( 63)
         mat( 64) = lmat( 64)
         mat( 72) = mat( 72) + lmat( 72)
         mat( 77) = mat( 77) + lmat( 77)
         mat( 90) = mat( 90) + lmat( 90)
         mat( 93) = lmat( 93)
         mat( 94) = mat( 94) + lmat( 94)
         mat( 95) = mat( 95) + lmat( 95)
         mat( 97) = mat( 97) + lmat( 97)
         mat( 101) = mat( 101) + lmat( 101)
         mat( 103) = lmat( 103)
         mat( 106) = mat( 106) + lmat( 106)
         mat( 108) = lmat( 108)
         mat( 142) = mat( 142) + lmat( 142)
         mat( 147) = mat( 147) + lmat( 147)
         mat( 148) = mat( 148) + lmat( 148)
         mat( 150) = mat( 150) + lmat( 150)
         mat( 151) = mat( 151) + lmat( 151)
         mat( 152) = mat( 152) + lmat( 152)
         mat( 154) = mat( 154) + lmat( 154)
         mat( 156) = mat( 156) + lmat( 156)
         mat( 157) = lmat( 157)
         mat( 160) = mat( 160) + lmat( 160)
         mat( 161) = mat( 161) + lmat( 161)
         mat( 162) = lmat( 162)
         mat( 163) = lmat( 163)
         mat( 164) = mat( 164) + lmat( 164)
         mat( 165) = mat( 165) + lmat( 165)
         mat( 169) = mat( 169) + lmat( 169)
         mat( 172) = mat( 172) + lmat( 172)
         mat( 175) = lmat( 175)
         mat( 176) = mat( 176) + lmat( 176)
         mat( 178) = mat( 178) + lmat( 178)
         mat( 182) = mat( 182) + lmat( 182)
         mat( 186) = mat( 186) + lmat( 186)
         mat( 187) = mat( 187) + lmat( 187)
         mat( 214) = mat( 214) + lmat( 214)
         mat( 216) = mat( 216) + lmat( 216)
         mat( 220) = mat( 220) + lmat( 220)
         mat( 252) = mat( 252) + lmat( 252)
         mat( 259) = lmat( 259)
         mat( 268) = mat( 268) + lmat( 268)
         mat( 280) = mat( 280) + lmat( 280)
         mat( 281) = mat( 281) + lmat( 281)
         mat( 282) = lmat( 282)
         mat( 290) = mat( 290) + lmat( 290)
         mat( 291) = mat( 291) + lmat( 291)
         mat( 304) = mat( 304) + lmat( 304)
         mat( 307) = mat( 307) + lmat( 307)
         mat( 308) = mat( 308) + lmat( 308)
         mat( 309) = mat( 309) + lmat( 309)
         mat( 310) = mat( 310) + lmat( 310)
         mat( 329) = mat( 329) + lmat( 329)
         mat( 330) = mat( 330) + lmat( 330)
         mat( 332) = mat( 332) + lmat( 332)
         mat( 389) = lmat( 389)
         mat( 397) = mat( 397) + lmat( 397)
         mat( 401) = mat( 401) + lmat( 401)
         mat( 407) = mat( 407) + lmat( 407)
         mat( 410) = mat( 410) + lmat( 410)
         mat( 413) = mat( 413) + lmat( 413)
         mat( 420) = mat( 420) + lmat( 420)
         mat( 421) = mat( 421) + lmat( 421)
         mat( 423) = mat( 423) + lmat( 423)
         mat( 426) = mat( 426) + lmat( 426)
         mat( 427) = mat( 427) + lmat( 427)
         mat( 429) = mat( 429) + lmat( 429)
         mat( 433) = mat( 433) + lmat( 433)
         mat( 441) = mat( 441) + lmat( 441)
         mat( 442) = mat( 442) + lmat( 442)
         mat( 445) = lmat( 445)
         mat( 447) = mat( 447) + lmat( 447)
         mat( 448) = lmat( 448)
         mat( 449) = lmat( 449)
         mat( 450) = mat( 450) + lmat( 450)
         mat( 451) = lmat( 451)
         mat( 455) = lmat( 455)
         mat( 457) = mat( 457) + lmat( 457)
         mat( 459) = mat( 459) + lmat( 459)
         mat( 460) = mat( 460) + lmat( 460)
         mat( 463) = lmat( 463)
         mat( 469) = lmat( 469)
         mat( 476) = mat( 476) + lmat( 476)
         mat( 477) = mat( 477) + lmat( 477)
         mat( 481) = mat( 481) + lmat( 481)
         mat( 60) = 0._r8
         mat( 88) = 0._r8
         mat( 89) = 0._r8
         mat( 104) = 0._r8
         mat( 112) = 0._r8
         mat( 117) = 0._r8
         mat( 119) = 0._r8
         mat( 120) = 0._r8
         mat( 127) = 0._r8
         mat( 129) = 0._r8
         mat( 133) = 0._r8
         mat( 136) = 0._r8
         mat( 140) = 0._r8
         mat( 153) = 0._r8
         mat( 190) = 0._r8
         mat( 195) = 0._r8
         mat( 201) = 0._r8
         mat( 205) = 0._r8
         mat( 210) = 0._r8
         mat( 211) = 0._r8
         mat( 213) = 0._r8
         mat( 218) = 0._r8
         mat( 222) = 0._r8
         mat( 224) = 0._r8
         mat( 225) = 0._r8
         mat( 233) = 0._r8
         mat( 235) = 0._r8
         mat( 240) = 0._r8
         mat( 246) = 0._r8
         mat( 247) = 0._r8
         mat( 256) = 0._r8
         mat( 262) = 0._r8
         mat( 277) = 0._r8
         mat( 284) = 0._r8
         mat( 287) = 0._r8
         mat( 296) = 0._r8
         mat( 299) = 0._r8
         mat( 303) = 0._r8
         mat( 306) = 0._r8
         mat( 311) = 0._r8
         mat( 313) = 0._r8
         mat( 315) = 0._r8
         mat( 316) = 0._r8
         mat( 317) = 0._r8
         mat( 321) = 0._r8
         mat( 324) = 0._r8
         mat( 326) = 0._r8
         mat( 333) = 0._r8
         mat( 335) = 0._r8
         mat( 338) = 0._r8
         mat( 339) = 0._r8
         mat( 341) = 0._r8
         mat( 344) = 0._r8
         mat( 346) = 0._r8
         mat( 347) = 0._r8
         mat( 348) = 0._r8
         mat( 349) = 0._r8
         mat( 350) = 0._r8
         mat( 353) = 0._r8
         mat( 354) = 0._r8
         mat( 356) = 0._r8
         mat( 357) = 0._r8
         mat( 367) = 0._r8
         mat( 380) = 0._r8
         mat( 390) = 0._r8
         mat( 392) = 0._r8
         mat( 393) = 0._r8
         mat( 394) = 0._r8
         mat( 395) = 0._r8
         mat( 396) = 0._r8
         mat( 399) = 0._r8
         mat( 417) = 0._r8
         mat( 425) = 0._r8
         mat( 439) = 0._r8
         mat( 452) = 0._r8
         mat( 453) = 0._r8
         mat( 454) = 0._r8
         mat( 466) = 0._r8
         mat( 471) = 0._r8
         mat( 472) = 0._r8
         mat( 474) = 0._r8
         mat( 475) = 0._r8
         mat( 480) = 0._r8
         mat( 1) = mat( 1) - dti
         mat( 4) = mat( 4) - dti
         mat( 7) = mat( 7) - dti
         mat( 9) = mat( 9) - dti
         mat( 12) = mat( 12) - dti
         mat( 14) = mat( 14) - dti
         mat( 17) = mat( 17) - dti
         mat( 23) = mat( 23) - dti
         mat( 27) = mat( 27) - dti
         mat( 34) = mat( 34) - dti
         mat( 40) = mat( 40) - dti
         mat( 47) = mat( 47) - dti
         mat( 55) = mat( 55) - dti
         mat( 61) = mat( 61) - dti
         mat( 67) = mat( 67) - dti
         mat( 72) = mat( 72) - dti
         mat( 81) = mat( 81) - dti
         mat( 90) = mat( 90) - dti
         mat( 95) = mat( 95) - dti
         mat( 106) = mat( 106) - dti
         mat( 115) = mat( 115) - dti
         mat( 126) = mat( 126) - dti
         mat( 132) = mat( 132) - dti
         mat( 142) = mat( 142) - dti
         mat( 152) = mat( 152) - dti
         mat( 161) = mat( 161) - dti
         mat( 176) = mat( 176) - dti
         mat( 186) = mat( 186) - dti
         mat( 199) = mat( 199) - dti
         mat( 214) = mat( 214) - dti
         mat( 237) = mat( 237) - dti
         mat( 268) = mat( 268) - dti
         mat( 291) = mat( 291) - dti
         mat( 309) = mat( 309) - dti
         mat( 332) = mat( 332) - dti
         mat( 351) = mat( 351) - dti
         mat( 376) = mat( 376) - dti
         mat( 397) = mat( 397) - dti
         mat( 423) = mat( 423) - dti
         mat( 441) = mat( 441) - dti
         mat( 459) = mat( 459) - dti
         mat( 481) = mat( 481) - dti

      end subroutine nlnmat_finit

      subroutine nlnmat( mat, y, rxt, lmat, dti )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(nzcnt)
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)

      call nlnmat01( mat, y, rxt )
      call nlnmat02( mat, y, rxt )
      call nlnmat03( mat, y, rxt )
      call nlnmat_finit( mat, lmat, dti )

      end subroutine nlnmat

      end module mo_nln_matrix
