      module mo_prod_loss

      contains

      subroutine exp_prod_loss( prod, loss, y, rxt, het_rates )

      use ppgrid, only : pver
      use shr_kind_mod, only : r8 => shr_kind_r8

      implicit none

!--------------------------------------------------------------------
! ... dummy args
!--------------------------------------------------------------------
      real(r8), dimension(:,:,:), intent(out) :: &
            prod, &
            loss
      real(r8), intent(in) :: y(:,:,:)
      real(r8), intent(in) :: rxt(:,:,:)
      real(r8), intent(in) :: het_rates(:,:,:)



!--------------------------------------------------------------------
! ... loss and production for Explicit method
!--------------------------------------------------------------------


         loss(:,:,1) = ((rxt(:,:,87) +rxt(:,:,88) +rxt(:,:,89))* y(:,:,3) &
                  +rxt(:,:,123)* y(:,:,22) +rxt(:,:,153)* y(:,:,25) + rxt(:,:,46) &
                  + rxt(:,:,47))* y(:,:,15)
         prod(:,:,1) = 0.
         loss(:,:,2) = ((rxt(:,:,80) +rxt(:,:,81))* y(:,:,3) + rxt(:,:,5))* y(:,:,7)
         prod(:,:,2) = 0.
         loss(:,:,3) = (rxt(:,:,130)* y(:,:,22))* y(:,:,19)
         prod(:,:,3) =.380_r8*rxt(:,:,47)*y(:,:,15) +rxt(:,:,186)*y(:,:,39)*y(:,:,25) &
                  +rxt(:,:,45)*y(:,:,49)
         loss(:,:,4) = (rxt(:,:,90)* y(:,:,3) +rxt(:,:,141)* y(:,:,22) +rxt(:,:,148) &
                 * y(:,:,25))* y(:,:,20)
         prod(:,:,4) = (1.440_r8*rxt(:,:,47) +rxt(:,:,89)*y(:,:,3))*y(:,:,15)
         loss(:,:,5) = (rxt(:,:,187)* y(:,:,22) +rxt(:,:,186)* y(:,:,25) &
                  + rxt(:,:,35))* y(:,:,39)
         prod(:,:,5) = 0.
         loss(:,:,6) = (rxt(:,:,190)* y(:,:,22) + rxt(:,:,42))* y(:,:,40)
         prod(:,:,6) = 0.
         loss(:,:,7) = (rxt(:,:,83)* y(:,:,3) + rxt(:,:,38))* y(:,:,41)
         prod(:,:,7) = 0.
         loss(:,:,8) = (rxt(:,:,84)* y(:,:,3) + rxt(:,:,39))* y(:,:,42)
         prod(:,:,8) = 0.
         loss(:,:,9) = (rxt(:,:,85)* y(:,:,3) + rxt(:,:,40))* y(:,:,43)
         prod(:,:,9) = 0.
         loss(:,:,10) = (rxt(:,:,86)* y(:,:,3) +rxt(:,:,189)* y(:,:,22) + rxt(:,:,41)) &
                 * y(:,:,44)
         prod(:,:,10) = 0.
         loss(:,:,11) = ( + rxt(:,:,36))* y(:,:,45)
         prod(:,:,11) = 0.
         loss(:,:,12) = (rxt(:,:,188)* y(:,:,22) + rxt(:,:,37))* y(:,:,46)
         prod(:,:,12) = 0.
         loss(:,:,13) = ( + rxt(:,:,43))* y(:,:,47)
         prod(:,:,13) = 0.
         loss(:,:,14) = ( + rxt(:,:,44))* y(:,:,48)
         prod(:,:,14) = 0.
         loss(:,:,15) = ( + rxt(:,:,45))* y(:,:,49)
         prod(:,:,15) =.440_r8*rxt(:,:,47)*y(:,:,15) +rxt(:,:,130)*y(:,:,22)*y(:,:,19)

      end subroutine exp_prod_loss

      subroutine imp_prod_loss( prod, loss, y, rxt, het_rates )

      use ppgrid, only : pver
      use shr_kind_mod, only : r8 => shr_kind_r8

      implicit none

!--------------------------------------------------------------------
! ... dummy args
!--------------------------------------------------------------------
      real(r8), dimension(:), intent(out) :: &
            prod, &
            loss
      real(r8), intent(in) :: y(:)
      real(r8), intent(in) :: rxt(:)
      real(r8), intent(in) :: het_rates(:)



!--------------------------------------------------------------------
! ... loss and production for Implicit method
!--------------------------------------------------------------------


         loss(40) = (rxt(74)* y(2) +rxt(82)* y(3) +rxt(108)* y(9) +rxt(111)* y(10) &
                  +rxt(132)* y(21) +rxt(137)* y(22) +rxt(144)* y(23) +rxt(147)* y(25) &
                  +rxt(173)* y(34) + rxt(3) + rxt(4))* y(1)
         prod(40) =rxt(73)*y(4)*y(2)
         loss(32) = (rxt(74)* y(1) + 2._r8*rxt(75)* y(2) +rxt(73)* y(4) +rxt(106) &
                 * y(9) + (rxt(109) +rxt(110))* y(10) +rxt(117)* y(11) +rxt(129) &
                 * y(18) +rxt(136)* y(22) +rxt(143)* y(23) +rxt(146)* y(24) +rxt(154) &
                 * y(27) +rxt(166)* y(30) +rxt(167)* y(31) +rxt(170)* y(32) +rxt(176) &
                 * y(35) + (rxt(210) +rxt(218))* y(50) +rxt(215)* y(52) + rxt(48) &
                  + rxt(49) + rxt(50) + rxt(61) + rxt(62) + rxt(63))* y(2)
         prod(32) = (rxt(1) +2.000_r8*rxt(2) +rxt(54) +rxt(55) +rxt(56) + &
                 2.000_r8*rxt(59) +rxt(66) +rxt(67) +rxt(68) +2.000_r8*rxt(71) + &
                 rxt(77)*y(3) +rxt(78)*y(3) +rxt(104)*y(8) +rxt(208)*y(53) + &
                 rxt(214)*y(52))*y(4) + (rxt(105)*y(9) +rxt(211)*y(51))*y(8) &
                  + (rxt(219)*y(54) +1.150_r8*rxt(220)*y(51))*y(55) +rxt(4)*y(1) &
                  +rxt(76)*y(3) +rxt(6)*y(9) +rxt(8)*y(10) +rxt(12)*y(11) +rxt(10) &
                 *y(14) +rxt(135)*y(23)*y(21) +rxt(139)*y(22)*y(22) +rxt(24)*y(28) &
                  +rxt(31)*y(35) +rxt(21)*y(57)
         loss(41) = (rxt(82)* y(1) + (rxt(77) +rxt(78))* y(4) + (rxt(80) +rxt(81)) &
                 * y(7) + (rxt(87) +rxt(88) +rxt(89))* y(15) +rxt(90)* y(20) +rxt(91) &
                 * y(30) +rxt(83)* y(41) +rxt(84)* y(42) +rxt(85)* y(43) +rxt(86) &
                 * y(44) +rxt(79)* y(57) + rxt(76))* y(3)
         prod(41) = (rxt(1) +rxt(102)*y(56))*y(4) +rxt(3)*y(1) +.850_r8*rxt(220)*y(55) &
                 *y(51) +rxt(20)*y(57)
         loss(27) = (rxt(73)* y(2) +rxt(77)* y(3) +rxt(99)* y(6) +rxt(104)* y(8) &
                  +rxt(131)* y(21) +rxt(216)* y(50) + (rxt(213) +rxt(214))* y(52) &
                  +rxt(208)* y(53) +rxt(102)* y(56) + rxt(1) + rxt(2) + rxt(52) &
                  + rxt(54) + rxt(55) + rxt(56) + rxt(59) + rxt(64) + rxt(66) &
                  + rxt(67) + rxt(68) + rxt(71))* y(4)
         prod(27) = (rxt(119)*y(11) +rxt(125)*y(16) +rxt(134)*y(21) +rxt(138)*y(22) + &
                 rxt(143)*y(2) +2.000_r8*rxt(144)*y(1) +rxt(145)*y(23) + &
                 rxt(150)*y(25) +rxt(157)*y(27) +rxt(174)*y(34) +rxt(178)*y(35))*y(23) &
                  + (rxt(4) +2.000_r8*rxt(74)*y(2) +2.000_r8*rxt(82)*y(3) + &
                 rxt(108)*y(9) +rxt(111)*y(10) +rxt(132)*y(21) +rxt(137)*y(22) + &
                 rxt(147)*y(25) +rxt(173)*y(34))*y(1) + (rxt(75)*y(2) +rxt(98)*y(6) + &
                 rxt(109)*y(10) +rxt(117)*y(11) +rxt(136)*y(22) +rxt(154)*y(27) + &
                 rxt(176)*y(35))*y(2) + (rxt(156)*y(22) +rxt(160)*y(27) + &
                 rxt(161)*y(27) +rxt(182)*y(35) +rxt(183)*y(35))*y(27) + (rxt(100) + &
                 rxt(101) +2.000_r8*rxt(99)*y(4))*y(6) +rxt(81)*y(7)*y(3) +rxt(97) &
                 *y(5) +rxt(212)*y(51)*y(9) +rxt(13)*y(11) +rxt(121)*y(22)*y(13) &
                  +rxt(184)*y(35)*y(35)
         loss(3) = (rxt(95)* y(1) +rxt(92)* y(2) +rxt(93)* y(4) +rxt(96)* y(49) &
                  + rxt(94) + rxt(97))* y(5)
         prod(3) =rxt(77)*y(4)*y(3)
         loss(2) = (rxt(98)* y(2) +rxt(99)* y(4) + rxt(100) + rxt(101))* y(6)
         prod(2) = (rxt(94) +rxt(96)*y(49) +rxt(92)*y(2) +rxt(93)*y(4) +rxt(95)*y(1)) &
                 *y(5) +rxt(3)*y(1)
         loss(20) = (rxt(104)* y(4) +rxt(105)* y(9) +rxt(211)* y(51) + rxt(51))* y(8)
         prod(20) = (rxt(103)*y(56) +rxt(215)*y(52))*y(2) + (.200_r8*rxt(219)*y(54) + &
                 1.100_r8*rxt(221)*y(50))*y(55) +rxt(213)*y(52)*y(4) +rxt(6)*y(9) &
                  +rxt(209)*y(53)
         loss(33) = (rxt(108)* y(1) +rxt(106)* y(2) +rxt(105)* y(8) +rxt(116)* y(11) &
                  +rxt(124)* y(16) +rxt(107)* y(23) +rxt(158)* y(27) +rxt(179)* y(35) &
                  +rxt(212)* y(51) + rxt(6) + rxt(7))* y(9)
         prod(33) = (rxt(102)*y(56) +rxt(104)*y(8))*y(4) + (rxt(8) +rxt(109)*y(2)) &
                 *y(10) +2.000_r8*rxt(80)*y(7)*y(3) +rxt(13)*y(11) +rxt(10)*y(14) &
                  +rxt(217)*y(51)
         loss(35) = (rxt(111)* y(1) + (rxt(109) +rxt(110))* y(2) +rxt(112)* y(11) &
                  +rxt(114)* y(22) +rxt(120)* y(23) +rxt(159)* y(27) +rxt(180)* y(35) &
                  + rxt(8))* y(10)
         prod(35) = (rxt(106)*y(2) +rxt(107)*y(23) +rxt(108)*y(1) + &
                 2.000_r8*rxt(116)*y(11) +rxt(124)*y(16) +rxt(158)*y(27) + &
                 rxt(179)*y(35))*y(9) + (rxt(12) +rxt(117)*y(2) +rxt(118)*y(22) + &
                 rxt(119)*y(23))*y(11) + (rxt(15) +rxt(122) +rxt(121)*y(22))*y(13) &
                  + (rxt(9) +rxt(113))*y(14) +rxt(11)*y(12) +rxt(29)*y(32) +rxt(34) &
                 *y(38)
         loss(39) = (rxt(137)* y(1) +rxt(136)* y(2) +rxt(114)* y(10) +rxt(118)* y(11) &
                  +rxt(115)* y(12) +rxt(121)* y(13) +rxt(123)* y(15) +rxt(126)* y(17) &
                  +rxt(128)* y(18) +rxt(130)* y(19) +rxt(141)* y(20) &
                  + 2._r8*(rxt(139) +rxt(140))* y(22) +rxt(138)* y(23) +rxt(142) &
                 * y(24) + (rxt(155) +rxt(156))* y(27) +rxt(165)* y(30) +rxt(169) &
                 * y(31) +rxt(171)* y(32) +rxt(177)* y(35) +rxt(185)* y(36) +rxt(187) &
                 * y(39) +rxt(190)* y(40) +rxt(189)* y(44) +rxt(188)* y(46))* y(22)
         prod(39) = (rxt(107)*y(9) +rxt(119)*y(11) +2.000_r8*rxt(133)*y(21) + &
                 rxt(143)*y(2) +rxt(144)*y(1) +rxt(151)*y(25))*y(23) &
                  + (rxt(129)*y(18) +rxt(146)*y(24) +rxt(166)*y(30) +rxt(167)*y(31)) &
                 *y(2) + (rxt(87)*y(15) +rxt(90)*y(20) +2.000_r8*rxt(79)*y(57) + &
                 rxt(91)*y(30))*y(3) +rxt(132)*y(21)*y(1) +rxt(11)*y(12) +rxt(14) &
                 *y(13) +rxt(16)*y(17) +2.000_r8*rxt(22)*y(24) +rxt(26)*y(31) +rxt(32) &
                 *y(37) +rxt(19)*y(57)
         loss(34) = (rxt(117)* y(2) +rxt(116)* y(9) +rxt(112)* y(10) +rxt(127)* y(18) &
                  +rxt(118)* y(22) +rxt(119)* y(23) + rxt(12) + rxt(13))* y(11)
         prod(34) = (rxt(28) +rxt(170)*y(2) +rxt(171)*y(22) +rxt(172)*y(25))*y(32) &
                  + (rxt(9) +rxt(10) +rxt(113))*y(14) + (rxt(110)*y(2) +rxt(111)*y(1)) &
                 *y(10) +rxt(115)*y(22)*y(12) +rxt(14)*y(13) +rxt(33)*y(38)
         loss(18) = (rxt(115)* y(22) + rxt(11) + het_rates(2))* y(12)
         prod(18) = (rxt(192) +rxt(198) +rxt(203) +rxt(194)*y(30) +rxt(199)*y(30) + &
                 rxt(205)*y(30))*y(32) + (2.000_r8*rxt(191) +2.000_r8*rxt(197) + &
                 2.000_r8*rxt(202))*y(14) + (rxt(193) +rxt(201) +rxt(204))*y(38) &
                  +rxt(114)*y(22)*y(10) +rxt(127)*y(18)*y(11)
         loss(11) = (rxt(121)* y(22) + rxt(14) + rxt(15) + rxt(122) + het_rates(5)) &
                 * y(13)
         prod(11) =rxt(120)*y(23)*y(10)
         loss(7) = ( + rxt(9) + rxt(10) + rxt(113) + rxt(191) + rxt(197) + rxt(202) &
                  + het_rates(9))* y(14)
         prod(7) =rxt(112)*y(11)*y(10)
         loss(23) = (rxt(124)* y(9) +rxt(125)* y(23))* y(16)
         prod(23) = (rxt(87)*y(3) +rxt(123)*y(22) +rxt(153)*y(25))*y(15) &
                  +rxt(126)*y(22)*y(17)
         loss(10) = (rxt(126)* y(22) + rxt(16) + het_rates(4))* y(17)
         prod(10) =rxt(125)*y(23)*y(16)
         loss(28) = (rxt(129)* y(2) +rxt(127)* y(11) +rxt(128)* y(22) +rxt(152)* y(25) &
                  +rxt(175)* y(34) + rxt(17) + rxt(18) + het_rates(3))* y(18)
         prod(28) = (rxt(88)*y(15) +rxt(89)*y(15))*y(3) +rxt(124)*y(16)*y(9) +rxt(16) &
                 *y(17)
         loss(29) = (rxt(132)* y(1) +rxt(131)* y(4) + (rxt(133) +rxt(134) +rxt(135)) &
                 * y(23))* y(21)
         prod(29) = (rxt(130)*y(19) +rxt(141)*y(20) +rxt(128)*y(18) +rxt(136)*y(2)) &
                 *y(22) + (rxt(88)*y(15) +rxt(90)*y(20))*y(3) + (rxt(19) + &
                 2.000_r8*rxt(21))*y(57) +rxt(16)*y(17) +2.000_r8*rxt(17)*y(18) &
                  +rxt(148)*y(25)*y(20) +rxt(27)*y(30)
         loss(37) = (rxt(144)* y(1) +rxt(143)* y(2) +rxt(107)* y(9) +rxt(120)* y(10) &
                  +rxt(119)* y(11) +rxt(125)* y(16) + (rxt(133) +rxt(134) +rxt(135)) &
                 * y(21) +rxt(138)* y(22) + 2._r8*rxt(145)* y(23) + (rxt(150) + &
                 rxt(151))* y(25) +rxt(157)* y(27) +rxt(174)* y(34) +rxt(178)* y(35)) &
                 * y(23)
         prod(37) = (rxt(187)*y(39) +rxt(190)*y(40) +rxt(118)*y(11) +rxt(137)*y(1) + &
                 rxt(142)*y(24) +rxt(155)*y(27) +rxt(177)*y(35))*y(22) &
                  + (rxt(127)*y(11) +rxt(129)*y(2) +rxt(152)*y(25) +rxt(175)*y(34)) &
                 *y(18) + (rxt(15) +rxt(122))*y(13) + (rxt(146)*y(2) +rxt(149)*y(25)) &
                 *y(24) +rxt(88)*y(15)*y(3) +rxt(131)*y(21)*y(4) +rxt(124)*y(16)*y(9) &
                  +rxt(186)*y(39)*y(25)
         loss(16) = (rxt(146)* y(2) +rxt(142)* y(22) +rxt(149)* y(25) + rxt(22) &
                  + het_rates(1))* y(24)
         prod(16) =rxt(140)*y(22)*y(22) +rxt(145)*y(23)*y(23)
         loss(26) = (rxt(79)* y(3) + rxt(19) + rxt(20) + rxt(21))* y(57)
         prod(26) = (rxt(123)*y(15) +rxt(141)*y(20) +rxt(187)*y(39) +rxt(188)*y(46) + &
                 rxt(189)*y(44) +rxt(190)*y(40) +rxt(115)*y(12) +rxt(121)*y(13) + &
                 rxt(126)*y(17) +rxt(128)*y(18) +rxt(138)*y(23) +rxt(139)*y(22) + &
                 rxt(142)*y(24) +rxt(165)*y(30) +rxt(169)*y(31) +rxt(185)*y(36))*y(22) &
                  + (rxt(195)*y(31) +rxt(196)*y(37) +rxt(200)*y(31) +rxt(206)*y(31) + &
                 rxt(207)*y(37))*y(30) +rxt(135)*y(23)*y(21)
         loss(42) = (rxt(147)* y(1) +rxt(153)* y(15) +rxt(152)* y(18) +rxt(148)* y(20) &
                  + (rxt(150) +rxt(151))* y(23) +rxt(149)* y(24) +rxt(168)* y(31) &
                  +rxt(172)* y(32) +rxt(186)* y(39))* y(25)
         prod(42) = (rxt(154)*y(2) +rxt(155)*y(22) +rxt(158)*y(9) + &
                 2.000_r8*rxt(160)*y(27) +rxt(162)*y(27) +rxt(182)*y(35))*y(27) &
                  + (3.000_r8*rxt(83)*y(41) +2.000_r8*rxt(84)*y(42) + &
                 3.000_r8*rxt(85)*y(43) +rxt(86)*y(44) +rxt(91)*y(30))*y(3) &
                  + (rxt(187)*y(39) +3.000_r8*rxt(188)*y(46) +rxt(189)*y(44) + &
                 rxt(165)*y(30))*y(22) + (rxt(27) +rxt(166)*y(2))*y(30) &
                  +2.000_r8*rxt(23)*y(26) +2.000_r8*rxt(25)*y(29) +rxt(26)*y(31) &
                  +rxt(28)*y(32) +rxt(30)*y(33)
         loss(5) = ( + rxt(23))* y(26)
         prod(5) = (rxt(194)*y(32) +rxt(195)*y(31) +rxt(199)*y(32) +rxt(200)*y(31) + &
                 rxt(205)*y(32) +rxt(206)*y(31))*y(30) +rxt(172)*y(32)*y(25) &
                  +rxt(161)*y(27)*y(27)
         loss(31) = (rxt(154)* y(2) +rxt(158)* y(9) +rxt(159)* y(10) + (rxt(155) + &
                 rxt(156))* y(22) +rxt(157)* y(23) + 2._r8*(rxt(160) +rxt(161) + &
                 rxt(162) +rxt(163))* y(27) + (rxt(181) +rxt(182) +rxt(183))* y(35)) &
                 * y(27)
         prod(31) = (rxt(147)*y(1) +rxt(151)*y(23) +rxt(168)*y(31))*y(25) &
                  + (rxt(167)*y(31) +rxt(170)*y(32))*y(2) +rxt(169)*y(31)*y(22) &
                  +rxt(24)*y(28) +2.000_r8*rxt(164)*y(29) +rxt(29)*y(32)
         loss(4) = ( + rxt(24))* y(28)
         prod(4) = (rxt(162)*y(27) +rxt(181)*y(35))*y(27)
         loss(1) = ( + rxt(25) + rxt(164))* y(29)
         prod(1) =rxt(163)*y(27)*y(27)
         loss(38) = (rxt(166)* y(2) +rxt(91)* y(3) +rxt(165)* y(22) + (rxt(195) + &
                 rxt(200) +rxt(206))* y(31) + (rxt(194) +rxt(199) +rxt(205))* y(32) &
                  + (rxt(196) +rxt(207))* y(37) + rxt(27) + het_rates(8))* y(30)
         prod(38) = (rxt(148)*y(20) +rxt(153)*y(15) +2.000_r8*rxt(186)*y(39) + &
                 rxt(149)*y(24) +rxt(150)*y(23) +rxt(152)*y(18) +rxt(168)*y(31))*y(25) &
                  +rxt(156)*y(27)*y(22)
         loss(24) = (rxt(167)* y(2) +rxt(169)* y(22) +rxt(168)* y(25) + (rxt(195) + &
                 rxt(200) +rxt(206))* y(30) + rxt(26) + het_rates(10))* y(31)
         prod(24) = (rxt(192) +rxt(198) +rxt(203) +rxt(171)*y(22))*y(32) &
                  +rxt(157)*y(27)*y(23)
         loss(25) = (rxt(170)* y(2) +rxt(171)* y(22) +rxt(172)* y(25) + (rxt(194) + &
                 rxt(199) +rxt(205))* y(30) + rxt(28) + rxt(29) + rxt(192) + rxt(198) &
                  + rxt(203) + het_rates(6))* y(32)
         prod(25) =rxt(159)*y(27)*y(10)
         loss(6) = ( + rxt(30))* y(33)
         prod(6) = (rxt(196)*y(37) +rxt(207)*y(37))*y(30) +rxt(183)*y(35)*y(27)
         loss(36) = (rxt(173)* y(1) +rxt(175)* y(18) +rxt(174)* y(23))* y(34)
         prod(36) = (rxt(31) +rxt(176)*y(2) +rxt(177)*y(22) +rxt(179)*y(9) + &
                 rxt(181)*y(27) +rxt(182)*y(27) +2.000_r8*rxt(184)*y(35))*y(35) &
                  + (rxt(190)*y(40) +rxt(185)*y(36))*y(22) +rxt(30)*y(33) +rxt(32) &
                 *y(37) +rxt(33)*y(38)
         loss(30) = (rxt(176)* y(2) +rxt(179)* y(9) +rxt(180)* y(10) +rxt(177)* y(22) &
                  +rxt(178)* y(23) + (rxt(181) +rxt(182) +rxt(183))* y(27) &
                  + 2._r8*rxt(184)* y(35) + rxt(31))* y(35)
         prod(30) =rxt(173)*y(34)*y(1) +rxt(34)*y(38)
         loss(8) = (rxt(185)* y(22) + het_rates(12))* y(36)
         prod(8) = (rxt(174)*y(23) +rxt(175)*y(18))*y(34)
         loss(13) = ((rxt(196) +rxt(207))* y(30) + rxt(32) + het_rates(11))* y(37)
         prod(13) = (rxt(193) +rxt(201) +rxt(204))*y(38) +rxt(178)*y(35)*y(23)
         loss(9) = ( + rxt(33) + rxt(34) + rxt(193) + rxt(201) + rxt(204) &
                  + het_rates(7))* y(38)
         prod(9) =rxt(180)*y(35)*y(10)
         loss(17) = ((rxt(210) +rxt(218))* y(2) +rxt(216)* y(4) +rxt(221)* y(55)) &
                 * y(50)
         prod(17) = 0.
         loss(19) = (rxt(211)* y(8) +rxt(212)* y(9) +rxt(220)* y(55) + rxt(217)) &
                 * y(51)
         prod(19) = (rxt(52) +rxt(64) +rxt(208)*y(53) +rxt(213)*y(52) +rxt(216)*y(50)) &
                 *y(4)
         loss(12) = (rxt(215)* y(2) + (rxt(213) +rxt(214))* y(4))* y(52)
         prod(12) =rxt(51)*y(8)
         loss(14) = (rxt(208)* y(4) + rxt(209))* y(53)
         prod(14) = (rxt(48) +rxt(49) +rxt(50) +rxt(61) +rxt(62) +rxt(63) + &
                 rxt(215)*y(52) +rxt(218)*y(50))*y(2) + (rxt(54) +rxt(55) +rxt(56) + &
                 rxt(66) +rxt(67) +rxt(68))*y(4)
         loss(21) = (rxt(219)* y(55))* y(54)
         prod(21) = (rxt(217) +rxt(211)*y(8) +rxt(212)*y(9))*y(51) +rxt(210)*y(50) &
                 *y(2) +rxt(214)*y(52)*y(4) +rxt(7)*y(9) +rxt(209)*y(53)
         loss(15) = (rxt(103)* y(2) +rxt(102)* y(4))* y(56)
         prod(15) = (rxt(210)*y(2) +.900_r8*rxt(221)*y(55))*y(50) &
                  +.800_r8*rxt(219)*y(55)*y(54)
         loss(22) = (rxt(221)* y(50) +rxt(220)* y(51) +rxt(219)* y(54))* y(55)
         prod(22) = (rxt(52) +rxt(54) +rxt(55) +rxt(56) +rxt(64) +rxt(66) +rxt(67) + &
                 rxt(68))*y(4) + (rxt(48) +rxt(49) +rxt(50) +rxt(61) +rxt(62) + &
                 rxt(63))*y(2) +rxt(51)*y(8) +rxt(7)*y(9)

      end subroutine imp_prod_loss

      end module mo_prod_loss
