
      module mo_setrxt

      private
      public :: setrxt
      public :: setrxt_hrates

      contains

      subroutine setrxt( rate, temp, m, ncol )

      use ppgrid,       only : pver, pcols
      use shr_kind_mod, only : r8 => shr_kind_r8
      use chem_mods, only : rxntot
      use mo_jpl,    only : jpl

      implicit none

!-------------------------------------------------------
!       ... dummy arguments
!-------------------------------------------------------
      integer, intent(in) :: ncol
      real(r8), intent(in)    :: temp(pcols,pver)
      real(r8), intent(in)    :: m(ncol,pver)
      real(r8), intent(inout) :: rate(ncol,pver,rxntot)

!-------------------------------------------------------
!       ... local variables
!-------------------------------------------------------
      integer  ::  n
      real(r8)  ::  itemp(ncol,pver)
      real(r8)  ::  exp_fac(ncol,pver)
      real(r8)  :: ko(ncol,pver)
      real(r8)  :: kinf(ncol,pver)

      rate(:,:,79) = 2.2e-10_r8
      rate(:,:,80) = 6.7e-11_r8
      rate(:,:,81) = 4.9e-11_r8
      rate(:,:,82) = 1.20e-10_r8
      rate(:,:,83) = 1.70e-10_r8
      rate(:,:,84) = 1.20e-10_r8
      rate(:,:,85) = 1.50e-10_r8
      rate(:,:,86) = 7.20e-11_r8
      rate(:,:,87) = 1.125e-10_r8
      rate(:,:,88) = 3.0e-11_r8
      rate(:,:,89) = 7.5e-12_r8
      rate(:,:,90) = 1.1e-10_r8
      rate(:,:,91) = 1.5e-10_r8
      rate(:,:,92) = 8.e-14_r8
      rate(:,:,93) = 3.9e-17_r8
      rate(:,:,94) = 2.1e-15_r8
      rate(:,:,95) = 2.2e-11_r8
      rate(:,:,96) = 4.2e-13_r8
      rate(:,:,97) = 8.5e-2_r8
      rate(:,:,98) = 1.3e-16_r8
      rate(:,:,100) = 1.e-20_r8
      rate(:,:,101) = 2.58e-4_r8
      rate(:,:,102) = 5.e-12_r8
      rate(:,:,103) = 7.e-13_r8
      rate(:,:,117) = 1.e-11_r8
      rate(:,:,118) = 2.2e-11_r8
      rate(:,:,119) = 3.5e-12_r8
      rate(:,:,128) = 9.e-12_r8
      rate(:,:,133) = 7.21e-11_r8
      rate(:,:,134) = 7.29e-12_r8
      rate(:,:,135) = 1.62e-12_r8
      rate(:,:,167) = 1.70e-13_r8
      rate(:,:,177) = 7.5e-11_r8
      rate(:,:,185) = 1.10e-11_r8
      rate(:,:,211) = 1.e-10_r8
      rate(:,:,212) = 4.4e-10_r8
      rate(:,:,213) = 4.e-10_r8
      rate(:,:,214) = 2.e-10_r8
      rate(:,:,215) = 1.e-12_r8
      rate(:,:,216) = 6.e-11_r8
      rate(:,:,217) = 5.e-16_r8
      itemp(:ncol,:) = 1._r8 / temp(:ncol,:)
      n = ncol*pver
#ifndef AIX
      rate(:,:,74) = 8e-12_r8 * exp( -2060._r8 * itemp(:,:) )
      rate(:,:,76) = 1.8e-11_r8 * exp( 110._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 70._r8 * itemp(:,:) )
      rate(:,:,77) = 3.04e-11_r8 * exp_fac(:,:)
      rate(:,:,78) = 1.60e-12_r8 * exp_fac(:,:)
      rate(:,:,154) = 3.00e-11_r8 * exp_fac(:,:)
      rate(:,:,99) = 3.6e-18_r8 * exp( -220._r8 * itemp(:,:) )
      rate(:,:,104) = 1.5e-11_r8 * exp( -3600._r8 * itemp(:,:) )
      rate(:,:,105) = 2.1e-11_r8 * exp( 100._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 250._r8 * itemp(:,:) )
      rate(:,:,107) = 3.5e-12_r8 * exp_fac(:,:)
      rate(:,:,138) = 4.8e-11_r8 * exp_fac(:,:)
      rate(:,:,108) = 3e-12_r8 * exp( -1500._r8 * itemp(:,:) )
      rate(:,:,109) = 5.6e-12_r8 * exp( 180._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( -2450._r8 * itemp(:,:) )
      rate(:,:,111) = 1.2e-13_r8 * exp_fac(:,:)
      rate(:,:,160) = 3.00e-11_r8 * exp_fac(:,:)
      exp_fac(:,:) = exp( 170._r8 * itemp(:,:) )
      rate(:,:,116) = 1.5e-11_r8 * exp_fac(:,:)
      rate(:,:,150) = 1.80e-11_r8 * exp_fac(:,:)
      rate(:,:,121) = 1.3e-12_r8 * exp( 380._r8 * itemp(:,:) )
      rate(:,:,123) = 2.45e-12_r8 * exp( -1775._r8 * itemp(:,:) )
      rate(:,:,124) = 2.8e-12_r8 * exp( 300._r8 * itemp(:,:) )
      rate(:,:,125) = 4.1e-13_r8 * exp( 750._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 200._r8 * itemp(:,:) )
      rate(:,:,126) = 3.8e-12_r8 * exp_fac(:,:)
      rate(:,:,143) = 3e-11_r8 * exp_fac(:,:)
      rate(:,:,127) = 6.0e-13_r8 * exp( -2058._r8 * itemp(:,:) )
      rate(:,:,129) = 3.40e-11_r8 * exp( -1600.0_r8 * itemp(:,:) )
      rate(:,:,132) = 1.40e-10_r8 * exp( -470.0_r8 * itemp(:,:) )
      rate(:,:,136) = 2.2e-11_r8 * exp( 120._r8 * itemp(:,:) )
      rate(:,:,137) = 1.7e-12_r8 * exp( -940._r8 * itemp(:,:) )
      rate(:,:,139) = 4.2e-12_r8 * exp( -240._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( -2000._r8 * itemp(:,:) )
      rate(:,:,141) = 5.5e-12_r8 * exp_fac(:,:)
      rate(:,:,146) = 1.4e-12_r8 * exp_fac(:,:)
      rate(:,:,142) = 2.9e-12_r8 * exp( -160._r8 * itemp(:,:) )
      rate(:,:,144) = 1.e-14_r8 * exp( -490._r8 * itemp(:,:) )
      rate(:,:,147) = 2.30e-11_r8 * exp( -200._r8 * itemp(:,:) )
      rate(:,:,148) = 3.70e-11_r8 * exp( -2300.0_r8 * itemp(:,:) )
      rate(:,:,149) = 1.10e-11_r8 * exp( -980.0_r8 * itemp(:,:) )
      rate(:,:,151) = 4.10e-11_r8 * exp( -450.0_r8 * itemp(:,:) )
      rate(:,:,152) = 8.10e-11_r8 * exp( -30.0_r8 * itemp(:,:) )
      rate(:,:,153) = 9.60e-12_r8 * exp( -1360._r8 * itemp(:,:) )
      rate(:,:,155) = 7.4e-12_r8 * exp( 270._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 230._r8 * itemp(:,:) )
      rate(:,:,156) = 6.0e-13_r8 * exp_fac(:,:)
      rate(:,:,176) = 1.90e-11_r8 * exp_fac(:,:)
      rate(:,:,184) = 1.5e-12_r8 * exp_fac(:,:)
      rate(:,:,157) = 2.70e-12_r8 * exp( 220._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( +290.0_r8 * itemp(:,:) )
      rate(:,:,158) = 6.40e-12_r8 * exp_fac(:,:)
      rate(:,:,183) = 4.10e-13_r8 * exp_fac(:,:)
      rate(:,:,161) = 1.00e-12_r8 * exp( -1590.0_r8 * itemp(:,:) )
      rate(:,:,162) = 3.50e-13_r8 * exp( -1370.0_r8 * itemp(:,:) )
      rate(:,:,165) = 2.60e-12_r8 * exp( -350._r8 * itemp(:,:) )
      rate(:,:,166) = 1.00e-11_r8 * exp( -3300._r8 * itemp(:,:) )
      rate(:,:,168) = 2.50e-12_r8 * exp( -130._r8 * itemp(:,:) )
      rate(:,:,169) = 3.00e-12_r8 * exp( -500._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( -800._r8 * itemp(:,:) )
      rate(:,:,170) = 2.90e-12_r8 * exp_fac(:,:)
      rate(:,:,173) = 1.70e-11_r8 * exp_fac(:,:)
      rate(:,:,175) = 1.70e-11_r8 * exp_fac(:,:)
      rate(:,:,171) = 1.20e-12_r8 * exp( -330._r8 * itemp(:,:) )
      rate(:,:,172) = 6.50e-12_r8 * exp( 135._r8 * itemp(:,:) )
      rate(:,:,174) = 1.50e-11_r8 * exp( -600._r8 * itemp(:,:) )
      rate(:,:,178) = 3.40e-12_r8 * exp( 540._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 260._r8 * itemp(:,:) )
      rate(:,:,179) = 8.80e-12_r8 * exp_fac(:,:)
      rate(:,:,182) = 2.30e-12_r8 * exp_fac(:,:)
      rate(:,:,181) = 9.50e-13_r8 * exp( 550._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( -1250._r8 * itemp(:,:) )
      rate(:,:,186) = 3.20e-11_r8 * exp_fac(:,:)
      rate(:,:,187) = 2.40e-12_r8 * exp_fac(:,:)
      rate(:,:,188) = 1.60e-12_r8 * exp( -1520._r8 * itemp(:,:) )
      rate(:,:,189) = 4.00e-12_r8 * exp( -1400._r8 * itemp(:,:) )
      rate(:,:,190) = 2.35e-12_r8 * exp( -1300._r8 * itemp(:,:) )
#else
      call vexp( exp_fac, -2060._r8*itemp, n )
      rate(:,:,74) = 8e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 110._r8*itemp, n )
      rate(:,:,76) = 1.8e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 70._r8 * itemp, n )
      rate(:,:,77) = 3.04e-11_r8 * exp_fac(:,:)
      rate(:,:,78) = 1.60e-12_r8 * exp_fac(:,:)
      rate(:,:,154) = 3.00e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -220._r8*itemp, n )
      rate(:,:,99) = 3.6e-18_r8 * exp_fac(:,:)
      call vexp( exp_fac, -3600._r8*itemp, n )
      rate(:,:,104) = 1.5e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 100._r8*itemp, n )
      rate(:,:,105) = 2.1e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 250._r8 * itemp, n )
      rate(:,:,107) = 3.5e-12_r8 * exp_fac(:,:)
      rate(:,:,138) = 4.8e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1500._r8*itemp, n )
      rate(:,:,108) = 3e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 180._r8*itemp, n )
      rate(:,:,109) = 5.6e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -2450._r8 * itemp, n )
      rate(:,:,111) = 1.2e-13_r8 * exp_fac(:,:)
      rate(:,:,160) = 3.00e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 170._r8 * itemp, n )
      rate(:,:,116) = 1.5e-11_r8 * exp_fac(:,:)
      rate(:,:,150) = 1.80e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 380._r8*itemp, n )
      rate(:,:,121) = 1.3e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1775._r8*itemp, n )
      rate(:,:,123) = 2.45e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 300._r8*itemp, n )
      rate(:,:,124) = 2.8e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 750._r8*itemp, n )
      rate(:,:,125) = 4.1e-13_r8 * exp_fac(:,:)
      call vexp( exp_fac, 200._r8 * itemp, n )
      rate(:,:,126) = 3.8e-12_r8 * exp_fac(:,:)
      rate(:,:,143) = 3e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -2058._r8*itemp, n )
      rate(:,:,127) = 6.0e-13_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1600.0_r8*itemp, n )
      rate(:,:,129) = 3.40e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -470.0_r8*itemp, n )
      rate(:,:,132) = 1.40e-10_r8 * exp_fac(:,:)
      call vexp( exp_fac, 120._r8*itemp, n )
      rate(:,:,136) = 2.2e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -940._r8*itemp, n )
      rate(:,:,137) = 1.7e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -240._r8*itemp, n )
      rate(:,:,139) = 4.2e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -2000._r8 * itemp, n )
      rate(:,:,141) = 5.5e-12_r8 * exp_fac(:,:)
      rate(:,:,146) = 1.4e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -160._r8*itemp, n )
      rate(:,:,142) = 2.9e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -490._r8*itemp, n )
      rate(:,:,144) = 1.e-14_r8 * exp_fac(:,:)
      call vexp( exp_fac, -200._r8*itemp, n )
      rate(:,:,147) = 2.30e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -2300.0_r8*itemp, n )
      rate(:,:,148) = 3.70e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -980.0_r8*itemp, n )
      rate(:,:,149) = 1.10e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -450.0_r8*itemp, n )
      rate(:,:,151) = 4.10e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -30.0_r8*itemp, n )
      rate(:,:,152) = 8.10e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1360._r8*itemp, n )
      rate(:,:,153) = 9.60e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 270._r8*itemp, n )
      rate(:,:,155) = 7.4e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 230._r8 * itemp, n )
      rate(:,:,156) = 6.0e-13_r8 * exp_fac(:,:)
      rate(:,:,176) = 1.90e-11_r8 * exp_fac(:,:)
      rate(:,:,184) = 1.5e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 220._r8*itemp, n )
      rate(:,:,157) = 2.70e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, +290.0_r8 * itemp, n )
      rate(:,:,158) = 6.40e-12_r8 * exp_fac(:,:)
      rate(:,:,183) = 4.10e-13_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1590.0_r8*itemp, n )
      rate(:,:,161) = 1.00e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1370.0_r8*itemp, n )
      rate(:,:,162) = 3.50e-13_r8 * exp_fac(:,:)
      call vexp( exp_fac, -350._r8*itemp, n )
      rate(:,:,165) = 2.60e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -3300._r8*itemp, n )
      rate(:,:,166) = 1.00e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -130._r8*itemp, n )
      rate(:,:,168) = 2.50e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -500._r8*itemp, n )
      rate(:,:,169) = 3.00e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -800._r8 * itemp, n )
      rate(:,:,170) = 2.90e-12_r8 * exp_fac(:,:)
      rate(:,:,173) = 1.70e-11_r8 * exp_fac(:,:)
      rate(:,:,175) = 1.70e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -330._r8*itemp, n )
      rate(:,:,171) = 1.20e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 135._r8*itemp, n )
      rate(:,:,172) = 6.50e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -600._r8*itemp, n )
      rate(:,:,174) = 1.50e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 540._r8*itemp, n )
      rate(:,:,178) = 3.40e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 260._r8 * itemp, n )
      rate(:,:,179) = 8.80e-12_r8 * exp_fac(:,:)
      rate(:,:,182) = 2.30e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 550._r8*itemp, n )
      rate(:,:,181) = 9.50e-13_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1250._r8 * itemp, n )
      rate(:,:,186) = 3.20e-11_r8 * exp_fac(:,:)
      rate(:,:,187) = 2.40e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1520._r8*itemp, n )
      rate(:,:,188) = 1.60e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1400._r8*itemp, n )
      rate(:,:,189) = 4.00e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1300._r8*itemp, n )
      rate(:,:,190) = 2.35e-12_r8 * exp_fac(:,:)
#endif

      itemp(:,:) = 300._r8 * itemp(:,:)

      ko(:,:) = 9.0e-32_r8 * itemp(:,:)**1.5_r8
      kinf(:,:) = 3.0e-11_r8
      call jpl( rate(1,1,106), m, 0.6_r8, ko, kinf, n )

      ko(:,:) = 2.5e-31_r8 * itemp(:,:)**1.8_r8
      kinf(:,:) = 2.2e-11_r8 * itemp(:,:)**.7_r8
      call jpl( rate(1,1,110), m, 0.6_r8, ko, kinf, n )

      ko(:,:) = 2.e-30_r8 * itemp(:,:)**4.4_r8
      kinf(:,:) = 1.4e-12_r8 * itemp(:,:)**.7_r8
      call jpl( rate(1,1,112), m, .6_r8, ko, kinf, n )

      ko(:,:) = 2.0e-30_r8 * itemp(:,:)**3.0_r8
      kinf(:,:) = 2.5e-11_r8
      call jpl( rate(1,1,114), m, .6_r8, ko, kinf, n )

      ko(:,:) = 1.8e-31_r8 * itemp(:,:)**3.2_r8
      kinf(:,:) = 4.7e-12_r8 * itemp(:,:)**1.4_r8
      call jpl( rate(1,1,120), m, .6_r8, ko, kinf, n )

      ko(:,:) = 5.7e-32_r8 * itemp(:,:)**1.6_r8
      kinf(:,:) = 7.5e-11_r8
      call jpl( rate(1,1,131), m, .6_r8, ko, kinf, n )

      ko(:,:) = 6.9e-31_r8 * itemp(:,:)**1.0_r8
      kinf(:,:) = 2.6e-11_r8
      call jpl( rate(1,1,140), m, .6_r8, ko, kinf, n )

      ko(:,:) = 1.8e-31_r8 * itemp(:,:)**3.4_r8
      kinf(:,:) = 1.5e-11_r8 * itemp(:,:)**1.9_r8
      call jpl( rate(1,1,159), m, .6_r8, ko, kinf, n )

      ko(:,:) = 1.6e-32_r8 * itemp(:,:)**4.5_r8
      kinf(:,:) = 2.0e-12_r8 * itemp(:,:)**2.4_r8
      call jpl( rate(1,1,163), m, .6_r8, ko, kinf, n )

      ko(:,:) = 5.2e-31_r8 * itemp(:,:)**3.2_r8
      kinf(:,:) = 6.9e-12_r8 * itemp(:,:)**2.9_r8
      call jpl( rate(1,1,180), m, .6_r8, ko, kinf, n )

      end subroutine setrxt


      subroutine setrxt_hrates( rate, temp, m, ncol, kbot )

      use ppgrid,       only : pver, pcols
      use shr_kind_mod, only : r8 => shr_kind_r8
      use chem_mods, only : rxntot
      use mo_jpl,    only : jpl

      implicit none

!-------------------------------------------------------
!       ... dummy arguments
!-------------------------------------------------------
      integer, intent(in) :: ncol
      integer, intent(in) :: kbot
      real(r8), intent(in)    :: temp(pcols,pver)
      real(r8), intent(in)    :: m(ncol,pver)
      real(r8), intent(inout) :: rate(ncol,pver,rxntot)

!-------------------------------------------------------
!       ... local variables
!-------------------------------------------------------
      integer  ::  n
      real(r8)  ::  itemp(ncol,kbot)
      real(r8)  ::  exp_fac(ncol,kbot)
      real(r8)  :: ko(ncol,kbot)
      real(r8)  :: kinf(ncol,kbot)
      real(r8)  :: wrk(ncol,kbot)

      rate(:,:kbot,92) = 8.e-14_r8
      rate(:,:kbot,93) = 3.9e-17_r8
      rate(:,:kbot,94) = 2.1e-15_r8
      rate(:,:kbot,95) = 2.2e-11_r8
      rate(:,:kbot,97) = 8.5e-2_r8
      rate(:,:kbot,98) = 1.3e-16_r8
      rate(:,:kbot,100) = 1.e-20_r8
      rate(:,:kbot,101) = 2.58e-4_r8
      rate(:,:kbot,102) = 5.e-12_r8
      rate(:,:kbot,103) = 7.e-13_r8
      rate(:,:kbot,134) = 7.29e-12_r8
      rate(:,:kbot,211) = 1.e-10_r8
      rate(:,:kbot,212) = 4.4e-10_r8
      rate(:,:kbot,213) = 4.e-10_r8
      rate(:,:kbot,214) = 2.e-10_r8
      rate(:,:kbot,215) = 1.e-12_r8
      rate(:,:kbot,216) = 6.e-11_r8
      itemp(:ncol,:kbot) = 1._r8 / temp(:ncol,:kbot)
      n = ncol*kbot
#ifndef AIX
      rate(:,:kbot,74) = 8e-12_r8 * exp( -2060._r8 * itemp(:,:) )
      rate(:,:kbot,76) = 1.8e-11_r8 * exp( 110._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 70._r8 * itemp(:,:) )
      rate(:,:kbot,77) = 3.04e-11_r8 * exp_fac(:,:)
      rate(:,:kbot,78) = 1.60e-12_r8 * exp_fac(:,:)
      rate(:,:kbot,99) = 3.6e-18_r8 * exp( -220._r8 * itemp(:,:) )
      rate(:,:kbot,104) = 1.5e-11_r8 * exp( -3600._r8 * itemp(:,:) )
      rate(:,:kbot,105) = 2.1e-11_r8 * exp( 100._r8 * itemp(:,:) )
      exp_fac(:,:) = exp( 250._r8 * itemp(:,:) )
      rate(:,:kbot,107) = 3.5e-12_r8 * exp_fac(:,:)
      rate(:,:kbot,138) = 4.8e-11_r8 * exp_fac(:,:)
      rate(:,:kbot,108) = 3e-12_r8 * exp( -1500._r8 * itemp(:,:) )
      rate(:,:kbot,109) = 5.6e-12_r8 * exp( 180._r8 * itemp(:,:) )
      rate(:,:kbot,132) = 1.40e-10_r8 * exp( -470.0_r8 * itemp(:,:) )
      rate(:,:kbot,136) = 2.2e-11_r8 * exp( 120._r8 * itemp(:,:) )
      rate(:,:kbot,137) = 1.7e-12_r8 * exp( -940._r8 * itemp(:,:) )
      rate(:,:kbot,143) = 3e-11_r8 * exp( 200._r8 * itemp(:,:) )
      rate(:,:kbot,144) = 1.e-14_r8 * exp( -490._r8 * itemp(:,:) )
#else
      call vexp( exp_fac, -2060._r8*itemp, n )
      rate(:,:kbot,74) = 8e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 110._r8*itemp, n )
      rate(:,:kbot,76) = 1.8e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 70._r8 * itemp, n )
      rate(:,:kbot,77) = 3.04e-11_r8 * exp_fac(:,:)
      rate(:,:kbot,78) = 1.60e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -220._r8*itemp, n )
      rate(:,:kbot,99) = 3.6e-18_r8 * exp_fac(:,:)
      call vexp( exp_fac, -3600._r8*itemp, n )
      rate(:,:kbot,104) = 1.5e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 100._r8*itemp, n )
      rate(:,:kbot,105) = 2.1e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, 250._r8 * itemp, n )
      rate(:,:kbot,107) = 3.5e-12_r8 * exp_fac(:,:)
      rate(:,:kbot,138) = 4.8e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -1500._r8*itemp, n )
      rate(:,:kbot,108) = 3e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 180._r8*itemp, n )
      rate(:,:kbot,109) = 5.6e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, -470.0_r8*itemp, n )
      rate(:,:kbot,132) = 1.40e-10_r8 * exp_fac(:,:)
      call vexp( exp_fac, 120._r8*itemp, n )
      rate(:,:kbot,136) = 2.2e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -940._r8*itemp, n )
      rate(:,:kbot,137) = 1.7e-12_r8 * exp_fac(:,:)
      call vexp( exp_fac, 200._r8*itemp, n )
      rate(:,:kbot,143) = 3e-11_r8 * exp_fac(:,:)
      call vexp( exp_fac, -490._r8*itemp, n )
      rate(:,:kbot,144) = 1.e-14_r8 * exp_fac(:,:)
#endif

      itemp(:,:) = 300._r8 * itemp(:,:)






      ko(:,:) = 5.7e-32_r8 * itemp(:,:)**1.6_r8
      kinf(:,:) = 7.5e-11_r8
      call jpl( wrk, m, .6_r8, ko, kinf, n )
      rate(:,:kbot,131) = wrk(:,:)





      end subroutine setrxt_hrates

      end module mo_setrxt
