!===============================================================================
! CVS $Id: data_in.F90,v 1.4 2002/07/16 23:25:25 kauff Exp $
! CVS $Source: /fs/cgd/csm/models/CVS.REPOS/atm/datm5/data_in.F90,v $
! CVS $Name: ccsm2_0_beta58 $
!===============================================================================

      SUBROUTINE data_in_atm()

      use calendar_mod ! calendar routines
      use control_mod 
      use atmdata_mod 

      implicit none

      !----- local  ------
      integer      i,j,k,n   ! generic indicies
      integer      k1,k2   ! generic indicies
      integer      dyear     ! data  year  of input data
      integer      dmonth    ! data  month of input data
      integer      dday      ! data  day   of input data
      integer      dsec      ! data  sec   of input data
      integer      reday1     ! model eday  assigned to input data
      integer      reday2     ! model eday  assigned to input data
      integer      ryear     ! model year  assigned to input data
      integer      rmonth    ! model month assigned to input data
      integer      rday      ! model day   assigned to input data
      logical      firstcall ! flags one-time startup operations
      data         firstcall /.true./

      save

!-------------------------------------------------------------------------------
! PURPOSE:
!   update raw data fields
! ASSUMPTIONS:
!   o input data is in the form of daily mean fields
!   o input data is assigned to noon of any given day
!-------------------------------------------------------------------------------

      !-----------------------------------------------------------------------
      ! get real data that brackets model date & time 
      !-----------------------------------------------------------------------

      if ( (mod(sec+10800,21600).eq.0) .or. firstcall ) then 

          if (sec.lt.10800) reday1 = eday-1    ! we want data corresponding
          if (sec.ge.10800) reday1 = eday      ! we want data corresponding
          if (sec .ge. 75600 .or.  sec .lt. 10800) r_sec(1) = 75600
          if (sec .ge. 10800 .and. sec .lt. 32400) r_sec(1) = 10800 
          if (sec .ge. 32400 .and. sec .lt. 54000) r_sec(1) = 32400 
          if (sec .ge. 54000 .and. sec .lt. 75600) r_sec(1) = 54000 

          !--- normal situation ---
          call eday2ymd (reday1,ryear,rmonth,rday)
          call eday2date(reday1,r_cdate(1))
!         write(6,*)'ryear=',ryear,'rmonth=',rmonth,'rday=',rday 
          write(6,*) 'model date assigned to data r_cdate(1)= '  &
          &             ,r_cdate(1),'r_sec(1)=',r_sec(1)

          !----------------------------------------------
          ! get the data that brakets from below
          !----------------------------------------------
          dyear  = ryear
          dmonth = rmonth
          dday   = rday  
          dsec   = r_sec(1)
          k1 = 1
          call data_in_nc(dyear,dmonth,dday,dsec,k1)

          !-----------------------------------------------
          ! compute date of data that brackets from above
          !-----------------------------------------------
          if (sec.lt.75600) reday2 = eday    ! we want data corresponding
          if (sec.ge.75600) reday2 = eday + 1 ! to this date
          if (sec .ge. 75600 .or.  sec .lt. 10800) r_sec(2) = 10800
          if (sec .ge. 10800 .and. sec .lt. 32400) r_sec(2) = 32400 
          if (sec .ge. 32400 .and. sec .lt. 54000) r_sec(2) = 54000 
          if (sec .ge. 54000 .and. sec .lt. 75600) r_sec(2) = 75600 
          call eday2ymd (reday2,ryear,rmonth,rday)
          call eday2date(reday2,r_cdate(2))

          write(6,*) 'model date assigned to data r_cdate(2)= '  &
          &             ,r_cdate(2),'r_sec(2)=',r_sec(2)
          !----------------------------------------------
          ! get the data that brakets from above
          !----------------------------------------------
          dyear  = ryear
          dmonth = rmonth
          dday   = rday  
          dsec   = r_sec(2)
          k2     = 2 
          call data_in_nc(dyear,dmonth,dday,dsec,k2)

      endif

      firstcall = .false.

      RETURN
 9000 format('(data_in) ',a,a)
 9001 format('(data_in) ',a,i4,a,i4)
      END
 
!===============================================================================
