!===============================================================================
! CVS $Id: flux_solar.F90,v 1.4 2001/08/01 23:45:25 kauff Exp $
! CVS $Source: /fs/cgd/csm/models/CVS.REPOS/cpl/cpl5/flux_solar.F90,v $
! CVS $Name: ccsm2_0_beta58 $
!===============================================================================

SUBROUTINE flux_solar(Faoa,So,Faoc)

   USE buf_mod
   USE control_mod
   USE shr_orb_mod
   USE const_mod
   USE shr_timer_mod ! timing routines

   implicit none


   !----- arguments -----
   real    :: Faoa(n_o,nFaoa)     ! atm/ocn fluxes, computed by atm
   real    :: So  (n_o,nSo  )     ! ocn state
   real    :: Faoc(n_o,nFaoc)     ! atm/ocn fluxes, computed by cpl

   !----- local -----
   integer :: n                   ! loop index
   integer :: timer_n = -1        ! timer number

   save   

   character(len=*),parameter :: F00 = "('(flux_solar) ',2a)"

!-------------------------------------------------------------------------------
! PURPOSE:
!   compute atm/ocn absorbed short-wave (net sw)
!-------------------------------------------------------------------------------

   if (timer_n < 0) call shr_timer_get(timer_n,'flux_solar')
   call shr_timer_start(timer_n)

   if( albedo_type == 5 .or. albedo_type == 1 .or. albedo_type == 3 ) then   ! CPL original albedo scheme
!$OMP PARALLEL DO PRIVATE(n)
#ifdef MPI_P
      do n=ist_o,iend_o
#else
      do n=1,n_o
#endif
         Faoc(n,kFaoc_swnet) = (1.0-So(n,kSo_anidr))*Faoa(n,kFaoa_swndr)  &
        &                   + (1.0-So(n,kSo_avsdr))*Faoa(n,kFaoa_swvdr)  &
        &                   + (1.0-So(n,kSo_anidf))*Faoa(n,kFaoa_swndf)  &
        &                   + (1.0-So(n,kSo_avsdf))*Faoa(n,kFaoa_swvdf)
     enddo
!$omp  end parallel do
   else  if( albedo_type == 2 .or. albedo_type == 4 ) then ! the MOM  Albedo Scheme  
!$OMP PARALLEL DO PRIVATE(n)
#ifdef MPI_P
      do n=ist_o,iend_o
#else
      do n = 1, n_o
#endif
           Faoc(n,kFaoc_swnet) = ( 1 - So(n,kSo_albedo ) ) * ( Faoa(n,kFaoa_swndr) + Faoa(n,kFaoa_swvdr) + &
                                                       Faoa(n,kFaoa_swndf) + Faoa(n,kFaoa_swvdf) )
      enddo     
!$omp  end parallel do
   endif

   call shr_timer_stop(timer_n)

END subroutine flux_solar

