module spmd_mod

 use mpmd_mod,           only : master_task
  
 implicit none


contains
!--------------------------------------------------------------
 subroutine spmd_init( mpicom )

   include 'mpif.h'

   integer, intent(in) :: mpicom
  
   integer  :: rank
   integer  :: ierr, mpes, i, j

   integer, allocatable :: length(:)
   integer, allocatable :: displ(:)
   character*(MPI_MAX_PROCESSOR_NAME), allocatable :: proc_name(:)

   call mpi_comm_size( mpicom, mpes, ierr )
!   if( mpes == 1 ) master_task = .true. 

   call mpi_comm_rank(mpicom, rank, ierr )

   if( rank==0 ) then
       master_task = .true.
   else
      master_task = .false.
   endif
   
   print *,"------in spmd----myrank,master_task=",rank,master_task
   print *

   if( rank .ne. 0 )  CALL CLOSE_STDOUT 
   if( rank .ne. 0 )  CALL CLOSE_STDERR
   

!xjx   allocate (length(0:mpes-1))
!xjx   allocate (displ(0:mpes-1))
!xjx   allocate (proc_name(0:mpes-1))
!xjx---- added 20080510
!xjx     length = 0
!xjx     displ  = 0
!xjx------- end

!xjx   call mpi_get_processor_name (proc_name(rank),length(rank,ierr)
!xjx   call mpi_allgather (length(rank),1, mpi_integer, length, 1, mpi_integer, mpicom,ierr)
!xjx   do i =0,mpes-1
!xjx      displ(i)=i*MPI_MAX_PROCESSOR_NAME
!xjx   enddo
!xjx   call mpi_gatherv (proc_name(rank),length(rank),mpi_character, proc_name,length,displ,mpi_character,0,mpicom,ierr)

!xjx   deallocate (length)  
!xjx   deallocate (displ)  
!xjx   deallocate (proc_name)


   return

end subroutine spmd_init
!--------------------------------------------------------------
end module spmd_mod
