!===============================================================================
! CVS $Id: tcheck.F90,v 1.2 2000/04/28 16:26:20 kauff Exp $
! CVS $Source: /fs/cgd/csm/models/CVS.REPOS/cpl/cpl5/tcheck.F90,v $
! CVS $Name: ccsm2_0_beta58 $
!===============================================================================

SUBROUTINE tcheck(iflag)

   !--- global ---
   USE control_mod
   USE buf_mod
   USE calendar_mod  ! access to calendar routines
   USE shr_sys_mod   ! shared code: system calls
#ifdef MPI_P
!   use mpmd_mod, only: master_task
#endif

   !--- local ---
   integer          :: iflag      ! flags uncoordination in time
   integer          :: date_x     ! a model's cdate
   integer          :: year_x     ! a model's year 
   integer          :: month_x    ! a model's month
   integer          :: day_x      ! a model's day
   integer          :: sec_x      ! a model's elapsed seconds
   character(len=3) :: cmonth_x   ! month as a char string
   character(len=3) :: char_month(12)

   data  char_month /'Jan','Feb','Mar','Apr','May','Jun',  &
   &                 'Jul','Aug','Sep','Oct','Nov','Dec'/

   save 

   !--- formats ---
   character(len=*),parameter :: F00 = &
   &      "('(tcheck)',a4,' date ',i4.4,'-',a3,'-',i2.2,', ',i5,' sec')"

!-------------------------------------------------------------------------------
! PURPOSE:
!   check for time coordination between component models
!
! OPTIONS:
!   iflag .ne. 0 <=> the cpl will stop if component model dates 
!                    are uncoordinated (seconds are ignored)
!-------------------------------------------------------------------------------
   
   !--- print out cpl time & date ---
   date_x  = cdate
   sec_x   = sec
   call date2ymd(date_x,year_x,month_x,day_x)
   cmonth_x=char_month(month_x)
   write(6,F00) 'cpl',year_x,cmonth_x,day_x,sec_x

!---------------------wangln 20050707 to check the time at 11y5months--------------
!   write(6,*) '(Wangln)',cdate,sec
!   write(6,*) 'ATM Time',ibuff_a(4),ibuff_a(5) 
 !  write(6,*) 'LND Time',ibuff_l(4),ibuff_l(5) 
 !  write(6,*) 'OCN Time',ibuff_o(4),ibuff_o(5) 
 !  write(6,*) 'ICE Time',ibuff_i(4),ibuff_i(5) 
!---------------------wangln 20050707 to check the time at 11y5months--------------


   !--- check for time coordination (if requested) ---
   if (iflag.ne.0) then
     if (cdate .ne. ibuff_a(4)) ierr=-1
     if (sec   .ne. ibuff_a(5)) ierr=-1
     if (cdate .ne. ibuff_i(4)) ierr=-1
     if (sec   .ne. ibuff_i(5)) ierr=-1
     if (cdate .ne. ibuff_o(4)) ierr=-1
     if (sec   .ne. ibuff_o(5)) ierr=-1
     if (cdate .ne. ibuff_l(4)) ierr=-1
     if (sec   .ne. ibuff_l(5)) ierr=-1
   end if

   !--- print out model timesteps & dates ---
   if (eday.eq.eday0 .or. eday.eq.edayf .or.info_dbug.gt.1 .or. ierr.ne.0) then
      date_x  = ibuff_a(4)
      sec_x   = ibuff_a(5)
      call date2ymd(date_x,year_x,month_x,day_x)
      cmonth_x=char_month(month_x)
      write(6,F00) 'atm',year_x,cmonth_x,day_x,sec_x

      date_x  = ibuff_i(4)
      sec_x   = ibuff_i(5)
      call date2ymd(date_x,year_x,month_x,day_x)
      cmonth_x=char_month(month_x)
      write(6,F00) 'ice',year_x,cmonth_x,day_x,sec_x

      date_x  = ibuff_o(4)
      sec_x   = ibuff_o(5)
      call date2ymd(date_x,year_x,month_x,day_x)
      cmonth_x=char_month(month_x)
      write(6,F00) 'ocn',year_x,cmonth_x,day_x,sec_x

      date_x  = ibuff_l(4)
      sec_x   = ibuff_l(5)
      call date2ymd(date_x,year_x,month_x,day_x)
      cmonth_x=char_month(month_x)
      write(6,F00) 'lnd',year_x,cmonth_x,day_x,sec_x
   end if

   !--- enforce time coordination ---
   if (ierr.eq.-1) then
      write(6,*)'(tcheck) ERROR: models uncoordinated in time'
      call shr_sys_flush(6)
      STOP 'model t'
   end if 

END SUBROUTINE

!=======================================================================
