!===============================================================================
! CVS $Id: const_mod.F90,v 1.2 2001/12/07 22:13:35 kauff Exp $
! CVS $Source: /fs/cgd/csm/models/CVS.REPOS/cpl/cpl5/const_mod.F90,v $
! CVS $Name: ccsm2_0_beta58 $
!===============================================================================

module const_mod

   use kind_mod       ! defines kinds
   use shr_const_mod  ! shared physical constants

   public

   !----------------------------------------------------------------------------
   ! physical constants
   !----------------------------------------------------------------------------
   real,parameter :: pi      = SHR_CONST_PI      ! pi
   real,parameter :: rearth  = SHR_CONST_REARTH  ! radius of earth ~ m
   real,parameter :: g       = SHR_CONST_G       ! acceleration of gravity
   real,parameter :: deg2rad = pi/180.0_R8       ! convert degrees to radians
   real,parameter :: rad2deg = 180.0_R8/pi       ! convert radians to degrees

   real,parameter :: cpdair  = SHR_CONST_CPDAIR  ! specific heat of dry air
   real,parameter :: cpwv    = SHR_CONST_CPWV    ! specific heat of water vapor
   real,parameter :: cpvir   = cpwv/cpdair - 1.0 ! cpwv/cpdair - 1.0
   real,parameter :: zvir    = SHR_CONST_ZVIR    ! rh2o/rair   - 1.0
   real,parameter :: latvap  = SHR_CONST_LATVAP  ! latent heat of evaporation
   real,parameter :: latice  = SHR_CONST_LATICE  ! latent heat of fusion
   real,parameter :: stebol  = SHR_CONST_STEBOL  ! Stefan-Boltzmann constant
   real,parameter :: karman  = SHR_CONST_KARMAN  ! Von Karman constant

   real,parameter :: ocn_ref_sal = SHR_CONST_OCN_REF_SAL ! ocn ref salinity
   real,parameter :: ice_ref_sal = SHR_CONST_ICE_REF_SAL ! ice ref salinity

   real,parameter :: spval       = 1.0e30       ! special value

end module const_mod
