 program main


  use constants_mod,            only: constants_init
  use data_override_mod,        only: data_override_init, data_override
  use diag_manager_mod,         only: diag_manager_init, register_diag_field, diag_manager_end
  use diag_manager_mod,         only: DIAG_OCEAN, DIAG_OTHER, DIAG_ALL, get_base_date !liqq added
  use field_manager_mod,        only: field_manager_init
 
  use fms_mod,                  only: fms_init, fms_end, open_namelist_file, check_nml_error
  use fms_mod,                  only: close_file, file_exist, uppercase
  use fms_io_mod,               only: fms_io_exit
  
  use mpp_domains_mod,          only: domain2d, mpp_get_compute_domain
  use mpp_io_mod,               only: mpp_open, MPP_RDONLY, MPP_ASCII, MPP_OVERWR, MPP_APPEND, mpp_close, MPP_SINGLE
  use mpp_mod,                  only: mpp_error, FATAL, mpp_pe, mpp_npes, mpp_set_current_pelist
  use mpp_mod,                  only: stdlog, stdout, mpp_root_pe, mpp_clock_id
  use mpp_mod,                  only: mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC
  use mpp_mod,                  only: MPP_CLOCK_DETAILED, CLOCK_COMPONENT
 
  use fms_io_mod,               only: fms_io_init,close_file !liqq added
  use fms_mod,                  only: error_mesg, write_version_number !liqq added
  use mpp_mod,                  only: mpp_init, stderr,NOTE,WARNING, mpp_declare_pelist  !liqq added
  use mpp_io_mod,               only: MPP_NATIVE,MPP_DELETE !liqq added
  use mpp_domains_mod,          only: mpp_broadcast_domain !liqq  added

  use time_interp_external_mod, only: time_interp_external_init
  use time_manager_mod,         only: set_calendar_type, time_type, increment_time, increment_date
  use time_manager_mod,         only: set_time, set_date, get_time, get_date, month_name
  use time_manager_mod,         only: JULIAN, NOLEAP, THIRTY_DAY_MONTHS, NO_CALENDAR
  use time_manager_mod,         only: operator( <= ), operator( < ), operator( >= )
  use time_manager_mod,         only: operator( + ),  operator( - ), operator( / )
  use time_manager_mod,         only: days_in_month, operator (>), operator (*)  ! liqq added

  use ice_model_mod, only: ice_model_init, ice_model_end,  &
                              update_ice_model_slow_up,          &
                              update_ice_model_fast,          &
                              update_ice_model_slow_dn,          &
                              ice_data_type, land_ice_boundary_type, &
                              ocean_ice_boundary_type, atmos_ice_boundary_type
  !!================================= liuxw 20200616 ==============================       
  use ice_type_mod, only: ida_use, ida_analysis, ida_operate
  !!================================= liuxw 20200616 ==============================       
  use ice_type_mod, only: assimil_type, get_cycle_assimil

!---------wangln 2007-06-21 add the MPI--------------
   use mpmd_mod
   use shr_msg_mod,             only: shr_msg_chdir, shr_msg_stdio, shr_msg_dirio, shr_msg_finalize
   use shr_sys_mod,             only: shr_sys_flush
   use spmd_mod
   use mom_basic_mod,           only: read_spec_parameter, get_local_size
   use cpl_mod,                 only: read_global_info, init_cpl
   use cpl_mod,                 only: setup_mpi
   use cpl_mod,                 only: cpl_stop_now
   use cpl_mod,                 only: ex_ice_ocn, ex_ocn_ice 
   use scatter_data_mod,        only: scatter_force_field
   use gather_data_mod,         only: gather_local_data
   use mpp_mod,                 only: mpp_exit, mpp_sync
!---------wangln 2007-06-21 add the MPI--------------


!!------------xujx 2009-02-17 add for broadcast-------------------
  use cpl_mod,                 only: global_sin,global_cos
  use mom_basic_mod,           only: imt_global, jmt_global
  use cpl_mod,                 only: init_global_sin_cos
!!------------xujx 2009-02-17 add for broadcast-------------------

 implicit none

!!------------xujx 2009-02-17 add for broadcast-------------------
 include 'mpif.h'
!!------------xujx 2009-02-17 add for broadcast-------------------

! model defined-types ----
  type(ice_data_type)                    :: Ice  !liqq added

  type(atmos_ice_boundary_type)      :: Atmos_ice_boundary !liqq added
  type(land_ice_boundary_type)       :: Land_ice_boundary  !liqq added
  type(ocean_ice_boundary_type)      :: Ocean_ice_boundary !liqq added

! define some time types 
  type(time_type) :: Time_init    ! initial time for experiment
  type(time_type) :: Time_start   ! start time for experiment
  type(time_type) :: Time_end     ! end time for experiment (as determined by dtts)
  type(time_type) :: Run_len      ! length of experiment 

  type(time_type) :: Time_step_ice
  type(time_type) :: Time_step_coupled

  type(time_type) :: Time
  type(time_type) :: Time_ice   

  character(len=17) :: calendar = 'julian'
  character(len=9)  :: month
  character(len=8)  :: name_time                         !liqq added
  character(len=80) :: text                              !liqq

  character(len=256) :: version = ''
  character(len=256) :: tag = ''


  integer :: dt_ice   = 3600
  integer :: dt_cpld  = 7200
  integer :: num_cpld_calls  = 0
  integer :: num_ice_fast = 0
  integer(kind=4) :: nc
  integer :: calendar_type=-1   !liuxy  calendar_type = -99

  integer :: date_init(6)=0, date(6)
  integer :: years=0, months=0, days=0, hours=0, minutes=0, seconds=0
  integer :: yr, mon, day, hr, min, sec

  integer :: isc,iec,jsc,jec
  integer :: unit, log_unit, io_status, ierr

  integer :: memuse
  integer :: flags=0, override_clock
  integer :: nfields  !liuxy  nfields=5

  integer, dimension(6) :: current_date = (/ 0, 0, 0, 0, 0, 0 /)
  integer :: initClock, mainClock, termClock
  integer :: itmp, i, kd

!-------------------------wangln 2007-06-21------------------------
  integer :: nstep 
!-------------------------wangln 2007-06-21------------------------

   !!namelist /ice_solo_nml/ date_init, calendar, months, days, hours, minutes, seconds, dt_cpld, dt_ice  
   character(len=10) :: restart_freq = 'monthly'
   namelist /ice_solo_nml/ date_init, calendar, months, days, hours, minutes, seconds, dt_cpld, dt_ice, restart_freq  

! #######################################################################

! initialize shared modules

!----------------wangln 2007-06-21 For SIS MPMD-----------------------

  call setup_mpi

  call shr_msg_chdir('ice')
  call spmd_init( MPI_COMM_ICE )

  call fms_init(MPI_COMM_ICE )

  if( master_task ) then
    call read_spec_parameter()
    call get_local_size(MPI_COMM_ICE)
    call read_global_info()
  endif
 
!----------------wangln 2007-06-21 For SIS MPMD-----------------------

!===========xjx 2009-02-17 add for bcast============
 call MPI_BCAST(imt_global,1,MPI_INTEGER,0,MPI_COMM_ICE,ierr)
 call MPI_BCAST(jmt_global,1,MPI_INTEGER,0,MPI_COMM_ICE,ierr)

 if(.not. master_task) then
    call init_global_sin_cos()
 endif

 call MPI_BCAST( global_sin, imt_global*jmt_global, MPI_REAL8, 0, MPI_COMM_ICE, ierr)
 call MPI_BCAST( global_cos, imt_global*jmt_global, MPI_REAL8, 0, MPI_COMM_ICE, ierr)
!===========xjx 2009-02-17 add for bcast============

  flags = MPP_CLOCK_SYNC

! provide for namelist over-ride
  unit = open_namelist_file('input.nml')
  read  (unit, ice_solo_nml,iostat=io_status)  !liqq
  write (stdout(),'(/)')
  write (stdout(),'(/47x,a/)') '======== MODEL BEING DRIVEN BY ICE_SOLO_MOD ========'  !liqq
  write (stdout(), ice_solo_nml)  !liqq
  write (stdlog(), ice_solo_nml)  !liqq
  ierr = check_nml_error(io_status,'ice_solo_nml') !liqq
  call close_file (unit)

  write (stdlog(),'(/,80("="),/(a))') trim(version), trim(tag)

! set the calendar 
  select case( uppercase(trim(calendar)) )
  case( 'JULIAN' )
     calendar_type = JULIAN
  case( 'NOLEAP' )
     calendar_type = NOLEAP
  case( 'THIRTY_DAY' )
     calendar_type = THIRTY_DAY_MONTHS
  case( 'NO_CALENDAR' )
     calendar_type = NO_CALENDAR
  case default
     call mpp_error( FATAL, 'ice_solo: ice_solo_nml entry calendar must be one of JULIAN|NOLEAP|THIRTY_DAY|NO_CALENDAR.' ) !liqq
  end select 

! get ice_solo restart : this can override settings from namelist  ! liqq
  if (file_exist('INPUT/ice_solo.res')) then  !liqq
      call mpp_open(unit,'INPUT/ice_solo.res',form=MPP_ASCII,action=MPP_RDONLY)  !liqq
      read(unit,*) calendar_type 
      read(unit,*) date_init
      read(unit,*) date
      write(stdout(),*) ' Get ice_solo.res date=', date 
      call close_file(unit)
  endif
      
  call set_calendar_type (calendar_type)
                             
  call field_manager_init(nfields)  !deleted by liuxy

  call diag_manager_init()  


  call time_interp_external_init()  !deleted by liuxy


  if (sum(date_init) <= 0) then
      call mpp_error(FATAL,'==>Error from ice_solo_mod: date_init must be set either in ice_solo.res or in ice_solo_nml')  
  else
      Time_init  = set_date(date_init(1),date_init(2), date_init(3), &
           date_init(4),date_init(5),date_init(6))
  endif

  if (file_exist('INPUT/ice_solo.res')) then  
      Time_start =  set_date(date(1),date(2),date(3),date(4),date(5),date(6))
  else
      Time_start = Time_init
      date = date_init
  endif

  Time_end          = increment_date(Time_start, years, months, days, hours, minutes, seconds)
  Run_len           = Time_end - Time_start
 
  Time_step_coupled = set_time(dt_cpld, 0)
  Time_step_ice     = set_time(dt_ice,  0)

  num_cpld_calls    = Run_len / Time_step_coupled
  num_ice_fast      = Time_step_coupled / Time_step_ice

  Time = Time_start
  
  call ice_model_init( Ice, Time_init, Time, Time_step_ice, Time_step_coupled )  
  Time_ice = Time

  call data_override_init(Ice_domain_in = Ice%domain )
  
  override_clock = mpp_clock_id('Override', flags=flags,grain=CLOCK_COMPONENT)
  
  call mpp_get_compute_domain(Ice%domain, isc, iec, jsc, jec)  !liqq

!liqq----
	    kd = size(Ice%ice_mask,3)
        allocate( atmos_ice_boundary%u_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%v_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%u_star(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%t_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%q_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%lw_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux_vis(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux_dir(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux_vis_dir(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux_dif(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%sw_flux_vis_dif(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%lprec(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%fprec(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%dhdt(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%dedt(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%drdt(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%coszen(isc:iec,jsc:jec,kd) )
        allocate( atmos_ice_boundary%p(isc:iec,jsc:jec,kd) )
!-----------------------------wangln 2007-11-20 add the new variable---------------------
        allocate( atmos_ice_boundary%atmos_z(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_u(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_v(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_ptem(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_tbot(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_shum(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_dens(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_pbot(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_p_surf(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_swndr(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_swvdr(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_swndf(isc:iec,jsc:jec) )
        allocate( atmos_ice_boundary%atmos_swvdf(isc:iec,jsc:jec) )

        atmos_ice_boundary%atmos_z = 0.0 
        atmos_ice_boundary%atmos_u = 0.0 
        atmos_ice_boundary%atmos_v = 0.0 
        atmos_ice_boundary%atmos_ptem = 0.0 
        atmos_ice_boundary%atmos_tbot = 0.0 
        atmos_ice_boundary%atmos_shum = 0.0 
        atmos_ice_boundary%atmos_dens = 0.0 
        atmos_ice_boundary%atmos_pbot = 0.0 
        atmos_ice_boundary%atmos_p_surf = 0.0 
        atmos_ice_boundary%atmos_swndr = 0.0 
        atmos_ice_boundary%atmos_swvdr = 0.0 
        atmos_ice_boundary%atmos_swndf = 0.0 
        atmos_ice_boundary%atmos_swvdf = 0.0 
!-----------------------------wangln 2007-11-20 add the new variable---------------------


        atmos_ice_boundary%u_flux=0.0
        atmos_ice_boundary%v_flux=0.0
        atmos_ice_boundary%u_star=0.0
        atmos_ice_boundary%t_flux=0.0
        atmos_ice_boundary%q_flux=0.0
        atmos_ice_boundary%lw_flux=0.0
        atmos_ice_boundary%sw_flux=0.0
        atmos_ice_boundary%sw_flux_vis=0.0
        atmos_ice_boundary%sw_flux_dir=0.0
        atmos_ice_boundary%sw_flux_vis_dir=0.0
        atmos_ice_boundary%sw_flux_dif=0.0
        atmos_ice_boundary%sw_flux_vis_dif=0.0
        atmos_ice_boundary%lprec=0.0
        atmos_ice_boundary%fprec=0.0
        atmos_ice_boundary%dhdt=0.0
        atmos_ice_boundary%dedt=0.0
        atmos_ice_boundary%drdt=0.0
        atmos_ice_boundary%coszen=0.0
        atmos_ice_boundary%p=0.0


     allocate (land_ice_boundary%runoff (isc:iec,jsc:jec), &
 	           land_ice_boundary%calving (isc:iec,jsc:jec))
              
			   land_ice_boundary%runoff (isc:iec,jsc:jec)  =0.0
 	           land_ice_boundary%calving (isc:iec,jsc:jec) =0.0

!!------------------------------wangln 2007-12-12---------------------------------
     allocate (land_ice_boundary%step_runoff (isc:iec,jsc:jec), &
 	           land_ice_boundary%step_calving (isc:iec,jsc:jec))
              
			   land_ice_boundary%step_runoff (isc:iec,jsc:jec)  =0.0
 	           land_ice_boundary%step_calving (isc:iec,jsc:jec) =0.0
!!-------------------------------wangln 2007-12-12---------------------------------


     allocate (ocean_ice_boundary%u (isc:iec,jsc:jec), &
 	           ocean_ice_boundary%v (isc:iec,jsc:jec), &
 	           ocean_ice_boundary%t (isc:iec,jsc:jec), &
	           ocean_ice_boundary%s (isc:iec,jsc:jec), &
 !frazil and sea_level are optional, if not present they should be nullified
	           ocean_ice_boundary%frazil (isc:iec,jsc:jec), &
	           ocean_ice_boundary%sea_level (isc:iec,jsc:jec))

               ocean_ice_boundary%u (isc:iec,jsc:jec)         =0.0
 	           ocean_ice_boundary%v (isc:iec,jsc:jec)         =0.0
 	           ocean_ice_boundary%t (isc:iec,jsc:jec)         =273.0
	           ocean_ice_boundary%s (isc:iec,jsc:jec)         =0.0
	           ocean_ice_boundary%frazil (isc:iec,jsc:jec)    =0.0
	           ocean_ice_boundary%sea_level (isc:iec,jsc:jec) =0.0
!liqq--------------------------

!--------------wangln 2007-06-21----------------------------------
  nstep = 1
  call get_date (Time_start, date(1), date(2), date(3), date(4), date(5), date(6))
  call init_cpl( dt_ice, dt_cpld, date )

!!--------wangln 2008-06-01 For the First Send to CPL--------------------------
  if ( .not. ( file_exist('INPUT/ice_model.res.nc') ))  call Get_Init_field(Ice, isc, iec, jsc, jec)

!----------
! 2010.03.08
!
  if ( file_exist('INPUT/atmos_ice_boundary.res.nc') ) then
         call get_ice_boundary (atmos_ice_boundary) 
  endif

!------------------------
  call ice_ocn_flux( Ice, isc, iec, jsc, jec) 
  call ice_atmos_flux_cpl( Ice, isc, iec, jsc, jec)
  call gather_local_data( date, ice, isc,iec, jsc, jec  )

  nc = 1
  
  ex_ice_ocn = .false. 
  ex_ocn_ice = .false. 
  write(stdout(),'(a,i4)')' SIS Fast Call Frequence =', num_ice_fast

  SIS_STEP : do while( .not. cpl_stop_now ) 

     write(stdout(),'(a,i4,3i4.2,i8)' ) 'Date & SIS Steps = ', date(1), date(2), date(3), date(4), nc

!------------get Ice <->Ocn Exchange flag----------------------------------------------
     if(  mod( nc, num_ice_fast) == 0 ) then 
        ex_ice_ocn = .true.
     else if( mod( nc, num_ice_fast) /= 0 ) then
         ex_ice_ocn = .false.
     endif

     if( mod( nc-1, num_ice_fast ) == 0 ) then
        ex_ocn_ice = .true.
     else  
        ex_ocn_ice = .false.
     endif
!------------get Ice <->Ocn Exchange flag----------------------------------------------
 
     call get_date (Time_ice, date(1), date(2), date(3), date(4), date(5), date(6))

     call scatter_force_field( ocean_ice_boundary, atmos_ice_boundary, land_ice_boundary, isc,iec, jsc, jec , date )

     if( ex_ocn_ice ) then
! wutw 2009-10-23 add Atmos_ice_boundary ==>
!        call update_ice_model_slow_up( Ocean_ice_boundary, Ice )    !liqq added
         call update_ice_model_slow_up( ocean_ice_boundary, ice, atmos_ice_boundary ) !liqq added
! wutw 2009-10-23 add Atmos_ice_boundary <==
     endif



!    if( cpl_stop_now  ) then
!       write(stdout(), *) '---------Now The Days Count is End-------------'
!       exit SIS_STEP
!    endif
     call atmos_ice_flux_cpl( ice, atmos_ice_boundary, isc,iec, jsc, jec )
 
     call get_date (Time_ice, date(1), date(2), date(3), date(4), date(5), date(6))


     Time_ice = Time_ice + Time_step_ice

  !!================================= liuxw 20200616 ==============================       
   ! The Ice%Time is updated in update_ice_model_fast
     if( ida_use )then
       call ida_operate(Ice,Time_ice,dt_ice)   
     endif
  !!================================= liuxw 20200616 ==============================      

     call update_ice_model_fast( Atmos_ice_boundary, Ice )

     if( ex_ice_ocn ) then
         call update_ice_model_slow_dn(Atmos_ice_boundary, Land_ice_boundary, Ice )
         call ice_ocn_flux( Ice, isc, iec, jsc, jec)
     endif

     call get_date (Time_ice, date(1), date(2), date(3), date(4), date(5), date(6))
     call Output_Restart_File( restart_freq, Time, calendar_type, date_init, date, Ice ,&
	      atmos_ice_boundary)

  !!================================= liuxw 20200616 ==============================       
     if( ida_use )then
       if( date(4) == 0 .and. date(5) == 0 .and. date(6) == 0 )then
         call ida_analysis(date)
       endif
     !  call ida_operate(Ice,dt_ice)     
     endif
  !!================================= liuxw 20200616 ==============================       

  !---- assimil module by scnie 201711----------------
     if (trim(assimil_type) == 'cycle') &
        call get_cycle_assimil(Ice)         ! process of assimilation
     !---- end assimil module----------------

     if( .not. cpl_stop_now )  then
        call ice_atmos_flux_cpl( Ice, isc, iec, jsc, jec)
        call gather_local_data( date, Ice, isc,iec, jsc, jec  )
     endif 

     nc = nc + 1

  enddo SIS_STEP
     

!--------------wangln 2007-06-21----------------------------------

   call diag_manager_end( Time )
   call mpp_set_current_pelist()

   call mpp_close(unit)
   !!call fms_io_exit
   call fms_end    

   call shr_msg_finalize()

!!===============wangln 2007-07-28 Restart File output Sub===========================
CONTAINS
  
  Subroutine Output_Restart_file( restart_freq, Time, calendar_type, date_init, date, Ice, &
             atmos_ice_boundary )
  
    implicit none

      character(len=10),         intent(in)  :: restart_freq
      type(time_type),           intent(in)  :: time 
      integer,                   intent(in)  :: calendar_type 
      integer,                   intent(in)  :: date_init(6) 
      integer,                   intent(in)  :: date(6) 
      type(ice_data_type)                    :: Ice
      type(atmos_ice_boundary_type)      :: atmos_ice_boundary !liqq added
      
      logical                        :: output_rest = .false.
      character(len=10)               :: cdate
      
      save
      logical                        :: first_call = .true.

!-----------------------Output Frequency Year/Month---------------------------------------------------
      if( restart_freq(1:5) == 'daily' ) then

        if( date(4) == 0 .and. date(5) == 0 .and. date(6) == 0) then
          write(stdout(),*) ' Now is the Beginning a new day, and Output Restart File', date(1), date(2), date(3) , date(4)
          write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', date(2), '-', date(3)
          output_rest = .true.
        endif

      else if( restart_freq(1:7) == 'monthly' ) then

         if( date(3) == 1  .and. date(4) == 0  .and. date(5) == 0 .and. date(6) == 0) then
           write(stdout(),*) ' Now is the Beginning Day of This Month, and Output Restart File', date(1), date(2), date(3)
           write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', date(2), '-', 1
           output_rest = .true.
         endif

      else if( restart_freq(1:6) == 'yearly' ) then

         if( (date(2) == 1 ) .and. (date(3) == 1 ) .and. date(4) == 0 .and.  date(5) == 0 .and. date(6) == 0) then
           write(stdout(),*) ' Now is the Beginnig Day of This Year, and Output Restart File', date(1),date(2), date(3)
           write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', 1, '-', 1
           output_rest = .true.
         endif

      else if( restart_freq(1:4) == 'none' ) then
        output_rest = .false.
        if( first_call ) then
           write(stdout(),*) ' Now SIS Not Output Restart File & Restart_freq == NONE'
           first_call = .false.
        endif

      else
         output_rest = .false.
        if( first_call ) then
           write(stdout(),*) ' Now SIS Not Output Restart File & Restart Frequency is not valid'
           first_call = .false.
        endif

      endif


!-----------------------Output the Restart Time File & Archive the Restart files-----------------------------------------
      if( output_rest ) then
         output_rest = .false.
         !------------------- write restart file---------------------------
         call ice_model_end( Ice )

!----------
! 2010.03.08
!
		 call ice_boundary_end(atmos_ice_boundary)

!----------
         call fms_io_exit( cdate )
         call mpp_open( unit, 'RESTART/ice_solo.res'//'-'//cdate, nohdrs=.TRUE. )
         if ( mpp_pe().EQ.mpp_root_pe() )then
             write( unit, '(i6,8x,a)' )calendar_type, &
                   '(Calendar: no_calendar=0, thirty_day_months=1, julian=2, gregorian=3, noleap=4)'
             write( unit, '(6i6,8x,a)' )date_init(1), date_init(2), date_init(3), date_init(4), date_init(5), date_init(6),&
                   'Model start time:   year, month, day, hour, minute, second'
             write( unit, '(6i6,8x,a)' )date(1), date(2), date(3), date(4), date(5), date(6), &
                   'Current model time: year, month, day, hour, minute, second'
         endif
         call mpp_close(unit)
      endif !! ENDIF of output_rest 
         

      return
         

  end Subroutine Output_Restart_file

!!===============wangln 2007-07-28 Restart File output Sub===========================
!!=====================================================================================
 Subroutine Get_Init_field(Ice, isc, iec, jsc, jec)

  use ice_spec_mod,     only: get_sea_surface

  integer,             intent(in)     ::  isc, iec, jsc, jec
  type(ice_data_type), intent(inout)  :: Ice

  !-------------------Local-------------------------
  integer :: i, j, k

 !!---------------wangln 2008-06-01 For First Send to CPL---------------------------------------------------------------
    call get_sea_surface(Ice%Time, Ice%t_surf(:,:,1), Ice%part_size(isc:iec,jsc:jec,1:2), Ice%h_ice (isc:iec,jsc:jec,2))
    Ice % albedo_vis_dir(:,:,2) = 0.85
    Ice % albedo_vis_dif(:,:,2) = 0.85
    Ice % albedo_nir_dir(:,:,2) = 0.85
    Ice % albedo_nir_dif(:,:,2) = 0.85
    Ice % t_surf(:,:,2) = Ice % t_surf(:,:,1)
    !Ice%part_size(:,:,2:km) = Ice%part_size(isc:iec,jsc:jec,1)
    do j = jsc, jec
       do i = isc, iec
          if( Ice%part_size(i,j,2) > 0 ) then
             if( Ice % t_surf(i,j,2) >= 271.36 ) Ice % t_surf(i,j,2) = 271.36
             if( Ice % t_surf(i,j,2) <  271.36 ) Ice % t_surf(i,j,2) = 271.36
          endif
       enddo
    enddo
 !!---------------wangln 2008-06-01 For First Send to CPL---------------------------------------------------------------

  end Subroutine Get_Init_field



  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_model_init - initializes ice model data, parameters and diagnostics      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine get_ice_boundary (atmos_ice_boundary)
      use ice_grid_mod,     only: Domain
      use fms_io_mod,       only: read_data
      type(atmos_ice_boundary_type),     intent(inout) :: atmos_ice_boundary

    character(len=31) :: restart = 'INPUT/atmos_ice_boundary.res.nc'
    !
    ! read restart
    !
       write(stdout(),*) '---------Ice_boundary Restart Data-----------------------'
       call read_data( restart, 'u_flux',   atmos_ice_boundary%u_flux,        domain )
	   call read_data( restart, 'v_flux',   atmos_ice_boundary%v_flux,        domain )
       call read_data( restart, 'u_star',   atmos_ice_boundary%u_star,        domain )
       call read_data( restart, 't_flux',   atmos_ice_boundary%t_flux,        domain )
	   call read_data( restart, 'q_flux',   atmos_ice_boundary%q_flux,        domain )
	   call read_data( restart, 'lw_flux',   atmos_ice_boundary%lw_flux,        domain )
	   call read_data( restart, 'sw_flux',   atmos_ice_boundary%sw_flux,        domain )
	   call read_data( restart, 'sw_flux_vis',   atmos_ice_boundary%sw_flux_vis,        domain )
	   call read_data( restart, 'sw_flux_dir',   atmos_ice_boundary%sw_flux_dir,        domain )
	   call read_data( restart, 'sw_flux_vis_dir',   atmos_ice_boundary%sw_flux_vis_dir,        domain )
	   call read_data( restart, 'sw_flux_dif',   atmos_ice_boundary%sw_flux_dif,        domain )
	   call read_data( restart, 'sw_flux_vis_dif',   atmos_ice_boundary%sw_flux_vis_dif,        domain )
       call read_data( restart, 'lprec',   atmos_ice_boundary%lprec,        domain )
	   call read_data( restart, 'fprec',   atmos_ice_boundary%fprec,        domain )
	   call read_data( restart, 'dhdt',   atmos_ice_boundary%dhdt,        domain )
	   call read_data( restart, 'dedt',   atmos_ice_boundary%dedt,        domain )
	   call read_data( restart, 'drdt',   atmos_ice_boundary%drdt,        domain )
	   call read_data( restart, 'coszen',   atmos_ice_boundary%coszen,        domain )
	   call read_data( restart, 'p',   atmos_ice_boundary%p,        domain )
	   call read_data( restart, 'atmos_z',   atmos_ice_boundary%atmos_z,        domain )
	   call read_data( restart, 'atmos_u',   atmos_ice_boundary%atmos_u,        domain )
	   call read_data( restart, 'atmos_v',   atmos_ice_boundary%atmos_v,        domain )
       call read_data( restart, 'atmos_ptem',   atmos_ice_boundary%atmos_ptem,        domain )
       call read_data( restart, 'atmos_tbot',   atmos_ice_boundary%atmos_tbot,        domain )
       call read_data( restart, 'atmos_shum',   atmos_ice_boundary%atmos_shum,        domain )
       call read_data( restart, 'atmos_dens',   atmos_ice_boundary%atmos_dens,        domain )
       call read_data( restart, 'atmos_pbot',   atmos_ice_boundary%atmos_pbot,        domain )
       call read_data( restart, 'atmos_p_surf',   atmos_ice_boundary%atmos_p_surf,        domain )
       call read_data( restart, 'atmos_swndr',   atmos_ice_boundary%atmos_swndr,        domain )
       call read_data( restart, 'atmos_swvdr',   atmos_ice_boundary%atmos_swvdr,        domain )
       call read_data( restart, 'atmos_swndf',   atmos_ice_boundary%atmos_swndf,        domain )
       call read_data( restart, 'atmos_swvdf',   atmos_ice_boundary%atmos_swvdf,        domain )
      
  end subroutine get_ice_boundary

  !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_model_end - writes the restart file                                      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_boundary_end (atmos_ice_boundary)
      use fms_mod,          only: write_data
      use ice_grid_mod,     only: Domain
      type(atmos_ice_boundary_type),     intent(inout) :: atmos_ice_boundary

    character(len=30) :: restart='RESTART/atmos_ice_boundary.res'
    !
	   call write_data( restart, 'u_flux',   atmos_ice_boundary%u_flux,        domain )
	   call write_data( restart, 'v_flux',   atmos_ice_boundary%v_flux,        domain )
       call write_data( restart, 'u_star',   atmos_ice_boundary%u_star,        domain )
       call write_data( restart, 't_flux',   atmos_ice_boundary%t_flux,        domain )
	   call write_data( restart, 'q_flux',   atmos_ice_boundary%q_flux,        domain )
	   call write_data( restart, 'lw_flux',   atmos_ice_boundary%lw_flux,        domain )
	   call write_data( restart, 'sw_flux',   atmos_ice_boundary%sw_flux,        domain )
	   call write_data( restart, 'sw_flux_vis',   atmos_ice_boundary%sw_flux_vis,        domain )
	   call write_data( restart, 'sw_flux_dir',   atmos_ice_boundary%sw_flux_dir,        domain )
	   call write_data( restart, 'sw_flux_vis_dir',   atmos_ice_boundary%sw_flux_vis_dir,        domain )
	   call write_data( restart, 'sw_flux_dif',   atmos_ice_boundary%sw_flux_dif,        domain )
	   call write_data( restart, 'sw_flux_vis_dif',   atmos_ice_boundary%sw_flux_vis_dif,        domain )
       call write_data( restart, 'lprec',   atmos_ice_boundary%lprec,        domain )
	   call write_data( restart, 'fprec',   atmos_ice_boundary%fprec,        domain )
	   call write_data( restart, 'dhdt',   atmos_ice_boundary%dhdt,        domain )
	   call write_data( restart, 'dedt',   atmos_ice_boundary%dedt,        domain )
	   call write_data( restart, 'drdt',   atmos_ice_boundary%drdt,        domain )
	   call write_data( restart, 'coszen',   atmos_ice_boundary%coszen,        domain )
	   call write_data( restart, 'p',   atmos_ice_boundary%p,        domain )
	   call write_data( restart, 'atmos_z',   atmos_ice_boundary%atmos_z,        domain )
	   call write_data( restart, 'atmos_u',   atmos_ice_boundary%atmos_u,        domain )
	   call write_data( restart, 'atmos_v',   atmos_ice_boundary%atmos_v,        domain )
       call write_data( restart, 'atmos_ptem',   atmos_ice_boundary%atmos_ptem,        domain )
       call write_data( restart, 'atmos_tbot',   atmos_ice_boundary%atmos_tbot,        domain )
       call write_data( restart, 'atmos_shum',   atmos_ice_boundary%atmos_shum,        domain )
       call write_data( restart, 'atmos_dens',   atmos_ice_boundary%atmos_dens,        domain )
       call write_data( restart, 'atmos_pbot',   atmos_ice_boundary%atmos_pbot,        domain )
       call write_data( restart, 'atmos_p_surf',   atmos_ice_boundary%atmos_p_surf,        domain )
       call write_data( restart, 'atmos_swndr',   atmos_ice_boundary%atmos_swndr,        domain )
       call write_data( restart, 'atmos_swvdr',   atmos_ice_boundary%atmos_swvdr,        domain )
       call write_data( restart, 'atmos_swndf',   atmos_ice_boundary%atmos_swndf,        domain )
       call write_data( restart, 'atmos_swvdf',   atmos_ice_boundary%atmos_swvdf,        domain )

  end subroutine ice_boundary_end


end program main
