#include <misc.h>
#include <preproc.h>

#if (defined NIE_BLDAS_LST) || (defined NIE_BLDAS_SM)

Module CompMod
! !REVISION HISTORY:
! Created by Suping Nie

use shr_kind_mod, only: r8 => shr_kind_r8


contains

!-----------------------------------------------------------------------
        SUBROUTINE AGAUS(A,B,N,X,L)
!--
use shr_kind_mod, only: r8 => shr_kind_r8
!--
        integer :: N,L                      
		real(r8):: A(N,N),X(N),B(N),JS(N)   

        L=1
        DO 50 K=1,N-1
          D=0.0
          DO 210 I=K,N
          DO 210 J=K,N
            IF (ABS(A(I,J)).GT.D) THEN
              D=ABS(A(I,J))
              JS(K)=J
              IS=I
            END IF
210       CONTINUE
          IF (D+1.0.EQ.1.0) THEN
            L=0
          ELSE
            IF (JS(K).NE.K) THEN
              DO 220 I=1,N
                T=A(I,K)
                A(I,K)=A(I,JS(K))
                A(I,JS(K))=T
220           CONTINUE
            END IF
            IF (IS.NE.K) THEN
              DO 230 J=K,N
                T=A(K,J)
                A(K,J)=A(IS,J)
                A(IS,J)=T
230           CONTINUE
              T=B(K)
              B(K)=B(IS)
              B(IS)=T
            END IF
          END IF
          IF (L.EQ.0) THEN
            WRITE(*,100)
            RETURN
          END IF
          DO 10 J=K+1,N
            A(K,J)=A(K,J)/A(K,K)
10        CONTINUE
          B(K)=B(K)/A(K,K)
          DO 30 I=K+1,N
            DO 20 J=K+1,N
              A(I,J)=A(I,J)-A(I,K)*A(K,J)
20          CONTINUE
            B(I)=B(I)-A(I,K)*B(K)
30        CONTINUE
50      CONTINUE
        IF (ABS(A(N,N))+1.0.EQ.1.0) THEN
          L=0
          WRITE(*,100)
          RETURN
        END IF
        X(N)=B(N)/A(N,N)
        DO 70 I=N-1,1,-1
          T=0.0
          DO 60 J=I+1,N
            T=T+A(I,J)*X(J)
60        CONTINUE
          X(I)=B(I)-T
70      CONTINUE
100     FORMAT(1X,' FAIL ')
        JS(N)=N
        DO 150 K=N,1,-1
          IF (JS(K).NE.K) THEN
            T=X(K)
            X(K)=X(JS(K))
            X(JS(K))=T
          END IF
150     CONTINUE
        RETURN
        END SUBROUTINE AGAUS
!----------------------------------------------------------------
SUBROUTINE BRMUL(A,B,M,N,K,C)

use shr_kind_mod, only: r8 => shr_kind_r8
        integer :: M,N,K                
		real(r8):: A(M,N),B(N,K),C(M,K) 

        DO 50 I=1,M
        DO 50 J=1,K
          C(I,J)=0.0
          DO 10 L=1,N
            C(I,J)=C(I,J)+A(I,L)*B(L,J)
10        CONTINUE
50      CONTINUE
RETURN
END SUBROUTINE BRMUL
!------------------------------------------------------------------
        SUBROUTINE CJCBI(A,N,EPS,V,L)

use shr_kind_mod, only: r8 => shr_kind_r8
        integer :: N,L,P,Q                    
		real(r8):: A(N,N),V(N,N)              
		real(r8):: FM,CN,SN,OMEGA,X,Y         

        L=1
        DO 20 I=1,N
          V(I,I)=1.0
          DO 10 J=1,N
            IF (I.NE.J) V(I,J)=0.0
10        CONTINUE
20      CONTINUE
25      FM=0.0
        DO 30 I=2,N
        DO 30 J=1,I-1
          IF (ABS(A(I,J)).GT.FM) THEN
            FM=ABS(A(I,J))
            P=I
            Q=J
          END IF
30      CONTINUE
        IF (FM.LT.EPS) THEN
          L=1
          RETURN
        END IF
        IF (L.GT.100) THEN
          L=0
          RETURN
        END IF
        L=L+1
        X=-A(P,Q)
        Y=(A(Q,Q)-A(P,P))/2.0
        OMEGA=X/SQRT(X*X+Y*Y)
        IF (Y.LT.0.0) OMEGA=-OMEGA
        SN=1.0+SQRT(1.0-OMEGA*OMEGA)
        SN=OMEGA/SQRT(2.0*SN)
        CN=SQRT(1.0-SN*SN)
        FM=A(P,P)
        A(P,P)=FM*CN*CN+A(Q,Q)*SN*SN+A(P,Q)*OMEGA
        A(Q,Q)=FM*SN*SN+A(Q,Q)*CN*CN-A(P,Q)*OMEGA
        A(P,Q)=0.0
        A(Q,P)=0.0
        DO 60 J=1,N
          IF ((J.NE.P).AND.(J.NE.Q)) THEN
            FM=A(P,J)
            A(P,J)=FM*CN+A(Q,J)*SN
            A(Q,J)=-FM*SN+A(Q,J)*CN
          END IF
60      CONTINUE

        DO 70 I=1,N
          IF ((I.NE.P).AND.(I.NE.Q)) THEN
            FM=A(I,P)
            A(I,P)=FM*CN+A(I,Q)*SN
            A(I,Q)=-FM*SN+A(I,Q)*CN
          END IF
70      CONTINUE
        DO 80 I=1,N
          FM=V(I,P)
          V(I,P)=FM*CN+V(I,Q)*SN
          V(I,Q)=-FM*SN+V(I,Q)*CN
80      CONTINUE
        GOTO 25
        END SUBROUTINE CJCBI
!--------------------------------------------------------------------------------
SUBROUTINE TRANS_MATRIX(A,B,M,N)

use shr_kind_mod, only: r8 => shr_kind_r8

INTEGER:: M,N
INTEGER::I,J
		real(r8):: A(M,N),B(N,M),C(N,M)  

DO I=1,M
  DO J=1,N
    C(J,I)=A(I,J)
  ENDDO
ENDDO
B=C
RETURN
END SUBROUTINE TRANS_MATRIX
!--------------------------------------------------------------------------------------
!--------------------------------------------------------------------------------
end Module CompMod

#endif
