module spmd_mod

 use mpmd_mod,           only : master_task
  
 implicit none


contains
!--------------------------------------------------------------
 subroutine spmd_init( mpicom )

   include 'mpif.h'

   integer, intent(in) :: mpicom
  
   integer  :: iam
   integer  :: ierr, mpes, i, j

   integer, allocatable :: length(:),length_r(:)
   integer, allocatable :: displ(:)
   character*(MPI_MAX_PROCESSOR_NAME), allocatable :: proc_name(:),proc_name_r(:)


   call mpi_comm_rank(mpicom, iam, ierr )
   if( iam==0 ) then
       master_task = .true.
   else
      master_task = .false.
   endif

   call mpi_comm_size( mpicom, mpes, ierr )
   if( mpes == 1 ) master_task = .true. 
   
   allocate (length(0:mpes-1))
   allocate (length_r(0:mpes-1))
   allocate (displ(0:mpes-1))
   allocate (proc_name(0:mpes-1))
   allocate (proc_name_r(0:mpes-1))
   call mpi_get_processor_name (proc_name(iam),length(iam),ierr)
   length_r = length 
   call mpi_allgather (length(iam),1, mpi_integer, length_r, 1, mpi_integer, mpicom,ierr)
   length = length_r
   do i =0,mpes-1
      displ(i)=i*MPI_MAX_PROCESSOR_NAME
   enddo
   proc_name_r = proc_name
   call mpi_gatherv (proc_name(iam),length(iam),mpi_character, proc_name_r,length_r,displ,mpi_character,0,mpicom,ierr)
   proc_name = proc_name_r

   deallocate (length)  
   deallocate (length_r)  
   deallocate (displ)  
   deallocate (proc_name)
   deallocate (proc_name_r)


   return

 end subroutine spmd_init
!--------------------------------------------------------------
end module spmd_mod
