program main

  use data_override_mod,        only: data_override_init, data_override
  use diag_manager_mod,         only: diag_manager_init, register_diag_field, diag_manager_end
  use field_manager_mod,        only: field_manager_init
  use fms_mod,                  only: fms_init, fms_end, open_namelist_file, check_nml_error
  use fms_mod,                  only: close_file, file_exist, uppercase
  use fms_io_mod,               only: fms_io_exit

  use mpp_domains_mod,          only: domain2d, mpp_get_compute_domain, mpp_get_layout, mpp_get_global_domain, &
                                      mpp_get_pelist

  use mpp_io_mod,               only: mpp_open, MPP_RDONLY, MPP_ASCII, MPP_OVERWR, MPP_APPEND, mpp_close, MPP_SINGLE
  use mpp_mod,                  only: mpp_error, FATAL, mpp_pe, mpp_npes, mpp_set_current_pelist
  use mpp_mod,                  only: stdlog, stdout, mpp_root_pe, mpp_clock_id
  use mpp_mod,                  only: mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC
  use mpp_mod,                  only: MPP_CLOCK_DETAILED, CLOCK_COMPONENT
  use time_interp_external_mod, only: time_interp_external_init
  use time_manager_mod,         only: set_calendar_type, time_type, increment_time, increment_date
  use time_manager_mod,         only: set_time, set_date, get_time, get_date, month_name
  use time_manager_mod,         only: JULIAN, NOLEAP, THIRTY_DAY_MONTHS, NO_CALENDAR
  use time_manager_mod,         only: operator( <= ), operator( < ), operator( >= )
  use time_manager_mod,         only: operator( + ),  operator( - ), operator( / )

!!================================= liuxw 20161103 ==============================
 !use ocean_model_mod,          only: ocean_model_init , update_ocean_model, ocean_model_end
  use ocean_model_mod,          only: ocean_model_init , update_ocean_model, ocean_model_end, oda_analysis, oda_use
!!================================= liuxw 20161103 ==============================

  use ocean_types_mod,          only: ocean_data_type, ice_ocean_boundary_type
  use ocean_model_mod,          only: read_ice_ocean_boundary
!---------wangln 2006-03-10 add the MPI--------------
   use mpmd_mod
   use shr_msg_mod,             only: shr_msg_chdir, shr_msg_stdio, shr_msg_dirio, shr_msg_finalize
   use shr_sys_mod,             only: shr_sys_flush
   use spmd_mod
   use mom_basic_mod,           only: read_spec_parameter, get_local_size
   use cpl_mod,                 only: read_global_info, init_cpl
   use cpl_mod,                 only: setup_mpi
   use cpl_mod,                 only: cpl_stop_now
   use scatter_data_mod,        only: scatter_force_field
   use gather_data_mod,         only: gather_local_data
   use mpp_mod,                 only: mpp_exit, mpp_sync
!---------wangln 2006-03-10 add the MPI--------------

!!------------xujx 2008-06-16 add for broadcast-------------------
   use cpl_mod,                 only: global_sin,global_cos
   use mom_basic_mod,           only: imt_global, jmt_global
   use cpl_mod,                 only: init_global_sin_cos
!!------------xujx 2008-06-16 add for broadcast-------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Modified by Song.Zhenya 21/05/2009
   use wave_vert_mix_mod,      only: wave_vert_mix_init
! End Modify
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  implicit none

!!------------xujx 2008-06-16 add for broadcast-------------------
  include 'mpif.h'
!!------------xujx 2008-06-16 add for broadcast-------------------
  type (ocean_data_type)                 :: Ocean_sfc
  type(ice_ocean_boundary_type), target  :: Ice_ocean_boundary

  ! define some time types
  type(time_type) :: Time_init    ! initial time for experiment
  type(time_type) :: Time_start   ! start time for experiment
  type(time_type) :: Time_end     ! end time for experiment (as determined by dtts)
  type(time_type) :: Run_len      ! length of experiment
  type(time_type) :: Time
  type(time_type) :: Time_step_ocean
  type(time_type) :: Time_step_coupled

  character(len=17) :: calendar = 'julian'

  integer :: dt_ocean = 3600
  integer :: dt_cpld  = 86400
  integer :: num_cpld_calls  = 0
  integer :: num_ocean_calls = 0
  integer :: nc, no
  integer :: calendar_type=-1

  integer :: date_init(6)=0, date(6)
  integer :: years=0, months=0, days=0, hours=0, minutes=0, seconds=0
  integer :: yr, mon, day, hr, min, sec

  integer :: isc,iec,jsc,jec
  integer :: unit, log_unit, io_status, ierr

  integer :: memuse
  integer :: flags=0, override_clock
  integer :: nfields

  character(len=256) :: version = ''
  character(len=256) :: tag = ''

  logical :: ocean_seg_start
  logical :: ocean_seg_end

  character(len=9) :: month
!!================================wufh 2008-08-26===============================
  character(len=10)                           :: cdate
!!================================wufh 2008-08-26===============================

!---------wangln 2006-03-10 add the MPI--------------

  integer          :: nstep
  logical          :: do_init = .true.
  real             :: co2ini

!---------wangln 2006-03-10 add the MPI--------------
!!================================wangln 2007-07-28:: Add the Restart_Frequency=========================================
  !!namelist /ocean_solo_nml/ date_init, calendar, months, days, hours, minutes, seconds, dt_cpld, dt_ocean
  character(len=10) :: restart_freq = 'monthly'
  namelist /ocean_solo_nml/ date_init, calendar, months, days, hours, minutes, seconds, dt_cpld, dt_ocean, co2ini, restart_freq
!!================================wangln 2007-07-28:: Add the Restart_Frequency==========================================


! initialize shared modules

    call setup_mpi

    call shr_msg_chdir('ocn')

    call spmd_init( MPI_COMM_OCN )
    call fms_init(MPI_COMM_OCN)


   if( master_task ) then
     call read_spec_parameter()
     call get_local_size(MPI_COMM_OCN )
     call read_global_info()
   endif

!===========xjx 2008-06-12 add for bcast============
  call MPI_BCAST(imt_global,1,MPI_INTEGER,0,MPI_COMM_OCN,ierr)
  call MPI_BCAST(jmt_global,1,MPI_INTEGER,0,MPI_COMM_OCN,ierr)

  if(.not. master_task) then
     call init_global_sin_cos()
  endif

  call MPI_BCAST( global_sin, imt_global*jmt_global, MPI_REAL8, 0, MPI_COMM_OCN, ierr)
  call MPI_BCAST( global_cos, imt_global*jmt_global, MPI_REAL8, 0, MPI_COMM_OCN, ierr)
!===========xjx 2008-06-12 add for bcast============


  flags = MPP_CLOCK_SYNC

  ! provide for namelist over-ride
  unit = open_namelist_file('input.nml')
  read  (unit, ocean_solo_nml,iostat=io_status)
  write (stdout(),'(/)')
  write (stdout(),'(/47x,a/)') '======== MODEL BEING DRIVEN BY OCEAN_SOLO_MOD ========'
  write (stdout(), ocean_solo_nml)
  write (stdlog(), ocean_solo_nml)
  ierr = check_nml_error(io_status,'ocean_solo_nml')
  call close_file (unit)

  write (stdlog(),'(/,80("="),/(a))') trim(version), trim(tag)

  ! set the calendar

  select case( uppercase(trim(calendar)) )
  case( 'JULIAN' )
     calendar_type = JULIAN
  case( 'NOLEAP' )
     calendar_type = NOLEAP
  case( 'THIRTY_DAY' )
     calendar_type = THIRTY_DAY_MONTHS
  case( 'NO_CALENDAR' )
     calendar_type = NO_CALENDAR
  case default
     call mpp_error( FATAL, 'ocean_solo: ocean_solo_nml entry calendar must be one of JULIAN|NOLEAP|THIRTY_DAY|NO_CALENDAR.' )
  end select

  ! get ocean_solo restart : this can override settings from namelist
  if (file_exist('INPUT/ocean_solo.res')) then
      call mpp_open(unit,'INPUT/ocean_solo.res',form=MPP_ASCII,action=MPP_RDONLY)
      read(unit,*) calendar_type
      read(unit,*) date_init
      read(unit,*) date
      call close_file(unit)
      do_init = .false.
  endif

  call set_calendar_type (calendar_type)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Modified by Song.Zhenya 25/05/2009
  call wave_vert_mix_init
! End Modify
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!$ initialize pelists for ocean ensembles set current pelist to ensemble member
!!$ need to call prior to diagnostics_init
!!$ code presently not supported (mjh)
!!$  call ocean_ensemble_init()

  call field_manager_init(nfields)

  call diag_manager_init()

  call time_interp_external_init()

  if (sum(date_init) <= 0) then
      call mpp_error(FATAL,'==>Error from ocean_solo_mod: date_init must be set either in ocean_solo.res or in ocean_solo_nml')
  else
      Time_init  = set_date(date_init(1),date_init(2), date_init(3), &
           date_init(4),date_init(5),date_init(6))
  endif

  if (file_exist('INPUT/ocean_solo.res')) then
      Time_start =  set_date(date(1),date(2),date(3),date(4),date(5),date(6))
  else
      Time_start = Time_init
      date = date_init
  endif

  Time_end          = increment_date(Time_start, years, months, days, hours, minutes, seconds)
  Run_len           = Time_end - Time_start
  Time_step_ocean   = set_time(dt_ocean, 0)
  Time_step_coupled = set_time(dt_cpld, 0)
  num_cpld_calls    = Run_len / Time_step_coupled
  num_ocean_calls   = Time_step_coupled / Time_step_ocean
  Time = Time_start


  call ocean_model_init(Ocean_sfc, Time_init, Time, Time_step_ocean )

  call data_override_init(Ocean_domain_in = Ocean_sfc%domain)

  override_clock = mpp_clock_id('Override', flags=flags,grain=CLOCK_COMPONENT)

  call mpp_get_compute_domain(Ocean_sfc%domain, isc, iec, jsc, jec)

  allocate ( Ice_ocean_boundary% u_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% v_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% t_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% q_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% salt_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% lw_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux (isc:iec,jsc:jec), &
             Ice_ocean_boundary% lprec (isc:iec,jsc:jec), &
             Ice_ocean_boundary% fprec (isc:iec,jsc:jec), &
             Ice_ocean_boundary% runoff (isc:iec,jsc:jec), &
             Ice_ocean_boundary% calving (isc:iec,jsc:jec), &

!--------------------wangln 2008-09-04 add the carbon flux---------------------
             Ice_ocean_boundary% co2 (isc:iec,jsc:jec), &
!--------------------wangln 2008-09-04 add the carbon flux---------------------
             Ice_ocean_boundary% p (isc:iec,jsc:jec), &
!--------
             Ice_ocean_boundary% dEdt (isc:iec,jsc:jec) ) 
!-----------------

  Ice_ocean_boundary%u_flux    = 0.0
  Ice_ocean_boundary%v_flux    = 0.0
  Ice_ocean_boundary%t_flux    = 0.0
  Ice_ocean_boundary%q_flux    = 0.0
  Ice_ocean_boundary%salt_flux = 0.0
  Ice_ocean_boundary%lw_flux   = 0.0
  Ice_ocean_boundary%sw_flux   = 0.0
  Ice_ocean_boundary%lprec     = 0.0
  Ice_ocean_boundary%fprec     = 0.0
  Ice_ocean_boundary%runoff    = 0.0
  Ice_ocean_boundary%calving   = 0.0
  Ice_ocean_boundary%p         = 0.0
  Ice_ocean_boundary%co2       = co2ini           ! co2 unit : ppm
  Ice_ocean_boundary%dEdt      = 0.0
!---------------
  ! loop over the coupled calls
  nstep = 1

   call get_date (Time_start, date(1), date(2), date(3), date(4), date(5), date(6))
   call init_cpl( dt_ocean, dt_cpld, date )
   if ( do_init ) date(3) = date(3) + 1
   call gather_local_data( date, ocean_sfc, isc,iec, jsc, jec  )

   nc = 1
   MOM_STEP : do while( .not. cpl_stop_now)

     call mpp_clock_begin(override_clock)

     if ( do_init ) then
	     if( nc == 1) then
                   write(stdout(),*) 'nc=',nc
		   call read_ice_ocean_boundary('INPUT/ocean_boundary.res.nc',Ice_ocean_boundary,ocean_sfc)
		 else
           call scatter_force_field( Ice_ocean_boundary, isc,iec, jsc, jec  )
         endif
     else
         call scatter_force_field( Ice_ocean_boundary, isc,iec, jsc, jec  )
     endif
     if( cpl_stop_now  ) then
         write(stdout(), *) '---------Now The Coupler Calls is End-------------'
         exit MOM_STEP
     endif

     call mpp_clock_end(override_clock)
!----------------------lijl, 2009-12-01, show co2 -----------------------
!    write(stdout(), *) 'co2 = (ppm)', Ice_ocean_boundary%co2 
!----------------------iijl, 2009-12-01, show co2 -----------------------

     ! loop over the ocean calls
     do no = 1, num_ocean_calls
           ocean_seg_start = ( no .eq. 1 )
           ocean_seg_end   = ( no .eq. num_ocean_calls )
!--------------------------lijl, 2009-08-05, add zosga -------------------------------------------
!        call update_ocean_model(Ice_ocean_boundary, Ocean_sfc, ocean_seg_start, ocean_seg_end, num_ocean_calls)
        call update_ocean_model(Ice_ocean_boundary, Ocean_sfc, ocean_seg_start, ocean_seg_end, num_ocean_calls,nc)
!--------------------------lijl, 2009-08-05, add zosga -------------------------------------------
           Time = Time + Time_step_ocean
     enddo

     call get_date (Time, date(1), date(2), date(3), date(4), date(5), date(6))
     call Output_Restart_File( restart_freq, Time, calendar_type, date_init, date, Ocean_sfc )

!!================================= liuxw 20161103 ==============================
     if( oda_use .and. date(4) == 0 .and. date(5) == 0 .and. date(6) == 0 )then
     call oda_analysis(date)
     endif
!!================================= liuxw 20161103 ==============================   

     if( mpp_pe() == mpp_root_pe() ) then
    !    write(stdout(),'(a,5i10)') '---- Main Step= ', nstep, no, nc, num_ocean_calls, num_cpld_calls
     endif

     call get_date (Time, date(1), date(2), date(3), date(4), date(5), date(6))
!!================================wufh 2008-08-26===============================
     write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', date(2), '-', 1
     call fms_io_exit(cdate)
!!================================wufh 2008-08-26===============================

     nstep = nstep +1

     if ( do_init ) then
         if( nc /= 1 .and. ( .not. cpl_stop_now ) ) call gather_local_data( date, ocean_sfc, isc,iec, jsc, jec  )
     else
         if(  .not. cpl_stop_now ) call gather_local_data( date, ocean_sfc, isc,iec, jsc, jec  )
     endif
     nc = nc + 1

  enddo MOM_STEP


  call diag_manager_end(Time)
  call mpp_set_current_pelist()
  call mpp_close(unit)
  !!call fms_io_exit
  call fms_end

  call shr_msg_finalize()

!!===============wangln 2007-07-28 Restart File output Sub===========================
CONTAINS

  Subroutine Output_Restart_file( restart_freq, Time, calendar_type, date_init, date, ocean_sfc )

    implicit none

      character(len=10),         intent(in)  :: restart_freq
      type(time_type),           intent(in)  :: time
      integer,                   intent(in)  :: calendar_type
      integer,                   intent(in)  :: date_init(6)
      integer,                   intent(in)  :: date(6)
      type (ocean_data_type),    intent(in)  :: Ocean_sfc


      logical                        :: output_rest = .false.
      character(len=10)               :: cdate

      save
      logical                        :: first_call = .true.

!-----------------------Output Frequency Year/Month---------------------------------------------------
      if( restart_freq(1:5) == 'daily' ) then
        if( date(4) == 0 .and. date(5) == 0 .and. date(6) == 0) then
          write(stdout(),*) ' Now is the Beginning a new day, and Output Restart File', date(1), date(2), date(3) , date(4)
          write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', date(2), '-', date(3)
          output_rest = .true.
        endif

      else if( restart_freq(1:7) == 'monthly' ) then

         if( date(3) == 1  .and. date(4) == 0  .and. date(5) == 0 .and. date(6) == 0) then
           write(stdout(),*) ' Now is the Beginning Day of This Month, and Output Restart File', date(1), date(2), date(3)
           write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', date(2), '-', 1
           output_rest = .true.
         endif

      else if( restart_freq(1:6) == 'yearly' ) then

         if( (date(2) == 1 ) .and. (date(3) == 1 ) .and. date(4) == 0 .and.  date(5) == 0 .and. date(6) == 0) then
           write(stdout(),*) ' Now is the Beginnig Day of This Year, and Output Restart File', date(1),date(2), date(3)
           write(cdate,'(i4.4,a,i2.2,a,i2.2)') date(1), '-', 1, '-', 1
           output_rest = .true.
         endif
      else if( restart_freq(1:4) == 'none' ) then
        output_rest = .false.
        if( first_call ) then
           write(stdout(),*) ' Now MOM Not Output Restart File & Restart_freq == NONE'
           first_call = .false.
        endif

      else
        output_rest = .false.
        if( first_call ) then
           write(stdout(),*) ' Now MOM Not Output Restart File & Restart Frequency is not valid'
           first_call = .false.
        endif

      endif

!-----------------------Output the Restart Time File & Archive the Restart files-----------------------------------------
      if( output_rest ) then
         output_rest = .false.
         call ocean_model_end(Ice_ocean_boundary, Ocean_sfc)
         call fms_io_exit( cdate )
         !------------------- write restart file---------------------------
         call mpp_open( unit, 'RESTART/ocean_solo.res'//'-'//cdate, nohdrs=.TRUE. )
         if ( mpp_pe().EQ.mpp_root_pe() )then
             write(stdout(),*) 'Output-------,date', date(1), date(2), date(3), date(4), date(5), date(6)
             write( unit, '(i6,8x,a)' )calendar_type, &
                   '(Calendar: no_calendar=0, thirty_day_months=1, julian=2, gregorian=3, noleap=4)'
             write( unit, '(6i6,8x,a)' )date_init(1), date_init(2), date_init(3), date_init(4), date_init(5), date_init(6),&
                   'Model start time:   year, month, day, hour, minute, second'
             write( unit, '(6i6,8x,a)' )date(1), date(2), date(3), date(4), date(5), date(6), &
             !!write( unit, '(6i6,8x,a)' )date(1), date(2), date(3), date_init(4), date_init(5), date_init(6), &
                   'Current model time: year, month, day, hour, minute, second'
         endif
         call mpp_close(unit)
      endif !! ENDIF of output_rest


      return


  end Subroutine Output_Restart_file

!!===============wangln 2007-07-28 Restart File output Sub===========================

end program main
